;              
CREATE USER IF NOT EXISTS "" SALT '' HASH '' ADMIN;            
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_49E4B062_1A06_40A3_8ED6_7972DF343511" START WITH 145 BELONGS_TO_TABLE;               
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_14F6B4EE_EB13_4EF7_BAFA_6C4D874674B1" START WITH 1484 BELONGS_TO_TABLE;              
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_5965FBCA_B16F_436C_9148_DEFA039A9FF4" START WITH 139 BELONGS_TO_TABLE;               
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_CC1FF0F3_FE0A_4D63_B941_016BBBD65B37" START WITH 1 BELONGS_TO_TABLE; 
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_234A4E4D_CC86_4B31_895E_BAAF598244AC" START WITH 29 BELONGS_TO_TABLE;
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_0ECCA014_C94F_4A29_8615_8ED49C561442" START WITH 57 BELONGS_TO_TABLE;
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_FCE2482C_869C_4A8A_8ADF_14A0C357B389" START WITH 1 BELONGS_TO_TABLE; 
CREATE SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_C8BB383D_C675_4B58_838D_1A3C23B678B3" START WITH 1 BELONGS_TO_TABLE; 
CREATE MEMORY TABLE "PUBLIC"."BLANGFUNCTION"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_14F6B4EE_EB13_4EF7_BAFA_6C4D874674B1") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_14F6B4EE_EB13_4EF7_BAFA_6C4D874674B1",
    "PACKAGEID" INT NOT NULL,
    "OBJECTID" INT DEFAULT '-1' NOT NULL,
    "NAME" VARCHAR(256) NOT NULL,
    "PRIVATE" BIT DEFAULT 1 NOT NULL,
    "ACTION" BIT DEFAULT 0 NOT NULL,
    "ATTACHED" BIT DEFAULT 0 NOT NULL,
    "COMPLETIONITEM" VARCHAR NOT NULL
);    
ALTER TABLE "PUBLIC"."BLANGFUNCTION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_A" PRIMARY KEY("ID"); 
-- 1483 +/- SELECT COUNT(*) FROM PUBLIC.BLANGFUNCTION;         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1, 1, -1, 'getScopes', TRUE, FALSE, FALSE, '{"label":"getScopes(string username, string tableName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nReads the scope(s) of the user of the given username.\n  \n**Params**  \n- `string` username: The username of the user.  \n- `string` tableName: The table name of the TOML file of the user-store.  \n  \n**Returns** `string[]`   \n- An array of groups of the user who is denoted by the username.  \n  \n"}},"insertText":"getScopes(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(2, 1, -1, 'extractHash', TRUE, FALSE, FALSE, '{"label":"extractHash(string configValue)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nExtracts the password hash from the configuration file.\n  \n**Params**  \n- `string` configValue: Config value to extract the password from  \n  \n**Returns** `string`   \n- Password hash extracted from the configuration field  \n  \n"}},"insertText":"extractHash(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(3, 1, -1, 'readPassword', TRUE, FALSE, FALSE, '{"label":"readPassword(string username)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nReads the password hash for a user.\n  \n**Params**  \n- `string` username: Username  \n  \n**Returns** `string`   \n- Password hash read from userstore, or nil if not found  \n  \n"}},"insertText":"readPassword(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(4, 1, -1, 'getConfigAuthValue', TRUE, FALSE, FALSE, '{"label":"getConfigAuthValue(string instanceId, string property)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getConfigAuthValue(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(5, 1, -1, 'getArray', TRUE, FALSE, FALSE, '{"label":"getArray(string groupString)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nConstruct an array of groups from the comma separed group string passed.\n  \n**Params**  \n- `string` groupString: Comma separated string of groups  \n  \n**Returns** `string[]`   \n- Array of groups, nil if the groups string is empty/nil  \n  \n"}},"insertText":"getArray(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(6, 1, -1, 'getAuthTokenForBasicAuth', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForBasicAuth(auth:Credential credential)((string|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nProcesses the auth token for Basic Auth.\n  \n**Params**  \n- `auth:Credential` credential: The credential configurations.  \n  \n**Returns** `(string|auth:Error)`   \n- The auth token or the `Error` if an error occurred during validation.  \n  \n"}},"insertText":"getAuthTokenForBasicAuth(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(7, 1, -1, 'extractUsernameAndPassword', FALSE, FALSE, FALSE, '{"label":"extractUsernameAndPassword(string credential)(([string,string]|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nExtracts the username and password from the credential values.\n  \n**Params**  \n- `string` credential: The credential values.  \n  \n**Returns** `([string,string]|auth:Error)`   \n- A `string` tuple with the extracted username and password or `Error` occurred while extracting credentials  \n  \n"}},"insertText":"extractUsernameAndPassword(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(8, 1, -1, 'prepareError', FALSE, FALSE, FALSE, '{"label":"prepareError(string message, (()|error) err)(auth:Error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nLog and prepare `error` as a `Error`.\n  \n**Params**  \n- `string` message: Error message  \n- `(()|error)` err: `error` instance(Defaultable)  \n- `(()|error)` err: `error` instance  \n  \n**Returns** `auth:Error`   \n- Prepared `Error` instance  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(9, 1, -1, 'setAuthenticationContext', FALSE, FALSE, FALSE, '{"label":"setAuthenticationContext(string scheme, string authToken)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nSet the authentication context values to invocation context.\n  \n**Params**  \n- `string` scheme: Auth scheme (JWT, LDAP, OAuth2, Basic etc.)  \n- `string` authToken: Auth token (credential)"}},"insertText":"setAuthenticationContext(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(10, 1, -1, 'setPrincipal', FALSE, FALSE, FALSE, '{"label":"setPrincipal((string|()) userId, (string|()) username, (string[]|()) scopes, (map\u003cany\u003e|()) claims)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nSet the principal values to invocation context.\n  \n**Params**  \n- `(string|())` userId: User Id of the authenticated user.(Defaultable)  \n- `(string|())` userId: User Id of the authenticated user.  \n- `(string|())` username: Username of the authenticated user.(Defaultable)  \n- `(string|())` username: Username of the authenticated user.  \n- `(map\u003cany\u003e|())` claims: Claims of the authenticated user.(Defaultable)  \n- `(map\u003cany\u003e|())` claims: Claims of the authenticated user.  \n- `(string[]|())` scopes: Authenticated user scopes.(Defaultable)  \n- `(string[]|())` scopes: Authenticated user scopes."}},"insertText":"setPrincipal(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(11, 1, 1, 'InboundAuthProvider.authenticate', FALSE, FALSE, TRUE, '{"label":"authenticate(string credential)((boolean|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nAuthenticate with credential value passed.\n  \n**Params**  \n- `string` credential: Credential value  \n  \n**Returns** `(boolean|auth:Error)`   \n- True if authentication is a success, else false or `Error` if any error occurred  \n  \n"}},"insertText":"authenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(12, 1, 2, 'InboundBasicAuthProvider.authenticate', FALSE, FALSE, TRUE, '{"label":"authenticate(string credential)((boolean|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nAttempts to authenticate with credentials.\n  \n**Params**  \n- `string` credential: Credential  \n  \n**Returns** `(boolean|auth:Error)`   \n- `true` if authentication is successful, otherwise `false` or `Error` occurred while extracting credentials  \n  \n"}},"insertText":"authenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(13, 1, 2, 'InboundBasicAuthProvider.__init', FALSE, FALSE, TRUE, '{"label":"__init((auth:BasicAuthConfig|()) basicAuthConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nProvides authentication based on the provided configuration.\n  \n**Params**  \n- `(auth:BasicAuthConfig|())` basicAuthConfig: The Basic Auth provider configurations.(Defaultable)  \n- `(auth:BasicAuthConfig|())` basicAuthConfig: The Basic Auth provider configurations."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(14, 1, 3, 'OutboundAuthProvider.generateToken', FALSE, FALSE, TRUE, '{"label":"generateToken()((string|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nGenerates a token for the outbound request.\n  \n  \n  \n**Returns** `(string|auth:Error)`   \n- The String token or the `Error` occurred when generating the token.  \n  \n"}},"insertText":"generateToken()","insertTextFormat":"Snippet"}'),
(15, 1, 3, 'OutboundAuthProvider.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(map\u003canydata\u003e data)((string|()|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nInspects the incoming data and generates the token as needed.\n  \n**Params**  \n- `map\u003canydata\u003e` data: Map of the data, which is extracted from the HTTP response.  \n  \n**Returns** `(string|()|auth:Error)`   \n- The String token, the `Error` occurred when generating the token, or `()` if nothing is to be returned.  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(16, 1, 4, 'OutboundBasicAuthProvider.generateToken', FALSE, FALSE, TRUE, '{"label":"generateToken()((string|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nGenerates a token for Basic authentication.\n  \n  \n  \n**Returns** `(string|auth:Error)`   \n- The generated token or the `Error` if an error occurred during validation.  \n  \n"}},"insertText":"generateToken()","insertTextFormat":"Snippet"}'),
(17, 1, 4, 'OutboundBasicAuthProvider.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(map\u003canydata\u003e data)((string|()|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nInspects the incoming data and generates the token for Basic authentication.\n  \n**Params**  \n- `map\u003canydata\u003e` data: Map of the data, which is extracted from the HTTP response.  \n  \n**Returns** `(string|()|auth:Error)`   \n- The String token, the `Error` occurred when generating the token, or `()` if nothing is to be returned.  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(18, 1, 4, 'OutboundBasicAuthProvider.__init', FALSE, FALSE, TRUE, '{"label":"__init((auth:Credential|()) credential)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/auth_  \n  \nProvides authentication based on the provided Basic Auth configuration.\n  \n**Params**  \n- `(auth:Credential|())` credential: The credential configurations.(Defaultable)  \n- `(auth:Credential|())` credential: The credential configurations."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(19, 2, -1, 'runCacheExpiry', TRUE, FALSE, FALSE, '{"label":"runCacheExpiry()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nRemoves expired cache entries from all caches.  \n"}},"insertText":"runCacheExpiry();","insertTextFormat":"Snippet"}'),
(20, 2, -1, 'checkAndAdd', TRUE, FALSE, FALSE, '{"label":"checkAndAdd(int numberOfKeysToEvict, string[] cacheKeys, int[] timestamps, string key, int lastAccessTime)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nUtility function to identify which cache entries should be evicted.  \n"}},"insertText":"checkAndAdd(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(21, 2, 5, 'Cache.hasKey', FALSE, FALSE, TRUE, '{"label":"hasKey(string key)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nChecks whether the given key has an accociated cache value.\n  \n  \n  \n**Returns** `boolean`   \n- True if the given key has an associated value, false otherwise.  \n  \n"}},"insertText":"hasKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(22, 2, 5, 'Cache.size', FALSE, FALSE, TRUE, '{"label":"size()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nReturns the size of the cache.\n  \n  \n  \n**Returns** `int`   \n- The size of the cache  \n  \n"}},"insertText":"size()","insertTextFormat":"Snippet"}'),
(23, 2, 5, 'Cache.put', FALSE, FALSE, TRUE, '{"label":"put(string key, any value)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nAdds the given key, value pair to the provided cache.\n  \n**Params**  \n- `string` key: value which should be used as the key  \n- `any` value: value to be cached"}},"insertText":"put(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(24, 2, 5, 'Cache.evict', TRUE, FALSE, TRUE, '{"label":"evict()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nEvicts the cache when cache is full.  \n"}},"insertText":"evict();","insertTextFormat":"Snippet"}'),
(25, 2, 5, 'Cache.get', FALSE, FALSE, TRUE, '{"label":"get(string key)((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nReturns the cached value associated with the given key. If the provided cache key is not found,\n() will be returned.\n  \n**Params**  \n- `string` key: key which is used to retrieve the cached value  \n  \n**Returns** `(any|())`   \n- The cached value associated with the given key  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(26, 2, 5, 'Cache.remove', FALSE, FALSE, TRUE, '{"label":"remove(string key)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nRemoves a cached value from a cache.\n  \n**Params**  \n- `string` key: key of the cache entry which needs to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(27, 2, 5, 'Cache.keys', FALSE, FALSE, TRUE, '{"label":"keys()(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nReturns all keys from current cache.\n  \n  \n  \n**Returns** `string[]`   \n- all keys  \n  \n"}},"insertText":"keys()","insertTextFormat":"Snippet"}'),
(28, 2, 5, 'Cache.getLRUCacheKeys', TRUE, FALSE, TRUE, '{"label":"getLRUCacheKeys(int numberOfKeysToEvict)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \nReturns the key of the Least Recently Used cache entry. This is used to remove cache entries if the cache is\nfull.\n  \n  \n  \n**Returns** `string[]`   \n- number of keys to be evicted  \n  \n"}},"insertText":"getLRUCacheKeys(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(29, 2, 5, 'Cache.__init', FALSE, FALSE, TRUE, '{"label":"__init(int expiryTimeInMillis, int capacity, float evictionFactor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/cache_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(30, 3, -1, 'getAsString', FALSE, FALSE, FALSE, '{"label":"getAsString(string key, string defaultValue)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nRetrieves the specified configuration value as a string.\n  \n**Params**  \n- `string` key: The configuration to be retrieved  \n- `string` defaultValue: The default value to be use in case there is no mapping for the provided key(Defaultable)  \n- `string` defaultValue: The default value to be use in case there is no mapping for the provided key  \n  \n**Returns** `string`   \n- Configuration value mapped by the key  \n  \n"}},"insertText":"getAsString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(31, 3, -1, 'getAsInt', FALSE, FALSE, FALSE, '{"label":"getAsInt(string key, int defaultValue)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nRetrieves the specified configuration value as an int.\n  \n**Params**  \n- `string` key: The configuration to be retrieved  \n- `int` defaultValue: The default value to be use in case there is no mapping for the provided key(Defaultable)  \n- `int` defaultValue: The default value to be use in case there is no mapping for the provided key  \n  \n**Returns** `int`   \n- Configuration value mapped by the key  \n  \n"}},"insertText":"getAsInt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(32, 3, -1, 'getAsFloat', FALSE, FALSE, FALSE, '{"label":"getAsFloat(string key, float defaultVal)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nRetrieves the specified configuration value as a float.\n  \n**Params**  \n- `string` key: The configuration to be retrieved  \n- `float` defaultVal: The default value to be use in case there is no mapping for the provided key(Defaultable)  \n- `float` defaultVal: The default value to be use in case there is no mapping for the provided key  \n  \n**Returns** `float`   \n- Configuration value mapped by the key  \n  \n"}},"insertText":"getAsFloat(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(33, 3, -1, 'getAsBoolean', FALSE, FALSE, FALSE, '{"label":"getAsBoolean(string key, boolean defaultValue)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nRetrieves the specified configuration value as a boolean.\n  \n**Params**  \n- `string` key: The configuration to be retrieved  \n- `boolean` defaultValue: The default value to be use in case there is no mapping for the provided key(Defaultable)  \n- `boolean` defaultValue: The default value to be use in case there is no mapping for the provided key  \n  \n**Returns** `boolean`   \n- Configuration value mapped by the key  \n  \n"}},"insertText":"getAsBoolean(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(34, 3, -1, 'getAsMap', FALSE, FALSE, FALSE, '{"label":"getAsMap(string key)(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nRetrieves the specified configuration value as a map. If there is no mapping, an empty map will be returned.\n  \n**Params**  \n- `string` key: The configuration to be retrieved  \n  \n**Returns** `map\u003cany\u003e`   \n- Configuration value mapped by the key  \n  \n"}},"insertText":"getAsMap(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(35, 3, -1, 'lookupEnvVar', TRUE, FALSE, FALSE, '{"label":"lookupEnvVar(string key)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"lookupEnvVar(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(36, 3, -1, 'contains', FALSE, FALSE, FALSE, '{"label":"contains(string key)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nChecks whether the given key is in the configuration registry.\n  \n**Params**  \n- `string` key: The configuration key to be looked-up  \n  \n**Returns** `boolean`   \n- Returns true if the key is present; if not returs false  \n  \n"}},"insertText":"contains(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(37, 3, -1, 'setConfig', FALSE, FALSE, FALSE, '{"label":"setConfig(string key, (string|int|float|boolean) value)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \nSets the specified key/value pair as a configuration.\n  \n**Params**  \n- `string` key: The key of the configuration value to be set  \n- `(string|int|float|boolean)` value: The configuration value to be set"}},"insertText":"setConfig(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(38, 3, -1, 'get', TRUE, FALSE, FALSE, '{"label":"get(string key, (STRING|INT|FLOAT|BOOLEAN|MAP|ARRAY) vType)((string|int|float|boolean|map\u003cany\u003e))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/config_  \n  \n  \n  \n  \n**Returns** `(string|int|float|boolean|map\u003cany\u003e)`   \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(39, 4, -1, 'hashMd5', FALSE, FALSE, FALSE, '{"label":"hashMd5(byte[] input)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the MD5 hash of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n  \n**Returns** `byte[]`   \n- Hashed output  \n  \n"}},"insertText":"hashMd5(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(40, 4, -1, 'hashSha1', FALSE, FALSE, FALSE, '{"label":"hashSha1(byte[] input)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the SHA-1 hash of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n  \n**Returns** `byte[]`   \n- Hashed output  \n  \n"}},"insertText":"hashSha1(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(41, 4, -1, 'hashSha256', FALSE, FALSE, FALSE, '{"label":"hashSha256(byte[] input)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the SHA-256 hash of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n  \n**Returns** `byte[]`   \n- Hashed output  \n  \n"}},"insertText":"hashSha256(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(42, 4, -1, 'hashSha384', FALSE, FALSE, FALSE, '{"label":"hashSha384(byte[] input)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the SHA-384 hash of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n  \n**Returns** `byte[]`   \n- Hashed output  \n  \n"}},"insertText":"hashSha384(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(43, 4, -1, 'hashSha512', FALSE, FALSE, FALSE, '{"label":"hashSha512(byte[] input)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the SHA-512 hash of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n  \n**Returns** `byte[]`   \n- Hashed output  \n  \n"}},"insertText":"hashSha512(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(44, 4, -1, 'hmacMd5', FALSE, FALSE, FALSE, '{"label":"hmacMd5(byte[] input, byte[] key)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the HMAC using MD-5 hash function of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n- `byte[]` key: Key used for HMAC generation  \n  \n**Returns** `byte[]`   \n- HMAC output  \n  \n"}},"insertText":"hmacMd5(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(45, 4, -1, 'hmacSha1', FALSE, FALSE, FALSE, '{"label":"hmacSha1(byte[] input, byte[] key)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the HMAC using SHA-1 hash function of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n- `byte[]` key: Key used for HMAC generation  \n  \n**Returns** `byte[]`   \n- HMAC output  \n  \n"}},"insertText":"hmacSha1(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(46, 4, -1, 'hmacSha256', FALSE, FALSE, FALSE, '{"label":"hmacSha256(byte[] input, byte[] key)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the HMAC using SHA-256 hash function of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n- `byte[]` key: Key used for HMAC generation  \n  \n**Returns** `byte[]`   \n- HMAC output  \n  \n"}},"insertText":"hmacSha256(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(47, 4, -1, 'hmacSha384', FALSE, FALSE, FALSE, '{"label":"hmacSha384(byte[] input, byte[] key)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the HMAC using SHA-384 hash function of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n- `byte[]` key: Key used for HMAC generation  \n  \n**Returns** `byte[]`   \n- HMAC output  \n  \n"}},"insertText":"hmacSha384(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(48, 4, -1, 'hmacSha512', FALSE, FALSE, FALSE, '{"label":"hmacSha512(byte[] input, byte[] key)(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns the HMAC using SHA-512 hash function of the given data.\n  \n**Params**  \n- `byte[]` input: Value to be hashed  \n- `byte[]` key: Key used for HMAC generation  \n  \n**Returns** `byte[]`   \n- HMAC output  \n  \n"}},"insertText":"hmacSha512(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(49, 4, -1, 'crc32b', FALSE, FALSE, FALSE, '{"label":"crc32b(byte[] input)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns Hex encoded CRC32B value for the provided element.\n  \n**Params**  \n- `byte[]` input: Value for checksum generation  \n  \n**Returns** `string`   \n- The generated checksum  \n  \n"}},"insertText":"crc32b(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(50, 4, -1, 'signRsaMd5', FALSE, FALSE, FALSE, '{"label":"signRsaMd5(byte[] input, crypto:PrivateKey privateKey)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA-MD5 based signature value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be signed  \n- `crypto:PrivateKey` privateKey: Private key used for signing  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- The generated signature or `Error` if private key is invalid  \n  \n"}},"insertText":"signRsaMd5(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(51, 4, -1, 'signRsaSha1', FALSE, FALSE, FALSE, '{"label":"signRsaSha1(byte[] input, crypto:PrivateKey privateKey)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA-SHA1 based signature value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be signed  \n- `crypto:PrivateKey` privateKey: Private key used for signing  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- The generated signature or `Error` if private key is invalid  \n  \n"}},"insertText":"signRsaSha1(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(52, 4, -1, 'signRsaSha256', FALSE, FALSE, FALSE, '{"label":"signRsaSha256(byte[] input, crypto:PrivateKey privateKey)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA-SHA256 based signature value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be signed  \n- `crypto:PrivateKey` privateKey: Private key used for signing  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- The generated signature or `Error` if private key is invalid  \n  \n"}},"insertText":"signRsaSha256(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(53, 4, -1, 'signRsaSha384', FALSE, FALSE, FALSE, '{"label":"signRsaSha384(byte[] input, crypto:PrivateKey privateKey)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA-SHA384 based signature value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be signed  \n- `crypto:PrivateKey` privateKey: Private key used for signing.  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- The generated signature or `Error` if private key is invalid  \n  \n"}},"insertText":"signRsaSha384(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(54, 4, -1, 'signRsaSha512', FALSE, FALSE, FALSE, '{"label":"signRsaSha512(byte[] input, crypto:PrivateKey privateKey)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA-SHA512 based signature value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be signed  \n- `crypto:PrivateKey` privateKey: Private key used for signing  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- The generated signature or `Error` if private key is invalid  \n  \n"}},"insertText":"signRsaSha512(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(55, 4, -1, 'verifyRsaMd5Signature', FALSE, FALSE, FALSE, '{"label":"verifyRsaMd5Signature(byte[] data, byte[] signature, crypto:PublicKey publicKey)((boolean|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nVerify RSA-MD5 based signature.\n  \n**Params**  \n- `byte[]` data: The content to be verified  \n- `byte[]` signature: Signature value  \n- `crypto:PublicKey` publicKey: Public key used for verification  \n  \n**Returns** `(boolean|crypto:Error)`   \n- Validity of the signature or `Error` if public key is invalid  \n  \n"}},"insertText":"verifyRsaMd5Signature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(56, 4, -1, 'verifyRsaSha1Signature', FALSE, FALSE, FALSE, '{"label":"verifyRsaSha1Signature(byte[] data, byte[] signature, crypto:PublicKey publicKey)((boolean|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nVerify RSA-SHA1 based signature.\n  \n**Params**  \n- `byte[]` data: The content to be verified  \n- `byte[]` signature: Signature value  \n- `crypto:PublicKey` publicKey: Public key used for verification  \n  \n**Returns** `(boolean|crypto:Error)`   \n- Validity of the signature or `Error` if public key is invalid  \n  \n"}},"insertText":"verifyRsaSha1Signature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(57, 4, -1, 'verifyRsaSha256Signature', FALSE, FALSE, FALSE, '{"label":"verifyRsaSha256Signature(byte[] data, byte[] signature, crypto:PublicKey publicKey)((boolean|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nVerify RSA-SHA256 based signature.\n  \n**Params**  \n- `byte[]` data: The content to be verified  \n- `byte[]` signature: Signature value  \n- `crypto:PublicKey` publicKey: Public key used for verification  \n  \n**Returns** `(boolean|crypto:Error)`   \n- Validity of the signature or `Error` if public key is invalid  \n  \n"}},"insertText":"verifyRsaSha256Signature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(58, 4, -1, 'verifyRsaSha384Signature', FALSE, FALSE, FALSE, '{"label":"verifyRsaSha384Signature(byte[] data, byte[] signature, crypto:PublicKey publicKey)((boolean|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nVerify RSA-SHA384 based signature.\n  \n**Params**  \n- `byte[]` data: The content to be verified  \n- `byte[]` signature: Signature value  \n- `crypto:PublicKey` publicKey: Public key used for verification  \n  \n**Returns** `(boolean|crypto:Error)`   \n- Validity of the signature or `Error` if public key is invalid  \n  \n"}},"insertText":"verifyRsaSha384Signature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(59, 4, -1, 'verifyRsaSha512Signature', FALSE, FALSE, FALSE, '{"label":"verifyRsaSha512Signature(byte[] data, byte[] signature, crypto:PublicKey publicKey)((boolean|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nVerify RSA-SHA512 based signature.\n  \n**Params**  \n- `byte[]` data: The content to be verified  \n- `byte[]` signature: Signature value  \n- `crypto:PublicKey` publicKey: Public key used for verification  \n  \n**Returns** `(boolean|crypto:Error)`   \n- Validity of the signature or `Error` if public key is invalid  \n  \n"}},"insertText":"verifyRsaSha512Signature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(60, 4, -1, 'decodePrivateKey', FALSE, FALSE, FALSE, '{"label":"decodePrivateKey((crypto:KeyStore|crypto:TrustStore) keyStore, string keyAlias, string keyPassword)((crypto:PrivateKey|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nRead a private key from the provided PKCS#12 archive file.\n  \n**Params**  \n- `(crypto:KeyStore|crypto:TrustStore)` keyStore: Key store or Trust store configuration  \n- `string` keyAlias: Key alias  \n- `string` keyPassword: Key password  \n  \n**Returns** `(crypto:PrivateKey|crypto:Error)`   \n- Reference to the private key or `Error` if private key was unreadable  \n  \n"}},"insertText":"decodePrivateKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(61, 4, -1, 'decodePublicKey', FALSE, FALSE, FALSE, '{"label":"decodePublicKey((crypto:KeyStore|crypto:TrustStore) keyStore, string keyAlias)((crypto:PublicKey|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nRead a public key from the provided PKCS#12 archive file.\n  \n**Params**  \n- `(crypto:KeyStore|crypto:TrustStore)` keyStore: Key store or Trust store configuration  \n- `string` keyAlias: Key alias  \n  \n**Returns** `(crypto:PublicKey|crypto:Error)`   \n- Reference to the public key or `Error` if private key was unreadable  \n  \n"}},"insertText":"decodePublicKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(62, 4, -1, 'encryptRsaEcb', FALSE, FALSE, FALSE, '{"label":"encryptRsaEcb(byte[] input, (crypto:PrivateKey|crypto:PublicKey) key, (PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA encrypted value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be encrypted  \n- `(crypto:PrivateKey|crypto:PublicKey)` key: Private or public key used for encryption  \n- `(PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1)` padding: The padding(Defaultable)  \n- `(PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Encrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"encryptRsaEcb(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(63, 4, -1, 'encryptAesCbc', FALSE, FALSE, FALSE, '{"label":"encryptAesCbc(byte[] input, byte[] key, byte[] iv, (NONE|PKCS5) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES CBC encrypted value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be encrypted  \n- `byte[]` key: Encryption key  \n- `byte[]` iv: Initialization vector  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Encrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"encryptAesCbc(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(64, 4, -1, 'encryptAesEcb', FALSE, FALSE, FALSE, '{"label":"encryptAesEcb(byte[] input, byte[] key, (NONE|PKCS5) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES ECB encrypted value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be encrypted  \n- `byte[]` key: Encryption key  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Encrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"encryptAesEcb(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(65, 4, -1, 'encryptAesGcm', FALSE, FALSE, FALSE, '{"label":"encryptAesGcm(byte[] input, byte[] key, byte[] iv, (NONE|PKCS5) padding, int tagSize)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES GCM encrypted value for the given data.\n  \n**Params**  \n- `byte[]` input: The content to be encrypted  \n- `byte[]` key: Encryption key  \n- `byte[]` iv: Initialization vector  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n- `int` tagSize: Tag size(Defaultable)  \n- `int` tagSize: Tag size  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Encrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"encryptAesGcm(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(66, 4, -1, 'decryptRsaEcb', FALSE, FALSE, FALSE, '{"label":"decryptRsaEcb(byte[] input, (crypto:PrivateKey|crypto:PublicKey) key, (PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns RSA decrypted value for the given RSA encrypted data.\n  \n**Params**  \n- `byte[]` input: The content to be decrypted  \n- `(crypto:PrivateKey|crypto:PublicKey)` key: Private or public key used for encryption  \n- `(PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1)` padding: The padding(Defaultable)  \n- `(PKCS1|OAEPwithMD5andMGF1|OAEPWithSHA1AndMGF1|OAEPWithSHA256AndMGF1|OAEPwithSHA384andMGF1|OAEPwithSHA512andMGF1)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Decrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"decryptRsaEcb(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(67, 4, -1, 'decryptAesCbc', FALSE, FALSE, FALSE, '{"label":"decryptAesCbc(byte[] input, byte[] key, byte[] iv, (NONE|PKCS5) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES CBC decrypted value for the given AES CBC encrypted data.\n  \n**Params**  \n- `byte[]` input: The content to be decrypted  \n- `byte[]` key: Encryption key  \n- `byte[]` iv: Initialization vector  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Decrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"decryptAesCbc(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(68, 4, -1, 'decryptAesEcb', FALSE, FALSE, FALSE, '{"label":"decryptAesEcb(byte[] input, byte[] key, (NONE|PKCS5) padding)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES ECB decrypted value for the given AES ECB encrypted data.\n  \n**Params**  \n- `byte[]` input: The content to be decrypted  \n- `byte[]` key: Encryption key  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Decrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"decryptAesEcb(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(69, 4, -1, 'decryptAesGcm', FALSE, FALSE, FALSE, '{"label":"decryptAesGcm(byte[] input, byte[] key, byte[] iv, (NONE|PKCS5) padding, int tagSize)((byte[]|crypto:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/crypto_  \n  \nReturns AES GCM decrypted value for the given AES GCM encrypted data.\n  \n**Params**  \n- `byte[]` input: The content to be decrypted  \n- `byte[]` key: Encryption key  \n- `byte[]` iv: Initialization vector  \n- `(NONE|PKCS5)` padding: The padding(Defaultable)  \n- `(NONE|PKCS5)` padding: The padding  \n- `int` tagSize: Tag size(Defaultable)  \n- `int` tagSize: Tag size  \n  \n**Returns** `(byte[]|crypto:Error)`   \n- Decrypted data or `Error` if key is invalid  \n  \n"}},"insertText":"decryptAesGcm(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(70, 5, -1, 'encodeBase64', FALSE, FALSE, FALSE, '{"label":"encodeBase64(byte[] input)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nReturns the Base64 encoded `string` value of the given byte array.\n  \n**Params**  \n- `byte[]` input: Value to be encoded  \n  \n**Returns** `string`   \n- Encoded output  \n  \n"}},"insertText":"encodeBase64(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(71, 5, -1, 'decodeBase64', FALSE, FALSE, FALSE, '{"label":"decodeBase64(string input)((byte[]|encoding:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nDecode Base64 encoded `string` into byte array.\n  \n**Params**  \n- `string` input: Value to be decoded  \n  \n**Returns** `(byte[]|encoding:Error)`   \n- Decoded output or `Error` if input is not a valid Base64 value  \n  \n"}},"insertText":"decodeBase64(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(72, 5, -1, 'encodeBase64Url', FALSE, FALSE, FALSE, '{"label":"encodeBase64Url(byte[] input)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nReturns the Base64 URL encoded `string` value of the given byte array.\n  \n**Params**  \n- `byte[]` input: Value to be encoded  \n  \n**Returns** `string`   \n- Encoded output  \n  \n"}},"insertText":"encodeBase64Url(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(73, 5, -1, 'decodeBase64Url', FALSE, FALSE, FALSE, '{"label":"decodeBase64Url(string input)((byte[]|encoding:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nDecode Base64 URL encoded `string` into byte array.\n  \n**Params**  \n- `string` input: Value to be decoded  \n  \n**Returns** `(byte[]|encoding:Error)`   \n- Decoded output or `Error` if input is not a valid Base64 URL encoded value  \n  \n"}},"insertText":"decodeBase64Url(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(74, 5, -1, 'encodeHex', FALSE, FALSE, FALSE, '{"label":"encodeHex(byte[] input)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nReturns the Hex encoded `string` value of the given byte array.\n  \n**Params**  \n- `byte[]` input: Value to be encoded  \n  \n**Returns** `string`   \n- Encoded output  \n  \n"}},"insertText":"encodeHex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(75, 5, -1, 'decodeHex', FALSE, FALSE, FALSE, '{"label":"decodeHex(string input)((byte[]|encoding:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nDecode Hex encoded `string` into byte array.\n  \n**Params**  \n- `string` input: Value to be decoded  \n  \n**Returns** `(byte[]|encoding:Error)`   \n- Decoded output or `Error` if input is not a valid Hex value  \n  \n"}},"insertText":"decodeHex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(76, 5, -1, 'byteArrayToString', FALSE, FALSE, FALSE, '{"label":"byteArrayToString(byte[] content, string encoding)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/encoding_  \n  \nConverts given byte array to a string.\n  \n**Params**  \n- `byte[]` content: Byte array content to be converted  \n- `string` encoding: Encoding to used in byte array conversion to string(Defaultable)  \n- `string` encoding: Encoding to used in byte array conversion to string  \n  \n**Returns** `string`   \n- String representation of the given byte array  \n  \n"}},"insertText":"byteArrayToString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(77, 6, -1, 'getCurrentDirectory', FALSE, FALSE, FALSE, '{"label":"getCurrentDirectory()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns the current working directory.\n  \n  \n  \n**Returns** `string`   \n- Current working directory or an empty string if the current working directory cannot be determined  \n  \n"}},"insertText":"getCurrentDirectory()","insertTextFormat":"Snippet"}'),
(78, 6, -1, 'exists', FALSE, FALSE, FALSE, '{"label":"exists(string path)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReports whether file or directory exists for the given the path.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `boolean`   \n- True if path is absolute, else false  \n  \n"}},"insertText":"exists(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(79, 6, -1, 'createDir', FALSE, FALSE, FALSE, '{"label":"createDir(string dir, boolean parentDirs)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nCreates a new directory with the specified file name.\nIf parentDirs flag is true, Creates a directory in specified path with any necessary parents.\n  \n**Params**  \n- `string` dir: directory name.  \n- `boolean` parentDirs: Indicates whether the `createDir` should create non-existing parent directories.(Defaultable)  \n- `boolean` parentDirs: Indicates whether the `createDir` should create non-existing parent directories.  \n  \n**Returns** `(string|error)`   \n- Returns absolute path value of the created directory or an `Error` if failed  \n  \n"}},"insertText":"createDir(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(80, 6, -1, 'remove', FALSE, FALSE, FALSE, '{"label":"remove(string path, boolean recursive)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nRemoves the specified file or directory.\nIf recursive flag is true, Removes the path and any children it contains.\n  \n**Params**  \n- `string` path: String value of file/directory path.  \n- `boolean` recursive: Indicates whether the `remove` should recursively remove all the file inside the given directory.(Defaultable)  \n- `boolean` recursive: Indicates whether the `remove` should recursively remove all the file inside the given directory.  \n  \n**Returns** `(()|error)`   \n- Returns an `Error` if failed to remove.  \n  \n"}},"insertText":"remove(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(81, 6, -1, 'rename', FALSE, FALSE, FALSE, '{"label":"rename(string oldPath, string newPath)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nRenames(Moves) old path to new path.\nIf new path already exists and it is not a directory, this replaces the file.\n  \n**Params**  \n- `string` oldPath: String value of old file path.  \n- `string` newPath: String value of new file path.  \n  \n**Returns** `(()|error)`   \n- Returns an `Error` if failed to rename.  \n  \n"}},"insertText":"rename(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(82, 6, -1, 'tempDir', FALSE, FALSE, FALSE, '{"label":"tempDir()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns the default directory to use for temporary files.\n  \n  \n  \n**Returns** `string`   \n- Temporary directory location.  \n  \n"}},"insertText":"tempDir()","insertTextFormat":"Snippet"}'),
(83, 6, -1, 'createFile', FALSE, FALSE, FALSE, '{"label":"createFile(string path)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nCreates a file in specified file path.\nTruncates if file already exists in the given path.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|error)`   \n- Returns absolute path value of the created file or an `Error` if failed  \n  \n"}},"insertText":"createFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(84, 6, -1, 'getFileInfo', FALSE, FALSE, FALSE, '{"label":"getFileInfo(string path)((file:FileInfo|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns metadata information of the file specified in file path.\n  \n**Params**  \n- `string` path: String value of the file path.  \n  \n**Returns** `(file:FileInfo|error)`   \n- Returns FileInfo instance with file metadata or an `Error`  \n  \n"}},"insertText":"getFileInfo(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(85, 6, -1, 'readDir', FALSE, FALSE, FALSE, '{"label":"readDir(string path, int maxDepth)((file:FileInfo[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReads the directory and returns a list of files and directories # inside the specified directory\n  \n**Params**  \n- `string` path: String value of directory path.  \n- `int` maxDepth: The maximum number of directory levels to visit. -1 to indicate that all levels should be visited.(Defaultable)  \n- `int` maxDepth: The maximum number of directory levels to visit. -1 to indicate that all levels should be visited.  \n  \n**Returns** `(file:FileInfo[]|error)`   \n- Returns FileInfo array or an `Error` if there is an error while changing the mode.  \n  \n"}},"insertText":"readDir(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(86, 6, -1, 'copy', FALSE, FALSE, FALSE, '{"label":"copy(string sourcePath, string destinationPath, boolean replaceExisting)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nCopy file/directory in old path to new path.\nIf new path already exists, this replaces the file.\n  \n**Params**  \n- `string` sourcePath: String value of old file path.  \n- `string` destinationPath: String value of new file path.  \n- `boolean` replaceExisting: Flag to allow replace if file already exists in destination path.(Defaultable)  \n- `boolean` replaceExisting: Flag to allow replace if file already exists in destination path.  \n  \n**Returns** `(()|error)`   \n- Returns an `Error` if failed to rename.  \n  \n"}},"insertText":"copy(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(87, 6, 6, 'FileInfo.getName', FALSE, FALSE, TRUE, '{"label":"getName()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns the file name.\n  \n  \n  \n**Returns** `string`   \n- the file name  \n  \n"}},"insertText":"getName()","insertTextFormat":"Snippet"}'),
(88, 6, 6, 'FileInfo.getSize', FALSE, FALSE, TRUE, '{"label":"getSize()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns the file size.\n  \n  \n  \n**Returns** `int`   \n- the file size  \n  \n"}},"insertText":"getSize()","insertTextFormat":"Snippet"}'),
(89, 6, 6, 'FileInfo.getLastModifiedTime', FALSE, FALSE, TRUE, '{"label":"getLastModifiedTime()(time:Time)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns last modified time of the file.\n  \n  \n  \n**Returns** `time:Time`   \n- Last modified time of the file.  \n  \n"}},"insertText":"getLastModifiedTime()","insertTextFormat":"Snippet"}'),
(90, 6, 6, 'FileInfo.isDir', FALSE, FALSE, TRUE, '{"label":"isDir()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \nReturns whether the file is a directory.\n  \n  \n  \n**Returns** `boolean`   \n- File is a directory or not.  \n  \n"}},"insertText":"isDir()","insertTextFormat":"Snippet"}'),
(91, 6, 6, 'FileInfo.__init', FALSE, FALSE, TRUE, '{"label":"__init(string name, int size, time:Time modifiedTime, boolean dir)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/file_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(92, 7, -1, 'absolute', FALSE, FALSE, FALSE, '{"label":"absolute(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nRetrieves the absolute path from the provided location.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- The absolute path reference or an error if the path cannot be derived  \n  \n"}},"insertText":"absolute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(93, 7, -1, 'getPathSeparator', FALSE, FALSE, FALSE, '{"label":"getPathSeparator()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns path separator of underline operating system.\n  \n  \n  \n**Returns** `string`   \n- String value of path separator  \n  \n"}},"insertText":"getPathSeparator()","insertTextFormat":"Snippet"}'),
(94, 7, -1, 'getPathListSeparator', FALSE, FALSE, FALSE, '{"label":"getPathListSeparator()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns path list separator of underline operating system.\n  \n  \n  \n**Returns** `string`   \n- String value of path list separator  \n  \n"}},"insertText":"getPathListSeparator()","insertTextFormat":"Snippet"}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(95, 7, -1, 'isAbsolute', FALSE, FALSE, FALSE, '{"label":"isAbsolute(string path)((boolean|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReports whether the path is absolute.\nA path is absolute if it is independent of the current directory.\nOn Unix, a path is absolute if it starts with the root.\nOn Windows, a path is absolute if it has a prefix and starts with the root: c:\\windows is absolute\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(boolean|filepath:Error)`   \n- True if path is absolute, else false  \n  \n"}},"insertText":"isAbsolute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(96, 7, -1, 'filename', FALSE, FALSE, FALSE, '{"label":"filename(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nRetrieves the base name of the file from the provided location.\nThe last element of path.\nTrailing path separators are removed before extracting the last element.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Returns the name of the file  \n  \n"}},"insertText":"filename(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(97, 7, -1, 'parent', FALSE, FALSE, FALSE, '{"label":"parent(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns the enclosing parent directory.\nIf the path is empty, parent returns \".\".\nThe returned path does not end in a separator unless it is the root directory.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Path of parent folder or error occurred while getting parent directory  \n  \n"}},"insertText":"parent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(98, 7, -1, 'normalize', FALSE, FALSE, FALSE, '{"label":"normalize(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns the shortest path name equivalent to path by purely lexical processing.\nReplace multiple Separator elements with a single one.\nEliminate each . path name element (the current directory).\nEliminate each inner .. path name element (the parent directory)\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Normalized file path  \n  \n"}},"insertText":"normalize(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(99, 7, -1, 'split', FALSE, FALSE, FALSE, '{"label":"split(string path)((string[]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nSplits a list of paths joined by the OS-specific Path Separator.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string[]|filepath:Error)`   \n- String array of part components  \n  \n"}},"insertText":"split(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(100, 7, -1, 'build', FALSE, FALSE, FALSE, '{"label":"build(...string)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nJoins any number of path elements into a single path\n  \n**Params**  \n- parts: String values of file path parts.  \n  \n**Returns** `(string|filepath:Error)`   \n- String value of file path.  \n  \n"}},"insertText":"build(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(101, 7, -1, 'isReservedName', FALSE, FALSE, FALSE, '{"label":"isReservedName(string name)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReports whether the filename is reserved.\nReserved words only exist in windows.\n  \n**Params**  \n- `string` name: filename  \n  \n**Returns** `boolean`   \n- true, if path is Windows reserved name.  \n  \n"}},"insertText":"isReservedName(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(102, 7, -1, 'extension', FALSE, FALSE, FALSE, '{"label":"extension(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nRetrieves the extension of the file path.\nThe extension is the suffix beginning at the final dot in the final element of path.\nit is empty if there is no dot.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Returns the extension of the file. Empty string if no extension.  \n  \n"}},"insertText":"extension(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(103, 7, -1, 'relative', FALSE, FALSE, FALSE, '{"label":"relative(string base, string target)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns a relative path that is logically equivalent to target path when joined to base path with an intervening\nseparator.\nAn error is returned if target path can\u0027t be made relative to base path.\n  \n**Params**  \n- `string` base: String value of the base file path.  \n- `string` target: String value of the target file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Returns the extension of the file. Empty string if no extension.  \n  \n"}},"insertText":"relative(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(104, 7, -1, 'resolve', FALSE, FALSE, FALSE, '{"label":"resolve(string path)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns the filepath after the evaluation of any symbolic links.\nIf path is relative, the result will be relative to the current directory,\nunless one of the components is an absolute symbolic link.\nResolve calls normalize on the result.\n  \n**Params**  \n- `string` path: String value of file path.  \n  \n**Returns** `(string|filepath:Error)`   \n- Resolved file path  \n  \n"}},"insertText":"resolve(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(105, 7, -1, 'matches', FALSE, FALSE, FALSE, '{"label":"matches(string path, string pattern)((boolean|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReports whether all of filename matches the provided pattern, not just a substring.\nAn error is returned if the pattern is malformed.\n  \n**Params**  \n- `string` path: String value of the file path.  \n- `string` pattern: String value of the target file path.  \n  \n**Returns** `(boolean|filepath:Error)`   \n- True if filename of the path matches with the pattern, else false  \n  \n"}},"insertText":"matches(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(106, 7, -1, 'parse', TRUE, FALSE, FALSE, '{"label":"parse(string input)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nParses the give path and remove redundent slashes.\n  \n**Params**  \n- `string` input: string path value  \n  \n**Returns** `(string|filepath:Error)`   \n- parsed path,error if given path is invalid.  \n  \n"}},"insertText":"parse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(107, 7, -1, 'getRoot', TRUE, FALSE, FALSE, '{"label":"getRoot(string input)(([string,int]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `([string,int]|filepath:Error)`   \n  \n"}},"insertText":"getRoot(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(108, 7, -1, 'isSlash', TRUE, FALSE, FALSE, '{"label":"isSlash(string c)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isSlash(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(109, 7, -1, 'nextNonSlashIndex', TRUE, FALSE, FALSE, '{"label":"nextNonSlashIndex(string path, int offset, int end)((int|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(int|filepath:Error)`   \n  \n"}},"insertText":"nextNonSlashIndex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(110, 7, -1, 'nextSlashIndex', TRUE, FALSE, FALSE, '{"label":"nextSlashIndex(string path, int offset, int end)((int|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(int|filepath:Error)`   \n  \n"}},"insertText":"nextSlashIndex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(111, 7, -1, 'isLetter', TRUE, FALSE, FALSE, '{"label":"isLetter(string c)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isLetter(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(112, 7, -1, 'isUNC', TRUE, FALSE, FALSE, '{"label":"isUNC(string path)((boolean|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(boolean|filepath:Error)`   \n  \n"}},"insertText":"isUNC(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(113, 7, -1, 'isEmpty', TRUE, FALSE, FALSE, '{"label":"isEmpty(string path)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isEmpty(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(114, 7, -1, 'getOffsetIndexes', TRUE, FALSE, FALSE, '{"label":"getOffsetIndexes(string path)((int[]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(int[]|filepath:Error)`   \n  \n"}},"insertText":"getOffsetIndexes(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(115, 7, -1, 'charAt', TRUE, FALSE, FALSE, '{"label":"charAt(string input, int index)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(string|filepath:Error)`   \n  \n"}},"insertText":"charAt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(116, 7, -1, 'isSamePath', TRUE, FALSE, FALSE, '{"label":"isSamePath(string base, string target)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isSamePath(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(117, 7, -1, 'prepareError', FALSE, FALSE, FALSE, '{"label":"prepareError(string message, (()|error) err)(filepath:Error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nPrepare the `error` as an `Error`.\n  \n**Params**  \n- `string` message: The error message.  \n- `(()|error)` err: The `error` instance.(Defaultable)  \n- `(()|error)` err: The `error` instance.  \n  \n**Returns** `filepath:Error`   \n- Prepared `Error` instance.  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(118, 7, -1, 'buildUnixPath', TRUE, FALSE, FALSE, '{"label":"buildUnixPath(...string)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(string|filepath:Error)`   \n  \n"}},"insertText":"buildUnixPath(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(119, 7, -1, 'getUnixRoot', TRUE, FALSE, FALSE, '{"label":"getUnixRoot(string input)(([string,int]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `([string,int]|filepath:Error)`   \n  \n"}},"insertText":"getUnixRoot(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(120, 7, -1, 'getUnixOffsetIndex', TRUE, FALSE, FALSE, '{"label":"getUnixOffsetIndex(string path)((int[]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(int[]|filepath:Error)`   \n  \n"}},"insertText":"getUnixOffsetIndex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(121, 7, -1, 'isPosixSlash', TRUE, FALSE, FALSE, '{"label":"isPosixSlash((string|byte) c)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isPosixSlash(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(122, 7, -1, 'parsePosixPath', TRUE, FALSE, FALSE, '{"label":"parsePosixPath(string input, int off)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(string|filepath:Error)`   \n  \n"}},"insertText":"parsePosixPath(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(123, 7, -1, 'isWindowsReservedName', TRUE, FALSE, FALSE, '{"label":"isWindowsReservedName(string path)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isWindowsReservedName(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(124, 7, -1, 'buildWindowsPath', TRUE, FALSE, FALSE, '{"label":"buildWindowsPath(...string)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(string|filepath:Error)`   \n  \n"}},"insertText":"buildWindowsPath(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(125, 7, -1, 'getWindowsRoot', TRUE, FALSE, FALSE, '{"label":"getWindowsRoot(string input)(([string,int]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `([string,int]|filepath:Error)`   \n  \n"}},"insertText":"getWindowsRoot(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(126, 7, -1, 'getWindowsOffsetIndex', TRUE, FALSE, FALSE, '{"label":"getWindowsOffsetIndex(string path)((int[]|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(int[]|filepath:Error)`   \n  \n"}},"insertText":"getWindowsOffsetIndex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(127, 7, -1, 'isWindowsSlash', TRUE, FALSE, FALSE, '{"label":"isWindowsSlash(string c)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isWindowsSlash(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(128, 7, -1, 'getVolumnNameLength', TRUE, FALSE, FALSE, '{"label":"getVolumnNameLength(string path)((int|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \nReturns length of windows volumn length.\nIf volumn doesn\u0027t exist, return 0\n  \n**Params**  \n- `string` path: string path value  \n  \n**Returns** `(int|filepath:Error)`   \n- windows volumn length  \n  \n"}},"insertText":"getVolumnNameLength(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(129, 7, -1, 'parseWindowsPath', TRUE, FALSE, FALSE, '{"label":"parseWindowsPath(string path, int off)((string|filepath:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/filepath_  \n  \n  \n  \n  \n**Returns** `(string|filepath:Error)`   \n  \n"}},"insertText":"parseWindowsPath(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(130, 8, -1, 'prepareError', FALSE, FALSE, FALSE, '{"label":"prepareError(({ballerina/grpc}CancelledError|{ballerina/grpc}UnKnownError|{ballerina/grpc}InvalidArgumentError|{ballerina/grpc}DeadlineExceededError|{ballerina/grpc}NotFoundError|{ballerina/grpc}AleadyExistsError|{ballerina/grpc}PermissionDeniedError|{ballerina/grpc}UnauthenticatedError|{ballerina/grpc}ResourceExhaustedError|{ballerina/grpc}FailedPreconditionError|{ballerina/grpc}AbortedError|{ballerina/grpc}OutOfRangeError|{ballerina/grpc}UnimplementedError|{ballerina/grpc}InternalError|{ballerina/grpc}UnavailableError|{ballerina/grpc}DataLossError) errorType, string message, error other)((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nPrepare the `error` as a `Error`.\n  \n**Params**  \n- `({ballerina/grpc}CancelledError|{ballerina/grpc}UnKnownError|{ballerina/grpc}InvalidArgumentError|{ballerina/grpc}DeadlineExceededError|{ballerina/grpc}NotFoundError|{ballerina/grpc}AleadyExistsError|{ballerina/grpc}PermissionDeniedError|{ballerina/grpc}UnauthenticatedError|{ballerina/grpc}ResourceExhaustedError|{ballerina/grpc}FailedPreconditionError|{ballerina/grpc}AbortedError|{ballerina/grpc}OutOfRangeError|{ballerina/grpc}UnimplementedError|{ballerina/grpc}InternalError|{ballerina/grpc}UnavailableError|{ballerina/grpc}DataLossError)` errorType: the error type.  \n- `string` message: the error message.  \n- `error` other: the `error` instance.  \n  \n**Returns** `(error)`   \n- prepared `Error` instance.  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(131, 8, 7, 'Caller.getId', FALSE, FALSE, TRUE, '{"label":"getId()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getId()","insertTextFormat":"Snippet"}'),
(132, 8, 7, 'Caller.send', FALSE, TRUE, TRUE, '{"label":"send(any res, (grpc:Headers|()) headers)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nSends outbound response to the caller.\n  \n**Params**  \n- `any` res: - The outbound response message.  \n- `(grpc:Headers|())` headers: - Optional headers parameter. Passes header value if needed. Default sets to nil.(Defaultable)  \n- `(grpc:Headers|())` headers: - Optional headers parameter. Passes header value if needed. Default sets to nil.  \n  \n**Returns** `(()|error)`   \n- - Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"send(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(133, 8, 7, 'Caller.complete', FALSE, TRUE, TRUE, '{"label":"complete()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nInforms the caller, server finished sending messages.\n  \n  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"complete()","insertTextFormat":"Snippet"}'),
(134, 8, 7, 'Caller.isCancelled', FALSE, FALSE, TRUE, '{"label":"isCancelled()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nChecks whether the connection is closed by the caller.\n  \n  \n  \n**Returns** `boolean`   \n- Returns true, if caller already closed the connection. false otherwise.  \n  \n"}},"insertText":"isCancelled()","insertTextFormat":"Snippet"}'),
(135, 8, 7, 'Caller.sendError', FALSE, TRUE, TRUE, '{"label":"sendError(int statusCode, string message, (grpc:Headers|()) headers)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nSends server error to the caller.\n  \n**Params**  \n- `int` statusCode: Error status code.  \n- `string` message: Error message.  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.(Defaultable)  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"sendError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(136, 8, 7, 'Caller.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(137, 8, 8, 'ConnectionManager.initGlobalPool', TRUE, FALSE, TRUE, '{"label":"initGlobalPool(grpc:PoolConfiguration poolConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n"}},"insertText":"initGlobalPool(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(138, 8, 8, 'ConnectionManager.getPoolConfiguration', FALSE, FALSE, TRUE, '{"label":"getPoolConfiguration()(grpc:PoolConfiguration)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `grpc:PoolConfiguration`   \n  \n"}},"insertText":"getPoolConfiguration()","insertTextFormat":"Snippet"}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(139, 8, 8, 'ConnectionManager.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(140, 8, 9, 'Client.init', TRUE, FALSE, TRUE, '{"label":"init(string url, grpc:ClientEndpointConfig config, grpc:PoolConfiguration globalPoolConfig)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"init(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(141, 8, 9, 'Client.initStub', FALSE, FALSE, TRUE, '{"label":"initStub(grpc:AbstractClientEndpoint clientEndpoint, string stubType, string descriptorKey, map\u003cany\u003e descriptorMap)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nCalls when initializing client endpoint with service descriptor data extracted from proto file.\n  \n**Params**  \n- `string` stubType: Service Stub type. possible values: blocking, nonblocking.  \n- `string` descriptorKey: Proto descriptor key. Key of proto descriptor.  \n- `map\u003cany\u003e` descriptorMap: Proto descriptor map. descriptor map with all dependent descriptors.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while initializing the stub, returns nill otherwise.  \n  \n"}},"insertText":"initStub(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(142, 8, 9, 'Client.blockingExecute', FALSE, TRUE, TRUE, '{"label":"blockingExecute(string methodID, anydata payload, (grpc:Headers|()) headers)(([anydata,grpc:Headers]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nCalls when executing blocking call with gRPC service.\n  \n**Params**  \n- `string` methodID: Remote service method id.  \n- `anydata` payload: Request message. Message type varies with remote service method parameter.  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.(Defaultable)  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.  \n  \n**Returns** `([anydata,grpc:Headers]|error)`   \n- Returns response message and headers if executes successfully, error otherwise.  \n  \n"}},"insertText":"blockingExecute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(143, 8, 9, 'Client.nonBlockingExecute', FALSE, TRUE, TRUE, '{"label":"nonBlockingExecute(string methodID, anydata payload, service listenerService, (grpc:Headers|()) headers)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nCalls when executing non-blocking call with gRPC service.\n  \n**Params**  \n- `string` methodID: Remote service method id.  \n- `anydata` payload: Request message. Message type varies with remote service method parameter..  \n- `service` listenerService: Call back listener service. This service listens the response message from service.  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.(Defaultable)  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the request, returns nil otherwise.  \n  \n"}},"insertText":"nonBlockingExecute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(144, 8, 9, 'Client.streamingExecute', FALSE, TRUE, TRUE, '{"label":"streamingExecute(string methodID, service listenerService, (grpc:Headers|()) headers)((grpc:StreamingClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nCalls when executing streaming call with gRPC service.\n  \n**Params**  \n- `string` methodID: Remote service method id.  \n- `service` listenerService: Call back listener service. This service listens the response message from service.  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.(Defaultable)  \n- `(grpc:Headers|())` headers: Optional headers parameter. Passes header value if needed. Default sets to nil.  \n  \n**Returns** `(grpc:StreamingClient|error)`   \n- Returns client connection if executes successfully, error otherwise.  \n  \n"}},"insertText":"streamingExecute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(145, 8, 9, 'Client.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, (grpc:ClientEndpointConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nGets invoked to initialize the endpoint. During initialization, configurations provided through the `config`\nrecord is used for endpoint initialization.\n  \n**Params**  \n- `string` url: The server url.  \n- `(grpc:ClientEndpointConfig|())` config: - The ClientEndpointConfig of the endpoint.(Defaultable)  \n- `(grpc:ClientEndpointConfig|())` config: - The ClientEndpointConfig of the endpoint."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(146, 8, 11, 'Headers.exists', FALSE, FALSE, TRUE, '{"label":"exists(string headerName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nCheck whether the requested header exists.\n  \n**Params**  \n- `string` headerName: The header name.  \n  \n**Returns** `boolean`   \n- Returns true if header exists, false otherwise.  \n  \n"}},"insertText":"exists(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(147, 8, 11, 'Headers.get', FALSE, FALSE, TRUE, '{"label":"get(string headerName)((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nReturns the header value with the specified header name. If there are more than one header value for the\nspecified header name, the first value is returned.\n  \n**Params**  \n- `string` headerName: The header name.  \n  \n**Returns** `(string|())`   \n- Returns first header value if exists, nil otherwise.  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(148, 8, 11, 'Headers.getAll', FALSE, FALSE, TRUE, '{"label":"getAll(string headerName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nGets all transport headers with the specified header name.\n  \n**Params**  \n- `string` headerName: The header name.  \n  \n**Returns** `string[]`   \n- Returns header value array.  \n  \n"}},"insertText":"getAll(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(149, 8, 11, 'Headers.setEntry', FALSE, FALSE, TRUE, '{"label":"setEntry(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nSets the value of a transport header.\n  \n**Params**  \n- `string` headerName: The header name.  \n- `string` headerValue: The header value."}},"insertText":"setEntry(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(150, 8, 11, 'Headers.addEntry', FALSE, FALSE, TRUE, '{"label":"addEntry(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nAdds the specified key/value pair as an HTTP header to the request.\n  \n**Params**  \n- `string` headerName: The header name.  \n- `string` headerValue: The header value."}},"insertText":"addEntry(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(151, 8, 11, 'Headers.remove', FALSE, FALSE, TRUE, '{"label":"remove(string headerName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nRemoves a transport header from the request.\n  \n**Params**  \n- `string` headerName: The header name."}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(152, 8, 11, 'Headers.removeAll', FALSE, FALSE, TRUE, '{"label":"removeAll()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nRemoves all transport headers from the message.  \n"}},"insertText":"removeAll();","insertTextFormat":"Snippet"}'),
(153, 8, 11, 'Headers.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(154, 8, 12, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nStarts the registered service.\n  \n  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while starting the server, returns nil otherwise.  \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(155, 8, 12, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(156, 8, 12, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nStops the registered service.\n  \n  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while stopping the server, returns nil otherwise.  \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(157, 8, 12, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nGets called every time a service attaches itself to this endpoint - also happens at module init time.\n  \n**Params**  \n- `service` s: The type of the service to be registered.  \n- `(string|())` name: Name of the service.(Defaultable)  \n- `(string|())` name: Name of the service.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while attaching the service, returns nil otherwise.  \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(158, 8, 12, 'Listener.initEndpoint', TRUE, FALSE, TRUE, '{"label":"initEndpoint()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint()","insertTextFormat":"Snippet"}'),
(159, 8, 12, 'Listener.register', TRUE, FALSE, TRUE, '{"label":"register(service serviceType, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(160, 8, 12, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(161, 8, 12, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"stop()","insertTextFormat":"Snippet"}'),
(162, 8, 12, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init(int port, (grpc:ListenerConfiguration|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nGets called when the endpoint is being initialize during module init time.\n  \n**Params**  \n- `int` port: Listener port.  \n- `(grpc:ListenerConfiguration|())` config: The ServiceEndpointConfiguration of the endpoint.(Defaultable)  \n- `(grpc:ListenerConfiguration|())` config: The ServiceEndpointConfiguration of the endpoint."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(163, 8, 13, 'StreamingClient.send', FALSE, TRUE, TRUE, '{"label":"send(any res)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nSends request message to the server.\n  \n**Params**  \n- `any` res: The inbound request message.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"send(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(164, 8, 13, 'StreamingClient.complete', FALSE, TRUE, TRUE, '{"label":"complete()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nInforms the server, caller finished sending messages.\n  \n  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"complete()","insertTextFormat":"Snippet"}'),
(165, 8, 13, 'StreamingClient.sendError', FALSE, TRUE, TRUE, '{"label":"sendError(int statusCode, string message)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/grpc_  \n  \nSends error message to the server.\n  \n**Params**  \n- `int` statusCode: Error status code.  \n- `string` message: Error message.  \n  \n**Returns** `(()|error)`   \n- Returns an error if encounters an error while sending the response, returns nil otherwise.  \n  \n"}},"insertText":"sendError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(166, 8, 13, 'StreamingClient.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(167, 9, -1, 'handleAuthRequest', TRUE, FALSE, FALSE, '{"label":"handleAuthRequest((http:InboundAuthHandler[]|http:InboundAuthHandler[][]) authHandlers, http:Request request)((boolean|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(boolean|http:AuthenticationError)`   \n  \n"}},"insertText":"handleAuthRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(168, 9, -1, 'checkForAuthHandlers', TRUE, FALSE, FALSE, '{"label":"checkForAuthHandlers(http:InboundAuthHandler[] authHandlers, http:Request request)((boolean|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(boolean|http:AuthenticationError)`   \n  \n"}},"insertText":"checkForAuthHandlers(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(169, 9, -1, 'isAuthnSuccessful', TRUE, FALSE, FALSE, '{"label":"isAuthnSuccessful(http:Caller caller, (boolean|http:AuthenticationError) authenticated)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nVerifies if the authentication is successful. If not responds to the user.\n  \n**Params**  \n- `http:Caller` caller: Caller for outbound HTTP responses  \n- `(boolean|http:AuthenticationError)` authenticated: Authentication status for the request, or `AuthenticationError` if error occurred  \n  \n**Returns** `boolean`   \n- Authentication result to indicate if the filter can proceed(true) or not(false)  \n  \n"}},"insertText":"isAuthnSuccessful(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(170, 9, -1, 'handleAuthzRequest', TRUE, FALSE, FALSE, '{"label":"handleAuthzRequest(http:AuthzHandler authzHandler, http:Request request, http:FilterContext context, (string[]|string[][]) scopes)((boolean|http:AuthorizationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(boolean|http:AuthorizationError)`   \n  \n"}},"insertText":"handleAuthzRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(171, 9, -1, 'isAuthzSuccessful', TRUE, FALSE, FALSE, '{"label":"isAuthzSuccessful(http:Caller caller, (boolean|http:AuthorizationError) authorized)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nVerifies if the authorization is successful. If not responds to the user.\n  \n**Params**  \n- `http:Caller` caller: Caller for outbound HTTP responses  \n- `(boolean|http:AuthorizationError)` authorized: Authorization status for the request, or `AuthorizationError` if error occurred  \n  \n**Returns** `boolean`   \n- Authorization result to indicate if the filter can proceed(true) or not(false)  \n  \n"}},"insertText":"isAuthzSuccessful(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(172, 9, -1, 'checkForScopeMatch', TRUE, FALSE, FALSE, '{"label":"checkForScopeMatch((string[]|string[][]) resourceScopes, string[] userScopes, string resourceName, string method)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCheck whether the scopes of the user and scopes of resource matches.\n  \n**Params**  \n- `(string[]|string[][])` resourceScopes: Scopes of resource  \n- `string[]` userScopes: Scopes of user  \n- `string` resourceName: Name of the `resource`  \n- `string` method: HTTP method name  \n  \n**Returns** `boolean`   \n- true if there is a match between resource and user scopes, else false  \n  \n"}},"insertText":"checkForScopeMatch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(173, 9, -1, 'matchScopes', TRUE, FALSE, FALSE, '{"label":"matchScopes(string[] resourceScopes, string[] userScopes)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to find a match between the two scope arrays.\n  \n**Params**  \n- `string[]` resourceScopes: Scopes of resource  \n- `string[]` userScopes: Scopes of the user  \n  \n**Returns** `boolean`   \n- true if one of the resourceScopes can be found at userScopes, else false  \n  \n"}},"insertText":"matchScopes(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(174, 9, -1, 'extractAuthorizationHeaderValue', FALSE, FALSE, FALSE, '{"label":"extractAuthorizationHeaderValue(http:Request req)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts the Authorization header value from the request.\n  \n**Params**  \n- `http:Request` req: Request instance  \n  \n**Returns** `string`   \n- Value of the Authorization header  \n  \n"}},"insertText":"extractAuthorizationHeaderValue(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(175, 9, -1, 'getAuthHandlers', TRUE, FALSE, FALSE, '{"label":"getAuthHandlers(http:FilterContext context)((http:InboundAuthHandler[]|http:InboundAuthHandler[][]|boolean))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to retrieve the inbound authentication handlers based on their hierarchy (i.e., first from the resource level and then\nfrom the service level, if it is not there at the resource level).\n  \n**Params**  \n- `http:FilterContext` context: The `FilterContext` instance.  \n  \n**Returns** `(http:InboundAuthHandler[]|http:InboundAuthHandler[][]|boolean)`   \n- Returns the authentication handlers or whether it is needed to engage listener-level handlers or not.  \n  \n"}},"insertText":"getAuthHandlers(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(176, 9, -1, 'getScopes', TRUE, FALSE, FALSE, '{"label":"getScopes(http:FilterContext context)((string[]|string[][]|boolean))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to retrieve the authorization scopes hierarchically - first from the resource level and then\nfrom the service level, if it is not there in the resource level.\n  \n**Params**  \n- `http:FilterContext` context: `FilterContext` instance  \n  \n**Returns** `(string[]|string[][]|boolean)`   \n- Authorization scopes or whether it is needed to engage listener level scopes or not  \n  \n"}},"insertText":"getScopes(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(177, 9, -1, 'getServiceResourceAuthConfig', TRUE, FALSE, FALSE, '{"label":"getServiceResourceAuthConfig(http:FilterContext context)([(http:ServiceResourceAuth|()),(http:ServiceResourceAuth|())])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieve the authentication annotation value for resource level and service level.\n  \n**Params**  \n- `http:FilterContext` context: The `FilterContext` instance.  \n  \n**Returns** `[(http:ServiceResourceAuth|()),(http:ServiceResourceAuth|())]`   \n- Returns the resource-level and service-level authentication annotations.  \n  \n"}},"insertText":"getServiceResourceAuthConfig(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(178, 9, -1, 'isServiceResourceSecured', TRUE, FALSE, FALSE, '{"label":"isServiceResourceSecured((http:ServiceResourceAuth|()) serviceResourceAuth)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCheck for the service or the resource is secured by evaluating the enabled flag configured by the user.\n  \n**Params**  \n- `(http:ServiceResourceAuth|())` serviceResourceAuth: Service or resource auth annotation  \n  \n**Returns** `boolean`   \n- Whether the service or resource secured or not  \n  \n"}},"insertText":"isServiceResourceSecured(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(179, 9, -1, 'createResponseHeaderMap', TRUE, FALSE, FALSE, '{"label":"createResponseHeaderMap(http:Response resp)(map\u003canydata\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreates a map out of the headers of the HTTP response.\n  \n**Params**  \n- `http:Response` resp: The `Response` instance.  \n  \n**Returns** `map\u003canydata\u003e`   \n- Returns the map of the response headers.  \n  \n"}},"insertText":"createResponseHeaderMap(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(180, 9, -1, 'prepareAuthenticationError', TRUE, FALSE, FALSE, '{"label":"prepareAuthenticationError(string message, (()|error) err)(http:AuthenticationError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nLogs, prepares, and returns the `AuthenticationError`.\n  \n**Params**  \n- `string` message: The error message.  \n- `(()|error)` err: The `error` instance.(Defaultable)  \n- `(()|error)` err: The `error` instance.  \n  \n**Returns** `http:AuthenticationError`   \n- Returns the prepared `AuthenticationError` instance.  \n  \n"}},"insertText":"prepareAuthenticationError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(181, 9, -1, 'prepareAuthorizationError', TRUE, FALSE, FALSE, '{"label":"prepareAuthorizationError(string message, (()|error) err)(http:AuthorizationError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nLogs, prepares, and returns the `AuthorizationError`.\n  \n**Params**  \n- `string` message: The error message.  \n- `(()|error)` err: The `error` instance.(Defaultable)  \n- `(()|error)` err: The `error` instance.  \n  \n**Returns** `http:AuthorizationError`   \n- Returns the prepared `AuthorizationError` instance.  \n  \n"}},"insertText":"prepareAuthorizationError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(182, 9, -1, 'appendFields', TRUE, FALSE, FALSE, '{"label":"appendFields(string[] fields)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"appendFields(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(183, 9, -1, 'buildCommaSeparatedString', TRUE, FALSE, FALSE, '{"label":"buildCommaSeparatedString(string[] values)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"buildCommaSeparatedString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(184, 9, -1, 'getExpirationDirectiveValue', TRUE, FALSE, FALSE, '{"label":"getExpirationDirectiveValue(string directive)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getExpirationDirectiveValue(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(185, 9, -1, 'setRequestCacheControlHeader', TRUE, FALSE, FALSE, '{"label":"setRequestCacheControlHeader(http:Request request)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"setRequestCacheControlHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(186, 9, -1, 'setResponseCacheControlHeader', TRUE, FALSE, FALSE, '{"label":"setResponseCacheControlHeader(http:Response response)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"setResponseCacheControlHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(187, 9, -1, 'isCacheableStatusCode', TRUE, FALSE, FALSE, '{"label":"isCacheableStatusCode(int statusCode)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isCacheableStatusCode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(188, 9, -1, 'addEntry', TRUE, FALSE, FALSE, '{"label":"addEntry(cache:Cache cache, string key, http:Response inboundResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"addEntry(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(189, 9, -1, 'weakValidatorEquals', TRUE, FALSE, FALSE, '{"label":"weakValidatorEquals(string etag1, string etag2)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"weakValidatorEquals(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(190, 9, -1, 'getCacheKey', TRUE, FALSE, FALSE, '{"label":"getCacheKey(string httpMethod, string url)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getCacheKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(191, 9, -1, 'createHttpCachingClient', FALSE, FALSE, FALSE, '{"label":"createHttpCachingClient(string url, http:ClientEndpointConfig config, http:CacheConfig cacheConfig)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreates an HTTP client capable of caching HTTP responses.\n  \n**Params**  \n- `string` url: The URL of the HTTP endpoint to connect to  \n- `http:ClientEndpointConfig` config: The configurations for the client endpoint associated with the caching client  \n- `http:CacheConfig` cacheConfig: The configurations for the HTTP cache to be used with the caching client  \n  \n**Returns** `(http:HttpClient|error)`   \n- An `HttpCachingClient` instance which wraps the base `Client` with a caching layer  \n  \n"}},"insertText":"createHttpCachingClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(192, 9, -1, 'getCachedResponse', TRUE, FALSE, FALSE, '{"label":"getCachedResponse(http:HttpCache cache, http:HttpClient httpClient, http:Request req, string httpMethod, string path, boolean isShared, boolean forwardRequest)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"getCachedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(193, 9, -1, 'isNoCacheSet', TRUE, FALSE, FALSE, '{"label":"isNoCacheSet((http:RequestCacheControl|()) reqCC, (http:ResponseCacheControl|()) resCC)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isNoCacheSet(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(194, 9, -1, 'getValidationResponse', TRUE, FALSE, FALSE, '{"label":"getValidationResponse(http:HttpClient httpClient, http:Request req, http:Response cachedResponse, http:HttpCache cache, time:Time currentT, string path, string httpMethod, boolean isFreshResponse)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"getValidationResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(195, 9, -1, 'handle304Response', TRUE, FALSE, FALSE, '{"label":"handle304Response(http:Response validationResponse, http:Response cachedResponse, http:HttpCache cache, string path, string httpMethod)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"handle304Response(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(196, 9, -1, 'invalidateResponses', TRUE, FALSE, FALSE, '{"label":"invalidateResponses(http:HttpCache httpCache, http:Response inboundResponse, string path)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"invalidateResponses(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(197, 9, -1, 'getFreshnessLifetime', TRUE, FALSE, FALSE, '{"label":"getFreshnessLifetime(http:Response cachedResponse, boolean isSharedCache)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getFreshnessLifetime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(198, 9, -1, 'isFreshResponse', TRUE, FALSE, FALSE, '{"label":"isFreshResponse(http:Response cachedResponse, boolean isSharedCache)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isFreshResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(199, 9, -1, 'isAllowedToBeServedStale', TRUE, FALSE, FALSE, '{"label":"isAllowedToBeServedStale((http:RequestCacheControl|()) requestCacheControl, http:Response cachedResponse, boolean isSharedCache)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isAllowedToBeServedStale(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(200, 9, -1, 'isServingStaleProhibited', TRUE, FALSE, FALSE, '{"label":"isServingStaleProhibited((http:RequestCacheControl|()) reqCC, (http:ResponseCacheControl|()) resCC)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isServingStaleProhibited(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(201, 9, -1, 'isStaleResponseAccepted', TRUE, FALSE, FALSE, '{"label":"isStaleResponseAccepted((http:RequestCacheControl|()) requestCacheControl, http:Response cachedResponse, boolean isSharedCache)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isStaleResponseAccepted(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(202, 9, -1, 'sendValidationRequest', TRUE, FALSE, FALSE, '{"label":"sendValidationRequest(http:HttpClient httpClient, string path, http:Response cachedResponse)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"sendValidationRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(203, 9, -1, 'sendNewRequest', TRUE, FALSE, FALSE, '{"label":"sendNewRequest(http:HttpClient httpClient, http:Request request, string path, string httpMethod, boolean forwardRequest)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"sendNewRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(204, 9, -1, 'setAgeHeader', TRUE, FALSE, FALSE, '{"label":"setAgeHeader(http:Response cachedResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"setAgeHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(205, 9, -1, 'calculateCurrentResponseAge', TRUE, FALSE, FALSE, '{"label":"calculateCurrentResponseAge(http:Response cachedResponse)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"calculateCurrentResponseAge(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(206, 9, -1, 'updateResponse', TRUE, FALSE, FALSE, '{"label":"updateResponse(http:Response cachedResponse, http:Response validationResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"updateResponse(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(207, 9, -1, 'hasAWeakValidator', TRUE, FALSE, FALSE, '{"label":"hasAWeakValidator(http:Response validationResponse, string etag)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"hasAWeakValidator(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(208, 9, -1, 'isAStrongValidator', TRUE, FALSE, FALSE, '{"label":"isAStrongValidator(string etag)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isAStrongValidator(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(209, 9, -1, 'replaceHeaders', TRUE, FALSE, FALSE, '{"label":"replaceHeaders(http:Response cachedResponse, http:Response validationResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"replaceHeaders(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(210, 9, -1, 'retain2xxWarnings', TRUE, FALSE, FALSE, '{"label":"retain2xxWarnings(http:Response cachedResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"retain2xxWarnings(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(211, 9, -1, 'getResponseAge', TRUE, FALSE, FALSE, '{"label":"getResponseAge(http:Response cachedResponse)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getResponseAge(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(212, 9, -1, 'updateResponseTimestamps', TRUE, FALSE, FALSE, '{"label":"updateResponseTimestamps(http:Response response, int requestedTime, int receivedTime)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"updateResponseTimestamps(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(213, 9, -1, 'getDateValue', TRUE, FALSE, FALSE, '{"label":"getDateValue(http:Response inboundResponse)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getDateValue(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(214, 9, -1, 'getWarningAgent', TRUE, FALSE, FALSE, '{"label":"getWarningAgent()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getWarningAgent()","insertTextFormat":"Snippet"}'),
(215, 9, -1, 'createSimpleHttpClient', TRUE, FALSE, FALSE, '{"label":"createSimpleHttpClient(http:HttpClient caller, http:PoolConfiguration globalPoolConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"createSimpleHttpClient(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(216, 9, -1, 'initialize', TRUE, FALSE, FALSE, '{"label":"initialize(string serviceUrl, http:ClientEndpointConfig config)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"initialize(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(217, 9, -1, 'createRedirectClient', TRUE, FALSE, FALSE, '{"label":"createRedirectClient(string url, http:ClientEndpointConfig configuration)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"createRedirectClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(218, 9, -1, 'checkForRetry', TRUE, FALSE, FALSE, '{"label":"checkForRetry(string url, http:ClientEndpointConfig config)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"checkForRetry(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(219, 9, -1, 'createCircuitBreakerClient', TRUE, FALSE, FALSE, '{"label":"createCircuitBreakerClient(string uri, http:ClientEndpointConfig configuration)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"createCircuitBreakerClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(220, 9, -1, 'createRetryClient', TRUE, FALSE, FALSE, '{"label":"createRetryClient(string url, http:ClientEndpointConfig configuration)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"createRetryClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(221, 9, -1, 'nativePost', TRUE, FALSE, FALSE, '{"label":"nativePost(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativePost(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(222, 9, -1, 'nativeHead', TRUE, FALSE, FALSE, '{"label":"nativeHead(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeHead(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(223, 9, -1, 'nativePut', TRUE, FALSE, FALSE, '{"label":"nativePut(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativePut(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(224, 9, -1, 'nativeExecute', TRUE, FALSE, FALSE, '{"label":"nativeExecute(http:HttpClient caller, string httpVerb, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeExecute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(225, 9, -1, 'nativePatch', TRUE, FALSE, FALSE, '{"label":"nativePatch(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativePatch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(226, 9, -1, 'nativeDelete', TRUE, FALSE, FALSE, '{"label":"nativeDelete(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeDelete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(227, 9, -1, 'nativeGet', TRUE, FALSE, FALSE, '{"label":"nativeGet(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeGet(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(228, 9, -1, 'nativeOptions', TRUE, FALSE, FALSE, '{"label":"nativeOptions(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeOptions(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(229, 9, -1, 'nativeSubmit', TRUE, FALSE, FALSE, '{"label":"nativeSubmit(http:HttpClient caller, string httpVerb, string path, http:Request req)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpFuture|error)`   \n  \n"}},"insertText":"nativeSubmit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(230, 9, -1, 'nativeForward', TRUE, FALSE, FALSE, '{"label":"nativeForward(http:HttpClient caller, string path, http:Request req)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"nativeForward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(231, 9, -1, 'createClient', TRUE, FALSE, FALSE, '{"label":"createClient(string url, http:ClientEndpointConfig config)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:HttpClient|error)`   \n  \n"}},"insertText":"createClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(232, 9, -1, 'parseHeader', FALSE, FALSE, FALSE, '{"label":"parseHeader(string headerValue)(([string,map\u003cany\u003e]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nParses the given header value to extract its value and parameter map.\n  \n**Params**  \n- `string` headerValue: The header value  \n  \n**Returns** `([string,map\u003cany\u003e]|error)`   \n- Returns a tuple containing the value and its parameter map  \n  \n"}},"insertText":"parseHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(233, 9, -1, 'buildRequest', TRUE, FALSE, FALSE, '{"label":"buildRequest((http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)(http:Request)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Request`   \n  \n"}},"insertText":"buildRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(234, 9, -1, 'buildResponse', TRUE, FALSE, FALSE, '{"label":"buildResponse((http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)(http:Response)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Response`   \n  \n"}},"insertText":"buildResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(235, 9, -1, 'invokeEndpoint', FALSE, FALSE, FALSE, '{"label":"invokeEndpoint(string path, http:Request outRequest, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) requestAction, http:HttpClient httpClient, string verb)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe HEAD remote function implementation of the Circuit Breaker. This wraps the `head()` function of the underlying\nHTTP remote function provider.  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` outRequest: A Request struct  \n- `(FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE)` requestAction: `HttpOperation` related to the request  \n- `http:HttpClient` httpClient: HTTP client which uses to call the relevant functions  \n- `string` verb: HTTP verb used for submit method(Defaultable)  \n- `string` verb: HTTP verb used for submit method  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"invokeEndpoint(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(236, 9, -1, 'extractHttpOperation', TRUE, FALSE, FALSE, '{"label":"extractHttpOperation(string httpVerb)((FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE)`   \n  \n"}},"insertText":"extractHttpOperation(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(237, 9, -1, 'populateErrorCodeIndex', TRUE, FALSE, FALSE, '{"label":"populateErrorCodeIndex(int[] errorCode)(boolean[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean[]`   \n  \n"}},"insertText":"populateErrorCodeIndex(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(238, 9, -1, 'getError', TRUE, FALSE, FALSE, '{"label":"getError()(http:UnsupportedActionError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:UnsupportedActionError`   \n  \n"}},"insertText":"getError()","insertTextFormat":"Snippet"}'),
(239, 9, -1, 'populateRequestFields', TRUE, FALSE, FALSE, '{"label":"populateRequestFields(http:Request originalRequest, http:Request newRequest)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"populateRequestFields(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(240, 9, -1, 'populateMultipartRequest', TRUE, FALSE, FALSE, '{"label":"populateMultipartRequest(http:Request inRequest)((http:Request|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Request|error)`   \n  \n"}},"insertText":"populateMultipartRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(241, 9, -1, 'isMultipartRequest', TRUE, FALSE, FALSE, '{"label":"isMultipartRequest(http:Request request)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isMultipartRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(242, 9, -1, 'isNestedEntity', TRUE, FALSE, FALSE, '{"label":"isNestedEntity(mime:Entity entity)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isNestedEntity(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(243, 9, -1, 'createFailoverRequest', TRUE, FALSE, FALSE, '{"label":"createFailoverRequest(http:Request request, mime:Entity requestEntity)((http:Request|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Request|error)`   \n  \n"}},"insertText":"createFailoverRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(244, 9, -1, 'getInvalidTypeError', TRUE, FALSE, FALSE, '{"label":"getInvalidTypeError()((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(error)`   \n  \n"}},"insertText":"getInvalidTypeError()","insertTextFormat":"Snippet"}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(245, 9, -1, 'resolve', TRUE, FALSE, FALSE, '{"label":"resolve(string baseUrl, string path)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(string|error)`   \n  \n"}},"insertText":"resolve(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(246, 9, -1, 'nativeRespond', TRUE, FALSE, FALSE, '{"label":"nativeRespond(http:Caller caller, http:Response response)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"nativeRespond(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(247, 9, -1, 'getGenericClientError', TRUE, FALSE, FALSE, '{"label":"getGenericClientError(string message, error cause)(http:GenericClientError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:GenericClientError`   \n  \n"}},"insertText":"getGenericClientError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(248, 9, -1, 'createHttpSecureClient', FALSE, FALSE, FALSE, '{"label":"createHttpSecureClient(string url, http:ClientEndpointConfig config)((http:HttpClient|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreates an HTTP client capable of securing HTTP requests with authentication.\n  \n**Params**  \n- `string` url: Base URL  \n- `http:ClientEndpointConfig` config: Client endpoint configurations  \n  \n**Returns** `(http:HttpClient|error)`   \n- Created secure HTTP client  \n  \n"}},"insertText":"createHttpSecureClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(249, 9, -1, 'prepareSecureRequest', TRUE, FALSE, FALSE, '{"label":"prepareSecureRequest(http:Request req, http:ClientEndpointConfig config)((http:Request|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPrepare an HTTP request with the required headers for authentication based on the scheme.\n  \n**Params**  \n- `http:Request` req: An HTTP outbound request message  \n- `http:ClientEndpointConfig` config: Client endpoint configurations  \n  \n**Returns** `(http:Request|error)`   \n- Prepared HTTP request or `http:ClientError` if an error occurred at auth handler invocation  \n  \n"}},"insertText":"prepareSecureRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(250, 9, -1, 'doInspection', TRUE, FALSE, FALSE, '{"label":"doInspection(http:Request req, http:Response res, http:ClientEndpointConfig config)((http:Request|()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nDo inspection with the received HTTP response for the prepared HTTP request.\n  \n**Params**  \n- `http:Request` req: An HTTP outbound request message  \n- `http:Response` res: An HTTP outbound response message  \n- `http:ClientEndpointConfig` config: Client endpoint configurations  \n  \n**Returns** `(http:Request|()|error)`   \n- Prepared HTTP request or `()` if nothing to be done or `http:ClientError` if an error occurred at auth handler invocation  \n  \n"}},"insertText":"doInspection(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(251, 9, -1, 'performRedirectIfEligible', TRUE, FALSE, FALSE, '{"label":"performRedirectIfEligible(http:RedirectClient redirectClient, string path, http:Request request, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) httpOperation)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performRedirectIfEligible(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(252, 9, -1, 'checkRedirectEligibility', TRUE, FALSE, FALSE, '{"label":"checkRedirectEligibility((http:Response|http:HttpFuture|error) response, string resolvedRequestedURI, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) httpVerb, http:Request request, http:RedirectClient redirectClient)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"checkRedirectEligibility(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(253, 9, -1, 'isRedirectResponse', TRUE, FALSE, FALSE, '{"label":"isRedirectResponse(int statusCode)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isRedirectResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(254, 9, -1, 'redirect', TRUE, FALSE, FALSE, '{"label":"redirect(http:Response response, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) httpVerb, http:Request request, http:RedirectClient redirectClient, string resolvedRequestedURI)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"redirect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(255, 9, -1, 'performRedirection', TRUE, FALSE, FALSE, '{"label":"performRedirection(string location, http:RedirectClient redirectClient, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) redirectMethod, http:Request request, http:Response response)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performRedirection(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(256, 9, -1, 'createNewEndpointConfig', TRUE, FALSE, FALSE, '{"label":"createNewEndpointConfig(http:ClientEndpointConfig config)(http:ClientEndpointConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:ClientEndpointConfig`   \n  \n"}},"insertText":"createNewEndpointConfig(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(257, 9, -1, 'getRedirectMethod', TRUE, FALSE, FALSE, '{"label":"getRedirectMethod((FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) httpVerb, http:Response response)((FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE|())`   \n  \n"}},"insertText":"getRedirectMethod(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(258, 9, -1, 'createRedirectRequest', TRUE, FALSE, FALSE, '{"label":"createRedirectRequest(int statusCode, http:Request request)(http:Request)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Request`   \n  \n"}},"insertText":"createRedirectRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(259, 9, -1, 'isAbsolute', TRUE, FALSE, FALSE, '{"label":"isAbsolute(string locationUrl)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isAbsolute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(260, 9, -1, 'setCountAndResolvedURL', TRUE, FALSE, FALSE, '{"label":"setCountAndResolvedURL(http:RedirectClient redirectClient, http:Response response, string resolvedRequestedURI)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"setCountAndResolvedURL(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(261, 9, -1, 'performExecuteAction', TRUE, FALSE, FALSE, '{"label":"performExecuteAction(string path, http:Request request, string httpVerb, http:FailoverClient failoverClient, string verb)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performExecuteAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(262, 9, -1, 'performFailoverAction', TRUE, FALSE, FALSE, '{"label":"performFailoverAction(string path, http:Request request, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) requestAction, http:FailoverClient failoverClient, string verb)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performFailoverAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(263, 9, -1, 'populateGenericFailoverActionError', TRUE, FALSE, FALSE, '{"label":"populateGenericFailoverActionError((()|error)[] failoverActionErr, (error) httpActionErr, int index)((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(error)`   \n  \n"}},"insertText":"populateGenericFailoverActionError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(264, 9, -1, 'populateFailoverErrorHttpStatusCodes', TRUE, FALSE, FALSE, '{"label":"populateFailoverErrorHttpStatusCodes(http:Response inResponse, (()|error)[] failoverActionErr, int index)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"populateFailoverErrorHttpStatusCodes(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(265, 9, -1, 'populateErrorsFromLastResponse', TRUE, FALSE, FALSE, '{"label":"populateErrorsFromLastResponse(http:Response inResponse, (()|error)[] failoverActionErr, int index)((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(error)`   \n  \n"}},"insertText":"populateErrorsFromLastResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(266, 9, -1, 'createClientEPConfigFromFailoverEPConfig', TRUE, FALSE, FALSE, '{"label":"createClientEPConfigFromFailoverEPConfig(http:FailoverClientEndpointConfiguration foConfig, http:TargetService target)(http:ClientEndpointConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:ClientEndpointConfig`   \n  \n"}},"insertText":"createClientEPConfigFromFailoverEPConfig(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(267, 9, -1, 'createFailoverHttpClientArray', TRUE, FALSE, FALSE, '{"label":"createFailoverHttpClientArray(http:FailoverClientEndpointConfiguration failoverClientConfig)(((http:Client|())[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `((http:Client|())[]|error)`   \n  \n"}},"insertText":"createFailoverHttpClientArray(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(268, 9, -1, 'getLastSuceededClientEP', TRUE, FALSE, FALSE, '{"label":"getLastSuceededClientEP(http:FailoverClient failoverClient)(http:Client)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Client`   \n  \n"}},"insertText":"getLastSuceededClientEP(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(269, 9, -1, 'handleResponseWithErrorCode', TRUE, FALSE, FALSE, '{"label":"handleResponseWithErrorCode(http:Response response, int initialIndex, int noOfEndpoints, int index, (()|error)[] failoverActionErrData)([int,(()|error)])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `[int,(()|error)]`   \n  \n"}},"insertText":"handleResponseWithErrorCode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(270, 9, -1, 'handleError', TRUE, FALSE, FALSE, '{"label":"handleError((error) err, int initialIndex, int noOfEndpoints, int index, (()|error)[] failoverActionErrData)([int,(()|error)])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `[int,(()|error)]`   \n  \n"}},"insertText":"handleError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(271, 9, -1, 'updateCircuitState', TRUE, FALSE, FALSE, '{"label":"updateCircuitState(http:CircuitHealth circuitHealth, (OPEN|HALF_OPEN|CLOSED) currentStateValue, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)((OPEN|HALF_OPEN|CLOSED))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nUpdate circuit state.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n- `(OPEN|HALF_OPEN|CLOSED)` currentStateValue: Circuit Breaker current state value  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`  \n  \n**Returns** `(OPEN|HALF_OPEN|CLOSED)`   \n- State of the circuit  \n  \n"}},"insertText":"updateCircuitState(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(272, 9, -1, 'updateCircuitHealthAndRespond', TRUE, FALSE, FALSE, '{"label":"updateCircuitHealthAndRespond((http:Response|error) serviceResponse, http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"updateCircuitHealthAndRespond(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(273, 9, -1, 'updateCircuitHealthFailure', TRUE, FALSE, FALSE, '{"label":"updateCircuitHealthFailure(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"updateCircuitHealthFailure(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(274, 9, -1, 'updateCircuitHealthSuccess', TRUE, FALSE, FALSE, '{"label":"updateCircuitHealthSuccess(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"updateCircuitHealthSuccess(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(275, 9, -1, 'handleOpenCircuit', TRUE, FALSE, FALSE, '{"label":"handleOpenCircuit(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(error)`   \n  \n"}},"insertText":"handleOpenCircuit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(276, 9, -1, 'validateCircuitBreakerConfiguration', TRUE, FALSE, FALSE, '{"label":"validateCircuitBreakerConfiguration(http:CircuitBreakerConfig circuitBreakerConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"validateCircuitBreakerConfiguration(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(277, 9, -1, 'getCurrentFailureRatio', TRUE, FALSE, FALSE, '{"label":"getCurrentFailureRatio(http:CircuitHealth circuitHealth)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCalculate Failure at a given point.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n  \n**Returns** `float`   \n- Current failure ratio  \n  \n"}},"insertText":"getCurrentFailureRatio(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(278, 9, -1, 'getTotalRequestsCount', TRUE, FALSE, FALSE, '{"label":"getTotalRequestsCount(http:CircuitHealth circuitHealth)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCalculate total requests count within `RollingWindow`.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n  \n**Returns** `int`   \n- Total requests count  \n  \n"}},"insertText":"getTotalRequestsCount(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(279, 9, -1, 'getCurrentBucketId', TRUE, FALSE, FALSE, '{"label":"getCurrentBucketId(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCalculate the current bucket Id.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`  \n  \n**Returns** `int`   \n- Current bucket id  \n  \n"}},"insertText":"getCurrentBucketId(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(280, 9, -1, 'updateRejectedRequestCount', TRUE, FALSE, FALSE, '{"label":"updateRejectedRequestCount(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nUpdate rejected requests count.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`"}},"insertText":"updateRejectedRequestCount(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(281, 9, -1, 'resetBucketStats', TRUE, FALSE, FALSE, '{"label":"resetBucketStats(http:CircuitHealth circuitHealth, int bucketId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nReset the bucket values to default ones.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: - Circuit Breaker health status.  \n- `int` bucketId: - Id of the bucket should reset."}},"insertText":"resetBucketStats(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(282, 9, -1, 'getEffectiveErrorTime', TRUE, FALSE, FALSE, '{"label":"getEffectiveErrorTime(http:CircuitHealth circuitHealth)(time:Time)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `time:Time`   \n  \n"}},"insertText":"getEffectiveErrorTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(283, 9, -1, 'prepareRollingWindow', TRUE, FALSE, FALSE, '{"label":"prepareRollingWindow(http:CircuitHealth circuitHealth, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPopulate the `RollingWindow` statistics to handle circuit breaking within the `RollingWindow` time frame.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`"}},"insertText":"prepareRollingWindow(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(284, 9, -1, 'reInitializeBuckets', TRUE, FALSE, FALSE, '{"label":"reInitializeBuckets(http:CircuitHealth circuitHealth)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nReinitialize the Buckets to default state.\n  \n**Params**  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status"}},"insertText":"reInitializeBuckets(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(285, 9, -1, 'updateLastUsedBucketId', TRUE, FALSE, FALSE, '{"label":"updateLastUsedBucketId(int bucketId, http:CircuitHealth circuitHealth)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nUpdates the `lastUsedBucketId` in `CircuitHealth`.\n  \n**Params**  \n- `int` bucketId: Possition of the currrently used bucket  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status"}},"insertText":"updateLastUsedBucketId(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(286, 9, -1, 'switchCircuitStateOpenToHalfOpenOnResetTime', TRUE, FALSE, FALSE, '{"label":"switchCircuitStateOpenToHalfOpenOnResetTime(http:CircuitBreakerInferredConfig circuitBreakerInferredConfig, http:CircuitHealth circuitHealth, (OPEN|HALF_OPEN|CLOSED) currentState)((OPEN|HALF_OPEN|CLOSED))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSwitches circuit state from open to half open state when reset time exceeded.\n  \n**Params**  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`  \n- `http:CircuitHealth` circuitHealth: Circuit Breaker health status  \n- `(OPEN|HALF_OPEN|CLOSED)` currentState: current state of the circuit  \n  \n**Returns** `(OPEN|HALF_OPEN|CLOSED)`   \n- Calculated state value of the circuit  \n  \n"}},"insertText":"switchCircuitStateOpenToHalfOpenOnResetTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(287, 9, -1, 'performRetryClientExecuteAction', TRUE, FALSE, FALSE, '{"label":"performRetryClientExecuteAction(string path, http:Request request, string httpVerb, http:RetryClient retryClient, string verb)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performRetryClientExecuteAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(288, 9, -1, 'performRetryAction', TRUE, FALSE, FALSE, '{"label":"performRetryAction(string path, http:Request request, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) requestAction, http:RetryClient retryClient, string verb)((http:Response|http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|http:HttpFuture|error)`   \n  \n"}},"insertText":"performRetryAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(289, 9, -1, 'initializeBackOffFactorAndMaxWaitInterval', TRUE, FALSE, FALSE, '{"label":"initializeBackOffFactorAndMaxWaitInterval(http:RetryClient retryClient)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"initializeBackOffFactorAndMaxWaitInterval(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(290, 9, -1, 'getWaitTime', TRUE, FALSE, FALSE, '{"label":"getWaitTime(float backOffFactor, int maxWaitTime, int interval)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getWaitTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(291, 9, -1, 'calculateEffectiveIntervalAndRetryCount', TRUE, FALSE, FALSE, '{"label":"calculateEffectiveIntervalAndRetryCount(http:RetryClient retryClient, int currentRetryCount, int currentDelay)([int,int])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `[int,int]`   \n  \n"}},"insertText":"calculateEffectiveIntervalAndRetryCount(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(292, 9, -1, 'performLoadBalanceExecuteAction', TRUE, FALSE, FALSE, '{"label":"performLoadBalanceExecuteAction(http:LoadBalanceClient lb, string path, http:Request request, string httpVerb)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"performLoadBalanceExecuteAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(293, 9, -1, 'performLoadBalanceAction', TRUE, FALSE, FALSE, '{"label":"performLoadBalanceAction(http:LoadBalanceClient lb, string path, http:Request request, (FORWARD|GET|POST|DELETE|OPTIONS|PUT|PATCH|HEAD|SUBMIT|NONE) requestAction)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response|error)`   \n  \n"}},"insertText":"performLoadBalanceAction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(294, 9, -1, 'populateGenericLoadBalanceActionError', TRUE, FALSE, FALSE, '{"label":"populateGenericLoadBalanceActionError(http:LoadBalanceActionErrorData loadBalanceActionErrorData)((error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(error)`   \n  \n"}},"insertText":"populateGenericLoadBalanceActionError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(295, 9, -1, 'createClientEPConfigFromLoalBalanceEPConfig', TRUE, FALSE, FALSE, '{"label":"createClientEPConfigFromLoalBalanceEPConfig(http:LoadBalanceClientEndpointConfiguration lbConfig, http:TargetService target)(http:ClientEndpointConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:ClientEndpointConfig`   \n  \n"}},"insertText":"createClientEPConfigFromLoalBalanceEPConfig(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(296, 9, -1, 'createLoadBalanceHttpClientArray', TRUE, FALSE, FALSE, '{"label":"createLoadBalanceHttpClientArray(http:LoadBalanceClientEndpointConfiguration loadBalanceClientConfig)(((http:Client|())[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `((http:Client|())[]|error)`   \n  \n"}},"insertText":"createLoadBalanceHttpClientArray(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(297, 9, -1, 'addAuthFilters', TRUE, FALSE, FALSE, '{"label":"addAuthFilters(http:ListenerConfiguration config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAdds authentication and authorization filters.\n  \n**Params**  \n- `http:ListenerConfiguration` config: `ServiceEndpointConfiguration` instance"}},"insertText":"addAuthFilters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(298, 9, -1, 'addAttributeFilter', TRUE, FALSE, FALSE, '{"label":"addAttributeFilter(http:ListenerConfiguration config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"addAttributeFilter(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(299, 9, -1, 'encode', FALSE, FALSE, FALSE, '{"label":"encode(string url, string charset)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nEncodes the given URL.\n  \n**Params**  \n- `string` url: URL to be encoded  \n- `string` charset: Charactor set that URL to be encoded in  \n  \n**Returns** `(string|error)`   \n- The `string` Value of the encoded url or an `ClientError` that occurred during encoding  \n  \n"}},"insertText":"encode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(300, 9, -1, 'decode', FALSE, FALSE, FALSE, '{"label":"decode(string url, string charset)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nDecodes the given URL.\n  \n**Params**  \n- `string` url: URL to be decoded  \n- `string` charset: Character set from which the URL is decoded  \n  \n**Returns** `(string|error)`   \n- The `string` Value of the decoded url or an `ClientError` that occurred during decoding  \n  \n"}},"insertText":"decode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(301, 9, 14, 'AuthnFilter.filterRequest', FALSE, FALSE, TRUE, '{"label":"filterRequest(http:Caller caller, http:Request request, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe request filter method, which attempts to authenticate the request.\n  \n**Params**  \n- `http:Caller` caller: Caller for outbound HTTP responses  \n- `http:Request` request: An inbound HTTP request message  \n- `http:FilterContext` context: A filter context  \n  \n**Returns** `boolean`   \n- Returns `true` if the filter succeeds. Else, returns `false`.  \n  \n"}},"insertText":"filterRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(302, 9, 14, 'AuthnFilter.filterResponse', FALSE, FALSE, TRUE, '{"label":"filterResponse(http:Response response, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"filterResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(303, 9, 14, 'AuthnFilter.__init', FALSE, FALSE, TRUE, '{"label":"__init((http:InboundAuthHandler[]|http:InboundAuthHandler[][]) authHandlers)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(304, 9, 15, 'AuthzFilter.filterRequest', FALSE, FALSE, TRUE, '{"label":"filterRequest(http:Caller caller, http:Request request, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nFilter function implementation which tries to authorize the request\n  \n**Params**  \n- `http:Caller` caller: Caller for outbound HTTP responses  \n- `http:Request` request: `Request` instance  \n- `http:FilterContext` context: `FilterContext` instance  \n  \n**Returns** `boolean`   \n- A flag to indicate if the request flow should be continued(true) or aborted(false), a code and a message  \n  \n"}},"insertText":"filterRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(305, 9, 15, 'AuthzFilter.filterResponse', FALSE, FALSE, TRUE, '{"label":"filterResponse(http:Response response, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"filterResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(306, 9, 15, 'AuthzFilter.__init', FALSE, FALSE, TRUE, '{"label":"__init(http:AuthzHandler authzHandler, (string[]|string[][]|()) scopes)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(307, 9, 16, 'AuthzHandler.canProcess', TRUE, FALSE, TRUE, '{"label":"canProcess(http:Request req)((boolean|http:AuthorizationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks if the request can be authorized.\n  \n**Params**  \n- `http:Request` req: `Request` instance  \n  \n**Returns** `(boolean|http:AuthorizationError)`   \n- `true` if can be authorized, else `false`, or `AuthorizationError` if error occurred  \n  \n"}},"insertText":"canProcess(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(308, 9, 16, 'AuthzHandler.process', TRUE, FALSE, TRUE, '{"label":"process(string username, string serviceName, string resourceName, string method, (string[]|string[][]) scopes)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to authorize the request.\n  \n**Params**  \n- `string` username: User name  \n- `string` serviceName: `Service` name  \n- `string` resourceName: `Resource` name  \n- `string` method: HTTP method name  \n- `(string[]|string[][])` scopes: Array of scopes or Array of arrays of scopes  \n  \n**Returns** `boolean`   \n- true if authorization check is a success, else false  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(309, 9, 16, 'AuthzHandler.authorizeFromCache', TRUE, FALSE, TRUE, '{"label":"authorizeFromCache(string authzCacheKey)((boolean|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to retrieve authorization decision from the cached information, if any.\n  \n**Params**  \n- `string` authzCacheKey: Cache key  \n  \n**Returns** `(boolean|())`   \n- true or false in case of a cache hit, nil in case of a cache miss  \n  \n"}},"insertText":"authorizeFromCache(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(310, 9, 16, 'AuthzHandler.cacheAuthzResult', TRUE, FALSE, TRUE, '{"label":"cacheAuthzResult(string authzCacheKey, boolean authorized)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCached the authorization result.\n  \n**Params**  \n- `string` authzCacheKey: Cache key  \n- `boolean` authorized: boolean flag to indicate the authorization decision"}},"insertText":"cacheAuthzResult(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(311, 9, 16, 'AuthzHandler.__init', FALSE, FALSE, TRUE, '{"label":"__init((cache:Cache|()) positiveAuthzCache, (cache:Cache|()) negativeAuthzCache)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(312, 9, 17, 'InboundAuthHandler.canProcess', FALSE, FALSE, TRUE, '{"label":"canProcess(http:Request req)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks if the request can be authenticated with the relevant `InboundAuthHandler` implementation.\n  \n**Params**  \n- `http:Request` req: The `Request` instance.  \n  \n**Returns** `boolean`   \n- Returns `true` if can be authenticated. Else, returns `false`.  \n  \n"}},"insertText":"canProcess(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(313, 9, 17, 'InboundAuthHandler.process', FALSE, FALSE, TRUE, '{"label":"process(http:Request req)((boolean|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTries to authenticate the request with the relevant `InboundAuthHandler` implementation.\n  \n**Params**  \n- `http:Request` req: `Request` instance  \n  \n**Returns** `(boolean|http:AuthenticationError)`   \n- `true` if authenticated successfully, else `false` or, `AuthenticationError` in case of errors  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(314, 9, 18, 'OutboundAuthHandler.prepare', FALSE, FALSE, TRUE, '{"label":"prepare(http:Request req)((http:Request|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPrepares the request with the relevant authentication requirements.\n  \n**Params**  \n- `http:Request` req: The `Request` instance.  \n  \n**Returns** `(http:Request|http:AuthenticationError)`   \n- Returns the updated `Request` instance or the `AuthenticationError` in case of an error.  \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(315, 9, 18, 'OutboundAuthHandler.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(http:Request req, http:Response resp)((http:Request|()|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInspects the request and response and evaluates what is to be done.\n\nreq - The `Request` instance.\nresp - The `Response` instance.  \n  \n  \n**Returns** `(http:Request|()|http:AuthenticationError)`   \n- Returns the updated `Request` instance, the `AuthenticationError` in case of an error, or `()` if nothing is to be returned.  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(316, 9, 19, 'RequestCacheControl.buildCacheControlDirectives', FALSE, FALSE, TRUE, '{"label":"buildCacheControlDirectives()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nBuilds the cache control directives string from the current `RequestCacheControl` configurations.\n  \n  \n  \n**Returns** `string`   \n- The cache control directives string to be used in the `cache-control` header  \n  \n"}},"insertText":"buildCacheControlDirectives()","insertTextFormat":"Snippet"}'),
(317, 9, 19, 'RequestCacheControl.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(318, 9, 20, 'ResponseCacheControl.buildCacheControlDirectives', FALSE, FALSE, TRUE, '{"label":"buildCacheControlDirectives()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nBuilds the cache control directives string from the current `ResponseCacheControl` configurations.\n  \n  \n  \n**Returns** `string`   \n- The cache control directives string to be used in the `cache-control` header  \n  \n"}},"insertText":"buildCacheControlDirectives()","insertTextFormat":"Snippet"}'),
(319, 9, 20, 'ResponseCacheControl.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(320, 9, 21, 'HttpCache.isAllowedToCache', TRUE, FALSE, TRUE, '{"label":"isAllowedToCache(http:Response response)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isAllowedToCache(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(321, 9, 21, 'HttpCache.put', TRUE, FALSE, TRUE, '{"label":"put(string key, (http:RequestCacheControl|()) requestCacheControl, http:Response inboundResponse)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"put(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(322, 9, 21, 'HttpCache.isNonCacheableResponse', TRUE, FALSE, TRUE, '{"label":"isNonCacheableResponse((http:RequestCacheControl|()) reqCC, (http:ResponseCacheControl|()) resCC)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isNonCacheableResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(323, 9, 21, 'HttpCache.isCacheableResponse', TRUE, FALSE, TRUE, '{"label":"isCacheableResponse(http:Response inboundResp)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isCacheableResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(324, 9, 21, 'HttpCache.hasKey', TRUE, FALSE, TRUE, '{"label":"hasKey(string key)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"hasKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(325, 9, 21, 'HttpCache.get', TRUE, FALSE, TRUE, '{"label":"get(string key)(http:Response)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Response`   \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(326, 9, 21, 'HttpCache.getAll', TRUE, FALSE, TRUE, '{"label":"getAll(string key)((http:Response[]|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(http:Response[]|())`   \n  \n"}},"insertText":"getAll(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(327, 9, 21, 'HttpCache.getAllByETag', TRUE, FALSE, TRUE, '{"label":"getAllByETag(string key, string etag)(http:Response[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Response[]`   \n  \n"}},"insertText":"getAllByETag(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(328, 9, 21, 'HttpCache.getAllByWeakETag', TRUE, FALSE, TRUE, '{"label":"getAllByWeakETag(string key, string etag)(http:Response[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `http:Response[]`   \n  \n"}},"insertText":"getAllByWeakETag(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(329, 9, 21, 'HttpCache.remove', TRUE, FALSE, TRUE, '{"label":"remove(string key)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(330, 9, 21, 'HttpCache.__init', FALSE, FALSE, TRUE, '{"label":"__init(http:CacheConfig cacheConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreates the HTTP cache.\n  \n**Params**  \n- config: The configurations for the HTTP cache"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(331, 9, 22, 'HttpCachingClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses returned for POST requests are not cacheable. Therefore, the requests are simply directed to the\norigin server. Responses received for POST requests invalidate the cached responses for the same resource.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(332, 9, 22, 'HttpCachingClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses for HEAD requests are cacheable and as such, will be routed through the HTTP cache. Only if a\nsuitable response cannot be found will the request be directed to the origin server.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(333, 9, 22, 'HttpCachingClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses returned for PUT requests are not cacheable. Therefore, the requests are simply directed to the\norigin server. In addition, PUT requests invalidate the currently stored responses for the given path.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(334, 9, 22, 'HttpCachingClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpMethod, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInvokes an HTTP call with the specified HTTP method. This is not a cacheable operation, unless the HTTP method\nused is GET or HEAD.\n  \n**Params**  \n- `string` httpMethod: HTTP method to be used for the request  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(335, 9, 22, 'HttpCachingClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses returned for PATCH requests are not cacheable. Therefore, the requests are simply directed to\nthe origin server. Responses received for PATCH requests invalidate the cached responses for the same resource.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(336, 9, 22, 'HttpCachingClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses returned for DELETE requests are not cacheable. Therefore, the requests are simply directed to the\norigin server. Responses received for DELETE requests invalidate the cached responses for the same resource.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(337, 9, 22, 'HttpCachingClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses for GET requests are cacheable and as such, will be routed through the HTTP cache. Only if a suitable\nresponse cannot be found will the request be directed to the origin server.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(338, 9, 22, 'HttpCachingClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponses returned for OPTIONS requests are not cacheable. Therefore, the requests are simply directed to the\norigin server. Responses received for OPTIONS requests invalidate the cached responses for the same resource.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(339, 9, 22, 'HttpCachingClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nForward remote function can be used to invoke an HTTP call with inbound request\u0027s HTTP method. Only inbound requests of\nGET and HEAD HTTP method types are cacheable.\n  \n**Params**  \n- `string` path: Request path  \n- `http:Request` request: The HTTP request to be forwarded  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(340, 9, 22, 'HttpCachingClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an error if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(341, 9, 22, 'HttpCachingClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` related to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(342, 9, 22, 'HttpCachingClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether a `PushPromise` exists for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(343, 9, 22, 'HttpCachingClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(344, 9, 22, 'HttpCachingClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(345, 9, 22, 'HttpCachingClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRejects a `PushPromise`. When a `PushPromise` is rejected, there is no chance of fetching a promised\nresponse using the rejected promise.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(346, 9, 22, 'HttpCachingClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, http:ClientEndpointConfig config, http:CacheConfig cacheConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nTakes a service URL, a `CliendEndpointConfig` and a `CacheConfig` and builds an HTTP client capable of\ncaching responses. The `CacheConfig` instance is used for initializing a new HTTP cache for the client and\nthe `ClientEndpointConfig` is used for creating the underlying HTTP client.\n  \n**Params**  \n- `string` url: The URL of the HTTP endpoint to connect to  \n- `http:ClientEndpointConfig` config: The configurations for the client endpoint associated with the caching client  \n- `http:CacheConfig` cacheConfig: The configurations for the HTTP cache to be used with the caching client"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(347, 9, 23, 'Client.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `post()` function can be used to send HTTP POST requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(348, 9, 23, 'Client.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `head()` function can be used to send HTTP HEAD requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(349, 9, 23, 'Client.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `put()` function can be used to send HTTP PUT requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(350, 9, 23, 'Client.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInvokes an HTTP call with the specified HTTP verb.\n  \n**Params**  \n- `string` httpVerb: HTTP verb value  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(351, 9, 23, 'Client.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `patch()` function can be used to send HTTP PATCH requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(352, 9, 23, 'Client.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `delete()` function can be used to send HTTP DELETE requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(353, 9, 23, 'Client.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `get()` function can be used to send HTTP GET requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(354, 9, 23, 'Client.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `options()` function can be used to send HTTP OPTIONS requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(355, 9, 23, 'Client.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `forward()` function can be used to invoke an HTTP call with inbound request\u0027s HTTP verb\n  \n**Params**  \n- `string` path: Request path  \n- `http:Request` request: An HTTP inbound request message  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(356, 9, 23, 'Client.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\nThe `submit()` function does not give out a `Response` as the result,\nrather it returns an `HttpFuture` which can be used to do further interactions with the endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an `http:ClientError` if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(357, 9, 23, 'Client.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an error if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(358, 9, 23, 'Client.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(359, 9, 23, 'Client.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an error if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(360, 9, 23, 'Client.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(361, 9, 23, 'Client.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(362, 9, 23, 'Client.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, (http:ClientEndpointConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets invoked to initialize the client. During initialization, configurations provided through the `config`\nrecord is used to determine which type of additional behaviours are added to the endpoint (e.g: caching,\nsecurity, circuit breaking).\n  \n**Params**  \n- `string` url: URL of the target service  \n- `(http:ClientEndpointConfig|())` config: The configurations to be used when initializing the client(Defaultable)  \n- `(http:ClientEndpointConfig|())` config: The configurations to be used when initializing the client"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(363, 9, 24, 'HttpFuture.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(364, 9, 25, 'PushPromise.hasHeader', FALSE, FALSE, TRUE, '{"label":"hasHeader(string headerName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether the requested header exists.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `boolean`   \n- A `boolean` representing the existence of a given header  \n  \n"}},"insertText":"hasHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(365, 9, 25, 'PushPromise.getHeader', FALSE, FALSE, TRUE, '{"label":"getHeader(string headerName)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nReturns the header value with the specified header name.\nIf there are more than one header value for the specified header name, the first value is returned.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string`   \n- The header value, or null if there is no such header  \n  \n"}},"insertText":"getHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(366, 9, 25, 'PushPromise.getHeaders', FALSE, FALSE, TRUE, '{"label":"getHeaders(string headerName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets transport headers from the `PushPromise`.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string[]`   \n- The array of header values  \n  \n"}},"insertText":"getHeaders(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(367, 9, 25, 'PushPromise.addHeader', FALSE, FALSE, TRUE, '{"label":"addHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAdds the specified key/value pair as an HTTP header to the `PushPromise`.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"addHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(368, 9, 25, 'PushPromise.setHeader', FALSE, FALSE, TRUE, '{"label":"setHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the value of a transport header in `PushPromise`.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"setHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(369, 9, 25, 'PushPromise.removeHeader', FALSE, FALSE, TRUE, '{"label":"removeHeader(string headerName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves a transport header from the `PushPromise`.\n  \n**Params**  \n- `string` headerName: The header name"}},"insertText":"removeHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(370, 9, 25, 'PushPromise.removeAllHeaders', FALSE, FALSE, TRUE, '{"label":"removeAllHeaders()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves all transport headers from the `PushPromise`.  \n"}},"insertText":"removeAllHeaders();","insertTextFormat":"Snippet"}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(371, 9, 25, 'PushPromise.getHeaderNames', FALSE, FALSE, TRUE, '{"label":"getHeaderNames()(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all transport header names from the `PushPromise`.\n  \n  \n  \n**Returns** `string[]`   \n- An array of all transport header names  \n  \n"}},"insertText":"getHeaderNames()","insertTextFormat":"Snippet"}'),
(372, 9, 25, 'PushPromise.__init', FALSE, FALSE, TRUE, '{"label":"__init(string path, string method)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nConstructs a `PushPromise` from a given path and a method.\n  \n**Params**  \n- `string` path: The resource path(Defaultable)  \n- `string` path: The resource path  \n- `string` method: The HTTP method(Defaultable)  \n- `string` method: The HTTP method"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(373, 9, 26, 'HttpClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `post()` function can be used to send HTTP POST requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(374, 9, 26, 'HttpClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `head()` function can be used to send HTTP HEAD requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(375, 9, 26, 'HttpClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `put()` function can be used to send HTTP PUT requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(376, 9, 26, 'HttpClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInvokes an HTTP call with the specified HTTP verb.\n  \n**Params**  \n- `string` httpVerb: HTTP verb value  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(377, 9, 26, 'HttpClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `patch()` function can be used to send HTTP PATCH requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(378, 9, 26, 'HttpClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `delete()` function can be used to send HTTP DELETE requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(379, 9, 26, 'HttpClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `get()` function can be used to send HTTP GET requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(380, 9, 26, 'HttpClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `options()` function can be used to send HTTP OPTIONS requests to HTTP endpoints.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(381, 9, 26, 'HttpClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `forward()` function can be used to invoke an HTTP call with inbound request\u0027s HTTP verb\n  \n**Params**  \n- `string` path: Request path  \n- `http:Request` request: An HTTP inbound request message  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `ClientError` if failed to establish communication with the upstream server  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(382, 9, 26, 'HttpClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\nThe `submit()` function does not give out a `Response` as the result,\nrather it returns an `HttpFuture` which can be used to do further interactions with the endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an `ClientError` if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(383, 9, 26, 'HttpClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` related to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(384, 9, 26, 'HttpClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether a `PushPromise` exists for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(385, 9, 26, 'HttpClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(386, 9, 26, 'HttpClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(387, 9, 26, 'HttpClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRejects a `PushPromise`. When a `PushPromise` is rejected, there is no chance of fetching a promised\nresponse using the rejected promise.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(388, 9, 26, 'HttpClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, (http:ClientEndpointConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(389, 9, 27, 'ConnectionManager.initGlobalPool', TRUE, FALSE, TRUE, '{"label":"initGlobalPool(http:PoolConfiguration poolConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"initGlobalPool(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(390, 9, 27, 'ConnectionManager.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(391, 9, 28, 'Caller.respond', FALSE, TRUE, TRUE, '{"label":"respond((http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends the outbound response to the caller.\n  \n**Params**  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to respond  \n  \n"}},"insertText":"respond(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(392, 9, 28, 'Caller.promise', FALSE, TRUE, TRUE, '{"label":"promise(http:PushPromise promise)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPushes a promise to the caller.\n  \n**Params**  \n- `http:PushPromise` promise: Push promise message  \n  \n**Returns** `(()|error)`   \n- An `http:ListenerError` in case of failures  \n  \n"}},"insertText":"promise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(393, 9, 28, 'Caller.pushPromisedResponse', FALSE, TRUE, TRUE, '{"label":"pushPromisedResponse(http:PushPromise promise, http:Response response)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends a promised push response to the caller.\n  \n**Params**  \n- `http:PushPromise` promise: Push promise message  \n- `http:Response` response: The outbound response  \n  \n**Returns** `(()|error)`   \n- An `http:ListenerError` in case of failures while responding with the promised response  \n  \n"}},"insertText":"pushPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(394, 9, 28, 'Caller.acceptWebSocketUpgrade', FALSE, TRUE, TRUE, '{"label":"acceptWebSocketUpgrade(map\u003cstring\u003e headers)(http:WebSocketCaller)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends an upgrade request with custom headers.\n  \n**Params**  \n- `map\u003cstring\u003e` headers: A `map` of custom headers for handshake  \n  \n**Returns** `http:WebSocketCaller`   \n- WebSocket service endpoint  \n  \n"}},"insertText":"acceptWebSocketUpgrade(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(395, 9, 28, 'Caller.cancelWebSocketUpgrade', FALSE, TRUE, TRUE, '{"label":"cancelWebSocketUpgrade(int status, string reason)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCancels the handshake.\n  \n**Params**  \n- `int` status: Error Status code for cancelling the upgrade and closing the connection.\n           This error status code need to be 4xx or 5xx else the default status code would be 400.  \n- `string` reason: Reason for cancelling the upgrade  \n  \n**Returns** `(()|error)`   \n- An `error` if an error occurs during cancelling the upgrade or nil  \n  \n"}},"insertText":"cancelWebSocketUpgrade(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(396, 9, 28, 'Caller.continue', FALSE, TRUE, TRUE, '{"label":"continue()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends a `100-continue` response to the caller.\n  \n  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to send the `100-continue` response  \n  \n"}},"insertText":"continue()","insertTextFormat":"Snippet"}'),
(397, 9, 28, 'Caller.redirect', FALSE, TRUE, TRUE, '{"label":"redirect(http:Response response, (300|301|302|303|304|305|307|308) code, string[] locations)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends a redirect response to the user with the specified redirection status code.\n  \n**Params**  \n- `http:Response` response: Response to be sent to the caller  \n- `(300|301|302|303|304|305|307|308)` code: The redirect status code to be sent  \n- `string[]` locations: An array of URLs to which the caller can redirect to  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to send the redirect response  \n  \n"}},"insertText":"redirect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(398, 9, 28, 'Caller.ok', FALSE, TRUE, TRUE, '{"label":"ok((http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends the outbound response to the caller with the status 200 OK.\n  \n**Params**  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to respond  \n  \n"}},"insertText":"ok(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(399, 9, 28, 'Caller.created', FALSE, TRUE, TRUE, '{"label":"created(string uri, (http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends the outbound response to the caller with the status 201 Created.\n  \n**Params**  \n- `string` uri: Represents the most specific URI for the newly created resource  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`. This message is optional.(Defaultable)  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`. This message is optional.  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to respond  \n  \n"}},"insertText":"created(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(400, 9, 28, 'Caller.accepted', FALSE, TRUE, TRUE, '{"label":"accepted((http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSends the outbound response to the caller with the status 202 Accepted.\n  \n**Params**  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`. This message is optional.(Defaultable)  \n- `(http:Response|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: The outbound response or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`. This message is optional.  \n  \n**Returns** `(()|error)`   \n- Returns an `http:ListenerError` if failed to respond  \n  \n"}},"insertText":"accepted(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(401, 9, 28, 'Caller.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(402, 9, 29, 'RequestFilter.filterRequest', FALSE, FALSE, TRUE, '{"label":"filterRequest(http:Caller caller, http:Request request, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRequest filter function. If a false is returned the response should have been sent from this function as it will\nnot be dispatched to the next filter or the resource.\n  \n**Params**  \n- `http:Caller` caller: The http caller  \n- `http:Request` request: An inbound HTTP request message  \n- `http:FilterContext` context: A filter context  \n  \n**Returns** `boolean`   \n- True if the filter succeeds  \n  \n"}},"insertText":"filterRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(403, 9, 30, 'ResponseFilter.filterResponse', FALSE, FALSE, TRUE, '{"label":"filterResponse(http:Response response, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nResponse filter function. If a false is returned a 500 Internal Server Error would be sent to the client.\n  \n**Params**  \n- `http:Response` response: An outbound HTTP response message  \n- `http:FilterContext` context: A filter context  \n  \n**Returns** `boolean`   \n- True if the filter succeeds  \n  \n"}},"insertText":"filterResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(404, 9, 31, 'FilterContext.getService', FALSE, FALSE, TRUE, '{"label":"getService()(service)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `service`   \n  \n"}},"insertText":"getService()","insertTextFormat":"Snippet"}'),
(405, 9, 31, 'FilterContext.getServiceName', FALSE, FALSE, TRUE, '{"label":"getServiceName()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getServiceName()","insertTextFormat":"Snippet"}'),
(406, 9, 31, 'FilterContext.getResourceName', FALSE, FALSE, TRUE, '{"label":"getResourceName()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getResourceName()","insertTextFormat":"Snippet"}'),
(407, 9, 31, 'FilterContext.__init', FALSE, FALSE, TRUE, '{"label":"__init(service serviceRef, string serviceName, string resourceName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(408, 9, 32, 'Request.createNewEntity', TRUE, FALSE, TRUE, '{"label":"createNewEntity()(mime:Entity)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreate a new `Entity` and link it with the request.\n  \n  \n  \n**Returns** `mime:Entity`   \n- Newly created `Entity` that has been set to the request  \n  \n"}},"insertText":"createNewEntity()","insertTextFormat":"Snippet"}'),
(409, 9, 32, 'Request.setEntity', FALSE, FALSE, TRUE, '{"label":"setEntity(mime:Entity e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the provided `Entity` to the request.\n  \n**Params**  \n- `mime:Entity` e: The `Entity` to be set to the request"}},"insertText":"setEntity(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(410, 9, 32, 'Request.getQueryParams', FALSE, FALSE, TRUE, '{"label":"getQueryParams()(map\u003cstring[]\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the query parameters of the request as a map consisting of a string array.\n  \n  \n  \n**Returns** `map\u003cstring[]\u003e`   \n- String array map of the query params  \n  \n"}},"insertText":"getQueryParams()","insertTextFormat":"Snippet"}'),
(411, 9, 32, 'Request.getQueryParamValue', FALSE, FALSE, TRUE, '{"label":"getQueryParamValue(string key)((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the query param value associated with the given key.\n  \n**Params**  \n- `string` key: Represents the query param key  \n  \n**Returns** `(string|())`   \n- Returns the query param value associated with the given key as a string. If multiple param values are  \n           present, then the first value is returned. Nil is returned if no key is found.  \n  \n"}},"insertText":"getQueryParamValue(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(412, 9, 32, 'Request.getQueryParamValues', FALSE, FALSE, TRUE, '{"label":"getQueryParamValues(string key)((string[]|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all the query param values associated with the given key.\n  \n**Params**  \n- `string` key: Represents the query param key  \n  \n**Returns** `(string[]|())`   \n- Returns all the query param values associated with the given key as a `string[]`. Nil is returned if no key  \n           is found.  \n  \n"}},"insertText":"getQueryParamValues(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(413, 9, 32, 'Request.getMatrixParams', FALSE, FALSE, TRUE, '{"label":"getMatrixParams(string path)(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the matrix parameters of the request.\n  \n**Params**  \n- `string` path: Path to the location of matrix parameters  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of matrix parameters which can be found for the given path  \n  \n"}},"insertText":"getMatrixParams(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(414, 9, 32, 'Request.getEntity', FALSE, FALSE, TRUE, '{"label":"getEntity()((mime:Entity|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the `Entity` associated with the request.\n  \n  \n  \n**Returns** `(mime:Entity|error)`   \n- The `Entity` of the request. An `http:ClientError` is returned, if entity construction fails  \n  \n"}},"insertText":"getEntity()","insertTextFormat":"Snippet"}'),
(415, 9, 32, 'Request.getEntityWithoutBody', TRUE, FALSE, TRUE, '{"label":"getEntityWithoutBody()(mime:Entity)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `mime:Entity`   \n  \n"}},"insertText":"getEntityWithoutBody()","insertTextFormat":"Snippet"}'),
(416, 9, 32, 'Request.hasHeader', FALSE, FALSE, TRUE, '{"label":"hasHeader(string headerName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether the requested header key exists in the header map.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `boolean`   \n- Returns true if the specified header key exists  \n  \n"}},"insertText":"hasHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(417, 9, 32, 'Request.getHeader', FALSE, FALSE, TRUE, '{"label":"getHeader(string headerName)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nReturns the value of the specified header. If the specified header key maps to multiple values, the first of\nthese values is returned.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string`   \n- The first header value for the specified header name. An exception is thrown if no header is found. Use  \n           `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(418, 9, 32, 'Request.getHeaders', FALSE, FALSE, TRUE, '{"label":"getHeaders(string headerName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all the header values to which the specified header key maps to.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string[]`   \n- The header values the specified header key maps to. An exception is thrown if no header is found. Use  \n           `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeaders(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(419, 9, 32, 'Request.setHeader', FALSE, FALSE, TRUE, '{"label":"setHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the specified header to the request. If a mapping already exists for the specified header key, the existing\nheader value is replaced with the specified header value.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"setHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(420, 9, 32, 'Request.addHeader', FALSE, FALSE, TRUE, '{"label":"addHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAdds the specified header to the request. Existing header values are not replaced.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"addHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(421, 9, 32, 'Request.removeHeader', FALSE, FALSE, TRUE, '{"label":"removeHeader(string key)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves the specified header from the request.\n  \n**Params**  \n- `string` key: The header name"}},"insertText":"removeHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(422, 9, 32, 'Request.removeAllHeaders', FALSE, FALSE, TRUE, '{"label":"removeAllHeaders()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves all the headers from the request.  \n"}},"insertText":"removeAllHeaders();","insertTextFormat":"Snippet"}'),
(423, 9, 32, 'Request.getHeaderNames', FALSE, FALSE, TRUE, '{"label":"getHeaderNames()(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all the names of the headers of the request.\n  \n  \n  \n**Returns** `string[]`   \n- An array of all the header names  \n  \n"}},"insertText":"getHeaderNames()","insertTextFormat":"Snippet"}'),
(424, 9, 32, 'Request.expects100Continue', FALSE, FALSE, TRUE, '{"label":"expects100Continue()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether the client expects a `100-continue` response.\n  \n  \n  \n**Returns** `boolean`   \n- Returns true if the client expects a `100-continue` response  \n  \n"}},"insertText":"expects100Continue()","insertTextFormat":"Snippet"}'),
(425, 9, 32, 'Request.setContentType', FALSE, FALSE, TRUE, '{"label":"setContentType(string contentType)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the `content-type` header to the request.\n  \n**Params**  \n- `string` contentType: Content type value to be set as the `content-type` header  \n  \n**Returns** `(()|error)`   \n- Nil if successful, error in case of invalid content-type  \n  \n"}},"insertText":"setContentType(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(426, 9, 32, 'Request.getContentType', FALSE, FALSE, TRUE, '{"label":"getContentType()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the type of the payload of the request (i.e: the `content-type` header value).\n  \n  \n  \n**Returns** `string`   \n- Returns the `content-type` header value as a string  \n  \n"}},"insertText":"getContentType()","insertTextFormat":"Snippet"}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(427, 9, 32, 'Request.getJsonPayload', FALSE, FALSE, TRUE, '{"label":"getJsonPayload()((json|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts `json` payload from the request. If the content type is not JSON, an `http:ClientError` is returned.\n  \n  \n  \n**Returns** `(json|error)`   \n- The `json` payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getJsonPayload()","insertTextFormat":"Snippet"}'),
(428, 9, 32, 'Request.getXmlPayload', FALSE, FALSE, TRUE, '{"label":"getXmlPayload()((xml|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts `xml` payload from the request. If the content type is not XML, an `http:ClientError` is returned.\n  \n  \n  \n**Returns** `(xml|error)`   \n- The `xml` payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getXmlPayload()","insertTextFormat":"Snippet"}'),
(429, 9, 32, 'Request.getTextPayload', FALSE, FALSE, TRUE, '{"label":"getTextPayload()((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts `text` payload from the request. If the content type is not of type text, an `http:ClientError` is returned.\n  \n  \n  \n**Returns** `(string|error)`   \n- The `text` payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getTextPayload()","insertTextFormat":"Snippet"}'),
(430, 9, 32, 'Request.getByteChannel', FALSE, FALSE, TRUE, '{"label":"getByteChannel()((io:ReadableByteChannel|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the request payload as a `ByteChannel` except in the case of multiparts. To retrieve multiparts, use\n`getBodyParts()`.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|error)`   \n- A byte channel from which the message payload can be read or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getByteChannel()","insertTextFormat":"Snippet"}'),
(431, 9, 32, 'Request.getBinaryPayload', FALSE, FALSE, TRUE, '{"label":"getBinaryPayload()((byte[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the request payload as a `byte[]`.\n  \n  \n  \n**Returns** `(byte[]|error)`   \n- The byte[] representation of the message payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getBinaryPayload()","insertTextFormat":"Snippet"}'),
(432, 9, 32, 'Request.getFormParams', FALSE, FALSE, TRUE, '{"label":"getFormParams()((map\u003cstring\u003e|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the form parameters from the HTTP request as a `map` when content type is application/x-www-form-urlencoded.\n  \n  \n  \n**Returns** `(map\u003cstring\u003e|error)`   \n- The map of form params or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getFormParams()","insertTextFormat":"Snippet"}'),
(433, 9, 32, 'Request.getBodyParts', FALSE, FALSE, TRUE, '{"label":"getBodyParts()((mime:Entity[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts body parts from the request. If the content type is not a composite media type, an error\nis returned.  \n  \n  \n**Returns** `(mime:Entity[]|error)`   \n- Returns the body parts as an array of entities or an `http:ClientError` if there were any errors in  \n           constructing the body parts from the request  \n  \n"}},"insertText":"getBodyParts()","insertTextFormat":"Snippet"}'),
(434, 9, 32, 'Request.setJsonPayload', FALSE, FALSE, TRUE, '{"label":"setJsonPayload(json payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `json` as the payload.\n  \n**Params**  \n- `json` payload: The `json` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `json`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `json`"}},"insertText":"setJsonPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(435, 9, 32, 'Request.setXmlPayload', FALSE, FALSE, TRUE, '{"label":"setXmlPayload(xml payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets an `xml` as the payload.\n  \n**Params**  \n- `xml` payload: The `xml` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `xml`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `xml`"}},"insertText":"setXmlPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(436, 9, 32, 'Request.setTextPayload', FALSE, FALSE, TRUE, '{"label":"setTextPayload(string payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `string` as the payload.\n  \n**Params**  \n- `string` payload: The `string` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `string`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `string`"}},"insertText":"setTextPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(437, 9, 32, 'Request.setBinaryPayload', FALSE, FALSE, TRUE, '{"label":"setBinaryPayload(byte[] payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `byte[]` as the payload.\n  \n**Params**  \n- `byte[]` payload: The `byte[]` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `byte[]`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `byte[]`"}},"insertText":"setBinaryPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(438, 9, 32, 'Request.setBodyParts', FALSE, FALSE, TRUE, '{"label":"setBodyParts(mime:Entity[] bodyParts, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSet multiparts as the payload.\n  \n**Params**  \n- `mime:Entity[]` bodyParts: The entities which make up the message body  \n- `string` contentType: The content type of the top level message. Set this to override the default\n                `content-type` header value(Defaultable)  \n- `string` contentType: The content type of the top level message. Set this to override the default\n                `content-type` header value"}},"insertText":"setBodyParts(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(439, 9, 32, 'Request.setFileAsPayload', FALSE, FALSE, TRUE, '{"label":"setFileAsPayload(string filePath, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the content of the specified file as the entity body of the request.\n  \n**Params**  \n- `string` filePath: Path to the file to be set as the payload  \n- `string` contentType: The content type of the specified file. Set this to override the default `content-type`\n                header value(Defaultable)  \n- `string` contentType: The content type of the specified file. Set this to override the default `content-type`\n                header value"}},"insertText":"setFileAsPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(440, 9, 32, 'Request.setByteChannel', FALSE, FALSE, TRUE, '{"label":"setByteChannel(io:ReadableByteChannel payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `ByteChannel` as the payload.\n  \n**Params**  \n- `io:ReadableByteChannel` payload: A `ByteChannel` through which the message payload can be read  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type`\n                header value(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type`\n                header value"}},"insertText":"setByteChannel(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(441, 9, 32, 'Request.setPayload', FALSE, FALSE, TRUE, '{"label":"setPayload((string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) payload)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the request payload. Note that any string value is set as `text/plain`. To send a JSON-compatible string,\nset the content-type header to `application/json` or use the `setJsonPayload` method instead.\n  \n**Params**  \n- `(string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` payload: Payload can be of type `string`, `xml`, `json`, `byte[]`, `ByteChannel`, or `Entity[]` (i.e., a set\nof body parts)."}},"insertText":"setPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(442, 9, 32, 'Request.parseCacheControlHeader', TRUE, FALSE, TRUE, '{"label":"parseCacheControlHeader()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"parseCacheControlHeader();","insertTextFormat":"Snippet"}'),
(443, 9, 32, 'Request.checkEntityBodyAvailability', TRUE, FALSE, TRUE, '{"label":"checkEntityBodyAvailability()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCheck whether the entity body is present.\n  \n  \n  \n**Returns** `boolean`   \n- a boolean indicating entity body availability  \n  \n"}},"insertText":"checkEntityBodyAvailability()","insertTextFormat":"Snippet"}'),
(444, 9, 32, 'Request.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(445, 9, 33, 'Response.createNewEntity', TRUE, FALSE, TRUE, '{"label":"createNewEntity()(mime:Entity)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreate a new `Entity` and link it with the response.\n  \n  \n  \n**Returns** `mime:Entity`   \n- Newly created `Entity` that has been set to the response  \n  \n"}},"insertText":"createNewEntity()","insertTextFormat":"Snippet"}'),
(446, 9, 33, 'Response.getEntity', FALSE, FALSE, TRUE, '{"label":"getEntity()((mime:Entity|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the `Entity` associated with the response.\n  \n  \n  \n**Returns** `(mime:Entity|error)`   \n- The `Entity` of the response. An `http:ClientError` is returned, if entity construction fails  \n  \n"}},"insertText":"getEntity()","insertTextFormat":"Snippet"}'),
(447, 9, 33, 'Response.getEntityWithoutBody', TRUE, FALSE, TRUE, '{"label":"getEntityWithoutBody()(mime:Entity)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `mime:Entity`   \n  \n"}},"insertText":"getEntityWithoutBody()","insertTextFormat":"Snippet"}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(448, 9, 33, 'Response.setEntity', FALSE, FALSE, TRUE, '{"label":"setEntity(mime:Entity e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the provided `Entity` to the response.\n  \n**Params**  \n- `mime:Entity` e: The `Entity` to be set to the response"}},"insertText":"setEntity(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(449, 9, 33, 'Response.hasHeader', FALSE, FALSE, TRUE, '{"label":"hasHeader(string headerName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether the requested header key exists in the header map.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `boolean`   \n- Returns true if the specified header key exists  \n  \n"}},"insertText":"hasHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(450, 9, 33, 'Response.getHeader', FALSE, FALSE, TRUE, '{"label":"getHeader(string headerName)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nReturns the value of the specified header. If the specified header key maps to multiple values, the first of\nthese values is returned.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string`   \n- The first header value for the specified header name. An exception is thrown if no header is found. Use  \n           `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(451, 9, 33, 'Response.addHeader', FALSE, FALSE, TRUE, '{"label":"addHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAdds the specified header to the response. Existing header values are not replaced.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"addHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(452, 9, 33, 'Response.getHeaders', FALSE, FALSE, TRUE, '{"label":"getHeaders(string headerName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all the header values to which the specified header key maps to.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string[]`   \n- The header values the specified header key maps to. An exception is thrown if no header is found. Use  \n           `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeaders(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(453, 9, 33, 'Response.setHeader', FALSE, FALSE, TRUE, '{"label":"setHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the specified header to the response. If a mapping already exists for the specified header key, the\nexisting header value is replaced with the specified header value.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: The header value"}},"insertText":"setHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(454, 9, 33, 'Response.removeHeader', FALSE, FALSE, TRUE, '{"label":"removeHeader(string key)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves the specified header from the response.\n  \n**Params**  \n- `string` key: The header name"}},"insertText":"removeHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(455, 9, 33, 'Response.removeAllHeaders', FALSE, FALSE, TRUE, '{"label":"removeAllHeaders()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves all the headers from the response.  \n"}},"insertText":"removeAllHeaders();","insertTextFormat":"Snippet"}'),
(456, 9, 33, 'Response.getHeaderNames', FALSE, FALSE, TRUE, '{"label":"getHeaderNames()(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets all the names of the headers of the response.\n  \n  \n  \n**Returns** `string[]`   \n- An array of all the header names  \n  \n"}},"insertText":"getHeaderNames()","insertTextFormat":"Snippet"}'),
(457, 9, 33, 'Response.setContentType', FALSE, FALSE, TRUE, '{"label":"setContentType(string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the `content-type` header to the response.\n  \n**Params**  \n- `string` contentType: Content type value to be set as the `content-type` header"}},"insertText":"setContentType(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(458, 9, 33, 'Response.getContentType', FALSE, FALSE, TRUE, '{"label":"getContentType()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the type of the payload of the response (i.e: the `content-type` header value).\n  \n  \n  \n**Returns** `string`   \n- Returns the `content-type` header value as a string  \n  \n"}},"insertText":"getContentType()","insertTextFormat":"Snippet"}'),
(459, 9, 33, 'Response.getJsonPayload', FALSE, FALSE, TRUE, '{"label":"getJsonPayload()((json|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtract `json` payload from the response. If the content type is not JSON, an `http:ClientError` is returned.\n  \n  \n  \n**Returns** `(json|error)`   \n- The `json` payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getJsonPayload()","insertTextFormat":"Snippet"}'),
(460, 9, 33, 'Response.getXmlPayload', FALSE, FALSE, TRUE, '{"label":"getXmlPayload()((xml|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts `xml` payload from the response.\n  \n  \n  \n**Returns** `(xml|error)`   \n- The `xml` payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getXmlPayload()","insertTextFormat":"Snippet"}'),
(461, 9, 33, 'Response.getTextPayload', FALSE, FALSE, TRUE, '{"label":"getTextPayload()((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts `text` payload from the response.\n  \n  \n  \n**Returns** `(string|error)`   \n- The string representation of the message payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getTextPayload()","insertTextFormat":"Snippet"}'),
(462, 9, 33, 'Response.getByteChannel', FALSE, FALSE, TRUE, '{"label":"getByteChannel()((io:ReadableByteChannel|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the response payload as a `ByteChannel`, except in the case of multiparts. To retrieve multiparts, use\n`getBodyParts()`.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|error)`   \n- A byte channel from which the message payload can be read or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getByteChannel()","insertTextFormat":"Snippet"}'),
(463, 9, 33, 'Response.getBinaryPayload', FALSE, FALSE, TRUE, '{"label":"getBinaryPayload()((byte[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets the response payload as a `byte[]`.\n  \n  \n  \n**Returns** `(byte[]|error)`   \n- The byte[] representation of the message payload or `http:ClientError` in case of errors  \n  \n"}},"insertText":"getBinaryPayload()","insertTextFormat":"Snippet"}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(464, 9, 33, 'Response.getBodyParts', FALSE, FALSE, TRUE, '{"label":"getBodyParts()((mime:Entity[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nExtracts body parts from the response. If the content type is not a composite media type, an error is returned.\n  \n  \n  \n**Returns** `(mime:Entity[]|error)`   \n- Returns the body parts as an array of entities or an `http:ClientError` if there were any errors in  \n           constructing the body parts from the response  \n  \n"}},"insertText":"getBodyParts()","insertTextFormat":"Snippet"}'),
(465, 9, 33, 'Response.setETag', FALSE, FALSE, TRUE, '{"label":"setETag((json|xml|string|byte[]) payload)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the `etag` header for the given payload. The ETag is generated using a CRC32 hash function.\n  \n**Params**  \n- `(json|xml|string|byte[])` payload: The payload for which the ETag should be set"}},"insertText":"setETag(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(466, 9, 33, 'Response.setLastModified', FALSE, FALSE, TRUE, '{"label":"setLastModified()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the current time as the `last-modified` header.  \n"}},"insertText":"setLastModified();","insertTextFormat":"Snippet"}'),
(467, 9, 33, 'Response.setJsonPayload', FALSE, FALSE, TRUE, '{"label":"setJsonPayload(json payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `json` as the payload.\n  \n**Params**  \n- `json` payload: The `json` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `json`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `json`"}},"insertText":"setJsonPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(468, 9, 33, 'Response.setXmlPayload', FALSE, FALSE, TRUE, '{"label":"setXmlPayload(xml payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets an `xml` as the payload\n  \n**Params**  \n- `xml` payload: The `xml` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `xml`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `xml`"}},"insertText":"setXmlPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(469, 9, 33, 'Response.setTextPayload', FALSE, FALSE, TRUE, '{"label":"setTextPayload(string payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `string` as the payload.\n  \n**Params**  \n- `string` payload: The `string` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `string`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `string`"}},"insertText":"setTextPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(470, 9, 33, 'Response.setBinaryPayload', FALSE, FALSE, TRUE, '{"label":"setBinaryPayload(byte[] payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `byte[]` as the payload.\n  \n**Params**  \n- `byte[]` payload: The `byte[]` payload  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `byte[]`(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type` header value\n                for `byte[]`"}},"insertText":"setBinaryPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(471, 9, 33, 'Response.setBodyParts', FALSE, FALSE, TRUE, '{"label":"setBodyParts(mime:Entity[] bodyParts, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSet multiparts as the payload.\n  \n**Params**  \n- `mime:Entity[]` bodyParts: The entities which make up the message body  \n- `string` contentType: The content type of the top level message. Set this to override the default\n                `content-type` header value(Defaultable)  \n- `string` contentType: The content type of the top level message. Set this to override the default\n                `content-type` header value"}},"insertText":"setBodyParts(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(472, 9, 33, 'Response.setFileAsPayload', FALSE, FALSE, TRUE, '{"label":"setFileAsPayload(string filePath, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the content of the specified file as the entity body of the response.\n  \n**Params**  \n- `string` filePath: Path to the file to be set as the payload  \n- `string` contentType: The content type of the specified file. Set this to override the default `content-type`\n                header value(Defaultable)  \n- `string` contentType: The content type of the specified file. Set this to override the default `content-type`\n                header value"}},"insertText":"setFileAsPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(473, 9, 33, 'Response.setByteChannel', FALSE, FALSE, TRUE, '{"label":"setByteChannel(io:ReadableByteChannel payload, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a `ByteChannel` as the payload.\n  \n**Params**  \n- `io:ReadableByteChannel` payload: A `ByteChannel` through which the message payload can be read  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type`\n                header value(Defaultable)  \n- `string` contentType: The content type of the payload. Set this to override the default `content-type`\n                header value"}},"insertText":"setByteChannel(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(474, 9, 33, 'Response.setPayload', FALSE, FALSE, TRUE, '{"label":"setPayload((string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) payload)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets the response payload.\n  \n**Params**  \n- `(string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` payload: Payload can be of type `string`, `xml`, `json`, `byte[]`, `ByteChannel` or `Entity[]` (i.e: a set\n            of body parts)"}},"insertText":"setPayload(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(475, 9, 33, 'Response.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(476, 9, 34, 'HttpSecureClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `post()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(477, 9, 34, 'HttpSecureClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `head()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(478, 9, 34, 'HttpSecureClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `put()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or an error occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(479, 9, 34, 'HttpSecureClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `execute()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders o the request and send the request to actual network call.\n  \n**Params**  \n- `string` httpVerb: HTTP verb value  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or an error occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(480, 9, 34, 'HttpSecureClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `patch()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or an error occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(481, 9, 34, 'HttpSecureClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `delete()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(482, 9, 34, 'HttpSecureClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `get()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(483, 9, 34, 'HttpSecureClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `options()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Request path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one  occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(484, 9, 34, 'HttpSecureClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `forward()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` path: Request path  \n- `http:Request` request: An HTTP inbound request message  \n  \n**Returns** `(http:Response|error)`   \n- The inbound response message or the error if one occurred while attempting to fulfill the HTTP request  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(485, 9, 34, 'HttpSecureClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `submit()` function of the underlying HTTP remote functions provider. Add relevant authentication\nheaders to the request and send the request to actual network call.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an error if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(486, 9, 34, 'HttpSecureClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an error if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(487, 9, 34, 'HttpSecureClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(488, 9, 34, 'HttpSecureClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an error if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(489, 9, 34, 'HttpSecureClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(490, 9, 34, 'HttpSecureClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis just pass the request to actual network call.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(491, 9, 34, 'HttpSecureClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, http:ClientEndpointConfig config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(492, 9, 35, 'MockListener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(493, 9, 35, 'MockListener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(494, 9, 35, 'MockListener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(495, 9, 35, 'MockListener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(496, 9, 35, 'MockListener.init', FALSE, FALSE, TRUE, '{"label":"init(http:ListenerConfiguration c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(497, 9, 35, 'MockListener.initEndpoint', FALSE, FALSE, TRUE, '{"label":"initEndpoint()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint()","insertTextFormat":"Snippet"}'),
(498, 9, 35, 'MockListener.register', FALSE, FALSE, TRUE, '{"label":"register(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(499, 9, 35, 'MockListener.start', FALSE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(500, 9, 35, 'MockListener.stop', FALSE, FALSE, TRUE, '{"label":"stop()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"stop();","insertTextFormat":"Snippet"}'),
(501, 9, 35, 'MockListener.detach', FALSE, FALSE, TRUE, '{"label":"detach(service s)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"detach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(502, 9, 35, 'MockListener.__init', FALSE, FALSE, TRUE, '{"label":"__init(int port, (http:ListenerConfiguration|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(503, 9, 36, 'RedirectClient.get', FALSE, FALSE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `get()` remote function is redirect eligible, redirect will be performed automatically\nby this `get()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(504, 9, 36, 'RedirectClient.post', FALSE, FALSE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `post()` remote function is redirect eligible, redirect will be performed automatically\nby this `post()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(505, 9, 36, 'RedirectClient.head', FALSE, FALSE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `head()` remote function is redirect eligible, redirect will be performed automatically\nby this `head()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(506, 9, 36, 'RedirectClient.put', FALSE, FALSE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `put()` remote function is redirect eligible, redirect will be performed automatically\nby this `put()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(507, 9, 36, 'RedirectClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `forward()` function is used to invoke an HTTP call with inbound request\u0027s HTTP verb.\n  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` request: An HTTP inbound request message  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(508, 9, 36, 'RedirectClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `execute()` sends an HTTP request to a service with the specified HTTP verb. Redirect will be performed\nonly for HTTP methods.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(509, 9, 36, 'RedirectClient.patch', FALSE, FALSE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `patch()` remote function is redirect eligible, redirect will be performed automatically\nby this `patch()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(510, 9, 36, 'RedirectClient.delete', FALSE, FALSE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `delete()` remote function is redirect eligible, redirect will be performed automatically\nby this `delete()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(511, 9, 36, 'RedirectClient.options', FALSE, FALSE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nIf the received response for the `options()` remote function is redirect eligible, redirect will be performed automatically\nby this `options()` function.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP outbound request message or any payload of type `string`, `xml`, `json`,\n            `byte[]`, `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(512, 9, 36, 'RedirectClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\nThe `submit()` function does not give out a `Response` as the result,\nrather it returns an `HttpFuture` which can be used to do further interactions with the endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an error if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(513, 9, 36, 'RedirectClient.getResponse', FALSE, FALSE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an error if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(514, 9, 36, 'RedirectClient.hasPromise', FALSE, FALSE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether a `PushPromise` exists for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(515, 9, 36, 'RedirectClient.getNextPromise', FALSE, FALSE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an error if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(516, 9, 36, 'RedirectClient.getPromisedResponse', FALSE, FALSE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(517, 9, 36, 'RedirectClient.rejectPromise', FALSE, FALSE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRejects a `PushPromise`.\nWhen a `PushPromise` is rejected, there is no chance of fetching a promised response using the rejected promise.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(518, 9, 36, 'RedirectClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, http:ClientEndpointConfig config, http:FollowRedirects redirectConfig, http:HttpClient httpClient)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCreate a redirect client with the given configurations.\n  \n**Params**  \n- `string` url: Target service url  \n- `http:ClientEndpointConfig` config: HTTP ClientEndpointConfig to be used for HTTP client invocation  \n- `http:FollowRedirects` redirectConfig: Configurations associated with redirect  \n- `http:HttpClient` httpClient: HTTP client for outbound HTTP requests"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(519, 9, 37, 'FailoverClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe POST remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(520, 9, 37, 'FailoverClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe HEAD remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(521, 9, 37, 'FailoverClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PATCH remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(522, 9, 37, 'FailoverClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PUT remote function  implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(523, 9, 37, 'FailoverClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe OPTIONS remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(524, 9, 37, 'FailoverClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInvokes an HTTP call using the incoming request\u0027s HTTP method.\n  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` request: An HTTP request  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(525, 9, 37, 'FailoverClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInvokes an HTTP call with the specified HTTP method.\n  \n**Params**  \n- `string` httpVerb: HTTP method to be used for the request  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(526, 9, 37, 'FailoverClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe DELETE remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(527, 9, 37, 'FailoverClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe GET remote function implementation of the Failover Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(528, 9, 37, 'FailoverClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb. The `submit()` function does not return\na `Response` as the result, rather it returns an `HttpFuture` which can be used for subsequent interactions\nwith the HTTP endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an `http:ClientError` if the submission  \n           fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(529, 9, 37, 'FailoverClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` related to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(530, 9, 37, 'FailoverClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether a `PushPromise` exists for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(531, 9, 37, 'FailoverClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(532, 9, 37, 'FailoverClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an `ClientError` if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(533, 9, 37, 'FailoverClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRejects a `PushPromise`. When a `PushPromise` is rejected, there is no chance of fetching a promised\nresponse using the rejected promise.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(534, 9, 37, 'FailoverClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(http:FailoverClientEndpointConfiguration failoverClientConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nFailover caller actions which provides failover capabilities to an HTTP client endpoint.\n  \n**Params**  \n- config: The configurations of the client endpoint associated with this `Failover` instance"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(535, 9, 38, 'CircuitBreakerClient.post', FALSE, FALSE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe POST remote function implementation of the Circuit Breaker. This wraps the `post()` function of the underlying\nHTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(536, 9, 38, 'CircuitBreakerClient.head', FALSE, FALSE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe HEAD remote function implementation of the Circuit Breaker. This wraps the `head()` function of the underlying\nHTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(537, 9, 38, 'CircuitBreakerClient.put', FALSE, FALSE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PUT remote function implementation of the Circuit Breaker. This wraps the `put()` function of the underlying\nHTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(538, 9, 38, 'CircuitBreakerClient.execute', FALSE, FALSE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `post()` function of the underlying HTTP remote functions provider. The `execute()` function can\nbe used to invoke an HTTP call with the given HTTP verb.\n  \n**Params**  \n- `string` httpVerb: HTTP verb to be used for the request  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel` or\n            `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(539, 9, 38, 'CircuitBreakerClient.patch', FALSE, FALSE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PATCH remote function implementation of the Circuit Breaker. This wraps the `patch()` function of the\nunderlying HTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel` or\n            `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(540, 9, 38, 'CircuitBreakerClient.delete', FALSE, FALSE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe DELETE remote function implementation of the Circuit Breaker. This wraps the `delete()` function of the\nunderlying HTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel` or\n            `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: A Request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel` or\n            `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(541, 9, 38, 'CircuitBreakerClient.get', FALSE, FALSE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe GET remote function implementation of the Circuit Breaker. This wraps the `get()` function of the underlying\nHTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n           `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n           `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(542, 9, 38, 'CircuitBreakerClient.options', FALSE, FALSE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe OPTIONS remote function implementation of the Circuit Breaker. This wraps the `options()` function of the\nunderlying HTTP remote functions provider.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP Request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP Request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(543, 9, 38, 'CircuitBreakerClient.forward', FALSE, FALSE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThis wraps the `forward()` function of the underlying HTTP remote functions provider. The Forward remote function\ncan be used to forward an incoming request to an upstream service as it is.\n  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` request: A Request struct  \n  \n**Returns** `(http:Response|error)`   \n- The response for the request or an `http:ClientError` if failed to establish communication with the upstream  \n           server  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(544, 9, 38, 'CircuitBreakerClient.submit', FALSE, FALSE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\nThe `submit()` function does not give out a `Response` as the result,\nrather it returns an `HttpFuture` which can be used to do further interactions with the endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an `http:ClientError` if the submission  \n           fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(545, 9, 38, 'CircuitBreakerClient.getResponse', FALSE, FALSE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` related to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(546, 9, 38, 'CircuitBreakerClient.hasPromise', FALSE, FALSE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCircuit breaking not supported. Defaults to the `hasPromise()` function of the underlying HTTP remote functions\nprovider.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(547, 9, 38, 'CircuitBreakerClient.getNextPromise', FALSE, FALSE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP `PushPromise` message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(548, 9, 38, 'CircuitBreakerClient.getPromisedResponse', FALSE, FALSE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(549, 9, 38, 'CircuitBreakerClient.rejectPromise', FALSE, FALSE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCircuit breaking not supported. Defaults to the `rejectPromise()` function of the underlying HTTP\nremote functions provider.\n  \n**Params**  \n- `http:PushPromise` promise: The `PushPromise` to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(550, 9, 38, 'CircuitBreakerClient.forceClose', FALSE, FALSE, TRUE, '{"label":"forceClose()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nForce the circuit into a closed state in which it will allow requests regardless of the error percentage\nuntil the failure threshold exceeds.  \n"}},"insertText":"forceClose();","insertTextFormat":"Snippet"}'),
(551, 9, 38, 'CircuitBreakerClient.forceOpen', FALSE, FALSE, TRUE, '{"label":"forceOpen()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nForce the circuit into a open state in which it will suspend all requests\nuntil `resetTimeInMillis` interval exceeds.  \n"}},"insertText":"forceOpen();","insertTextFormat":"Snippet"}'),
(552, 9, 38, 'CircuitBreakerClient.getCurrentState', FALSE, FALSE, TRUE, '{"label":"getCurrentState()((OPEN|HALF_OPEN|CLOSED))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nProvides `CircuitState` of the circuit breaker.\n  \n  \n  \n**Returns** `(OPEN|HALF_OPEN|CLOSED)`   \n- The current `CircuitState` of circuit breaker  \n  \n"}},"insertText":"getCurrentState()","insertTextFormat":"Snippet"}'),
(553, 9, 38, 'CircuitBreakerClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, http:ClientEndpointConfig config, http:CircuitBreakerInferredConfig circuitBreakerInferredConfig, http:HttpClient httpClient, http:CircuitHealth circuitHealth)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nA Circuit Breaker implementation which can be used to gracefully handle network failures.\n  \n**Params**  \n- `string` url: The URL of the target service  \n- `http:ClientEndpointConfig` config: The configurations of the client endpoint associated with this `CircuitBreaker` instance  \n- `http:CircuitBreakerInferredConfig` circuitBreakerInferredConfig: Configurations derived from `CircuitBreakerConfig`  \n- `http:HttpClient` httpClient: The underlying `HttpActions` instance which will be making the actual network calls  \n- `http:CircuitHealth` circuitHealth: The circuit health monitor"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(554, 9, 39, 'LoadBalancerRule.getNextClient', FALSE, FALSE, TRUE, '{"label":"getNextClient((http:Client|())[] loadBalanceCallerActionsArray)((http:Client|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nProvides an HTTP client which is chosen according to the algorithm.\n  \n**Params**  \n- `(http:Client|())[]` loadBalanceCallerActionsArray: Array of HTTP clients which needs to be load balanced  \n  \n**Returns** `(http:Client|error)`   \n- Chosen `Client` from the algorithm or an `http:ClientError`  \n           for the failure in the algorithm implementation  \n  \n"}},"insertText":"getNextClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(555, 9, 40, 'RetryClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `post()` function wraps the underlying HTTP remote functions in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(556, 9, 40, 'RetryClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `head()` function wraps the underlying HTTP remote functions in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(557, 9, 40, 'RetryClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `put()` function wraps the underlying HTTP remote function in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(558, 9, 40, 'RetryClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `forward()` function wraps the underlying HTTP remote function in a way to provide retrying functionality\nfor a given endpoint with inbound request\u0027s HTTP verb to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` request: An HTTP inbound request message  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(559, 9, 40, 'RetryClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `execute()` sends an HTTP request to a service with the specified HTTP verb. The function wraps the\nunderlying HTTP remote function in a way to provide retrying functionality for a given endpoint to recover\nfrom network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(560, 9, 40, 'RetryClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `patch()` function wraps the underlying HTTP remote function in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(561, 9, 40, 'RetryClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `delete()` function wraps the underlying HTTP remote function in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(562, 9, 40, 'RetryClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `get()` function wraps the underlying HTTP remote function in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(563, 9, 40, 'RetryClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe `options()` function wraps the underlying HTTP remote function in a way to provide\nretrying functionality for a given endpoint to recover from network level failures.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(564, 9, 40, 'RetryClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSubmits an HTTP request to a service with the specified HTTP verb.\ncThe `submit()` function does not give out a `Response` as the result,\ncrather it returns an `HttpFuture` which can be used to do further interactions with the endpoint.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an error if the submission fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(565, 9, 40, 'RetryClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the `Response` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an error if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(566, 9, 40, 'RetryClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks whether a `PushPromise` exists for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(567, 9, 40, 'RetryClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the next available `PushPromise` for a previously submitted request.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an error if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(568, 9, 40, 'RetryClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRetrieves the promised server push `Response` message.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an error if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(569, 9, 40, 'RetryClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRejects a `PushPromise`.\nWhen a `PushPromise` is rejected, there is no chance of fetching a promised response using the rejected promise.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(570, 9, 40, 'RetryClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, http:ClientEndpointConfig config, http:RetryInferredConfig retryInferredConfig, http:HttpClient httpClient)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nProvides the HTTP remote functions for interacting with an HTTP endpoint. This is created by wrapping the HTTP\nclient to provide retrying over HTTP requests.\n  \n**Params**  \n- `string` url: Target service url  \n- `http:ClientEndpointConfig` config: HTTP ClientEndpointConfig to be used for HTTP client invocation  \n- `http:RetryInferredConfig` retryInferredConfig: Derived set of configurations associated with retry  \n- `http:HttpClient` httpClient: HTTP client for outbound HTTP requests"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(571, 9, 41, 'LoadBalancerRounRobinRule.getNextClient', FALSE, FALSE, TRUE, '{"label":"getNextClient((http:Client|())[] loadBalanceCallerActionsArray)((http:Client|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nProvides an HTTP client which is chosen according to the round robin algorithm.\n  \n**Params**  \n- `(http:Client|())[]` loadBalanceCallerActionsArray: Array of HTTP clients which needs to be load balanced  \n  \n**Returns** `(http:Client|error)`   \n- Chosen `Client` from the algorithm or an `http:ClientError` for a failure in  \n           the algorithm implementation  \n  \n"}},"insertText":"getNextClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(572, 9, 41, 'LoadBalancerRounRobinRule.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(573, 9, 42, 'LoadBalanceClient.post', FALSE, TRUE, TRUE, '{"label":"post(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe POST remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"post(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(574, 9, 42, 'LoadBalanceClient.head', FALSE, TRUE, TRUE, '{"label":"head(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe HEAD remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"head(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(575, 9, 42, 'LoadBalanceClient.patch', FALSE, TRUE, TRUE, '{"label":"patch(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PATCH remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"patch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(576, 9, 42, 'LoadBalanceClient.put', FALSE, TRUE, TRUE, '{"label":"put(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe PUT remote function implementation of the Load Balance Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"put(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(577, 9, 42, 'LoadBalanceClient.options', FALSE, TRUE, TRUE, '{"label":"options(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe OPTIONS remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"options(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(578, 9, 42, 'LoadBalanceClient.forward', FALSE, TRUE, TRUE, '{"label":"forward(string path, http:Request request)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe FORWARD remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `http:Request` request: An optional HTTP request  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"forward(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(579, 9, 42, 'LoadBalanceClient.execute', FALSE, TRUE, TRUE, '{"label":"execute(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe EXECUTE remote function implementation of the LoadBalancer Connector.\nThe Execute remote function can be used to invoke an HTTP call with the given HTTP verb.\n  \n**Params**  \n- `string` httpVerb: HTTP method to be used for the request  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"execute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(580, 9, 42, 'LoadBalanceClient.delete', FALSE, TRUE, TRUE, '{"label":"delete(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe DELETE remote function implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`, `io:ReadableByteChannel`\n            or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"delete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(581, 9, 42, 'LoadBalanceClient.get', FALSE, TRUE, TRUE, '{"label":"get(string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe GET remote function implementation of the LoadBalancer Connector.  \n**Params**  \n- `string` path: Resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`(Defaultable)  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An optional HTTP request or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:Response|error)`   \n- The response or an `http:ClientError` if failed to fulfill the request  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(582, 9, 42, 'LoadBalanceClient.submit', FALSE, TRUE, TRUE, '{"label":"submit(string httpVerb, string path, (http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) message)((http:HttpFuture|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe submit implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `string` httpVerb: The HTTP verb value  \n- `string` path: The resource path  \n- `(http:Request|string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` message: An HTTP outbound request message or any payload of type `string`, `xml`, `json`, `byte[]`,\n            `io:ReadableByteChannel` or `mime:Entity[]`  \n  \n**Returns** `(http:HttpFuture|error)`   \n- An `HttpFuture` that represents an asynchronous service invocation, or an `http:ClientError` if the submission  \n           fails  \n  \n"}},"insertText":"submit(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(583, 9, 42, 'LoadBalanceClient.getResponse', FALSE, TRUE, TRUE, '{"label":"getResponse(http:HttpFuture httpFuture)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe getResponse implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` related to a previous asynchronous invocation  \n  \n**Returns** `(http:Response|error)`   \n- An HTTP response message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(584, 9, 42, 'LoadBalanceClient.hasPromise', FALSE, TRUE, TRUE, '{"label":"hasPromise(http:HttpFuture httpFuture)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe hasPromise implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `boolean`   \n- A `boolean` that represents whether a `PushPromise` exists  \n  \n"}},"insertText":"hasPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(585, 9, 42, 'LoadBalanceClient.getNextPromise', FALSE, TRUE, TRUE, '{"label":"getNextPromise(http:HttpFuture httpFuture)((http:PushPromise|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe getNextPromise implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `http:HttpFuture` httpFuture: The `HttpFuture` relates to a previous asynchronous invocation  \n  \n**Returns** `(http:PushPromise|error)`   \n- An HTTP Push Promise message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getNextPromise(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(586, 9, 42, 'LoadBalanceClient.getPromisedResponse', FALSE, TRUE, TRUE, '{"label":"getPromisedResponse(http:PushPromise promise)((http:Response|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe getPromisedResponse implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `http:PushPromise` promise: The related `PushPromise`  \n  \n**Returns** `(http:Response|error)`   \n- A promised HTTP `Response` message, or an `http:ClientError` if the invocation fails  \n  \n"}},"insertText":"getPromisedResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(587, 9, 42, 'LoadBalanceClient.rejectPromise', FALSE, TRUE, TRUE, '{"label":"rejectPromise(http:PushPromise promise)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nThe rejectPromise implementation of the LoadBalancer Connector.\n  \n**Params**  \n- `http:PushPromise` promise: The Push Promise to be rejected"}},"insertText":"rejectPromise(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(588, 9, 42, 'LoadBalanceClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(http:LoadBalanceClientEndpointConfiguration loadBalanceClientConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nLoad Balancer adds an additional layer to the HTTP client to make network interactions more resilient.\n  \n**Params**  \n- `http:LoadBalanceClientEndpointConfiguration` loadBalanceClientConfig: The configurations for the load balance client endpoint"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(589, 9, 43, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(590, 9, 43, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(591, 9, 43, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(592, 9, 43, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(593, 9, 43, 'Listener.init', FALSE, FALSE, TRUE, '{"label":"init(http:ListenerConfiguration c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets invoked during module initialization to initialize the endpoint.\n  \n**Params**  \n- `http:ListenerConfiguration` c: Configurations for HTTP service endpoints"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(594, 9, 43, 'Listener.initEndpoint', FALSE, FALSE, TRUE, '{"label":"initEndpoint()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint()","insertTextFormat":"Snippet"}'),
(595, 9, 43, 'Listener.register', TRUE, FALSE, TRUE, '{"label":"register(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets invoked when attaching a service to the endpoint.\n  \n**Params**  \n- `service` s: The service that needs to be attached  \n- `(string|())` name: Name of the service  \n  \n**Returns** `(()|error)`   \n- An `error` if there is any error occurred during the service attachment process or else nil  \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(596, 9, 43, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nStarts the registered service.  \n  \n  \n**Returns** `(()|error)`   \n- An `error` if there is any error occurred during the listener start process  \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(597, 9, 43, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nStops the registered service.  \n"}},"insertText":"stop();","insertTextFormat":"Snippet"}'),
(598, 9, 43, 'Listener.detach', FALSE, FALSE, TRUE, '{"label":"detach(service s)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nDisengage an attached service from the listener.\n  \n**Params**  \n- `service` s: The service that needs to be detached  \n  \n**Returns** `(()|error)`   \n- An `error` if there is any error occurred during the service detachment process or else nil  \n  \n"}},"insertText":"detach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(599, 9, 43, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init(int port, (http:ListenerConfiguration|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(600, 9, 44, 'AttributeFilter.filterRequest', FALSE, FALSE, TRUE, '{"label":"filterRequest(http:Caller caller, http:Request request, http:FilterContext context)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"filterRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(601, 9, 44, 'AttributeFilter.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(602, 9, 45, 'WebSocketListener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(603, 9, 45, 'WebSocketListener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(604, 9, 45, 'WebSocketListener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(605, 9, 45, 'WebSocketListener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(606, 9, 45, 'WebSocketListener.__init', FALSE, FALSE, TRUE, '{"label":"__init(int port, (http:ListenerConfiguration|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets invoked during module initialization to initialize the endpoint.\n  \n**Params**  \n- `int` port: The port of the endpoint  \n- `(http:ListenerConfiguration|())` config: The `ServiceEndpointConfiguration` of the endpoint(Defaultable)  \n- `(http:ListenerConfiguration|())` config: The `ServiceEndpointConfiguration` of the endpoint"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(607, 9, 46, 'WebSocketCaller.pushText', FALSE, TRUE, TRUE, '{"label":"pushText((string|json|xml|boolean|int|float|byte|byte[]) data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush text to the connection.\n  \n**Params**  \n- `(string|json|xml|boolean|int|float|byte|byte[])` data: Data to be sent, if byte[] it is converted to a UTF-8 string for sending  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message(Defaultable)  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushText(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(608, 9, 46, 'WebSocketCaller.pushBinary', FALSE, TRUE, TRUE, '{"label":"pushBinary(byte[] data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush binary data to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message(Defaultable)  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushBinary(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(609, 9, 46, 'WebSocketCaller.ping', FALSE, TRUE, TRUE, '{"label":"ping(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPing the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"ping(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(610, 9, 46, 'WebSocketCaller.pong', FALSE, TRUE, TRUE, '{"label":"pong(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSend pong message to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pong(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(611, 9, 46, 'WebSocketCaller.close', FALSE, TRUE, TRUE, '{"label":"close((int|()) statusCode, (string|()) reason, int timeoutInSeconds)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nClose the connection.\n  \n**Params**  \n- `(int|())` statusCode: Status code for closing the connection(Defaultable)  \n- `(int|())` statusCode: Status code for closing the connection  \n- `(string|())` reason: Reason for closing the connection(Defaultable)  \n- `(string|())` reason: Reason for closing the connection  \n- `int` timeoutInSeconds: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.(Defaultable)  \n- `int` timeoutInSeconds: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(612, 9, 46, 'WebSocketCaller.setAttribute', FALSE, FALSE, TRUE, '{"label":"setAttribute(string key, any value)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a connection related attribute.\n  \n**Params**  \n- `string` key: key that identifies the attribute  \n- `any` value: value of the attribute"}},"insertText":"setAttribute(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(613, 9, 46, 'WebSocketCaller.getAttribute', FALSE, FALSE, TRUE, '{"label":"getAttribute(string key)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets connection related attribute if any.\n  \n**Params**  \n- `string` key: the key to identify the attribute.  \n  \n**Returns** `any`   \n- the attribute related to the given key or `nil`  \n  \n"}},"insertText":"getAttribute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(614, 9, 46, 'WebSocketCaller.removeAttribute', FALSE, FALSE, TRUE, '{"label":"removeAttribute(string key)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves connection related attribute if any.\n  \n**Params**  \n- `string` key: the key to identify the attribute.  \n  \n**Returns** `any`   \n- the attribute related to the given key or `nil`  \n  \n"}},"insertText":"removeAttribute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(615, 9, 46, 'WebSocketCaller.getConnectionId', FALSE, FALSE, TRUE, '{"label":"getConnectionId()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the connection id associated with this connection.\n  \n  \n  \n**Returns** `string`   \n- the unique id associated with the connection  \n  \n"}},"insertText":"getConnectionId()","insertTextFormat":"Snippet"}'),
(616, 9, 46, 'WebSocketCaller.getNegotiatedSubProtocol', FALSE, FALSE, TRUE, '{"label":"getNegotiatedSubProtocol()((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the subprotocol if any that is negotiated with the client.\n  \n  \n  \n**Returns** `(string|())`   \n- The subprotocol if any negotiated with the client or `nil`  \n  \n"}},"insertText":"getNegotiatedSubProtocol()","insertTextFormat":"Snippet"}'),
(617, 9, 46, 'WebSocketCaller.isSecure', FALSE, FALSE, TRUE, '{"label":"isSecure()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the secured status of the connection.\n  \n  \n  \n**Returns** `boolean`   \n- `true` if the connection is secure.  \n  \n"}},"insertText":"isSecure()","insertTextFormat":"Snippet"}'),
(618, 9, 46, 'WebSocketCaller.isOpen', FALSE, FALSE, TRUE, '{"label":"isOpen()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the open or closed status of the connection.\n  \n  \n  \n**Returns** `boolean`   \n- `true` if the connection is open  \n  \n"}},"insertText":"isOpen()","insertTextFormat":"Snippet"}'),
(619, 9, 46, 'WebSocketCaller.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(620, 9, 47, 'WebSocketClient.initEndpoint', FALSE, FALSE, TRUE, '{"label":"initEndpoint()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInitializes the endpoint.  \n"}},"insertText":"initEndpoint();","insertTextFormat":"Snippet"}'),
(621, 9, 47, 'WebSocketClient.pushText', FALSE, TRUE, TRUE, '{"label":"pushText((string|json|xml|boolean|int|float|byte|byte[]) data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush text to the connection.\n  \n**Params**  \n- `(string|json|xml|boolean|int|float|byte|byte[])` data: Data to be sent, if byte[] it is converted to a UTF-8 string for sending  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message(Defaultable)  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushText(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(622, 9, 47, 'WebSocketClient.pushBinary', FALSE, TRUE, TRUE, '{"label":"pushBinary(byte[] data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush binary data to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message(Defaultable)  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushBinary(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(623, 9, 47, 'WebSocketClient.ping', FALSE, TRUE, TRUE, '{"label":"ping(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPing the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"ping(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(624, 9, 47, 'WebSocketClient.pong', FALSE, TRUE, TRUE, '{"label":"pong(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSend pong message to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pong(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(625, 9, 47, 'WebSocketClient.close', FALSE, TRUE, TRUE, '{"label":"close((int|()) statusCode, (string|()) reason, int timeoutInSeconds)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nClose the connection.\n  \n**Params**  \n- `(int|())` statusCode: Status code for closing the connection(Defaultable)  \n- `(int|())` statusCode: Status code for closing the connection  \n- `(string|())` reason: Reason for closing the connection(Defaultable)  \n- `(string|())` reason: Reason for closing the connection  \n- `int` timeoutInSeconds: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.(Defaultable)  \n- `int` timeoutInSeconds: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(626, 9, 47, 'WebSocketClient.ready', FALSE, TRUE, TRUE, '{"label":"ready()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCalled when the endpoint is ready to receive messages. Can be called only once per endpoint. For the\nWebSocketListener can be called only in upgrade or onOpen resources.\n  \n  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"ready()","insertTextFormat":"Snippet"}'),
(627, 9, 47, 'WebSocketClient.setAttribute', FALSE, FALSE, TRUE, '{"label":"setAttribute(string key, any value)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSets a connection related attribute.\n  \n**Params**  \n- `string` key: key that identifies the attribute  \n- `any` value: value of the attribute"}},"insertText":"setAttribute(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(628, 9, 47, 'WebSocketClient.getAttribute', FALSE, FALSE, TRUE, '{"label":"getAttribute(string key)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGets connection related attribute if any.\n  \n**Params**  \n- `string` key: the key to identify the attribute.  \n  \n**Returns** `any`   \n- the attribute related to the given key or `nil`  \n  \n"}},"insertText":"getAttribute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(629, 9, 47, 'WebSocketClient.removeAttribute', FALSE, FALSE, TRUE, '{"label":"removeAttribute(string key)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nRemoves connection related attribute if any.\n  \n**Params**  \n- `string` key: the key to identify the attribute.  \n  \n**Returns** `any`   \n- the attribute related to the given key or `nil`  \n  \n"}},"insertText":"removeAttribute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(630, 9, 47, 'WebSocketClient.getConnectionId', FALSE, FALSE, TRUE, '{"label":"getConnectionId()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the connection id associated with this connection.\n  \n  \n  \n**Returns** `string`   \n- the unique id associated with the connection  \n  \n"}},"insertText":"getConnectionId()","insertTextFormat":"Snippet"}'),
(631, 9, 47, 'WebSocketClient.getNegotiatedSubProtocol', FALSE, FALSE, TRUE, '{"label":"getNegotiatedSubProtocol()((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the subprotocol if any that is negotiated with the client.\n  \n  \n  \n**Returns** `(string|())`   \n- The subprotocol if any negotiated with the client or `nil`  \n  \n"}},"insertText":"getNegotiatedSubProtocol()","insertTextFormat":"Snippet"}'),
(632, 9, 47, 'WebSocketClient.isSecure', FALSE, FALSE, TRUE, '{"label":"isSecure()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the secured status of the connection.\n  \n  \n  \n**Returns** `boolean`   \n- `true` if the connection is secure.  \n  \n"}},"insertText":"isSecure()","insertTextFormat":"Snippet"}'),
(633, 9, 47, 'WebSocketClient.isOpen', FALSE, FALSE, TRUE, '{"label":"isOpen()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the open or closed status of the connection.\n  \n  \n  \n**Returns** `boolean`   \n- `true` if the connection is open  \n  \n"}},"insertText":"isOpen()","insertTextFormat":"Snippet"}'),
(634, 9, 47, 'WebSocketClient.getHttpResponse', FALSE, FALSE, TRUE, '{"label":"getHttpResponse()((http:Response|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nGives the HTTP response if any received for the client handshake request.\n  \n  \n  \n**Returns** `(http:Response|())`   \n- the HTTP response received for the client handshake request  \n  \n"}},"insertText":"getHttpResponse()","insertTextFormat":"Snippet"}'),
(635, 9, 47, 'WebSocketClient.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, (http:WebSocketClientConfiguration|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInitializes the client when called.\n  \n**Params**  \n- c: The `WebSocketClientConfiguration` of the endpoint"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(636, 9, 48, 'WebSocketConnector.pushText', FALSE, FALSE, TRUE, '{"label":"pushText((string|json|xml|boolean|int|float|byte|byte[]) data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush text to the connection.\n  \n**Params**  \n- `(string|json|xml|boolean|int|float|byte|byte[])` data: Data to be sent, if byte[] it is converted to a UTF-8 string for sending  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushText(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(637, 9, 48, 'WebSocketConnector.externPushText', TRUE, FALSE, TRUE, '{"label":"externPushText(string text, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"externPushText(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(638, 9, 48, 'WebSocketConnector.pushBinary', FALSE, FALSE, TRUE, '{"label":"pushBinary(byte[] data, boolean finalFrame)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPush binary data to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n- `boolean` finalFrame: Set to `true` if this is a final frame of a (long) message  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pushBinary(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(639, 9, 48, 'WebSocketConnector.ping', FALSE, FALSE, TRUE, '{"label":"ping(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPing the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"ping(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(640, 9, 48, 'WebSocketConnector.pong', FALSE, FALSE, TRUE, '{"label":"pong(byte[] data)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nSend pong message to the connection.\n  \n**Params**  \n- `byte[]` data: Binary data to be sent  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"pong(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(641, 9, 48, 'WebSocketConnector.close', FALSE, FALSE, TRUE, '{"label":"close((int|()) statusCode, (string|()) reason, int timeoutInSecs)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nClose the connection.\n  \n**Params**  \n- `(int|())` statusCode: Status code for closing the connection(Defaultable)  \n- `(int|())` statusCode: Status code for closing the connection  \n- `(string|())` reason: Reason for closing the connection(Defaultable)  \n- `(string|())` reason: Reason for closing the connection  \n- `int` timeoutInSecs: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.(Defaultable)  \n- `int` timeoutInSecs: Time to wait for the close frame to be received from the remote endpoint before closing the\n                  connection. If the timeout exceeds, then the connection is terminated even though a close frame\n                  is not received from the remote endpoint. If the value \u003c 0 (e.g., -1), then the connection waits\n                  until a close frame is received. If WebSocket frame is received from the remote endpoint,\n                  within waiting period the connection is terminated immediately.  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(642, 9, 48, 'WebSocketConnector.externClose', TRUE, FALSE, TRUE, '{"label":"externClose(int statusCode, string reason, int timeoutInSecs)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"externClose(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(643, 9, 48, 'WebSocketConnector.ready', FALSE, FALSE, TRUE, '{"label":"ready()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nCalled when the endpoint is ready to receive messages. Can be called only once per endpoint. For the\nWebSocketListener can be called only in upgrade or onOpen resources.\n  \n  \n  \n**Returns** `(()|error)`   \n- `error` if an error occurs when sending  \n  \n"}},"insertText":"ready()","insertTextFormat":"Snippet"}'),
(644, 9, 48, 'WebSocketConnector.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(645, 9, 49, 'BasicAuthHandler.canProcess', FALSE, FALSE, TRUE, '{"label":"canProcess(http:Request req)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks if the provided request can be authenticated with the Basic Auth header.\n  \n**Params**  \n- `http:Request` req: The request object.  \n  \n**Returns** `boolean`   \n- Returns `true` if authentication is successful. Else, returns `false`.  \n  \n"}},"insertText":"canProcess(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(646, 9, 49, 'BasicAuthHandler.process', FALSE, FALSE, TRUE, '{"label":"process(http:Request req)((boolean|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAuthenticates the incoming request with the use of the credentials passed as the Basic Auth header.\n  \n**Params**  \n- `http:Request` req: The request object.  \n  \n**Returns** `(boolean|http:AuthenticationError)`   \n- Returns `true` if it is possible to authenticate with Basic Auth. Else, returns `false` or  \nthe `AuthenticationError` in case of an error.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(647, 9, 49, 'BasicAuthHandler.prepare', FALSE, FALSE, TRUE, '{"label":"prepare(http:Request req)((http:Request|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPrepares the request with the Basic Auth header.\n  \n**Params**  \n- `http:Request` req: The`Request` instance.  \n  \n**Returns** `(http:Request|http:AuthenticationError)`   \n- Returns the updated `Request` instance or the `AuthenticationError` in case of an error.  \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(648, 9, 49, 'BasicAuthHandler.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(http:Request req, http:Response resp)((http:Request|()|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInspects the request and response and calls the Auth provider for inspection.\n\nreq - The `Request` instance.\nresp - The `Response` instance.  \n  \n  \n**Returns** `(http:Request|()|http:AuthenticationError)`   \n- Returns the updated `Request` instance, the `AuthenticationError` in case of an error,  \nor `()` if nothing is to be returned.  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(649, 9, 49, 'BasicAuthHandler.__init', FALSE, FALSE, TRUE, '{"label":"__init((auth:InboundAuthProvider|auth:OutboundAuthProvider) authProvider)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(650, 9, 50, 'BearerAuthHandler.canProcess', FALSE, FALSE, TRUE, '{"label":"canProcess(http:Request req)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nChecks if the request can be authenticated with the Bearer Auth header.\n  \n**Params**  \n- `http:Request` req: The `Request` instance.  \n  \n**Returns** `boolean`   \n- Returns `true` if can be authenticated. Else, returns `false`.  \n  \n"}},"insertText":"canProcess(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(651, 9, 50, 'BearerAuthHandler.process', FALSE, FALSE, TRUE, '{"label":"process(http:Request req)((boolean|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nAuthenticates the incoming request with the use of credentials passed as the Bearer Auth header.\n  \n**Params**  \n- `http:Request` req: The `Request` instance.  \n  \n**Returns** `(boolean|http:AuthenticationError)`   \n- Returns `true` if authenticated successfully. Else, returns `false`  \nor the `AuthenticationError` in case of an error.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(652, 9, 50, 'BearerAuthHandler.prepare', FALSE, FALSE, TRUE, '{"label":"prepare(http:Request req)((http:Request|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nPrepares the request with the Bearer Auth header.\n  \n**Params**  \n- `http:Request` req: The`Request` instance.  \n  \n**Returns** `(http:Request|http:AuthenticationError)`   \n- Returns the updated `Request` instance or the `AuthenticationError` in case of an error.  \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(653, 9, 50, 'BearerAuthHandler.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(http:Request req, http:Response resp)((http:Request|()|http:AuthenticationError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \nInspects the request and response and calls the Auth provider for inspection.\n\nreq - The `Request` instance.\nresp - The `Response` instance.  \n  \n  \n**Returns** `(http:Request|()|http:AuthenticationError)`   \n- Returns the updated `Request` instance, the `AuthenticationError` in case of an error,  \nor `()` if nothing is to be returned.  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(654, 9, 50, 'BearerAuthHandler.__init', FALSE, FALSE, TRUE, '{"label":"__init((auth:InboundAuthProvider|auth:OutboundAuthProvider) authProvider)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/http_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(655, 10, -1, 'openReadableFile', FALSE, FALSE, FALSE, '{"label":"openReadableFile(string path)((io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nRetrieves a ReadableByteChannel from a given file path.\n  \n**Params**  \n- `string` path: Relative/absolute path string to locate the file  \n  \n**Returns** `(io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- ByteChannel representation of the file resource or `Error` if any error occurred  \n  \n"}},"insertText":"openReadableFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(656, 10, -1, 'openWritableFile', FALSE, FALSE, FALSE, '{"label":"openWritableFile(string path, boolean append)((io:WritableByteChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nRetrieves a WritableByteChannel from a given file path.\n  \n**Params**  \n- `string` path: Relative/absolute path string to locate the file  \n- `boolean` append: Append to end of file.(Defaultable)  \n- `boolean` append: Append to end of file.  \n  \n**Returns** `(io:WritableByteChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- ByteChannel representation of the file resource or `Error` if any error occurred  \n  \n"}},"insertText":"openWritableFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(657, 10, -1, 'createReadableChannel', FALSE, FALSE, FALSE, '{"label":"createReadableChannel(byte[] content)((io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCreates an in-memory channel which will reference stream of bytes.\n  \n**Params**  \n- `byte[]` content: Content which should be exposed as channel  \n  \n**Returns** `(io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- ByteChannel representation to read the memory content or `Error` if any error occurred  \n  \n"}},"insertText":"createReadableChannel(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(658, 10, -1, 'openReadableCsvFile', FALSE, FALSE, FALSE, '{"label":"openReadableCsvFile(string path, (,|\t|:) fieldSeparator, string charset, int skipHeaders)((io:ReadableCSVChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nRetrieves a readable CSV channel from a give file path.\n  \n**Params**  \n- `string` path: File path which describes the location of the CSV  \n- `(,|\t|:)` fieldSeparator: CSV record separator (i.e comma or tab)(Defaultable)  \n- `(,|\t|:)` fieldSeparator: CSV record separator (i.e comma or tab)  \n- `string` charset: Encoding characters in the file represents(Defaultable)  \n- `string` charset: Encoding characters in the file represents  \n- `int` skipHeaders: Number of headers which should be skipped(Defaultable)  \n- `int` skipHeaders: Number of headers which should be skipped  \n  \n**Returns** `(io:ReadableCSVChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- ReadableCSVChannel which could be used to iterate through the CSV records  \n  \n"}},"insertText":"openReadableCsvFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(659, 10, -1, 'openWritableCsvFile', FALSE, FALSE, FALSE, '{"label":"openWritableCsvFile(string path, (,|\t|:) fieldSeparator, string charset, int skipHeaders)((io:WritableCSVChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nRetrieves a writable CSV channel from a give file path.\n  \n**Params**  \n- `string` path: File path which describes the location of the CSV  \n- `(,|\t|:)` fieldSeparator: CSV record separator (i.e comma or tab)(Defaultable)  \n- `(,|\t|:)` fieldSeparator: CSV record separator (i.e comma or tab)  \n- `string` charset: Encoding characters in the file represents(Defaultable)  \n- `string` charset: Encoding characters in the file represents  \n- `int` skipHeaders: Number of headers which should be skipped(Defaultable)  \n- `int` skipHeaders: Number of headers which should be skipped  \n  \n**Returns** `(io:WritableCSVChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- WritableCSVChannel which could be used to write CSV records or `Error` if any error occurred  \n  \n"}},"insertText":"openWritableCsvFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(660, 10, -1, 'print', FALSE, FALSE, FALSE, '{"label":"print(...(any|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nPrints `any` or `error` value(s) to the STDOUT.  \n**Params**  \n- values: The value(s) to be printed."}},"insertText":"print(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(661, 10, -1, 'println', FALSE, FALSE, FALSE, '{"label":"println(...(any|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nPrints `any` or `error` value(s) to the STDOUT followed by a new line.  \n**Params**  \n- values: The value(s) to be printed."}},"insertText":"println(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(662, 10, -1, 'sprintf', FALSE, FALSE, FALSE, '{"label":"sprintf(string format, ...(any|error))(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReturns a formatted string using the specified format string and arguments. Following format specifiers are allowed.\n   b              boolean\n   B              boolean (ALL_CAPS)\n   d              int\n   f              float\n   x              hex\n   X              HEX (ALL_CAPS)\n   s              string (This specifier is applicable for any of the supported types in Ballerina.\n                  These values will be converted to their string representation.)\n  \n**Params**  \n- `string` format: A format string  \n- args: Arguments referenced by the format specifiers in the format string.  \n  \n**Returns** `string`   \n- Formatted string  \n  \n"}},"insertText":"sprintf(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(663, 10, -1, 'readln', FALSE, FALSE, FALSE, '{"label":"readln(any a)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReturns the input read from STDIN.\n  \n**Params**  \n- `any` a: Any value to be printed  \n  \n**Returns** `string`   \n- Input read from STDIN  \n  \n"}},"insertText":"readln(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(664, 10, 51, 'ReadableByteChannel.read', FALSE, FALSE, TRUE, '{"label":"read(int nBytes)(([byte[],int]|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nSource bytes from a given input/output resource.\n\nNumber of bytes returned will be \u003c 0 if the file reached its end.\n\nThis operation will be asynchronous, where the total number of required bytes might not be returned at a given\ntime.\n  \n**Params**  \n- `int` nBytes: Positive integer. Represents the number of bytes which should be read  \n  \n**Returns** `([byte[],int]|io:GenericError|io:ConnectionTimedOutError)`   \n- Content, the number of bytes read or `Error` if any error occurred  \n  \n"}},"insertText":"read(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(665, 10, 51, 'ReadableByteChannel.base64Encode', FALSE, FALSE, TRUE, '{"label":"base64Encode()((io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nEncodes a given ReadableByteChannel with Base64 encoding scheme.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- Return an encoded ReadableByteChannel or `Error` if any error occurred  \n  \n"}},"insertText":"base64Encode()","insertTextFormat":"Snippet"}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(666, 10, 51, 'ReadableByteChannel.base64Decode', FALSE, FALSE, TRUE, '{"label":"base64Decode()((io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nDecodes a given ReadableByteChannel with Base64 encoding scheme.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|io:GenericError|io:ConnectionTimedOutError)`   \n- Return a decoded ReadableByteChannel or `Error` if any error occurred  \n  \n"}},"insertText":"base64Decode()","insertTextFormat":"Snippet"}'),
(667, 10, 51, 'ReadableByteChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given ReadableByteChannel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Will return () if there\u0027s no error  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(668, 10, 51, 'ReadableByteChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(669, 10, 52, 'ReadableCharacterChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:ReadableByteChannel bChannel, string cs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes a character ReadableCharacterChannel.\n  \n**Params**  \n- `io:ReadableByteChannel` bChannel: ReadableByteChannel which should be used to initialize the ReadableCharacterChannel  \n- `string` cs: Character-set (i.e UTF-8) which should be used to encode/decode"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(670, 10, 52, 'ReadableCharacterChannel.read', FALSE, FALSE, TRUE, '{"label":"read(int numberOfChars)((string|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a given number of characters.\n  \n**Params**  \n- `int` numberOfChars: Number of characters which should be read  \n  \n**Returns** `(string|io:GenericError|io:ConnectionTimedOutError)`   \n- Content which is read or `Error` if any error occurred  \n  \n"}},"insertText":"read(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(671, 10, 52, 'ReadableCharacterChannel.readJson', FALSE, FALSE, TRUE, '{"label":"readJson()((json|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a json from the given channel.\n  \n  \n  \n**Returns** `(json|io:GenericError|io:ConnectionTimedOutError)`   \n- Read json string or `Error` if any error occurred  \n  \n"}},"insertText":"readJson()","insertTextFormat":"Snippet"}'),
(672, 10, 52, 'ReadableCharacterChannel.readXml', FALSE, FALSE, TRUE, '{"label":"readXml()((xml|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a XML from the given channel.\n  \n  \n  \n**Returns** `(xml|io:GenericError|io:ConnectionTimedOutError)`   \n- Read xml or `Error` if any error occurred  \n  \n"}},"insertText":"readXml()","insertTextFormat":"Snippet"}'),
(673, 10, 52, 'ReadableCharacterChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given character channel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- If an error occurred while writing  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(674, 10, 52, 'ReadableCharacterChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:ReadableByteChannel byteChannel, string charset)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a ReadableCharacterChannel from a given ReadableByteChannel and Charset.  \n**Params**  \n- channel: ReadableByteChannel which would be used to read characters  \n- `string` charset: Character-Set which would be used to encode/decode given bytes to characters"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(675, 10, 53, 'ReadableCSVChannel.skipHeaders', TRUE, FALSE, TRUE, '{"label":"skipHeaders(int nHeaders)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nSkips the given number of headers.\n  \n**Params**  \n- `int` nHeaders: Number of headers which should be skipped"}},"insertText":"skipHeaders(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(676, 10, 53, 'ReadableCSVChannel.hasNext', FALSE, FALSE, TRUE, '{"label":"hasNext()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nIndicates whether there\u0027s another record which could be read.\n  \n  \n  \n**Returns** `boolean`   \n- True if there\u0027s a record  \n  \n"}},"insertText":"hasNext()","insertTextFormat":"Snippet"}'),
(677, 10, 53, 'ReadableCSVChannel.getNext', FALSE, FALSE, TRUE, '{"label":"getNext()((string[]|()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nGets the next record from the CSV file.\n  \n  \n  \n**Returns** `(string[]|()|io:GenericError|io:ConnectionTimedOutError)`   \n- List of fields in the CSV or `Error` if any error occurred  \n  \n"}},"insertText":"getNext()","insertTextFormat":"Snippet"}'),
(678, 10, 53, 'ReadableCSVChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given CSVChannel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Returns `Error` if any error occurred  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(679, 10, 53, 'ReadableCSVChannel.getTable', FALSE, FALSE, TRUE, '{"label":"getTable(typedesc\u003crecord {}\u003e structType)((table\u003crecord {}\u003e|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReturns a table which corresponds to the CSV records.\n  \n**Params**  \n- `typedesc\u003crecord {}\u003e` structType: The object the CSV records should be deserialized  \n  \n**Returns** `(table\u003crecord {}\u003e|io:GenericError|io:ConnectionTimedOutError)`   \n- Table which represents CSV records or `Error` if any error occurred  \n  \n"}},"insertText":"getTable(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(680, 10, 53, 'ReadableCSVChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:ReadableCharacterChannel byteChannel, (,|\t|:) fs, int nHeaders)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a CSV channel from a CharacterChannel to read/write CSV records.\n  \n**Params**  \n- `io:ReadableCharacterChannel` byteChannel: The CharacterChannel, which will represent the content in the CSV file  \n- `(,|\t|:)` fs: Field separator, which will separate between the records in the CSV file(Defaultable)  \n- `(,|\t|:)` fs: Field separator, which will separate between the records in the CSV file  \n- `int` nHeaders: Number of headers, which should be skipped prior to reading records(Defaultable)  \n- `int` nHeaders: Number of headers, which should be skipped prior to reading records"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(681, 10, 54, 'ReadableDataChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:ReadableByteChannel byteChannel, BE|LE bOrder)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes data channel.  \n**Params**  \n- `io:ReadableByteChannel` byteChannel: channel which would represent the source to read/write data  \n- `BE|LE` bOrder: network byte order"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(682, 10, 54, 'ReadableDataChannel.readInt16', FALSE, FALSE, TRUE, '{"label":"readInt16()((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a 16 bit integer.  \n  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the integer which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readInt16()","insertTextFormat":"Snippet"}'),
(683, 10, 54, 'ReadableDataChannel.readInt32', FALSE, FALSE, TRUE, '{"label":"readInt32()((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a 32 bit integer.  \n  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the integer which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readInt32()","insertTextFormat":"Snippet"}'),
(684, 10, 54, 'ReadableDataChannel.readInt64', FALSE, FALSE, TRUE, '{"label":"readInt64()((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a 64 bit integer.  \n  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the integer which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readInt64()","insertTextFormat":"Snippet"}'),
(685, 10, 54, 'ReadableDataChannel.readFloat32', FALSE, FALSE, TRUE, '{"label":"readFloat32()((float|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads 32 bit float.  \n  \n  \n**Returns** `(float|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the float which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readFloat32()","insertTextFormat":"Snippet"}'),
(686, 10, 54, 'ReadableDataChannel.readFloat64', FALSE, FALSE, TRUE, '{"label":"readFloat64()((float|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads 64 bit float.  \n  \n  \n**Returns** `(float|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the float which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readFloat64()","insertTextFormat":"Snippet"}'),
(687, 10, 54, 'ReadableDataChannel.readBool', FALSE, FALSE, TRUE, '{"label":"readBool()((boolean|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads 1 byte and convert it\u0027s value to boolean.  \n  \n  \n**Returns** `(boolean|io:GenericError|io:ConnectionTimedOutError)`   \n- boolean value which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readBool()","insertTextFormat":"Snippet"}'),
(688, 10, 54, 'ReadableDataChannel.readString', FALSE, FALSE, TRUE, '{"label":"readString(int nBytes, string encoding)((string|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads string value represented through the provided number of bytes.  \n**Params**  \n- `int` nBytes: specifies the number of bytes which represents the string  \n- `string` encoding: specifies the char-set encoding of the string  \n  \n**Returns** `(string|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the string or an error  \n  \n"}},"insertText":"readString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(689, 10, 54, 'ReadableDataChannel.readVarInt', FALSE, FALSE, TRUE, '{"label":"readVarInt()((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a variable length integer.  \n  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the integer which is read or `Error` if any error occurred  \n  \n"}},"insertText":"readVarInt()","insertTextFormat":"Snippet"}'),
(690, 10, 54, 'ReadableDataChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses the data channel.  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the channel is closed successfully or `Error` if any error occurred  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(691, 10, 54, 'ReadableDataChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:ReadableByteChannel byteChannel, BE|LE bOrder)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(692, 10, 55, 'ReadableTextRecordChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:ReadableCharacterChannel characterChannel, string fieldSeparator, string recordSeparator, string fmt)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes delimited record channel.\n  \n**Params**  \n- `io:ReadableCharacterChannel` characterChannel: Character channel which will be used for reading/writing records  \n- `string` fieldSeparator: Field separator which will separate between fields  \n- `string` recordSeparator: Record separator which will separate between records  \n- `string` fmt: Format which will be used to represent the type of record i.e csv"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(693, 10, 55, 'ReadableTextRecordChannel.hasNext', FALSE, FALSE, TRUE, '{"label":"hasNext()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nChecks whether there\u0027s a record left to be read.\n  \n  \n  \n**Returns** `boolean`   \n- True if there\u0027s a record left to be read  \n  \n"}},"insertText":"hasNext()","insertTextFormat":"Snippet"}'),
(694, 10, 55, 'ReadableTextRecordChannel.getNext', FALSE, FALSE, TRUE, '{"label":"getNext()((string[]|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nGet next record from the input/output resource.\n  \n  \n  \n**Returns** `(string[]|io:GenericError|io:ConnectionTimedOutError)`   \n- Set of fields included in the record or `Error` if any error occurred  \n  \n"}},"insertText":"getNext()","insertTextFormat":"Snippet"}'),
(695, 10, 55, 'ReadableTextRecordChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given record channel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- An `Error` if the record channel could not be closed properly  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(696, 10, 55, 'ReadableTextRecordChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:ReadableCharacterChannel charChannel, string fs, string rs, string fmt)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a ReadableTextRecordChannel from a given ReadableCharacterChannel.\n  \n**Params**  \n- `io:ReadableCharacterChannel` charChannel: CharacterChannel which will point to the input/output resource  \n- `string` fs: Field separator (this could be a regex)(Defaultable)  \n- `string` fs: Field separator (this could be a regex)  \n- `string` rs: Record separator (this could be a regex)(Defaultable)  \n- `string` rs: Record separator (this could be a regex)"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(697, 10, 56, 'StringReader.readJson', FALSE, FALSE, TRUE, '{"label":"readJson()((json|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads string as json from reader.\n  \n  \n  \n**Returns** `(json|io:GenericError|io:ConnectionTimedOutError)`   \n- json or `Error` if any error occurred  \n  \n"}},"insertText":"readJson()","insertTextFormat":"Snippet"}'),
(698, 10, 56, 'StringReader.readXml', FALSE, FALSE, TRUE, '{"label":"readXml()((xml|()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads string as XML from reader\n  \n  \n  \n**Returns** `(xml|()|io:GenericError|io:ConnectionTimedOutError)`   \n  \n"}},"insertText":"readXml()","insertTextFormat":"Snippet"}'),
(699, 10, 56, 'StringReader.readChar', FALSE, FALSE, TRUE, '{"label":"readChar(int nCharacters)((string|()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads characters from the given string.\n  \n**Params**  \n- `int` nCharacters: read specific number of characters  \n  \n**Returns** `(string|()|io:GenericError|io:ConnectionTimedOutError)`   \n- string or `Error` if any error occurred  \n  \n"}},"insertText":"readChar(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(700, 10, 56, 'StringReader.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses reader.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- An `Error` if could not close the channel.  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(701, 10, 56, 'StringReader.__init', FALSE, FALSE, TRUE, '{"label":"__init(string content, string encoding)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a channel to read string.\n  \n**Params**  \n- `string` content: content which should be written  \n- `string` encoding: encoding of the characters of the content(Defaultable)  \n- `string` encoding: encoding of the characters of the content"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(702, 10, 57, 'WritableByteChannel.write', FALSE, FALSE, TRUE, '{"label":"write(byte[] content, int offset)((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nSink bytes from a given input/output resource.\n\nThis operation will be asynchronous, write might return without writing all the content.\n  \n**Params**  \n- `byte[]` content: Block of bytes which should be written  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- Offset which should be kept when writing bytes.  \n           Number of bytes written or `Error` if any error occurred  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(703, 10, 57, 'WritableByteChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given byte channel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Will return () if there\u0027s no error  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(704, 10, 57, 'WritableByteChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(705, 10, 58, 'WritableCharacterChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:WritableByteChannel byteChannel, string cs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes a character channel.\n  \n**Params**  \n- `io:WritableByteChannel` byteChannel: The WritableByteChannel which should be used to initialize the character channel  \n- `string` cs: Character-set (i.e UTF-8) which should be used to encode"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(706, 10, 58, 'WritableCharacterChannel.write', FALSE, FALSE, TRUE, '{"label":"write(string content, int startOffset)((int|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites a given sequence of characters (string).\n  \n**Params**  \n- `string` content: Content which should be written  \n- `int` startOffset: Number of characters which should be offset when writing content  \n  \n**Returns** `(int|io:GenericError|io:ConnectionTimedOutError)`   \n- Content length that written or `Error` if any error occurred  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(707, 10, 58, 'WritableCharacterChannel.writeJson', FALSE, FALSE, TRUE, '{"label":"writeJson(json content)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites a given json to the given channel.\n  \n**Params**  \n- `json` content: The json which should be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- If an `Error` occurred while writing  \n  \n"}},"insertText":"writeJson(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(708, 10, 58, 'WritableCharacterChannel.writeXml', FALSE, FALSE, TRUE, '{"label":"writeXml(xml content)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites a given xml to the channel.\n  \n**Params**  \n- `xml` content: The XML which should be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Nil or `Error` if any error occurred  \n  \n"}},"insertText":"writeXml(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(709, 10, 58, 'WritableCharacterChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given WritableCharacterChannel channel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Nil or `Error` if any error occurred  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(710, 10, 58, 'WritableCharacterChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:WritableByteChannel bChannel, string charset)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a WritableByteChannel from a given WritableByteChannel and Charset.  \n**Params**  \n- `io:WritableByteChannel` bChannel: WritableByteChannel which would be used to write characters  \n- `string` charset: Character-Set which would be used to encode given bytes to characters"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(711, 10, 59, 'WritableCSVChannel.write', FALSE, FALSE, TRUE, '{"label":"write(string[] csvRecord)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites record to a given CSV file.  \n**Params**  \n- `string[]` csvRecord: A record to be written to the channel  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Returns an `Error` if the record could not be written properly  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(712, 10, 59, 'WritableCSVChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given CSVChannel.  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- Nil or `Error` if any error occurred  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(713, 10, 59, 'WritableCSVChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:WritableCharacterChannel characterChannel, (,|\t|:) fs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a CSV channel from a CharacterChannel to read/write CSV records.  \n**Params**  \n- channel: The CharacterChannel, which will represent the content in the CSV file  \n- `(,|\t|:)` fs: Field separator which will separate between the records in the CSV(Defaultable)  \n- `(,|\t|:)` fs: Field separator which will separate between the records in the CSV"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(714, 10, 60, 'WritableDataChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:WritableByteChannel byteChannel, BE|LE bOrder)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes data channel.\n  \n**Params**  \n- `io:WritableByteChannel` byteChannel: channel which would represent the source to read/write data  \n- `BE|LE` bOrder: network byte order"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(715, 10, 60, 'WritableDataChannel.writeInt16', FALSE, FALSE, TRUE, '{"label":"writeInt16(int value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites 16 bit integer.\n  \n**Params**  \n- `int` value: integer which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the content is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeInt16(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(716, 10, 60, 'WritableDataChannel.writeInt32', FALSE, FALSE, TRUE, '{"label":"writeInt32(int value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites 32 bit integer.\n  \n**Params**  \n- `int` value: integer which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the content is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeInt32(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(717, 10, 60, 'WritableDataChannel.writeInt64', FALSE, FALSE, TRUE, '{"label":"writeInt64(int value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites 64 bit integer.\n  \n**Params**  \n- `int` value: integer which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the content is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeInt64(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(718, 10, 60, 'WritableDataChannel.writeFloat32', FALSE, FALSE, TRUE, '{"label":"writeFloat32(float value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites 32 bit float.\n  \n**Params**  \n- `float` value: float which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the float is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeFloat32(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(719, 10, 60, 'WritableDataChannel.writeFloat64', FALSE, FALSE, TRUE, '{"label":"writeFloat64(float value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites 64 bit float.\n  \n**Params**  \n- `float` value: float which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the float is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeFloat64(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(720, 10, 60, 'WritableDataChannel.writeBool', FALSE, FALSE, TRUE, '{"label":"writeBool(boolean value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites boolean.\n  \n**Params**  \n- `boolean` value: boolean which will be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the content is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeBool(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(721, 10, 60, 'WritableDataChannel.writeString', FALSE, FALSE, TRUE, '{"label":"writeString(string value, string encoding)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites a given string value to the respective channel.\n  \n**Params**  \n- `string` value: the value which should be written  \n- `string` encoding: the encoding which will represent the value string  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the content is written successfully or `Error` if any error occurred  \n  \n"}},"insertText":"writeString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(722, 10, 60, 'WritableDataChannel.writeVarInt', FALSE, FALSE, TRUE, '{"label":"writeVarInt(int value)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nReads a variable length integer.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- value of the integer which is read or `Error` if any error occurred  \n  \n"}},"insertText":"writeVarInt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(723, 10, 60, 'WritableDataChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses the data channel.\n  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- nill if the channel is closed successfully or `Error` if any error occurred  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(724, 10, 60, 'WritableDataChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:WritableByteChannel byteChannel, BE|LE bOrder)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(725, 10, 61, 'WritableTextRecordChannel.init', TRUE, FALSE, TRUE, '{"label":"init(io:WritableCharacterChannel cChannel, string fieldSeparator, string recordSeparator, string fmt)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nInitializes delimited record channel.  \n**Params**  \n- `io:WritableCharacterChannel` cChannel: Character channel which will be used for reading/writing records  \n- `string` fieldSeparator: Field separator which will separate between fields  \n- `string` recordSeparator: Record separator which will separate between records  \n- `string` fmt: Format which will be used to represent the type of record i.e csv"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(726, 10, 61, 'WritableTextRecordChannel.write', FALSE, FALSE, TRUE, '{"label":"write(string[] textRecord)((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nWrites records to a given output resource.  \n**Params**  \n- `string[]` textRecord: List of fields to be written  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- An `Error` if the records could not be written properly  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(727, 10, 61, 'WritableTextRecordChannel.close', FALSE, FALSE, TRUE, '{"label":"close()((()|io:GenericError|io:ConnectionTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nCloses a given record channel.  \n  \n  \n**Returns** `(()|io:GenericError|io:ConnectionTimedOutError)`   \n- An `Error` if the record channel could not be closed properly  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(728, 10, 61, 'WritableTextRecordChannel.__init', FALSE, FALSE, TRUE, '{"label":"__init(io:WritableCharacterChannel characterChannel, string fs, string rs, string fmt)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/io_  \n  \nConstructs a DelimitedTextRecordChannel from a given WritableCharacterChannel.  \n**Params**  \n- channel: WritableCharacterChannel which will point to the input/output resource  \n- `string` rs: Record separator (this could be a regex)(Defaultable)  \n- `string` rs: Record separator (this could be a regex)  \n- `string` fs: Field separator (this could be a regex)(Defaultable)  \n- `string` fs: Field separator (this could be a regex)"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(729, 11, -1, 'authenticateFromCache', TRUE, FALSE, FALSE, '{"label":"authenticateFromCache(jwt:JwtValidatorConfig jwtValidatorConfig, string jwtToken)((jwt:JwtPayload|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(jwt:JwtPayload|())`   \n  \n"}},"insertText":"authenticateFromCache(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(730, 11, -1, 'addToAuthenticationCache', TRUE, FALSE, FALSE, '{"label":"addToAuthenticationCache(jwt:JwtValidatorConfig jwtValidatorConfig, string jwtToken, (int|()) exp, jwt:JwtPayload payload)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n"}},"insertText":"addToAuthenticationCache(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(731, 11, -1, 'setPrincipal', TRUE, FALSE, FALSE, '{"label":"setPrincipal(jwt:JwtPayload jwtPayload)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n"}},"insertText":"setPrincipal(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(732, 11, -1, 'issueJwt', FALSE, FALSE, FALSE, '{"label":"issueJwt(jwt:JwtHeader header, jwt:JwtPayload payload, (jwt:JwtKeyStoreConfig|()) config)((string|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nIssue a JWT token based on provided header and payload. JWT will be signed (JWS) if `keyStore` information is provided\nin the `JwtKeyStoreConfig` and the `alg` field of `JwtHeader` is not `NONE`.\n  \n**Params**  \n- `jwt:JwtHeader` header: JwtHeader object  \n- `jwt:JwtPayload` payload: JwtPayload object  \n- `(jwt:JwtKeyStoreConfig|())` config: JWT key store config record  \n  \n**Returns** `(string|jwt:Error)`   \n- JWT token string or an `Error` if token validation fails  \n  \n"}},"insertText":"issueJwt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(733, 11, -1, 'buildHeaderString', FALSE, FALSE, FALSE, '{"label":"buildHeaderString(jwt:JwtHeader header)((string|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nBuild the header string from the `JwtHeader` record.\n  \n**Params**  \n- `jwt:JwtHeader` header: JWT header record to be built as a string  \n  \n**Returns** `(string|jwt:Error)`   \n- The header string or an `Error` if building the string fails  \n  \n"}},"insertText":"buildHeaderString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(734, 11, -1, 'buildPayloadString', FALSE, FALSE, FALSE, '{"label":"buildPayloadString(jwt:JwtPayload payload)((string|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nBuild the payload string from the `JwtPayload` record.\n  \n**Params**  \n- `jwt:JwtPayload` payload: JWT payload record to be built as a string  \n  \n**Returns** `(string|jwt:Error)`   \n- The payload string or an `Error` if building the string fails  \n  \n"}},"insertText":"buildPayloadString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(735, 11, -1, 'appendToMap', TRUE, FALSE, FALSE, '{"label":"appendToMap(map\u003cjson\u003e fromMap, map\u003cjson\u003e toMap)(map\u003cjson\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `map\u003cjson\u003e`   \n  \n"}},"insertText":"appendToMap(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(736, 11, -1, 'validateJwt', FALSE, FALSE, FALSE, '{"label":"validateJwt(string jwtToken, jwt:JwtValidatorConfig config)((jwt:JwtPayload|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nValidate the given JWT string.\n  \n**Params**  \n- `string` jwtToken: JWT token that needs to be validated  \n- `jwt:JwtValidatorConfig` config: JWT validator config record  \n  \n**Returns** `(jwt:JwtPayload|jwt:Error)`   \n- If the JWT token is valid, return the JWT payload. Else, return an`Error` if token validation fails.  \n  \n"}},"insertText":"validateJwt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(737, 11, -1, 'getJwtComponents', TRUE, FALSE, FALSE, '{"label":"getJwtComponents(string jwtToken)((string[]|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(string[]|jwt:Error)`   \n  \n"}},"insertText":"getJwtComponents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(738, 11, -1, 'decodeJwt', FALSE, FALSE, FALSE, '{"label":"decodeJwt(string jwtToken)(([jwt:JwtHeader,jwt:JwtPayload]|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nDecode the given JWT string.\n  \n**Params**  \n- `string` jwtToken: JWT token that needs to be decoded  \n  \n**Returns** `([jwt:JwtHeader,jwt:JwtPayload]|jwt:Error)`   \n- The JWT header and payload tuple or an `Error` if token decoding fails.  \n  \n"}},"insertText":"decodeJwt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(739, 11, -1, 'getDecodedJwtComponents', TRUE, FALSE, FALSE, '{"label":"getDecodedJwtComponents(string[] encodedJwtComponents)(([map\u003cjson\u003e,map\u003cjson\u003e]|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `([map\u003cjson\u003e,map\u003cjson\u003e]|jwt:Error)`   \n  \n"}},"insertText":"getDecodedJwtComponents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(740, 11, -1, 'parseHeader', TRUE, FALSE, FALSE, '{"label":"parseHeader(map\u003cjson\u003e jwtHeaderJson)(jwt:JwtHeader)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `jwt:JwtHeader`   \n  \n"}},"insertText":"parseHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(741, 11, -1, 'parsePayload', TRUE, FALSE, FALSE, '{"label":"parsePayload(map\u003cjson\u003e jwtPayloadJson)((jwt:JwtPayload|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(jwt:JwtPayload|jwt:Error)`   \n  \n"}},"insertText":"parsePayload(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(742, 11, -1, 'validateJwtRecords', TRUE, FALSE, FALSE, '{"label":"validateJwtRecords(string jwtToken, jwt:JwtHeader jwtHeader, jwt:JwtPayload jwtPayload, jwt:JwtValidatorConfig config)((boolean|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(boolean|jwt:Error)`   \n  \n"}},"insertText":"validateJwtRecords(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(743, 11, -1, 'validateMandatoryJwtHeaderFields', TRUE, FALSE, FALSE, '{"label":"validateMandatoryJwtHeaderFields(jwt:JwtHeader jwtHeader)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"validateMandatoryJwtHeaderFields(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(744, 11, -1, 'validateCertificate', TRUE, FALSE, FALSE, '{"label":"validateCertificate(jwt:JwtTrustStoreConfig trustStoreConfig)((boolean|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(boolean|jwt:Error)`   \n  \n"}},"insertText":"validateCertificate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(745, 11, -1, 'validateSignature', TRUE, FALSE, FALSE, '{"label":"validateSignature(string jwtToken, jwt:JwtHeader jwtHeader, jwt:JwtTrustStoreConfig trustStoreConfig)((boolean|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(boolean|jwt:Error)`   \n  \n"}},"insertText":"validateSignature(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(746, 11, -1, 'validateIssuer', TRUE, FALSE, FALSE, '{"label":"validateIssuer(jwt:JwtPayload jwtPayload, string issuerConfig)((()|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(()|jwt:Error)`   \n  \n"}},"insertText":"validateIssuer(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(747, 11, -1, 'validateAudience', TRUE, FALSE, FALSE, '{"label":"validateAudience(jwt:JwtPayload jwtPayload, (string|string[]) audienceConfig)((()|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(()|jwt:Error)`   \n  \n"}},"insertText":"validateAudience(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(748, 11, -1, 'validateExpirationTime', TRUE, FALSE, FALSE, '{"label":"validateExpirationTime(int expTime, int clockSkew)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"validateExpirationTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(749, 11, -1, 'validateNotBeforeTime', TRUE, FALSE, FALSE, '{"label":"validateNotBeforeTime(int nbf)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"validateNotBeforeTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(750, 11, -1, 'convertToStringArray', TRUE, FALSE, FALSE, '{"label":"convertToStringArray(json jsonData)((string[]|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \n  \n  \n  \n**Returns** `(string[]|jwt:Error)`   \n  \n"}},"insertText":"convertToStringArray(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(751, 11, -1, 'getAuthTokenForJWTAuth', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForJWTAuth(jwt:JwtIssuerConfig jwtIssuerConfig)((string|jwt:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nProcess auth token for JWT auth.\n  \n**Params**  \n- `jwt:JwtIssuerConfig` jwtIssuerConfig: JWT issuer configurations  \n  \n**Returns** `(string|jwt:Error)`   \n- Auth token or `Error` if an error occurred during the JWT issuing or validation  \n  \n"}},"insertText":"getAuthTokenForJWTAuth(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(752, 11, -1, 'prepareError', TRUE, FALSE, FALSE, '{"label":"prepareError(string message, (()|error) err)(jwt:Error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nLog and prepare `error` as a `Error`.\n  \n**Params**  \n- `string` message: Error message  \n- `(()|error)` err: `error` instance(Defaultable)  \n- `(()|error)` err: `error` instance  \n  \n**Returns** `jwt:Error`   \n- Prepared `Error` instance  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(753, 11, 62, 'InboundJwtAuthProvider.authenticate', FALSE, FALSE, TRUE, '{"label":"authenticate(string credential)((boolean|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nAuthenticate with a JWT token.\n  \n**Params**  \n- `string` credential: Jwt token extracted from the authentication header  \n  \n**Returns** `(boolean|auth:Error)`   \n- `true` if authentication is successful, othewise `false` or `auth:Error` occurred during JWT validation  \n  \n"}},"insertText":"authenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(754, 11, 62, 'InboundJwtAuthProvider.__init', FALSE, FALSE, TRUE, '{"label":"__init(jwt:JwtValidatorConfig jwtValidatorConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nProvides authentication based on the provided JWT token.\n  \n**Params**  \n- `jwt:JwtValidatorConfig` jwtValidatorConfig: JWT validator configurations"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(755, 11, 63, 'OutboundJwtAuthProvider.generateToken', FALSE, FALSE, TRUE, '{"label":"generateToken()((string|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nGenerate token for JWT authentication.\n  \n  \n  \n**Returns** `(string|auth:Error)`   \n- Generated token or `auth:Error` if an error occurred during the JWT issuing or validation  \n  \n"}},"insertText":"generateToken()","insertTextFormat":"Snippet"}'),
(756, 11, 63, 'OutboundJwtAuthProvider.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(map\u003canydata\u003e data)((string|()|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nInspect the incoming data and generate the token for JWT authentication.\n  \n**Params**  \n- `map\u003canydata\u003e` data: Map of data which is extracted from the HTTP response  \n  \n**Returns** `(string|()|auth:Error)`   \n- String token, or `auth:Error` occurred when generating token or `()` if nothing to be returned  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(757, 11, 63, 'OutboundJwtAuthProvider.__init', FALSE, FALSE, TRUE, '{"label":"__init((jwt:JwtIssuerConfig|()) jwtIssuerConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/jwt_  \n  \nProvides authentication based on the provided JWT configuration.\n  \n**Params**  \n- `(jwt:JwtIssuerConfig|())` jwtIssuerConfig: JWT issuer configurations(Defaultable)  \n- `(jwt:JwtIssuerConfig|())` jwtIssuerConfig: JWT issuer configurations"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(758, 12, -1, 'getGroups', FALSE, FALSE, FALSE, '{"label":"getGroups(ldap:LdapConnection ldapConnection, string username)((string[]|ldap:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/ldap_  \n  \nReads the scope(s) for the user with the given username.\n  \n**Params**  \n- `ldap:LdapConnection` ldapConnection: `LdapConnection` instance  \n- `string` username: Username  \n  \n**Returns** `(string[]|ldap:Error)`   \n- Array of groups for the user denoted by the username or `Error` if error occurred  \n  \n"}},"insertText":"getGroups(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(759, 12, -1, 'doAuthenticate', FALSE, FALSE, FALSE, '{"label":"doAuthenticate(ldap:LdapConnection ldapConnection, string username, string password)((boolean|ldap:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/ldap_  \n  \nAuthenticate with username and password.\n  \n**Params**  \n- `ldap:LdapConnection` ldapConnection: `LdapConnection` instance  \n- `string` username: Username  \n- `string` password: Password  \n  \n**Returns** `(boolean|ldap:Error)`   \n- true if authentication is a success, else false or `Error` if error occurred  \n  \n"}},"insertText":"doAuthenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(760, 12, -1, 'initLdapConnectionContext', FALSE, FALSE, FALSE, '{"label":"initLdapConnectionContext(ldap:LdapConnectionConfig ldapConnectionConfig, string instanceId)((ldap:LdapConnection|ldap:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/ldap_  \n  \nInitailizes LDAP connection context.\n  \n**Params**  \n- `ldap:LdapConnectionConfig` ldapConnectionConfig: `LdapConnectionConfig` instance  \n- `string` instanceId: Unique id generated to identify an endpoint  \n  \n**Returns** `(ldap:LdapConnection|ldap:Error)`   \n- `LdapConnection` instance, or `Error` if error occurred  \n  \n"}},"insertText":"initLdapConnectionContext(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(761, 12, 64, 'InboundLdapAuthProvider.authenticate', FALSE, FALSE, TRUE, '{"label":"authenticate(string credential)((boolean|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/ldap_  \n  \nAuthenticate with username and password.\n  \n**Params**  \n- `string` credential: Credential value  \n  \n**Returns** `(boolean|auth:Error)`   \n- `true` if authentication is successful, otherwise `false` or `auth:Error` occurred while extracting credentials  \n  \n"}},"insertText":"authenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(762, 12, 64, 'InboundLdapAuthProvider.__init', FALSE, FALSE, TRUE, '{"label":"__init(ldap:LdapConnectionConfig ldapConnectionConfig, string instanceId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/ldap_  \n  \nCreate an LDAP auth store with the given configurations.\n  \n**Params**  \n- `ldap:LdapConnectionConfig` ldapConnectionConfig: LDAP connection configurations  \n- `string` instanceId: Endpoint instance id"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(763, 13, -1, 'printDebug', FALSE, FALSE, FALSE, '{"label":"printDebug((string|function () returns (string)) msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/log_  \n  \nLogs the specified value at DEBUG level.\n  \n**Params**  \n- `(string|function () returns (string))` msg: The message to be logged"}},"insertText":"printDebug(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(764, 13, -1, 'printError', FALSE, FALSE, FALSE, '{"label":"printError((string|function () returns (string)) msg, (()|error) err)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/log_  \n  \nLogs the specified message at ERROR level.\n  \n**Params**  \n- `(string|function () returns (string))` msg: The message to be logged  \n- `(()|error)` err: The error struct to be logged(Defaultable)  \n- `(()|error)` err: The error struct to be logged"}},"insertText":"printError(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(765, 13, -1, 'printInfo', FALSE, FALSE, FALSE, '{"label":"printInfo((string|function () returns (string)) msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/log_  \n  \nLogs the specified message at INFO level.\n  \n**Params**  \n- `(string|function () returns (string))` msg: The message to be logged"}},"insertText":"printInfo(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(766, 13, -1, 'printTrace', FALSE, FALSE, FALSE, '{"label":"printTrace((string|function () returns (string)) msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/log_  \n  \nLogs the specified message at TRACE level.\n  \n**Params**  \n- `(string|function () returns (string))` msg: The message to be logged"}},"insertText":"printTrace(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(767, 13, -1, 'printWarn', FALSE, FALSE, FALSE, '{"label":"printWarn((string|function () returns (string)) msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/log_  \n  \nLogs the specified message at WARN level.\n  \n**Params**  \n- `(string|function () returns (string))` msg: The message to be logged"}},"insertText":"printWarn(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(768, 14, -1, 'exp', FALSE, FALSE, FALSE, '{"label":"exp(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns Euler\u0027s number, that is \u0027e\u0027 raised to the power of exponent.\n  \n**Params**  \n- `float` val: Exponent value to raise  \n  \n**Returns** `float`   \n- Exp value  \n  \n"}},"insertText":"exp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(769, 14, -1, 'pow', FALSE, FALSE, FALSE, '{"label":"pow(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the value of the \u0027a\u0027 raised to the power of \u0027b\u0027.\n  \n**Params**  \n- `float` a: The base value  \n- `float` b: The exponent value  \n  \n**Returns** `float`   \n- Result value  \n  \n"}},"insertText":"pow(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(770, 14, -1, 'random', FALSE, FALSE, FALSE, '{"label":"random()(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns a random number between 0.0 and 1.0.\n  \n  \n  \n**Returns** `float`   \n- Random value  \n  \n"}},"insertText":"random()","insertTextFormat":"Snippet"}'),
(771, 14, -1, 'randomInRange', FALSE, FALSE, FALSE, '{"label":"randomInRange(int startRange, int endRange)((int|math:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns a random number between given start(inclusive) and end(exclusive) values.\n  \n**Params**  \n- `int` startRange: Range start value  \n- `int` endRange: Range end value  \n  \n**Returns** `(int|math:Error)`   \n- Random value or `Error` if start range is greater than the end range  \n  \n"}},"insertText":"randomInRange(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(772, 14, -1, 'sqrt', FALSE, FALSE, FALSE, '{"label":"sqrt(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns rounded positive square root of the given value.\n  \n**Params**  \n- `float` val: Value to get square root  \n  \n**Returns** `float`   \n- Square root value  \n  \n"}},"insertText":"sqrt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(773, 14, -1, 'absFloat', FALSE, FALSE, FALSE, '{"label":"absFloat(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the absolute value of a float value.\n  \n**Params**  \n- `float` val: Value to get absolute value  \n  \n**Returns** `float`   \n- Absolute value  \n  \n"}},"insertText":"absFloat(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(774, 14, -1, 'absInt', FALSE, FALSE, FALSE, '{"label":"absInt(int val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the absolute value of an int value.\n  \n**Params**  \n- `int` val: Value to get the absolute value  \n  \n**Returns** `int`   \n- Absolute value  \n  \n"}},"insertText":"absInt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(775, 14, -1, 'acos', FALSE, FALSE, FALSE, '{"label":"acos(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the arc cosine of a value; the returned angle is in the range 0.0 through pi.\n  \n**Params**  \n- `float` val: Value to get the arc cosine  \n  \n**Returns** `float`   \n- Arc cosine value  \n  \n"}},"insertText":"acos(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(776, 14, -1, 'asin', FALSE, FALSE, FALSE, '{"label":"asin(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the arc sine of a value.\n  \n**Params**  \n- `float` val: Value to get the arc sine  \n  \n**Returns** `float`   \n- Arc sine value  \n  \n"}},"insertText":"asin(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(777, 14, -1, 'atan', FALSE, FALSE, FALSE, '{"label":"atan(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the arc tangent of a value.\n  \n**Params**  \n- `float` val: Value to get the arc tangent  \n  \n**Returns** `float`   \n- Arc tangent value  \n  \n"}},"insertText":"atan(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(778, 14, -1, 'atan2', FALSE, FALSE, FALSE, '{"label":"atan2(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the angle theta from the conversion of rectangular coordinates (a, b) to polar coordinates (r, theta).\n  \n**Params**  \n- `float` a: The ordinate coordinate  \n- `float` b: The abscissa coordinate  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"atan2(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(779, 14, -1, 'cbrt', FALSE, FALSE, FALSE, '{"label":"cbrt(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the cube root of a float value.\n  \n**Params**  \n- `float` val: Value to get the cube root  \n  \n**Returns** `float`   \n- Cube root value  \n  \n"}},"insertText":"cbrt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(780, 14, -1, 'ceil', FALSE, FALSE, FALSE, '{"label":"ceil(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the smallest (closest to negative infinity) double value that is greater than orequal to the argument and\n   is equal to a mathematical integer.  \n**Params**  \n- `float` val: Value to get the ceil  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"ceil(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(781, 14, -1, 'copySign', FALSE, FALSE, FALSE, '{"label":"copySign(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the first floating-point argument with the sign of the second floating-point argument.\n  \n**Params**  \n- `float` a: The parameter providing the magnitude of the result  \n- `float` b: The parameter providing the sign of the result  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"copySign(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(782, 14, -1, 'cos', FALSE, FALSE, FALSE, '{"label":"cos(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the trigonometric cosine of an angle.\n  \n**Params**  \n- `float` val: Value to get the trigonometric cosine  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"cos(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(783, 14, -1, 'cosh', FALSE, FALSE, FALSE, '{"label":"cosh(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the hyperbolic cosine of a float value.\n  \n**Params**  \n- `float` val: The number whose hyperbolic cosine is to be returned  \n  \n**Returns** `float`   \n- The hyperbolic cosine of given float value  \n  \n"}},"insertText":"cosh(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(784, 14, -1, 'expm1', FALSE, FALSE, FALSE, '{"label":"expm1(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns (e to the power of x) -1.\n  \n**Params**  \n- `float` val: The exponent to raise e to in the computation  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"expm1(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(785, 14, -1, 'floor', FALSE, FALSE, FALSE, '{"label":"floor(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the largest (closest to positive infinity) float value that is less than or equal to the argument and is\n   equal to a mathematical integer.  \n**Params**  \n- `float` val: A float value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"floor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(786, 14, -1, 'floorDiv', FALSE, FALSE, FALSE, '{"label":"floorDiv(int a, int b)((int|math:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the largest (closest to positive infinity) int value that is less than or equal to the algebraic quotient.\n  \n**Params**  \n- `int` a: The dividend  \n- `int` b: The divisor  \n  \n**Returns** `(int|math:Error)`   \n- The result or `Error` if b is 0  \n  \n"}},"insertText":"floorDiv(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(787, 14, -1, 'floorMod', FALSE, FALSE, FALSE, '{"label":"floorMod(int a, int b)((int|math:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the floor modulus of the long arguments.\n  \n**Params**  \n- `int` a: The dividend  \n- `int` b: The divisor  \n  \n**Returns** `(int|math:Error)`   \n- The result or `Error` if b is 0  \n  \n"}},"insertText":"floorMod(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(788, 14, -1, 'getExponent', FALSE, FALSE, FALSE, '{"label":"getExponent(float val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the unbiased exponent used in the representation of a float.\n  \n**Params**  \n- `float` val: Float value  \n  \n**Returns** `int`   \n- The unbiased exponent of the argument  \n  \n"}},"insertText":"getExponent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(789, 14, -1, 'hypot', FALSE, FALSE, FALSE, '{"label":"hypot(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns sqrt(a squared +b squared) without intermediate overflow or underflow.\n  \n**Params**  \n- `float` a: Float value  \n- `float` b: Float value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"hypot(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(790, 14, -1, 'remainder', FALSE, FALSE, FALSE, '{"label":"remainder(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nComputes the remainder operation on two arguments as prescribed by the IEEE 754 standard.\n  \n**Params**  \n- `float` a: The dividend  \n- `float` b: The divisor  \n  \n**Returns** `float`   \n- The remainder when a is divided by b  \n  \n"}},"insertText":"remainder(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(791, 14, -1, 'log', FALSE, FALSE, FALSE, '{"label":"log(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the natural logarithm (base e) of a float value.\n  \n**Params**  \n- `float` val: A float value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"log(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(792, 14, -1, 'log10', FALSE, FALSE, FALSE, '{"label":"log10(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the base 10 logarithm of a float value.\n  \n**Params**  \n- `float` val: A float value  \n  \n**Returns** `float`   \n- The base 10 logarithm of a given float value  \n  \n"}},"insertText":"log10(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(793, 14, -1, 'log1p', FALSE, FALSE, FALSE, '{"label":"log1p(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the natural logarithm of the sum of the argument and 1.\n  \n**Params**  \n- `float` val: A float value  \n  \n**Returns** `float`   \n- The natural log of x + 1  \n  \n"}},"insertText":"log1p(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(794, 14, -1, 'negateExact', FALSE, FALSE, FALSE, '{"label":"negateExact(int val)((int|math:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the negation of the argument.\n  \n**Params**  \n- `int` val: The value to negate  \n  \n**Returns** `(int|math:Error)`   \n- The result or `Error` if overflow occurred  \n  \n"}},"insertText":"negateExact(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(795, 14, -1, 'nextAfter', FALSE, FALSE, FALSE, '{"label":"nextAfter(float a, float b)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the floating-point number adjacent to the first argument in the direction of the second argument.\n  \n**Params**  \n- `float` a: Starting floating-point value  \n- `float` b: Value indicating which of start\u0027s neighbors or start should be returned  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"nextAfter(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(796, 14, -1, 'nextDown', FALSE, FALSE, FALSE, '{"label":"nextDown(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the adjacent floating-point value closer to negative infinity.\n  \n**Params**  \n- `float` val: Starting floating-point value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"nextDown(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(797, 14, -1, 'nextUp', FALSE, FALSE, FALSE, '{"label":"nextUp(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the adjacent floating-point value closer to positive infinity.\n  \n**Params**  \n- `float` val: Starting floating-point value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"nextUp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(798, 14, -1, 'rint', FALSE, FALSE, FALSE, '{"label":"rint(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the double value that is closest in value to the argument and is equal to a mathematical integer.\n  \n**Params**  \n- `float` val: A float value  \n  \n**Returns** `float`   \n- The result  \n  \n"}},"insertText":"rint(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(799, 14, -1, 'round', FALSE, FALSE, FALSE, '{"label":"round(float val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the closest int to the argument, with ties rounding to positive infinity.\n  \n**Params**  \n- `float` val: A floating-point value to be rounded to an integer  \n  \n**Returns** `int`   \n- The value of the argument rounded to the nearest int value  \n  \n"}},"insertText":"round(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(800, 14, -1, 'scalb', FALSE, FALSE, FALSE, STRINGDECODE('{\"label\":\"scalb(float a, int b)(float)\",\"kind\":\"Function\",\"detail\":\"Function\",\"documentation\":{\"right\":{\"kind\":\"markdown\",\"value\":\"**Package:** _ballerina/math_  \\n  \\nReturns a \u00d7 (2 to the power of b) rounded as if performed by a single correctly rounded floating-point\\nmultiply to a member of the float value set.\\n  \\n**Params**  \\n- `float` a: Number to be scaled by a power of two  \\n- `int` b: Power of 2 used to scale a  \\n  \\n**Returns** `float`   \\n- The result  \\n  \\n\"}},\"insertText\":\"scalb(${1})\",\"insertTextFormat\":\"Snippet\",\"command\":{\"title\":\"editor.action.triggerParameterHints\",\"command\":\"editor.action.triggerParameterHints\"}}')),
(801, 14, -1, 'signum', FALSE, FALSE, FALSE, '{"label":"signum(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the signum function of the argument.\n  \n**Params**  \n- `float` val: The floating-point value whose signum is to be returned  \n  \n**Returns** `float`   \n- The signum function of the argument  \n  \n"}},"insertText":"signum(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(802, 14, -1, 'sin', FALSE, FALSE, FALSE, '{"label":"sin(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the trigonometric sine of an angle.\n  \n**Params**  \n- `float` val: An angle, in radians  \n  \n**Returns** `float`   \n- The sine of the argument  \n  \n"}},"insertText":"sin(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(803, 14, -1, 'sinh', FALSE, FALSE, FALSE, '{"label":"sinh(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the hyperbolic sine of a float value.\n  \n**Params**  \n- `float` val: The number whose hyperbolic sine is to be returned  \n  \n**Returns** `float`   \n- The hyperbolic sine of a given float  \n  \n"}},"insertText":"sinh(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(804, 14, -1, 'tan', FALSE, FALSE, FALSE, '{"label":"tan(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the trigonometric tangent of an angle.\n  \n**Params**  \n- `float` val: An angle, in radians  \n  \n**Returns** `float`   \n- The tangent of the argument  \n  \n"}},"insertText":"tan(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(805, 14, -1, 'tanh', FALSE, FALSE, FALSE, '{"label":"tanh(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the hyperbolic tangent of a double value.\n  \n**Params**  \n- `float` val: The number whose hyperbolic tangent is to be returned  \n  \n**Returns** `float`   \n- The hyperbolic tangent of x  \n  \n"}},"insertText":"tanh(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(806, 14, -1, 'toDegrees', FALSE, FALSE, FALSE, '{"label":"toDegrees(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nConverts an angle measured in radians to an approximately equivalent angle measured in degrees.\n  \n**Params**  \n- `float` val: An angle, in radians  \n  \n**Returns** `float`   \n- The measurement of the angle angrad in degrees  \n  \n"}},"insertText":"toDegrees(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(807, 14, -1, 'toRadians', FALSE, FALSE, FALSE, '{"label":"toRadians(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nConverts an angle measured in degrees to an approximately equivalent angle measured in radians.\n  \n**Params**  \n- `float` val: An angle, in degrees  \n  \n**Returns** `float`   \n- The measurement of the angle angdeg in radians  \n  \n"}},"insertText":"toRadians(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(808, 14, -1, 'ulp', FALSE, FALSE, FALSE, '{"label":"ulp(float val)(float)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/math_  \n  \nReturns the size of an ulp of the argument.\n  \n**Params**  \n- `float` val: The floating-point value whose ulp is to be returned  \n  \n**Returns** `float`   \n- The size of an ulp of the argument  \n  \n"}},"insertText":"ulp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(809, 15, -1, 'convertData', FALSE, FALSE, FALSE, '{"label":"convertData((byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n}) data)((string|byte[]|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(string|byte[]|error)`   \n  \n"}},"insertText":"convertData(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(810, 15, -1, 'prepareError', FALSE, FALSE, FALSE, '{"label":"prepareError(string message, (()|error) err)(nats:Error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nPrepare the `error` as a `Error`.\n  \n**Params**  \n- `string` message: the error message.  \n- `(()|error)` err: the `error` instance.(Defaultable)  \n- `(()|error)` err: the `error` instance.  \n  \n**Returns** `nats:Error`   \n- prepared `Error` instance.  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(811, 15, -1, 'detachFromNatsConnection', TRUE, FALSE, FALSE, '{"label":"detachFromNatsConnection((nats:StreamingProducer|nats:StreamingListener) streamingClient, (nats:Connection|()) natsConnection)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"detachFromNatsConnection(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(812, 15, -1, 'createStreamingConnection', TRUE, FALSE, FALSE, '{"label":"createStreamingConnection((nats:StreamingProducer|nats:StreamingListener) streamingClient, (nats:Connection|()) conn, string clusterId, (string|()) clientId, (nats:StreamingConfig|()) streamingConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"createStreamingConnection(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(813, 15, 65, 'Message.getData', FALSE, FALSE, TRUE, '{"label":"getData()(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nGet the message content.\n  \n  \n  \n**Returns** `byte[]`   \n- the data returned from the message as a \u0027byte[]\u0027.  \n  \n"}},"insertText":"getData()","insertTextFormat":"Snippet"}'),
(814, 15, 65, 'Message.getReplyTo', FALSE, FALSE, TRUE, '{"label":"getReplyTo()((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nGet the replyTo subject of the message.\n  \n  \n  \n**Returns** `(string|())`   \n- replyTo subject value.  \n  \n"}},"insertText":"getReplyTo()","insertTextFormat":"Snippet"}'),
(815, 15, 65, 'Message.getSubject', FALSE, FALSE, TRUE, '{"label":"getSubject()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nGet the subject of the message.\n  \n  \n  \n**Returns** `string`   \n- the subject that this message was sent to.  \n  \n"}},"insertText":"getSubject()","insertTextFormat":"Snippet"}'),
(816, 15, 65, 'Message.__init', FALSE, FALSE, TRUE, '{"label":"__init(string subject, byte[] content, (string|()) replyTo)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(817, 15, 66, 'Producer.init', TRUE, FALSE, TRUE, '{"label":"init(nats:Connection c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(818, 15, 66, 'Producer.publish', FALSE, TRUE, TRUE, '{"label":"publish(string subject, (byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n}) data)((()|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nProduces a message to a NATS basic server for the given subject.\n  \n**Params**  \n- `string` subject: Could also be referred as the \u0027topic/queue\u0027 name.  \n- `(byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n})` data: Data to publish.  \n  \n**Returns** `(()|nats:Error)`   \n- A specific error if there is a problem when publishing the message. Returns () otherwise.  \n  \n"}},"insertText":"publish(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(819, 15, 66, 'Producer.externPublish', TRUE, FALSE, TRUE, '{"label":"externPublish(string subject, (string|byte[]) data, (string|()) replyTo)((()|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|nats:Error)`   \n  \n"}},"insertText":"externPublish(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(820, 15, 66, 'Producer.request', FALSE, TRUE, TRUE, '{"label":"request(string subject, (byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n}) data, (int|()) duration)((nats:Message|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nProduces a message and would wait for a response.\n  \n**Params**  \n- `string` subject: Would represent the topic/queue name.  \n- `(byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n})` data: Data to publish.  \n- `(int|())` duration: The time to wait for a response measured in milliseconds.(Defaultable)  \n- `(int|())` duration: The time to wait for a response measured in milliseconds.  \n  \n**Returns** `(nats:Message|nats:Error)`   \n- The response message or an error.  \n  \n"}},"insertText":"request(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(821, 15, 66, 'Producer.externRequest', TRUE, FALSE, TRUE, '{"label":"externRequest(string subject, (byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n}) data, (int|()) duration)((nats:Message|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(nats:Message|nats:Error)`   \n  \n"}},"insertText":"externRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(822, 15, 66, 'Producer.close', FALSE, FALSE, TRUE, '{"label":"close()((()|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nClose a given connection.\n  \n  \n  \n**Returns** `(()|nats:Error)`   \n- Retruns () or the error if unable to complete the close operation.  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(823, 15, 66, 'Producer.closeConnection', TRUE, FALSE, TRUE, '{"label":"closeConnection()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"closeConnection();","insertTextFormat":"Snippet"}'),
(824, 15, 66, 'Producer.__init', FALSE, FALSE, TRUE, '{"label":"__init(nats:Connection c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nCreates a new producer.\n  \n**Params**  \n- `nats:Connection` c: An already-established connection."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(825, 15, 67, 'Listener.init', TRUE, FALSE, TRUE, '{"label":"init(nats:Connection c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(826, 15, 67, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nBinds the NATS consumer to a service.\n  \n**Params**  \n- `service` s: Type descriptor of the service.  \n- `(string|())` name: Name of the service.(Defaultable)  \n- `(string|())` name: Name of the service.  \n  \n**Returns** `(()|error)`   \n- Returns nil or the error upon failure to register the listener.  \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(827, 15, 67, 'Listener.register', TRUE, FALSE, TRUE, '{"label":"register(service serviceType, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(828, 15, 67, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nStarts the listener in the lifecyle.\n  \n  \n  \n**Returns** `(()|error)`   \n- Error or ().  \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(829, 15, 67, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"start();","insertTextFormat":"Snippet"}'),
(830, 15, 67, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(831, 15, 67, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nStops the listener in the lifecyle.\n  \n  \n  \n**Returns** `(()|error)`   \n- error or ().  \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(832, 15, 67, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"stop();","insertTextFormat":"Snippet"}'),
(833, 15, 67, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init(nats:Connection c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nCreates a new consumer. A new connection will be created if a refernece to a connection is not provided.\n  \n**Params**  \n- `nats:Connection` c: An already-established connection or configuration to create a new connection."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(834, 15, 68, 'Connection.init', TRUE, FALSE, TRUE, '{"label":"init(string url, nats:ConnectionConfig config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(835, 15, 68, 'Connection.close', FALSE, FALSE, TRUE, '{"label":"close((boolean|()) forceful)((()|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nCloses a given connection.\n  \n**Params**  \n- `(boolean|())` forceful: The graceful shutdown flag. If `true`, the connection closes immediately.\nBy default, this is set to false.(Defaultable)  \n- `(boolean|())` forceful: The graceful shutdown flag. If `true`, the connection closes immediately.\nBy default, this is set to false.  \n  \n**Returns** `(()|nats:Error)`   \n- Returns () or the error if unable to complete the close operation.  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(836, 15, 68, 'Connection.__init', FALSE, FALSE, TRUE, '{"label":"__init(string url, (nats:ConnectionConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nInitializes a connection with the NATS server.\n  \n**Params**  \n- `string` url: NATS Broker URL. For a clustered use case, pass the URLs as comma-separated values.  \n- `(nats:ConnectionConfig|())` config: Information necessary for the NATS client to establish a connection with the server.(Defaultable)  \n- `(nats:ConnectionConfig|())` config: Information necessary for the NATS client to establish a connection with the server."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(837, 15, 69, 'StreamingListener.init', TRUE, FALSE, TRUE, '{"label":"init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"init();","insertTextFormat":"Snippet"}'),
(838, 15, 69, 'StreamingListener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(839, 15, 69, 'StreamingListener.attach', TRUE, FALSE, TRUE, '{"label":"attach(service serviceType, (nats:Connection|()) conn)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"attach(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(840, 15, 69, 'StreamingListener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(841, 15, 69, 'StreamingListener.subscribe', TRUE, FALSE, TRUE, '{"label":"subscribe()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"subscribe();","insertTextFormat":"Snippet"}'),
(842, 15, 69, 'StreamingListener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(843, 15, 69, 'StreamingListener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(844, 15, 69, 'StreamingListener.close', TRUE, FALSE, TRUE, '{"label":"close()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(845, 15, 69, 'StreamingListener.__init', FALSE, FALSE, TRUE, '{"label":"__init(nats:Connection connection, (string|()) clientId, string clusterId, (nats:StreamingConfig|()) streamingConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nCreates a new StreamingListener.\n  \n**Params**  \n- `nats:Connection` connection: An established NATS connection.  \n- `string` clusterId: The ID of the cluster configured in the NATS server. Default value is `test-cluster`.(Defaultable)  \n- `string` clusterId: The ID of the cluster configured in the NATS server. Default value is `test-cluster`.  \n- `(string|())` clientId: A unique identifier representing the client. The `clientId` should be unique across subscriptions. Therefore,\n             multilpe subscription services cannot be bound to a single listener.(Defaultable)  \n- `(string|())` clientId: A unique identifier representing the client. The `clientId` should be unique across subscriptions. Therefore,\n             multilpe subscription services cannot be bound to a single listener.  \n- `(nats:StreamingConfig|())` streamingConfig: The configuration related to the NATS streaming connectivity.(Defaultable)  \n- `(nats:StreamingConfig|())` streamingConfig: The configuration related to the NATS streaming connectivity."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(846, 15, 70, 'StreamingMessage.getData', FALSE, FALSE, TRUE, '{"label":"getData()(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nGet the message content.\n  \n  \n  \n**Returns** `byte[]`   \n- the data from the message as a \u0027byte[]\u0027.  \n  \n"}},"insertText":"getData()","insertTextFormat":"Snippet"}'),
(847, 15, 70, 'StreamingMessage.getSubject', FALSE, FALSE, TRUE, '{"label":"getSubject()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nGet the subject.\n  \n  \n  \n**Returns** `string`   \n- subject value.  \n  \n"}},"insertText":"getSubject()","insertTextFormat":"Snippet"}'),
(848, 15, 70, 'StreamingMessage.ack', FALSE, TRUE, TRUE, '{"label":"ack()((()|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nAcknowledge the NATS Streaming server upon the receipt of the message.\n  \n  \n  \n**Returns** `(()|nats:Error)`   \n- Returns () if the acknowledgment completes successfully or an error.  \n  \n"}},"insertText":"ack()","insertTextFormat":"Snippet"}'),
(849, 15, 70, 'StreamingMessage.__init', FALSE, FALSE, TRUE, '{"label":"__init(string subject, byte[] content)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(850, 15, 71, 'StreamingProducer.publish', FALSE, TRUE, TRUE, '{"label":"publish(string subject, (byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n}) data)((string|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nPublishes data to a given subject.\n  \n**Params**  \n- `string` subject: NATS subject to publish data   \n- `(byte[]|boolean|string|int|float|decimal|xml|json|record {\n\n})` data: data to publish  \n  \n**Returns** `(string|nats:Error)`   \n- `string` value representing the NUID (NATS Unique Identifier) of the published message, if the  \n          message gets successfully published and acknowedged by the NATS server OR  \n          `nats/Error` with `nuid` and `message` fields in case an error occurs in publishing, the timeout  \n          elapses while waiting for the acknowledgement OR  \n          `nats/Error` only with the `message` field in case an error occurrs even before publishing  \n          is completed  \n  \n"}},"insertText":"publish(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(851, 15, 71, 'StreamingProducer.externPublish', TRUE, FALSE, TRUE, '{"label":"externPublish(string subject, (string|byte[]) data)((string|nats:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n  \n  \n**Returns** `(string|nats:Error)`   \n  \n"}},"insertText":"externPublish(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(852, 15, 71, 'StreamingProducer.close', FALSE, FALSE, TRUE, '{"label":"close()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \nClose the producer.\n  \n  \n  \n**Returns** `(()|error)`   \n- Retruns () or the error if unable to complete the close operation.  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(853, 15, 71, 'StreamingProducer.__init', FALSE, FALSE, TRUE, '{"label":"__init(nats:Connection conn, (string|()) clientId, string clusterId, (nats:StreamingConfig|()) streamingConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/nats_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(854, 16, 72, 'Channel.queueDeclare', FALSE, TRUE, TRUE, '{"label":"queueDeclare((rabbitmq:QueueConfiguration|()) queueConfig)((string|()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nActively declare a non-exclusive, autodelete, non-durable queue, or queue with the given configurations.\n  \n**Params**  \n- `(rabbitmq:QueueConfiguration|())` queueConfig: Holds the parameters required to declare a queue.(Defaultable)  \n- `(rabbitmq:QueueConfiguration|())` queueConfig: Holds the parameters required to declare a queue.  \n  \n**Returns** `(string|()|rabbitmq:Error)`   \n- The name of the queue if autogenerated or nil if the queue was successfully  \n              generated with the given parameters. An error is returned if an I/O error is encountered.  \n  \n"}},"insertText":"queueDeclare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(855, 16, 72, 'Channel.exchangeDeclare', FALSE, TRUE, TRUE, '{"label":"exchangeDeclare(rabbitmq:ExchangeConfiguration exchangeConfig)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nActively declare a non-autodelete, non-durable exchange with no extra arguments,\nIf the arguments are specifed, then the exchange is declared accordingly.\n  \n**Params**  \n- `rabbitmq:ExchangeConfiguration` exchangeConfig: Holds parameters required to declare an exchange.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"exchangeDeclare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(856, 16, 72, 'Channel.queueBind', FALSE, TRUE, TRUE, '{"label":"queueBind(string queueName, string exchangeName, string bindingKey)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nBinds a queue to an exchange with the given binding key.\n  \n**Params**  \n- `string` queueName: Name of the queue.  \n- `string` exchangeName: Name of the exchange.  \n- `string` bindingKey: Binding key used to bind the queue to the exchange.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"queueBind(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(857, 16, 72, 'Channel.basicPublish', FALSE, TRUE, TRUE, '{"label":"basicPublish((int|float|byte|boolean|string|map\u003cany\u003e|xml|json|byte[]) messageContent, string routingKey, string exchangeName, (rabbitmq:BasicProperties|()) properties)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nPublishes a message. Publishing to a non-existent exchange will result in a channel-level\nprotocol exception, which closes the channel.\n  \n**Params**  \n- `(int|float|byte|boolean|string|map\u003cany\u003e|xml|json|byte[])` messageContent: The message body.  \n- `string` routingKey: The routing key.  \n- `string` exchangeName: The name of the exchange to which the message is published.(Defaultable)  \n- `string` exchangeName: The name of the exchange to which the message is published.  \n- `(rabbitmq:BasicProperties|())` properties: Other properties for the message - routing headers etc.(Defaultable)  \n- `(rabbitmq:BasicProperties|())` properties: Other properties for the message - routing headers etc.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"basicPublish(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(858, 16, 72, 'Channel.queueDelete', FALSE, TRUE, TRUE, '{"label":"queueDelete(string queueName, (boolean|()) ifUnused, (boolean|()) ifEmpty)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nDeletes the queue with the given name although it is in use or has messages on it.\nIf the paramters ifUnused or ifEmpty is given, the queue is checked before deleting.\n  \n**Params**  \n- `string` queueName: Name of the queue to be deleted.  \n- `(boolean|())` ifUnused: True if the queue should be deleted only if not in use.(Defaultable)  \n- `(boolean|())` ifUnused: True if the queue should be deleted only if not in use.  \n- `(boolean|())` ifEmpty: True if the queue should be deleted only if empty.(Defaultable)  \n- `(boolean|())` ifEmpty: True if the queue should be deleted only if empty.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"queueDelete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(859, 16, 72, 'Channel.exchangeDelete', FALSE, TRUE, TRUE, '{"label":"exchangeDelete(string exchangeName)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nDeletes the exchange with the given name.\n  \n**Params**  \n- `string` exchangeName: The name of the exchange.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An I/O error if an error is encountered or nil otherwise.  \n  \n"}},"insertText":"exchangeDelete(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(860, 16, 72, 'Channel.queuePurge', FALSE, TRUE, TRUE, '{"label":"queuePurge(string queueName)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nPurges the contents of the given queue.\n  \n**Params**  \n- `string` queueName: The name of the queue.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"queuePurge(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(861, 16, 72, 'Channel.close', FALSE, FALSE, TRUE, '{"label":"close((int|()) closeCode, (string|()) closeMessage)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nCloses the RabbitMQ `Channel`.\n  \n**Params**  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).(Defaultable)  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).  \n- `(string|())` closeMessage: A message indicating the reason for closing the channel.(Defaultable)  \n- `(string|())` closeMessage: A message indicating the reason for closing the channel.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O problem is encountered.  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(862, 16, 72, 'Channel.abortChannel', FALSE, FALSE, TRUE, '{"label":"abortChannel((int|()) closeCode, (string|()) closeMessage)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nAborts the RabbitMQ `Channel`. Forces the `Channel` to close and waits for all the close operations\nto complete. Any encountered exceptions in the close operations are silently discarded.\n  \n**Params**  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).(Defaultable)  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).  \n- `(string|())` closeMessage: A message indicating the reason for closing the channel.(Defaultable)  \n- `(string|())` closeMessage: A message indicating the reason for closing the channel.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O problem is encountered.  \n  \n"}},"insertText":"abortChannel(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(863, 16, 72, 'Channel.getConnection', FALSE, FALSE, TRUE, '{"label":"getConnection()((rabbitmq:Connection|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieve the Connection which carries this channel.\n  \n  \n  \n**Returns** `(rabbitmq:Connection|rabbitmq:Error)`   \n- RabbitMQ Connection object or error if an I/O problem is encountered.  \n  \n"}},"insertText":"getConnection()","insertTextFormat":"Snippet"}'),
(864, 16, 72, 'Channel.createChannel', TRUE, FALSE, TRUE, '{"label":"createChannel((rabbitmq:Connection|()) connection)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n"}},"insertText":"createChannel(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(865, 16, 72, 'Channel.__init', FALSE, FALSE, TRUE, '{"label":"__init((rabbitmq:ConnectionConfiguration|rabbitmq:Connection) connectionOrConnectionConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nInitializes a Ballerina `Channel` object with the given `Connection` object or connection parameters.\nCreates a `Connection` object if only the connection configuration is given.\n  \n**Params**  \n- `(rabbitmq:ConnectionConfiguration|rabbitmq:Connection)` connectionOrConnectionConfig: Holds a Ballerina RabbitMQ `Connection` object or the connection parameters."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(866, 16, 73, 'Connection.close', FALSE, FALSE, TRUE, '{"label":"close((int|()) closeCode, (string|()) closeMessage, (int|()) timeoutInMillis)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nCloses the RabbitMQ `Connection` and all it\u0027s `Channel`s.\nIt waits with a provided timeout for all the close operations to complete.\nWhen timeout is reached the socket is forced to close.\n  \n**Params**  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).(Defaultable)  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).  \n- `(string|())` closeMessage: A message indicating the reason for closing the connection.(Defaultable)  \n- `(string|())` closeMessage: A message indicating the reason for closing the connection.  \n- `(int|())` timeoutInMillis: Timeout (in milliseconds) for completing all the close-related operations. Use -1 for infinity.(Defaultable)  \n- `(int|())` timeoutInMillis: Timeout (in milliseconds) for completing all the close-related operations. Use -1 for infinity.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O problem is encountered.  \n  \n"}},"insertText":"close(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(867, 16, 73, 'Connection.abortConnection', FALSE, FALSE, TRUE, '{"label":"abortConnection((int|()) closeCode, (string|()) closeMessage, (int|()) timeoutInMillis)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nAborts the RabbitMQ `Connection` and all its `Channel`s.\nForces the `Connection` to close and waits for all the close operations to complete. When timeout is reached\nthe socket is forced to close. Any encountered exceptions in the close operations are silently discarded.\n  \n**Params**  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).(Defaultable)  \n- `(int|())` closeCode: The close code (For information, go to the \"Reply Codes\" section in the\n              [AMQP 0-9-1 specification] (#https://www.rabbitmq.com/resources/specs/amqp0-9-1.pdf)).  \n- `(string|())` closeMessage: A message indicating the reason for closing the connection.(Defaultable)  \n- `(string|())` closeMessage: A message indicating the reason for closing the connection.  \n- `(int|())` timeoutInMillis: Timeout (in milliseconds) for completing all the close-related operations. Use -1 for infinity.(Defaultable)  \n- `(int|())` timeoutInMillis: Timeout (in milliseconds) for completing all the close-related operations. Use -1 for infinity.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O problem is encountered.  \n  \n"}},"insertText":"abortConnection(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(868, 16, 73, 'Connection.isClosed', FALSE, FALSE, TRUE, '{"label":"isClosed()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nChecks whether `close` was already called.\n  \n  \n  \n**Returns** `boolean`   \n- The value `true` if the `Connection` is already closed and `false` otherwise.  \n  \n"}},"insertText":"isClosed()","insertTextFormat":"Snippet"}'),
(869, 16, 73, 'Connection.createConnection', TRUE, FALSE, TRUE, '{"label":"createConnection(rabbitmq:ConnectionConfiguration connectionConfiguration)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n"}},"insertText":"createConnection(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(870, 16, 73, 'Connection.__init', FALSE, FALSE, TRUE, '{"label":"__init(rabbitmq:ConnectionConfiguration connectionConfiguration)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nInitializes a Ballerina RabbitMQ `Connection` object.\n  \n**Params**  \n- `rabbitmq:ConnectionConfiguration` connectionConfiguration: Holds connection parameters required to initialize the `Connection`."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(871, 16, 74, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nStarts the endpoint. Function is ignored by the ChannelListener.\n  \n  \n  \n**Returns** `(()|error)`   \n- Nil or error upon failure to start.  \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(872, 16, 74, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(873, 16, 74, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nStops consuming messages through ChannelListener endpoint.\n  \n  \n  \n**Returns** `(()|error)`   \n- Nil or error upon failure to close ChannelListener.  \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(874, 16, 74, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nBinds the ChannelListener to a service.\n  \n**Params**  \n- `service` s: Type descriptor of the service to bind to.  \n- `(string|())` name: Name of the service.(Defaultable)  \n- `(string|())` name: Name of the service.  \n  \n**Returns** `(()|error)`   \n- () or error upon failure to register listener.  \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(875, 16, 74, 'Listener.getChannel', FALSE, FALSE, TRUE, '{"label":"getChannel()((rabbitmq:Channel|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieve the Channel which initializes this listener.\n  \n  \n  \n**Returns** `(rabbitmq:Channel|error)`   \n- RabbitMQ Channel object or error if an I/O problem is encountered.  \n  \n"}},"insertText":"getChannel()","insertTextFormat":"Snippet"}'),
(876, 16, 74, 'Listener.registerListener', TRUE, FALSE, TRUE, '{"label":"registerListener(service serviceType)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"registerListener(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(877, 16, 74, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"stop()","insertTextFormat":"Snippet"}'),
(878, 16, 74, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(879, 16, 74, 'Listener.setQosSettings', TRUE, FALSE, TRUE, '{"label":"setQosSettings((int|()) prefetchCount, (int|()) prefetchSize)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"setQosSettings(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(880, 16, 74, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init((rabbitmq:ConnectionConfiguration|rabbitmq:Connection) connectionOrConnectionConfig, (int|()) prefetchCount, (int|()) prefetchSize)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nInitializes a Ballerina ChannelListener object with the given Connection object or connection parameters.\nCreates a Connection object if only the connection configuration is given. Sets global QoS settings,\nwhich will be applied to the entire channel.\n  \n**Params**  \n- `(rabbitmq:ConnectionConfiguration|rabbitmq:Connection)` connectionOrConnectionConfig: Holds a Ballerina RabbitMQ Connection object or the connection parameters.  \n- `(int|())` prefetchCount: Maximum number of messages that the server will deliver, 0 if unlimited.\n                     Unless explicitly given, this value is 10 by default.(Defaultable)  \n- `(int|())` prefetchCount: Maximum number of messages that the server will deliver, 0 if unlimited.\n                     Unless explicitly given, this value is 10 by default.  \n- `(int|())` prefetchSize: Maximum amount of content (measured in octets) that the server will deliver, 0 if unlimited.(Defaultable)  \n- `(int|())` prefetchSize: Maximum amount of content (measured in octets) that the server will deliver, 0 if unlimited."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(881, 16, 75, 'Message.basicAck', FALSE, TRUE, TRUE, '{"label":"basicAck((boolean|()) multiple)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nAcknowledge one or several received messages.\n  \n**Params**  \n- `(boolean|())` multiple: `true` to acknowledge all messages up to and including the message called on,\n               `false` to acknowledge just the message called on.(Defaultable)  \n- `(boolean|())` multiple: `true` to acknowledge all messages up to and including the message called on,\n               `false` to acknowledge just the message called on.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"basicAck(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(882, 16, 75, 'Message.basicNack', FALSE, TRUE, TRUE, '{"label":"basicNack((boolean|()) multiple, (boolean|()) requeue)((()|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nReject one or several received messages.\n  \n**Params**  \n- `(boolean|())` multiple: `true` to reject all messages up to and including the message called on;\n               `false` to reject just the message called on.(Defaultable)  \n- `(boolean|())` multiple: `true` to reject all messages up to and including the message called on;\n               `false` to reject just the message called on.  \n- `(boolean|())` requeue: `true` if the rejected message(s) should be requeued rather than discarded/dead-lettered.(Defaultable)  \n- `(boolean|())` requeue: `true` if the rejected message(s) should be requeued rather than discarded/dead-lettered.  \n  \n**Returns** `(()|rabbitmq:Error)`   \n- An error if an I/O error is encountered or nil if successful.  \n  \n"}},"insertText":"basicNack(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(883, 16, 75, 'Message.getDeliveryTag', FALSE, FALSE, TRUE, '{"label":"getDeliveryTag()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the delivery tag of the message.\n  \n  \n  \n**Returns** `int`   \n- int containing the delivery tag of the message.  \n  \n"}},"insertText":"getDeliveryTag()","insertTextFormat":"Snippet"}'),
(884, 16, 75, 'Message.getProperties', FALSE, FALSE, TRUE, '{"label":"getProperties()((rabbitmq:BasicProperties|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the properties of the message (i.e., routing headers etc.).\n  \n  \n  \n**Returns** `(rabbitmq:BasicProperties|rabbitmq:Error)`   \n- Properties of the message or error if an error is encountered.  \n  \n"}},"insertText":"getProperties()","insertTextFormat":"Snippet"}'),
(885, 16, 75, 'Message.getTextContent', FALSE, FALSE, TRUE, '{"label":"getTextContent()((string|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the text content of the RabbitMQ message.\n  \n  \n  \n**Returns** `(string|rabbitmq:Error)`   \n- string containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getTextContent()","insertTextFormat":"Snippet"}'),
(886, 16, 75, 'Message.getIntContent', FALSE, FALSE, TRUE, '{"label":"getIntContent()((int|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the int content of the RabbitMQ message.\n  \n  \n  \n**Returns** `(int|rabbitmq:Error)`   \n- int containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getIntContent()","insertTextFormat":"Snippet"}'),
(887, 16, 75, 'Message.getFloatContent', FALSE, FALSE, TRUE, '{"label":"getFloatContent()((float|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the float content of the RabbitMQ message.\n  \n  \n  \n**Returns** `(float|rabbitmq:Error)`   \n- float containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getFloatContent()","insertTextFormat":"Snippet"}'),
(888, 16, 75, 'Message.getJSONContent', FALSE, FALSE, TRUE, '{"label":"getJSONContent()((json|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the json content of the RabbitMQ message.\n  \n  \n  \n**Returns** `(json|rabbitmq:Error)`   \n- json containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getJSONContent()","insertTextFormat":"Snippet"}'),
(889, 16, 75, 'Message.getXMLContent', FALSE, FALSE, TRUE, '{"label":"getXMLContent()((xml|rabbitmq:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the xml content of the RabbitMQ message.\n  \n  \n  \n**Returns** `(xml|rabbitmq:Error)`   \n- xml containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getXMLContent()","insertTextFormat":"Snippet"}'),
(890, 16, 75, 'Message.getByteArrayContent', FALSE, FALSE, TRUE, '{"label":"getByteArrayContent()(byte[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/rabbitmq_  \n  \nRetrieves the byte array content of the RabbitMQ message.\n  \n  \n  \n**Returns** `byte[]`   \n- byte array containing message data or error if an error is encountered.  \n  \n"}},"insertText":"getByteArrayContent()","insertTextFormat":"Snippet"}'),
(891, 16, 75, 'Message.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(892, 17, -1, 'prepareEncodingErrorWithDetail', FALSE, FALSE, FALSE, '{"label":"prepareEncodingErrorWithDetail(string detail)(mime:EncodeError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \n  \n  \n  \n**Returns** `mime:EncodeError`   \n  \n"}},"insertText":"prepareEncodingErrorWithDetail(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(893, 17, -1, 'prepareDecodingErrorWithDetail', FALSE, FALSE, FALSE, '{"label":"prepareDecodingErrorWithDetail(string detail)(mime:DecodeError)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \n  \n  \n  \n**Returns** `mime:DecodeError`   \n  \n"}},"insertText":"prepareDecodingErrorWithDetail(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(894, 17, -1, 'base64Encode', FALSE, FALSE, FALSE, '{"label":"base64Encode((string|byte[]|io:ReadableByteChannel) contentToBeEncoded, string charset)((string|byte[]|io:ReadableByteChannel|mime:EncodeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nEncodes a given input with MIME specific Base64 encoding scheme.\n  \n**Params**  \n- `(string|byte[]|io:ReadableByteChannel)` contentToBeEncoded: Content that needs to be encoded can be of type `string`, `byte[]` or `io:ReadableByteChannel`  \n- `string` charset: Charset to be used. This is used only with the string input(Defaultable)  \n- `string` charset: Charset to be used. This is used only with the string input  \n  \n**Returns** `(string|byte[]|io:ReadableByteChannel|mime:EncodeError)`   \n- If the given input is of type string, an encoded `string` is returned.  \n           If the given input is of type byte[], an encoded `byte[]` is returned.  \n           If the given input is of type io:ReadableByteChannel, an encoded `io:ReadableByteChannel` is returned.  \n           In case of errors, an `EncodeError` record is returned.  \n  \n"}},"insertText":"base64Encode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(895, 17, -1, 'base64Decode', FALSE, FALSE, FALSE, '{"label":"base64Decode((string|byte[]|io:ReadableByteChannel) contentToBeDecoded, string charset)((string|byte[]|io:ReadableByteChannel|mime:DecodeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nDecodes a given input with MIME specific Base64 encoding scheme.\n  \n**Params**  \n- `(string|byte[]|io:ReadableByteChannel)` contentToBeDecoded: Content that needs to be decoded can be of type `string`, `byte[]` or `io:ReadableByteChannel`  \n- `string` charset: Charset to be used. This is used only with the string input(Defaultable)  \n- `string` charset: Charset to be used. This is used only with the string input  \n  \n**Returns** `(string|byte[]|io:ReadableByteChannel|mime:DecodeError)`   \n- If the given input is of type string, a decoded `string` is returned.  \n           If the given input is of type byte[], a decoded `byte[]` is returned.  \n           If the given input is of type io:ReadableByteChannel, a decoded `io:ReadableByteChannel` is returned.  \n           In case of errors, an `DecodeError` record is returned.  \n  \n"}},"insertText":"base64Decode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(896, 17, -1, 'base64EncodeBlob', FALSE, FALSE, FALSE, '{"label":"base64EncodeBlob(byte[] valueToBeEncoded)((byte[]|mime:EncodeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nEncodes a given byte[] with Base64 encoding scheme.\n  \n**Params**  \n- `byte[]` valueToBeEncoded: Content that needs to be encoded  \n  \n**Returns** `(byte[]|mime:EncodeError)`   \n- An encoded byte[]. In case of errors, an `EncodeError` record is returned  \n  \n"}},"insertText":"base64EncodeBlob(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(897, 17, -1, 'base64DecodeBlob', FALSE, FALSE, FALSE, '{"label":"base64DecodeBlob(byte[] valueToBeDecoded)((byte[]|mime:DecodeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nDecodes a given byte[] with Base64 encoding scheme.\n  \n**Params**  \n- `byte[]` valueToBeDecoded: Content that needs to be decoded  \n  \n**Returns** `(byte[]|mime:DecodeError)`   \n- A decoded `byte[]`. In case of errors, an `DecodeError` record is returned  \n  \n"}},"insertText":"base64DecodeBlob(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(898, 17, -1, 'getEncoding', TRUE, FALSE, FALSE, '{"label":"getEncoding(mime:MediaType contentType)((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the encoding value from a given MediaType.\n  \n**Params**  \n- `mime:MediaType` contentType: A MediaType struct  \n  \n**Returns** `(string|())`   \n- The encoding value as a `string`  \n  \n"}},"insertText":"getEncoding(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(899, 17, -1, 'getMediaType', FALSE, FALSE, FALSE, '{"label":"getMediaType(string contentType)((mime:MediaType|mime:InvalidContentTypeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven the Content-Type in string, gets the MediaType object populated with it.\n  \n**Params**  \n- `string` contentType: Content-Type in string  \n  \n**Returns** `(mime:MediaType|mime:InvalidContentTypeError)`   \n- `MediaType` object or an error in case of invalid content-type  \n  \n"}},"insertText":"getMediaType(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(900, 17, -1, 'getContentDispositionObject', FALSE, FALSE, FALSE, '{"label":"getContentDispositionObject(string contentDisposition)(mime:ContentDisposition)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven the Content-Disposition as a string, gets the ContentDisposition object with it.\n  \n**Params**  \n- `string` contentDisposition: Content disposition string  \n  \n**Returns** `mime:ContentDisposition`   \n- A `ContentDisposition` object  \n  \n"}},"insertText":"getContentDispositionObject(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(901, 17, 76, 'ContentDisposition.toString', FALSE, FALSE, TRUE, '{"label":"toString()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nConverts the `ContentDisposition` type to a string suitable for use as the value of a corresponding MIME header.  \n  \n  \n**Returns** `string`   \n- The `string` represnetation of the `ContentDisposition` object  \n  \n"}},"insertText":"toString()","insertTextFormat":"Snippet"}'),
(902, 17, 76, 'ContentDisposition.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(903, 17, 77, 'MediaType.getBaseType', FALSE, FALSE, TRUE, STRINGDECODE('{\"label\":\"getBaseType()(string)\",\"kind\":\"Function\",\"detail\":\"Function\",\"documentation\":{\"right\":{\"kind\":\"markdown\",\"value\":\"**Package:** _ballerina/mime_  \\n  \\nGets \u201cprimaryType/subtype+suffix\u201d combination in string format.\\n  \\n  \\n  \\n**Returns** `string`   \\n- Base type as a string from MediaType struct  \\n  \\n\"}},\"insertText\":\"getBaseType()\",\"insertTextFormat\":\"Snippet\"}')),
(904, 17, 77, 'MediaType.toString', FALSE, FALSE, TRUE, '{"label":"toString()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nConverts the media type to a string, suitable to be used as the value of a corresponding HTTP header.\n  \n  \n  \n**Returns** `string`   \n- Content type with parameters as a string  \n  \n"}},"insertText":"toString()","insertTextFormat":"Snippet"}');           
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(905, 17, 77, 'MediaType.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(906, 17, 78, 'Entity.setContentType', FALSE, FALSE, TRUE, '{"label":"setContentType(string mediaType)((()|mime:InvalidContentTypeError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the content-type to entity.\n  \n**Params**  \n- `string` mediaType: Content type that needs to be set to the entity  \n  \n**Returns** `(()|mime:InvalidContentTypeError)`   \n- Nil if successful, error in case of invalid media-type  \n  \n"}},"insertText":"setContentType(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(907, 17, 78, 'Entity.getContentType', FALSE, FALSE, TRUE, '{"label":"getContentType()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the content type of entity.\n  \n  \n  \n**Returns** `string`   \n- Content type as a `string`  \n  \n"}},"insertText":"getContentType()","insertTextFormat":"Snippet"}'),
(908, 17, 78, 'Entity.setContentId', FALSE, FALSE, TRUE, '{"label":"setContentId(string contentId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the content ID of the entity.\n  \n**Params**  \n- `string` contentId: Content ID that needs to be set to entity"}},"insertText":"setContentId(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(909, 17, 78, 'Entity.getContentId', FALSE, FALSE, TRUE, '{"label":"getContentId()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the content ID of entity.\n  \n  \n  \n**Returns** `string`   \n- Content ID as a `string`  \n  \n"}},"insertText":"getContentId()","insertTextFormat":"Snippet"}'),
(910, 17, 78, 'Entity.setContentLength', FALSE, FALSE, TRUE, '{"label":"setContentLength(int contentLength)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the content length of the entity.\n  \n**Params**  \n- `int` contentLength: Content length that needs to be set to entity"}},"insertText":"setContentLength(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(911, 17, 78, 'Entity.getContentLength', FALSE, FALSE, TRUE, '{"label":"getContentLength()((int|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the content length of entity.\n  \n  \n  \n**Returns** `(int|error)`   \n- Content length as an `int`  \n  \n"}},"insertText":"getContentLength()","insertTextFormat":"Snippet"}'),
(912, 17, 78, 'Entity.setContentDisposition', FALSE, FALSE, TRUE, '{"label":"setContentDisposition(mime:ContentDisposition contentDisposition)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the content disposition of the entity.\n  \n**Params**  \n- `mime:ContentDisposition` contentDisposition: Content disposition that needs to be set to entity"}},"insertText":"setContentDisposition(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(913, 17, 78, 'Entity.getContentDisposition', FALSE, FALSE, TRUE, '{"label":"getContentDisposition()(mime:ContentDisposition)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the content disposition of entity.\n  \n  \n  \n**Returns** `mime:ContentDisposition`   \n- A `ContentDisposition` object  \n  \n"}},"insertText":"getContentDisposition()","insertTextFormat":"Snippet"}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(914, 17, 78, 'Entity.setBody', FALSE, FALSE, TRUE, '{"label":"setBody((string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[]) entityBody)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the body of the entity with the given content. Note that any string value is set as `text/plain`. To send a\nJSON-compatible string, set the content-type header to `application/json` or use the `setJsonPayload` method instead.\n  \n**Params**  \n- `(string|xml|json|byte[]|io:ReadableByteChannel|mime:Entity[])` entityBody: Entity body can be of the type `string`,`xml`,`json`,`byte[]`,`io:ReadableByteChannel`, or `Entity[]`."}},"insertText":"setBody(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(915, 17, 78, 'Entity.setFileAsEntityBody', FALSE, FALSE, TRUE, '{"label":"setFileAsEntityBody(string filePath, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with a given file. This method overrides any existing `content-type` headers\nwith the default content type `application/octet-stream`. The default value `application/octet-stream`\ncan be overridden by passing the content type as an optional parameter.\n  \n**Params**  \n- `string` filePath: Represents the path to the file  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value.(Defaultable)  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value."}},"insertText":"setFileAsEntityBody(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(916, 17, 78, 'Entity.setJson', FALSE, FALSE, TRUE, '{"label":"setJson(json jsonContent, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with the given `json` content. This method overrides any existing `content-type` headers\nwith the default content type `application/json`. The default value `application/json` can be overridden\nby passing the content type as an optional parameter.\n  \n**Params**  \n- `json` jsonContent: JSON content that needs to be set to entity  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `application/json`\n                is used as the default value.(Defaultable)  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `application/json`\n                is used as the default value."}},"insertText":"setJson(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(917, 17, 78, 'Entity.getJson', FALSE, FALSE, TRUE, '{"label":"getJson()((json|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nExtracts JSON body from the entity. If the entity body is not a JSON, an error is returned.\n  \n  \n  \n**Returns** `(json|mime:ParserError)`   \n- `json` data extracted from the the entity body. An `ParserError` record is returned in case of  \n           errors.  \n  \n"}},"insertText":"getJson()","insertTextFormat":"Snippet"}'),
(918, 17, 78, 'Entity.setXml', FALSE, FALSE, TRUE, '{"label":"setXml(xml xmlContent, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with the given XML content. This method overrides any existing content-type headers\nwith the default content-type `application/xml`. The default value `application/xml` can be overridden\nby passing the content-type as an optional parameter.\n  \n**Params**  \n- `xml` xmlContent: XML content that needs to be set to entity  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `application/xml`\n                is used as the default value.(Defaultable)  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `application/xml`\n                is used as the default value."}},"insertText":"setXml(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(919, 17, 78, 'Entity.getXml', FALSE, FALSE, TRUE, '{"label":"getXml()((xml|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nExtracts `xml` body from the entity. If the entity body is not an XML, an error is returned.\n  \n  \n  \n**Returns** `(xml|mime:ParserError)`   \n- `xml` data extracted from the the entity body. An `ParserError` record is returned in case of  \n           errors.  \n  \n"}},"insertText":"getXml()","insertTextFormat":"Snippet"}'),
(920, 17, 78, 'Entity.setText', FALSE, FALSE, TRUE, '{"label":"setText(string textContent, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with the given text content. This method overrides any existing content-type headers\nwith the default content-type `text/plain`. The default value `text/plain` can be overridden\nby passing the content type as an optional parameter.\n  \n**Params**  \n- `string` textContent: Text content that needs to be set to entity  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `text/plain`\n                is used as the default value.(Defaultable)  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter. `text/plain`\n                is used as the default value."}},"insertText":"setText(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(921, 17, 78, 'Entity.getText', FALSE, FALSE, TRUE, '{"label":"getText()((string|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nExtracts text body from the entity. If the entity body is not text compatible an error is returned.\n  \n  \n  \n**Returns** `(string|mime:ParserError)`   \n- `string` data extracted from the the entity body or `ParserError` in case of errors.  \n  \n"}},"insertText":"getText()","insertTextFormat":"Snippet"}'),
(922, 17, 78, 'Entity.setByteArray', FALSE, FALSE, TRUE, '{"label":"setByteArray(byte[] blobContent, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with the given byte[] content. This method overrides any existing `content-type` headers\nwith the default content type `application/octet-stream`. The default value `application/octet-stream`\ncan be overridden by passing the content type as an optional parameter.\n  \n**Params**  \n- `byte[]` blobContent: byte[] content that needs to be set to entity  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value.(Defaultable)  \n- `string` contentType: Content type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value."}},"insertText":"setByteArray(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(923, 17, 78, 'Entity.getByteArray', FALSE, FALSE, TRUE, '{"label":"getByteArray()((byte[]|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven an entity, gets the entity body as a `byte[]`. If the entity size is considerably large consider\nusing getByteChannel() method instead.\n  \n  \n  \n**Returns** `(byte[]|mime:ParserError)`   \n- `byte[]` data extracted from the the entity body. An `ParserError` record is returned in case of  \n           errors.  \n  \n"}},"insertText":"getByteArray()","insertTextFormat":"Snippet"}'),
(924, 17, 78, 'Entity.setByteChannel', FALSE, FALSE, TRUE, '{"label":"setByteChannel(io:ReadableByteChannel byteChannel, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the entity body with the given byte channel content. This method overrides any existing content-type headers\nwith the default content-type `application/octet-stream`. The default value `application/octet-stream`\ncan be overridden by passing the content-type as an optional parameter.\n  \n**Params**  \n- `io:ReadableByteChannel` byteChannel: Byte channel that needs to be set to entity  \n- `string` contentType: Content-type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value.(Defaultable)  \n- `string` contentType: Content-type to be used with the payload. This is an optional parameter.\n                `application/octet-stream` is used as the default value."}},"insertText":"setByteChannel(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(925, 17, 78, 'Entity.getByteChannel', FALSE, FALSE, TRUE, '{"label":"getByteChannel()((io:ReadableByteChannel|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven an entity, gets the entity body as a byte channel.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|mime:ParserError)`   \n- An `io:ReadableByteChannel`. An `ParserError` record will be returned in case of errors  \n  \n"}},"insertText":"getByteChannel()","insertTextFormat":"Snippet"}'),
(926, 17, 78, 'Entity.getBodyParts', FALSE, FALSE, TRUE, '{"label":"getBodyParts()((mime:Entity[]|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven an entity, gets its body parts. If the entity body is not a set of body parts an error will be returned.\n  \n  \n  \n**Returns** `(mime:Entity[]|mime:ParserError)`   \n- An array of body parts(`Entity[]`) extracted from the entity body. An `ParserError` record will be  \n           returned in case of errors.  \n  \n"}},"insertText":"getBodyParts()","insertTextFormat":"Snippet"}'),
(927, 17, 78, 'Entity.getBodyPartsAsChannel', FALSE, FALSE, TRUE, '{"label":"getBodyPartsAsChannel()((io:ReadableByteChannel|mime:ParserError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGiven an entity, gets the body parts as a byte channel.\n  \n  \n  \n**Returns** `(io:ReadableByteChannel|mime:ParserError)`   \n- Body parts as a byte channel  \n  \n"}},"insertText":"getBodyPartsAsChannel()","insertTextFormat":"Snippet"}'),
(928, 17, 78, 'Entity.setBodyParts', FALSE, FALSE, TRUE, '{"label":"setBodyParts(mime:Entity[] bodyParts, string contentType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets body parts to entity. This method overrides any existing `content-type` headers\nwith the default content type `multipart/form-data`. The default value `multipart/form-data` can be overridden\nby passing the content type as an optional parameter.\n  \n**Params**  \n- `mime:Entity[]` bodyParts: Represents the body parts that needs to be set to the entity  \n- `string` contentType: Content-type to be used with the payload. This is an optional parameter.\n                `multipart/form-data` is used as the default value.(Defaultable)  \n- `string` contentType: Content-type to be used with the payload. This is an optional parameter.\n                `multipart/form-data` is used as the default value."}},"insertText":"setBodyParts(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(929, 17, 78, 'Entity.getHeader', FALSE, FALSE, TRUE, '{"label":"getHeader(string headerName)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets the header value associated with the given header name.\n  \n**Params**  \n- `string` headerName: Represents header name  \n  \n**Returns** `string`   \n- Header value associated with the given header name as a `string`. If multiple header values are  \n           present, then the first value is returned. An exception is thrown if no header is found. Use  \n           `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(930, 17, 78, 'Entity.getHeaders', FALSE, FALSE, TRUE, '{"label":"getHeaders(string headerName)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets all the header values associated with the given header name.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `string[]`   \n- All the header values associated with the given header name as a `string[]`. An exception is thrown  \n           if no header is found. Use `hasHeader()` beforehand to check the existence of header.  \n  \n"}},"insertText":"getHeaders(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(931, 17, 78, 'Entity.getHeaderNames', FALSE, FALSE, TRUE, '{"label":"getHeaderNames()(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nGets all header names.\n  \n  \n  \n**Returns** `string[]`   \n- All header names as a `string[]`  \n  \n"}},"insertText":"getHeaderNames()","insertTextFormat":"Snippet"}'),
(932, 17, 78, 'Entity.addHeader', FALSE, FALSE, TRUE, '{"label":"addHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nAdds the given header value against the given header.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: Represents the header value to be added"}},"insertText":"addHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(933, 17, 78, 'Entity.setHeader', FALSE, FALSE, TRUE, '{"label":"setHeader(string headerName, string headerValue)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nSets the given header value against the existing header. If a header already exists, its value is replaced\nwith the given header value.\n  \n**Params**  \n- `string` headerName: The header name  \n- `string` headerValue: Represents the header value"}},"insertText":"setHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(934, 17, 78, 'Entity.removeHeader', FALSE, FALSE, TRUE, '{"label":"removeHeader(string headerName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nRemoves the given header from the entity.\n  \n**Params**  \n- `string` headerName: Represents the header name"}},"insertText":"removeHeader(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(935, 17, 78, 'Entity.removeAllHeaders', FALSE, FALSE, TRUE, '{"label":"removeAllHeaders()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nRemoves all headers associated with the entity.  \n"}},"insertText":"removeAllHeaders();","insertTextFormat":"Snippet"}'),
(936, 17, 78, 'Entity.hasHeader', FALSE, FALSE, TRUE, '{"label":"hasHeader(string headerName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/mime_  \n  \nChecks whether the requested header key exists in the header map.\n  \n**Params**  \n- `string` headerName: The header name  \n  \n**Returns** `boolean`   \n- True if the specified header key exists  \n  \n"}},"insertText":"hasHeader(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(937, 17, 78, 'Entity.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(938, 18, -1, 'getScopes', FALSE, FALSE, FALSE, '{"label":"getScopes(string scopes)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nReads the scope(s) for the user with the given username.\n  \n**Params**  \n- `string` scopes: Set of scopes seperated with a space  \n  \n**Returns** `string[]`   \n- Array of groups for the user denoted by the username  \n  \n"}},"insertText":"getScopes(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(939, 18, -1, 'getAuthTokenForOAuth2', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForOAuth2((oauth2:ClientCredentialsGrantConfig|oauth2:PasswordGrantConfig|oauth2:DirectTokenConfig) authConfig, oauth2:CachedToken tokenCache, boolean updateRequest)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nProcess auth token for OAuth2.\n  \n**Params**  \n- `(oauth2:ClientCredentialsGrantConfig|oauth2:PasswordGrantConfig|oauth2:DirectTokenConfig)` authConfig: OAuth2 configurations  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n- `boolean` updateRequest: Check if the request is updated after a 401 response  \n  \n**Returns** `(string|oauth2:Error)`   \n- Auth token or `Error` if the validation fails  \n  \n"}},"insertText":"getAuthTokenForOAuth2(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(940, 18, -1, 'getAuthTokenForOAuth2PasswordGrant', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForOAuth2PasswordGrant(oauth2:PasswordGrantConfig grantTypeConfig, oauth2:CachedToken tokenCache)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nProcess the auth token for OAuth2 password grant.\n  \n**Params**  \n- `oauth2:PasswordGrantConfig` grantTypeConfig: Password grant configurations  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `(string|oauth2:Error)`   \n- Auth token or `Error` if an error occurred during the HTTP client invocation or validation  \n  \n"}},"insertText":"getAuthTokenForOAuth2PasswordGrant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(941, 18, -1, 'getAuthTokenForOAuth2ClientCredentialsGrant', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForOAuth2ClientCredentialsGrant(oauth2:ClientCredentialsGrantConfig grantTypeConfig, oauth2:CachedToken tokenCache)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nProcess the auth token for OAuth2 client credentials grant.\n  \n**Params**  \n- `oauth2:ClientCredentialsGrantConfig` grantTypeConfig: Client credentials grant configurations  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `(string|oauth2:Error)`   \n- Auth token or `Error` if an error occurred during the HTTP client invocation or validation  \n  \n"}},"insertText":"getAuthTokenForOAuth2ClientCredentialsGrant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(942, 18, -1, 'getAuthTokenForOAuth2DirectTokenMode', TRUE, FALSE, FALSE, '{"label":"getAuthTokenForOAuth2DirectTokenMode(oauth2:DirectTokenConfig grantTypeConfig, oauth2:CachedToken tokenCache)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nProcess the auth token for OAuth2 direct token mode.\n  \n**Params**  \n- `oauth2:DirectTokenConfig` grantTypeConfig: Direct token configurations  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `(string|oauth2:Error)`   \n- Auth token or `Error` if an error occurred during the HTTP client invocation or validation  \n  \n"}},"insertText":"getAuthTokenForOAuth2DirectTokenMode(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(943, 18, -1, 'isCachedTokenValid', TRUE, FALSE, FALSE, '{"label":"isCachedTokenValid(oauth2:CachedToken tokenCache)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nCheck the validity of the access toke,n which is in the cache. If the expiry time is 0, that means no expiry time is\nreturned with the authorization request. This implies that the token is valid forever.\n  \n**Params**  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `boolean`   \n- Whether the access token is valid or not  \n  \n"}},"insertText":"isCachedTokenValid(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(944, 18, -1, 'getAccessTokenFromAuthorizationRequest', TRUE, FALSE, FALSE, '{"label":"getAccessTokenFromAuthorizationRequest((oauth2:ClientCredentialsGrantConfig|oauth2:PasswordGrantConfig) config, oauth2:CachedToken tokenCache)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nRequest an access token from the authorization endpoint using the provided configurations.\n  \n**Params**  \n- `(oauth2:ClientCredentialsGrantConfig|oauth2:PasswordGrantConfig)` config: Grant type configuration  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `(string|oauth2:Error)`   \n- Access token received or `Error` if an error occurred during the HTTP client invocation  \n  \n"}},"insertText":"getAccessTokenFromAuthorizationRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(945, 18, -1, 'getAccessTokenFromRefreshRequest', TRUE, FALSE, FALSE, '{"label":"getAccessTokenFromRefreshRequest((oauth2:PasswordGrantConfig|oauth2:DirectTokenConfig) config, oauth2:CachedToken tokenCache)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nRequest an access token from the authorization endpoint using the provided refresh configurations.\n  \n**Params**  \n- `(oauth2:PasswordGrantConfig|oauth2:DirectTokenConfig)` config: Password grant type configuration or direct token configuration  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n  \n**Returns** `(string|oauth2:Error)`   \n- Access token received or `Error` if an error occurred during HTTP client invocation  \n  \n"}},"insertText":"getAccessTokenFromRefreshRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(946, 18, -1, 'doRequest', TRUE, FALSE, FALSE, '{"label":"doRequest(string url, http:Request request, http:ClientEndpointConfig clientConfig, oauth2:CachedToken tokenCache, int clockSkewInSeconds)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nExecute the actual request and get the access token from authorization endpoint.\n  \n**Params**  \n- `string` url: URL of the authorization endpoint  \n- `http:Request` request: Prepared request to be sent to the authorization endpoint  \n- `http:ClientEndpointConfig` clientConfig: HTTP client configurations which calls the authorization endpoint  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n- `int` clockSkewInSeconds: Clock skew in seconds  \n  \n**Returns** `(string|oauth2:Error)`   \n- Access token received or `Error` if an error occurred during HTTP client invocation  \n  \n"}},"insertText":"doRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(947, 18, -1, 'prepareRequest', TRUE, FALSE, FALSE, '{"label":"prepareRequest(oauth2:RequestConfig config)((http:Request|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nPrepare the request to be sent to the authorization endpoint by adding the relevant headers and payloads.\n  \n**Params**  \n- `oauth2:RequestConfig` config: `RequestConfig` record  \n  \n**Returns** `(http:Request|oauth2:Error)`   \n- Prepared HTTP request object or `Error` if an error occurred during preparing request  \n  \n"}},"insertText":"prepareRequest(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(948, 18, -1, 'extractAccessTokenFromResponse', TRUE, FALSE, FALSE, '{"label":"extractAccessTokenFromResponse(http:Response response, oauth2:CachedToken tokenCache, int clockSkewInSeconds)((string|oauth2:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nExtract the access token from the JSON payload of a given HTTP response and update the token cache.\n  \n**Params**  \n- `http:Response` response: HTTP response object  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n- `int` clockSkewInSeconds: Clock skew in seconds  \n  \n**Returns** `(string|oauth2:Error)`   \n- Extracted access token or `Error` if an error occurred during the HTTP client invocation  \n  \n"}},"insertText":"extractAccessTokenFromResponse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(949, 18, -1, 'updateTokenCache', TRUE, FALSE, FALSE, '{"label":"updateTokenCache(json responsePayload, oauth2:CachedToken tokenCache, int clockSkewInSeconds)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nUpdate the token cache with the received JSON payload of the response.\n  \n**Params**  \n- `json` responsePayload: Payload of the response  \n- `oauth2:CachedToken` tokenCache: Cached token configurations  \n- `int` clockSkewInSeconds: Clock skew in seconds"}},"insertText":"updateTokenCache(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(950, 18, -1, 'prepareError', TRUE, FALSE, FALSE, '{"label":"prepareError(string message, (()|error) err)(oauth2:Error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nLog and prepare `error` as a `Error`.\n  \n**Params**  \n- `string` message: Error message  \n- `(()|error)` err: `error` instance(Defaultable)  \n- `(()|error)` err: `error` instance  \n  \n**Returns** `oauth2:Error`   \n- Prepared `Error` instance  \n  \n"}},"insertText":"prepareError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(951, 18, 79, 'InboundOAuth2Provider.authenticate', FALSE, FALSE, TRUE, '{"label":"authenticate(string credential)((boolean|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nAttempts to authenticate with credential.\n  \n**Params**  \n- `string` credential: Credential  \n  \n**Returns** `(boolean|auth:Error)`   \n- `true` if authentication is successful, otherwise `false` or `auth:Error` if an error occurred  \n  \n"}},"insertText":"authenticate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(952, 18, 79, 'InboundOAuth2Provider.__init', FALSE, FALSE, TRUE, '{"label":"__init(oauth2:IntrospectionServerConfig config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(953, 18, 80, 'OutboundOAuth2Provider.generateToken', FALSE, FALSE, TRUE, '{"label":"generateToken()((string|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nGenerate token for OAuth2 authentication.\n  \n  \n  \n**Returns** `(string|auth:Error)`   \n- Generated token or `auth:Error` if an error occurred  \n  \n"}},"insertText":"generateToken()","insertTextFormat":"Snippet"}'),
(954, 18, 80, 'OutboundOAuth2Provider.inspect', FALSE, FALSE, TRUE, '{"label":"inspect(map\u003canydata\u003e data)((string|()|auth:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nInspect the incoming data and generate the token for OAuth2 authentication.\n  \n**Params**  \n- `map\u003canydata\u003e` data: Map of data which is extracted from the HTTP response  \n  \n**Returns** `(string|()|auth:Error)`   \n- String token, or `auth:Error` occurred when generating token or `()` if nothing to be returned  \n  \n"}},"insertText":"inspect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(955, 18, 80, 'OutboundOAuth2Provider.__init', FALSE, FALSE, TRUE, '{"label":"__init((oauth2:ClientCredentialsGrantConfig|oauth2:PasswordGrantConfig|oauth2:DirectTokenConfig|()) oauth2ProviderConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/oauth2_  \n  \nProvides authentication based on the provided OAuth2 configuration.\n  \n**Params**  \n- outboundJwtAuthConfig: Outbound OAuth2 authentication configurations"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(956, 20, -1, 'getServiceAnnotations', FALSE, FALSE, FALSE, '{"label":"getServiceAnnotations(service serviceType, string annotName, (string|()) moduleName)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/reflect_  \n  \n  \n  \n  \n**Returns** `any`   \n  \n"}},"insertText":"getServiceAnnotations(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(957, 20, -1, 'getResourceAnnotations', FALSE, FALSE, FALSE, '{"label":"getResourceAnnotations(service serviceType, string resourceName, string annotName, (string|()) moduleName)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/reflect_  \n  \n  \n  \n  \n**Returns** `any`   \n  \n"}},"insertText":"getResourceAnnotations(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(958, 20, -1, 'getServiceAnnotationsExternal', TRUE, FALSE, FALSE, '{"label":"getServiceAnnotationsExternal(service serviceType, string annot)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/reflect_  \n  \n  \n  \n  \n**Returns** `any`   \n  \n"}},"insertText":"getServiceAnnotationsExternal(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(959, 20, -1, 'getResourceAnnotationsExternal', TRUE, FALSE, FALSE, '{"label":"getResourceAnnotationsExternal(service serviceType, string resourceName, string annot)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/reflect_  \n  \n  \n  \n  \n**Returns** `any`   \n  \n"}},"insertText":"getResourceAnnotationsExternal(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(960, 20, -1, 'getAnnotQualifiedIdentifier', TRUE, FALSE, FALSE, '{"label":"getAnnotQualifiedIdentifier(string annotName, (string|()) moduleName)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/reflect_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getAnnotQualifiedIdentifier(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(961, 21, 81, 'Client.initEndpoint', TRUE, FALSE, TRUE, '{"label":"initEndpoint(socket:ClientConfig clientConfig)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(962, 21, 81, 'Client.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(963, 21, 81, 'Client.write', FALSE, TRUE, TRUE, '{"label":"write(byte[] content)((int|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nWrites given data to the client socket.\n  \n**Params**  \n- `byte[]` content: - the content that wish to send to the client socket  \n  \n**Returns** `(int|socket:GenericError|socket:ReadTimedOutError)`   \n- - number of bytes got written or an error if encounters an error while writing  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(964, 21, 81, 'Client.read', FALSE, TRUE, TRUE, '{"label":"read(int length)(([byte[],int]|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nReads data from the client socket. If the data has the specified length, then wait until that number of bytes\nare received from the client. Else, return the data available in the OS buffer.\nIn the case of the connection being closed by the client, then return either -1 or the data\nthat is currently available in the buffer.\nNumber of bytes returned will be \u003c 0 if the client closes the connection.\n  \n**Params**  \n- `int` length: - Positive integer. Represents the number of bytes which should be read(Defaultable)  \n- `int` length: - Positive integer. Represents the number of bytes which should be read  \n  \n**Returns** `([byte[],int]|socket:ReadTimedOutError)`   \n- - Content as a byte array and the number of bytes read or an error if encounters an error while reading  \n  \n"}},"insertText":"read(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(965, 21, 81, 'Client.close', FALSE, TRUE, TRUE, '{"label":"close()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nCloses the client socket connection.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- - an error if encounters an error while closing the connection or returns nil otherwise  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(966, 21, 81, 'Client.shutdownRead', FALSE, TRUE, TRUE, '{"label":"shutdownRead()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nShutdowns the further read from socket.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- an error if encounters an error while shutdown the read from socket or returns nil otherwise  \n  \n"}},"insertText":"shutdownRead()","insertTextFormat":"Snippet"}'),
(967, 21, 81, 'Client.shutdownWrite', FALSE, TRUE, TRUE, '{"label":"shutdownWrite()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nShutdowns the further write from socket.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- an error if encounters an error while shutdown the write from socket or returns nil otherwise  \n  \n"}},"insertText":"shutdownWrite()","insertTextFormat":"Snippet"}'),
(968, 21, 81, 'Client.__init', FALSE, FALSE, TRUE, '{"label":"__init((socket:ClientConfig|()) clientConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(969, 21, 82, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(970, 21, 82, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(971, 21, 82, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(972, 21, 82, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(973, 21, 82, 'Listener.initServer', TRUE, FALSE, TRUE, '{"label":"initServer(int port, socket:ListenerConfig config)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initServer(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(974, 21, 82, 'Listener.register', TRUE, FALSE, TRUE, '{"label":"register(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(975, 21, 82, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(976, 21, 82, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"stop()","insertTextFormat":"Snippet"}'),
(977, 21, 82, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init(int port, (socket:ListenerConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(978, 21, 83, 'Client.initEndpoint', TRUE, FALSE, TRUE, '{"label":"initEndpoint(socket:ClientConfig clientConfig)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(979, 21, 83, 'Client.start', TRUE, FALSE, TRUE, '{"label":"start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(980, 21, 83, 'Client.write', FALSE, TRUE, TRUE, '{"label":"write(byte[] content)((int|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nWrites given data to the client socket.\n  \n**Params**  \n- `byte[]` content: - the content that wish to send to the client socket  \n  \n**Returns** `(int|socket:GenericError|socket:ReadTimedOutError)`   \n- - number of bytes got written or an error if encounters an error while writing  \n  \n"}},"insertText":"write(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(981, 21, 83, 'Client.read', FALSE, TRUE, TRUE, '{"label":"read(int length)(([byte[],int]|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nReads data from the client socket. If the data has the specified length, then wait until that number of bytes\nare received from the client. Else, return the data available in the OS buffer.\nIn the case of the connection being closed by the client, then return either -1 or the data\nthat is currently available in the buffer.\nNumber of bytes returned will be \u003c 0 if the client closes the connection.\n  \n**Params**  \n- `int` length: - Positive integer. Represents the number of bytes which should be read(Defaultable)  \n- `int` length: - Positive integer. Represents the number of bytes which should be read  \n  \n**Returns** `([byte[],int]|socket:ReadTimedOutError)`   \n- - Content as a byte array and the number of bytes read or an error if encounters an error while reading  \n  \n"}},"insertText":"read(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(982, 21, 83, 'Client.close', FALSE, TRUE, TRUE, '{"label":"close()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nCloses the client socket connection.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- - an error if encounters an error while closing the connection or returns nil otherwise  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(983, 21, 83, 'Client.shutdownRead', FALSE, TRUE, TRUE, '{"label":"shutdownRead()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nShutdowns the further read from socket.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- an error if encounters an error while shutdown the read from socket or returns nil otherwise  \n  \n"}},"insertText":"shutdownRead()","insertTextFormat":"Snippet"}'),
(984, 21, 83, 'Client.shutdownWrite', FALSE, TRUE, TRUE, '{"label":"shutdownWrite()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nShutdowns the further write from socket.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- an error if encounters an error while shutdown the write from socket or returns nil otherwise  \n  \n"}},"insertText":"shutdownWrite()","insertTextFormat":"Snippet"}'),
(985, 21, 83, 'Client.__init', FALSE, FALSE, TRUE, '{"label":"__init((socket:ClientConfig|()) clientConfig)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(986, 21, 84, 'UdpClient.initEndpoint', TRUE, FALSE, TRUE, '{"label":"initEndpoint((socket:Address|()) localAddress, socket:UdpClientConfig config)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"initEndpoint(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(987, 21, 84, 'UdpClient.sendTo', FALSE, TRUE, TRUE, '{"label":"sendTo(byte[] content, socket:Address address)((int|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nSend given data to the specified remote client.\n  \n**Params**  \n- `byte[]` content: the content that wish to send to the client socket  \n- `socket:Address` address: the address of the remote client socket  \n  \n**Returns** `(int|socket:GenericError|socket:ReadTimedOutError)`   \n- number of bytes got written or an error if encounters an error while writing  \n  \n"}},"insertText":"sendTo(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(988, 21, 84, 'UdpClient.receiveFrom', FALSE, TRUE, TRUE, '{"label":"receiveFrom(int length)(([byte[],int,socket:Address]|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nReads data from the remote client. If the data has the specified length, then wait until that number of bytes\nare received from the client. Else, return the data available in the OS buffer or wait until data receive.\nIf the request length is lesser than the data in the buffer, then the rest will be discarded.\n  \n**Params**  \n- `int` length: Positive integer. Represents the number of bytes which should be read(Defaultable)  \n- `int` length: Positive integer. Represents the number of bytes which should be read  \n  \n**Returns** `([byte[],int,socket:Address]|socket:ReadTimedOutError)`   \n- Content as a byte array, the number of bytes read and the address of the sender  \nor an error if encounters an error while reading  \n  \n"}},"insertText":"receiveFrom(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(989, 21, 84, 'UdpClient.close', FALSE, TRUE, TRUE, '{"label":"close()((()|socket:GenericError|socket:ReadTimedOutError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nCloses the client socket connection.\n  \n  \n  \n**Returns** `(()|socket:GenericError|socket:ReadTimedOutError)`   \n- - an error if encounters an error while closing the connection or returns nil otherwise  \n  \n"}},"insertText":"close()","insertTextFormat":"Snippet"}'),
(990, 21, 84, 'UdpClient.__init', FALSE, FALSE, TRUE, '{"label":"__init((socket:Address|()) localAddress, (socket:UdpClientConfig|()) config)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/socket_  \n  \nInitialize the UDP client based on provided configuration.\n  \n**Params**  \n- `(socket:Address|())` localAddress: Locally binding interface and port(Defaultable)  \n- `(socket:Address|())` localAddress: Locally binding interface and port  \n- `(socket:UdpClientConfig|())` config: Configure additional details like read timeout etc.(Defaultable)  \n- `(socket:UdpClientConfig|())` config: Configure additional details like read timeout etc."}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(991, 22, -1, 'time', FALSE, FALSE, FALSE, '{"label":"time(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `time` function creates a `TimeWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"time(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(992, 22, -1, 'avg', FALSE, FALSE, FALSE, '{"label":"avg()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `Average` aggregator object. The aggregator function name which is used in a streaming query should have the\nsame name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which performs averaging.  \n  \n"}},"insertText":"avg()","insertTextFormat":"Snippet"}'),
(993, 22, -1, 'count', FALSE, FALSE, FALSE, '{"label":"count()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `Count` aggregator object. The aggregator function name which is used in a streaming query should have the\nsame name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which performs counting.  \n  \n"}},"insertText":"count()","insertTextFormat":"Snippet"}'),
(994, 22, -1, 'distinctCount', FALSE, FALSE, FALSE, '{"label":"distinctCount()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `DistinctCount` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which represents DistinctCount.  \n  \n"}},"insertText":"distinctCount()","insertTextFormat":"Snippet"}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(995, 22, -1, 'max', FALSE, FALSE, FALSE, '{"label":"max()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `Max` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which represents `Max`.  \n  \n"}},"insertText":"max()","insertTextFormat":"Snippet"}'),
(996, 22, -1, 'maxForever', FALSE, FALSE, FALSE, '{"label":"maxForever()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `MaxForever` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which represents `MaxForever`.  \n  \n"}},"insertText":"maxForever()","insertTextFormat":"Snippet"}'),
(997, 22, -1, 'min', FALSE, FALSE, FALSE, '{"label":"min()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `Min` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which represents `Min`.  \n  \n"}},"insertText":"min()","insertTextFormat":"Snippet"}'),
(998, 22, -1, 'minForever', FALSE, FALSE, FALSE, '{"label":"minForever()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `MinForever` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which represents `MainForever`.  \n  \n"}},"insertText":"minForever()","insertTextFormat":"Snippet"}'),
(999, 22, -1, 'stdDev', FALSE, FALSE, FALSE, '{"label":"stdDev()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `StdDev` aggregator object. The aggregator function name which is used in a streaming query should\nhave the same name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which represents `StdDev`.  \n  \n"}},"insertText":"stdDev()","insertTextFormat":"Snippet"}'),
(1000, 22, -1, 'sum', FALSE, FALSE, FALSE, '{"label":"sum()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a `Sum` aggregator object. The aggregator function name which is used in a streaming query should have the\nsame name as this function\u0027s name.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` which perform addition/summation.  \n  \n"}},"insertText":"sum()","insertTextFormat":"Snippet"}'),
(1001, 22, -1, 'createAndOperatorProcessor', FALSE, FALSE, FALSE, '{"label":"createAndOperatorProcessor()(streams:AndOperatorProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `AndOperatorProcessor` instance.\n  \n  \n  \n**Returns** `streams:AndOperatorProcessor`   \n- A `AndOperatorProcessor` instance.  \n  \n"}},"insertText":"createAndOperatorProcessor()","insertTextFormat":"Snippet"}'),
(1002, 22, -1, 'createCompoundPatternProcessor', FALSE, FALSE, FALSE, '{"label":"createCompoundPatternProcessor((int|()) withinTimeMillis)(streams:CompoundPatternProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `CompoundPatternProcessor` instance.\n  \n**Params**  \n- `(int|())` withinTimeMillis: time from initial state to current state\n(Defaultable)  \n- `(int|())` withinTimeMillis: time from initial state to current state\n  \n  \n**Returns** `streams:CompoundPatternProcessor`   \n- A `CompoundPatternProcessor` instance.  \n  \n"}},"insertText":"createCompoundPatternProcessor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1003, 22, -1, 'createFollowedByProcessor', FALSE, FALSE, FALSE, '{"label":"createFollowedByProcessor()(streams:FollowedByProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `FollowedByProcessor` instance.\n  \n  \n  \n**Returns** `streams:FollowedByProcessor`   \n- A `FollowedByProcessor` instance.  \n  \n"}},"insertText":"createFollowedByProcessor()","insertTextFormat":"Snippet"}'),
(1004, 22, -1, 'createNotOperatorProcessor', FALSE, FALSE, FALSE, '{"label":"createNotOperatorProcessor((int|()) forTimeMillis)(streams:NotOperatorProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `NotOperatorProcessor` instance.\n  \n**Params**  \n- `(int|())` forTimeMillis: `for` time in milliseconds\n  \n  \n**Returns** `streams:NotOperatorProcessor`   \n- A `NotOperatorProcessor` instance.  \n  \n"}},"insertText":"createNotOperatorProcessor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1005, 22, -1, 'createOperandProcessor', FALSE, FALSE, FALSE, '{"label":"createOperandProcessor(string alias, (function (map\u003canydata\u003e) returns (boolean)|()) onConditionFunc, int minOccurs, int maxOccurs)(streams:OperandProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `OperandProcessor` instance.\n  \n**Params**  \n- `string` alias: processor alias  \n- `(function (map\u003canydata\u003e) returns (boolean)|())` onConditionFunc: condition function (i.e [e1.id \u003d\u003d id])  \n- `int` minOccurs: minimum occurrences of the event(Defaultable)  \n- `int` minOccurs: minimum occurrences of the event  \n- `int` maxOccurs: maximum occurrences of the event\n(Defaultable)  \n- `int` maxOccurs: maximum occurrences of the event\n  \n  \n**Returns** `streams:OperandProcessor`   \n- A `OperandProcessor` instance.  \n  \n"}},"insertText":"createOperandProcessor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1006, 22, -1, 'createOrOperatorProcessor', FALSE, FALSE, FALSE, '{"label":"createOrOperatorProcessor()(streams:OrOperatorProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `OrOperatorProcessor` instance.\n  \n  \n  \n**Returns** `streams:OrOperatorProcessor`   \n- A `OrOperatorProcessor` instance.  \n  \n"}},"insertText":"createOrOperatorProcessor()","insertTextFormat":"Snippet"}'),
(1007, 22, -1, 'createStateMachine', FALSE, FALSE, FALSE, '{"label":"createStateMachine(streams:CompoundPatternProcessor rootProcessor, function (ballerina/streams:StreamEvent?[]) returns () nextProcPointer)(streams:StateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a `StateMachine` object.\n  \n**Params**  \n- `streams:CompoundPatternProcessor` rootProcessor: pointer to the root processor  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcPointer: pointer for the next processor\n  \n  \n**Returns** `streams:StateMachine`   \n- A `StateMachine` object which performs pattern processing.  \n  \n"}},"insertText":"createStateMachine(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1008, 22, -1, 'createFilter', FALSE, FALSE, FALSE, '{"label":"createFilter(function (ballerina/streams:StreamEvent?[]) returns () nextProcPointer, function (map\u003canydata\u003e) returns (boolean) conditionFunc)(streams:Filter)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates a `Filter` object and return it.  \n**Params**  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcPointer: The function pointer to the `process` function of the next processor.  \n- `function (map\u003canydata\u003e) returns (boolean)` conditionFunc: The function pointer to the condition evaluator. This is a function which returns true or false\n                  based on the boolean expression given in the where clause.  \n  \n**Returns** `streams:Filter`   \n- Returns a `Filter` object.  \n  \n"}},"insertText":"createFilter(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1009, 22, -1, 'createOrderBy', FALSE, FALSE, FALSE, '{"label":"createOrderBy(function (ballerina/streams:StreamEvent?[]) returns () nextProcessorPointer, (function (map\u003canydata\u003e) returns (anydata)|())[] fields, string[] sortFieldMetadata)(streams:OrderBy)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates an `OrderBy` object and return it.\n  \n**Params**  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcessorPointer: A function pointer to the `process` function of the next processor.  \n- `(function (map\u003canydata\u003e) returns (anydata)|())[]` fields: An array of function pointers which each returns a field by which the events are sorted. Events are\n           sorted by the first field, if there are elements of same value, the second field is used and so on.  \n- `string[]` sortFieldMetadata: sortTypes of the fields (`streams:ASCENDING` or `streams:DESCENDING`). First element is the\n                      sort type of the first element of `fields` and so on.\n  \n  \n**Returns** `streams:OrderBy`   \n- Returns a `OrderBy` object.  \n  \n"}},"insertText":"createOrderBy(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1010, 22, -1, 'createOutputProcess', FALSE, FALSE, FALSE, '{"label":"createOutputProcess(function (map\u003canydata\u003e[]) returns () outputFunc)(streams:OutputProcess)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and return a `OutputProcess` object.  \n**Params**  \n- `function (map\u003canydata\u003e[]) returns ()` outputFunc: The function pointer to a lambda function created out of the statements in the streaming action  \n  \n**Returns** `streams:OutputProcess`   \n- Returns a ` OutputProcess` object.  \n  \n"}},"insertText":"createOutputProcess(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1011, 22, -1, 'createSelect', FALSE, FALSE, FALSE, '{"label":"createSelect(function (ballerina/streams:StreamEvent?[]) returns () nextProcPointer, streams:Aggregator[] aggregatorArr, ((function (ballerina/streams:StreamEvent) returns (anydata)|())[]|()) groupbyFuncArray, function (ballerina/streams:StreamEvent,ballerina/streams:Aggregator[]) returns (map\u003canydata\u003e) selectFunc, string scopeName)(streams:Select)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates and returns a select clause.  \n**Params**  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcPointer: The function pointer to the `process` function of the next processor.  \n- `streams:Aggregator[]` aggregatorArr: The array of aggregators used in the select clause. If the same aggregator is used twice, the\n                 `aggregatorArr` will contains that specific aggregator twice in the order they appear in the select\n                  clause.  \n- `((function (ballerina/streams:StreamEvent) returns (anydata)|())[]|())` groupbyFuncArray: The array of function pointer which contains the lambda function which returns the expressions\n                     in the group by clause.  \n- `function (ballerina/streams:StreamEvent,ballerina/streams:Aggregator[]) returns (map\u003canydata\u003e)` selectFunc: The function pointer to a lambda function that creates the `data` field of the output stream event.  \n- `string` scopeName: A unique id to identify the forever block if there are multiple forever blocks.(Defaultable)  \n- `string` scopeName: A unique id to identify the forever block if there are multiple forever blocks.  \n  \n**Returns** `streams:Select`   \n- Returns a `Select` object.  \n  \n"}},"insertText":"createSelect(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1012, 22, -1, 'createStreamJoinProcessor', FALSE, FALSE, FALSE, '{"label":"createStreamJoinProcessor(function (ballerina/streams:StreamEvent?[]) returns () nextProcessor, JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN joinType, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc)(streams:StreamJoinProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates a `StreamJoinProcessor` and returns it.\n  \n**Params**  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcessor: The `process` function of the next processor, which can be a `Select` processor, `Aggregator`\n                  processor, `Having` processor.. etc.  \n- `JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN` joinType: Type of the join being performed (\"JOIN\"|\"LEFTOUTERJOIN\"|\"RIGHTOUTERJOIN\"|\"FULLOUTERJOIN\")  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: A lambda function which contains the joining condition and return true if the condition satifies\n                  the condition.\n(Defaultable)  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: A lambda function which contains the joining condition and return true if the condition satifies\n                  the condition.\n  \n  \n**Returns** `streams:StreamJoinProcessor`   \n- Returns a `StreamJoinProcessor` object.  \n  \n"}},"insertText":"createStreamJoinProcessor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1013, 22, -1, 'createTableJoinProcessor', FALSE, FALSE, FALSE, '{"label":"createTableJoinProcessor(function (ballerina/streams:StreamEvent?[]) returns () nextProcessor, JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN joinType, function (ballerina/streams:StreamEvent) returns (map\u003canydata\u003e[]) tableQuery)(streams:TableJoinProcessor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates a `TableJoinProcessor` and return it.\n  \n**Params**  \n- `function (ballerina/streams:StreamEvent?[]) returns ()` nextProcessor: The function pointer to `process` function of the next processor, which can be a `Select` processor,\n                 `Aggregator` processor, `Having` processor.. etc  \n- `JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN` joinType: The type of the join and it can be any value defined by `streams:JoinType`.  \n- `function (ballerina/streams:StreamEvent) returns (map\u003canydata\u003e[])` tableQuery: The function pointer to a function which retrieves the records from the table and joins w ith\n              each stream event.\n  \n  \n**Returns** `streams:TableJoinProcessor`   \n- Returns a `TableJoinProcessor` object.  \n  \n"}},"insertText":"createTableJoinProcessor(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1014, 22, -1, 'deserialize', TRUE, FALSE, FALSE, '{"label":"deserialize(string str)(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nNative function to deserialize a serialized snapshot.  \n**Params**  \n- `string` str: A `string` of serialized content.  \n  \n**Returns** `map\u003cany\u003e`   \n- A deserialized `map\u003cany\u003e` state.  \n  \n"}},"insertText":"deserialize(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1015, 22, -1, 'serialize', TRUE, FALSE, FALSE, '{"label":"serialize(map\u003cany\u003e data)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nNative function to serialize a snapshot.  \n**Params**  \n- `map\u003cany\u003e` data: A `map\u003cany\u003e` state to be serialized.  \n  \n**Returns** `string`   \n- A `string` of serialized state.  \n  \n"}},"insertText":"serialize(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1016, 22, -1, 'readCharacters', TRUE, FALSE, FALSE, '{"label":"readCharacters(io:ReadableCharacterChannel rch, int numberOfCharacters)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to read given number of characters from an io:ReadableCharacterChannel.  \n**Params**  \n- `io:ReadableCharacterChannel` rch: A `ReadableCharacterChannel` instance.  \n- `int` numberOfCharacters: A `int` indicating number of chars to read.  \n  \n**Returns** `(string|error)`   \n- A `string` of content or an `error`.  \n  \n"}},"insertText":"readCharacters(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1017, 22, -1, 'readAllCharacters', TRUE, FALSE, FALSE, '{"label":"readAllCharacters(io:ReadableCharacterChannel rch)((string|()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to read all characters as a string from an io:ReadableCharacterChannel.  \n**Params**  \n- `io:ReadableCharacterChannel` rch: A `ReadableCharacterChannel` instance.  \n  \n**Returns** `(string|()|error)`   \n- A `string` of content or an `error`.  \n  \n"}},"insertText":"readAllCharacters(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1018, 22, -1, 'writeCharacters', TRUE, FALSE, FALSE, '{"label":"writeCharacters(io:WritableCharacterChannel wch, string content, int startOffset)((int|()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to write a string to a file using an io:WritableCharacterChannel.  \n**Params**  \n- `io:WritableCharacterChannel` wch: A `WritableCharacterChannel` instance.  \n- `string` content: The `string` content to be written.  \n- `int` startOffset: A `int` indicating start offset.  \n  \n**Returns** `(int|()|error)`   \n- A `int` indicating number of chars got written or an `error`.  \n  \n"}},"insertText":"writeCharacters(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1019, 22, -1, 'createReadableCharacterChannel', TRUE, FALSE, FALSE, '{"label":"createReadableCharacterChannel(string filePath, string encoding)((io:ReadableCharacterChannel|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to initialize an io:ReadableCharacterChannel.  \n**Params**  \n- `string` filePath: A `string` path to the file.  \n- `string` encoding: A `string` indicating the encoding type.  \n  \n**Returns** `(io:ReadableCharacterChannel|())`   \n- The `ReadableCharacterChannel` which got initilized.  \n  \n"}},"insertText":"createReadableCharacterChannel(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1020, 22, -1, 'createWritableCharacterChannel', TRUE, FALSE, FALSE, '{"label":"createWritableCharacterChannel(string filePath, string encoding)((io:WritableCharacterChannel|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to initialize an io:WritableCharacterChannel.  \n**Params**  \n- `string` filePath: A `string` path to the file.  \n- `string` encoding: A `string` indicating the encoding type.  \n  \n**Returns** `(io:WritableCharacterChannel|())`   \n- The `WritableCharacterChannel` which got initilized.  \n  \n"}},"insertText":"createWritableCharacterChannel(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1021, 22, -1, 'closeCharChannel', TRUE, FALSE, FALSE, '{"label":"closeCharChannel(any c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to close writable/readable character channels.  \n**Params**  \n- `any` c: Character channel to be closed."}},"insertText":"closeCharChannel(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1022, 22, -1, 'readFile', TRUE, FALSE, FALSE, '{"label":"readFile(string filePath, string encoding)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to read a text file.  \n**Params**  \n- `string` filePath: A `string` path to the file.  \n- `string` encoding: A `string` indicating the encoding type.  \n  \n**Returns** `string`   \n- The `string` content of the file.  \n  \n"}},"insertText":"readFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1023, 22, -1, 'writeToFile', TRUE, FALSE, FALSE, '{"label":"writeToFile(string filePath, string encoding, string content)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to write text to a file.  \n**Params**  \n- `string` filePath: A `string` path to the file.  \n- `string` encoding: A `string` indicating the encoding type.  \n- `string` content: A `string` content to be written.  \n  \n**Returns** `int`   \n- An `int` indicating how many chars got written.  \n  \n"}},"insertText":"writeToFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1024, 22, -1, 'writeStateToFile', TRUE, FALSE, FALSE, '{"label":"writeStateToFile(string persistancePath)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to serialize a Snapshotable state and write that to given file.  \n**Params**  \n- `string` persistancePath: A `string` path of the persistance directory.  \n  \n**Returns** `(()|error)`   \n- An `error` if state cannot be written to a file.  \n  \n"}},"insertText":"writeStateToFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1025, 22, -1, 'getSnapshotFiles', TRUE, FALSE, FALSE, '{"label":"getSnapshotFiles(string persistancePath)(string[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to get all snapshot files in persistance path  \n**Params**  \n- `string` persistancePath: A `string` path of the persistance directory.  \n  \n**Returns** `string[]`   \n- An `array` containing absolute paths of all snapshot files.  \n  \n"}},"insertText":"getSnapshotFiles(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1026, 22, -1, 'getLatestSnapshotFile', TRUE, FALSE, FALSE, '{"label":"getLatestSnapshotFile(string persistancePath)((string|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to get latest snapshot file in persistance path  \n**Params**  \n- `string` persistancePath: A `string` path of the persistance directory.  \n  \n**Returns** `(string|())`   \n- A `string` absolute path of the latest snapshot file.  \n  \n"}},"insertText":"getLatestSnapshotFile(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1027, 22, -1, 'purgeOldSnapshotFiles', TRUE, FALSE, FALSE, '{"label":"purgeOldSnapshotFiles(string persistancePath)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to purge/delete old snapshot files from persistance path  \n**Params**  \n- `string` persistancePath: A `string` path of the directory where the states should get persisted."}},"insertText":"purgeOldSnapshotFiles(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1028, 22, -1, 'restoreStates', TRUE, FALSE, FALSE, '{"label":"restoreStates()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to restore a persisted snapshotable states from a file.  \n"}},"insertText":"restoreStates();","insertTextFormat":"Snippet"}'),
(1029, 22, -1, 'persistStatesAndPurgeOldSnapshots', TRUE, FALSE, FALSE, '{"label":"persistStatesAndPurgeOldSnapshots()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to iterate through all the snapshotables, and persist their states into a file.  \n  \n  \n**Returns** `(()|error)`   \n- An `error` if the state cannot be persisted into a file.  \n  \n"}},"insertText":"persistStatesAndPurgeOldSnapshots()","insertTextFormat":"Snippet"}'),
(1030, 22, -1, 'startPersisting', TRUE, FALSE, FALSE, '{"label":"startPersisting()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to initilize a Scheduler task and start periodic snapshotting.  \n"}},"insertText":"startPersisting();","insertTextFormat":"Snippet"}'),
(1031, 22, -1, 'restoreState', FALSE, FALSE, FALSE, '{"label":"restoreState(string key, any reference)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to restore state of a given object.  \n**Params**  \n- `string` key: An unique `string` identifier for the snapshotable reference.  \n- `any` reference: The snapshotable reference to be restored."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1032, 22, -1, 'removeState', FALSE, FALSE, FALSE, '{"label":"removeState(string key)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to clear an existing state.  \n**Params**  \n- `string` key: An unique `string` identifier for the snapshotable reference.  \n  \n**Returns** `boolean`   \n- A `boolean` indicating whether the state for the given key removed successfully.  \n  \n"}},"insertText":"removeState(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1033, 22, -1, 'registerSnapshotable', FALSE, FALSE, FALSE, '{"label":"registerSnapshotable(string key, any reference)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to register Snapshotables.  \n**Params**  \n- `string` key: An unique `string` identifier for the snapshotable reference.  \n- `any` reference: The snapshotable reference to be registered."}},"insertText":"registerSnapshotable(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1034, 22, -1, 'initPersistence', FALSE, FALSE, FALSE, '{"label":"initPersistence()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to initialize and start snapshotting.  \n"}},"insertText":"initPersistence();","insertTextFormat":"Snippet"}'),
(1035, 22, -1, 'buildStreamEvent', FALSE, FALSE, FALSE, '{"label":"buildStreamEvent(anydata t, string streamName)((streams:StreamEvent|())[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates  `streams:StreamEvent` object array for a record `t` received by the stream denoted by the name `streamNme`.  \n**Params**  \n- `anydata` t: A record received by the stream `streamName`.  \n- `string` streamName: Name of the stream to which the record `t` is received.  \n  \n**Returns** `(streams:StreamEvent|())[]`   \n- Returns an array of streams:StreamEvents|()  \n  \n"}},"insertText":"buildStreamEvent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1036, 22, -1, 'createResetStreamEvent', FALSE, FALSE, FALSE, '{"label":"createResetStreamEvent(streams:StreamEvent event)(streams:StreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates a RESET event from a given event.  \n**Params**  \n- `streams:StreamEvent` event: The event from which the reset event is created.  \n  \n**Returns** `streams:StreamEvent`   \n- A stream event of type streams:RESET.  \n  \n"}},"insertText":"createResetStreamEvent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1037, 22, -1, 'getStreamEvent', FALSE, FALSE, FALSE, '{"label":"getStreamEvent((any|()) anyEvent)(streams:StreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nGet the stream event from any? field. This function can only be used only if we are sure that the `anyEvent` is a\nstreams:StreamEvent.  \n**Params**  \n- `(any|())` anyEvent: The object from which, the stream event is extracted.  \n  \n**Returns** `streams:StreamEvent`   \n- Returns the extracted streams:StreamEvent object.  \n  \n"}},"insertText":"getStreamEvent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1038, 22, -1, 'toSnapshottableEvents', FALSE, FALSE, FALSE, '{"label":"toSnapshottableEvents((streams:StreamEvent[]|any[]|()) events)((streams:SnapshottableStreamEvent|())[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nConverts a given array of streams:StreamEvent objects to an array of `streams:SnapshottableStreamEvent`.  \n**Params**  \n- `(streams:StreamEvent[]|any[]|())` events: The events to be coverted to snapshotable events.  \n  \n**Returns** `(streams:SnapshottableStreamEvent|())[]`   \n- Returns the converted snapshotable events.  \n  \n"}},"insertText":"toSnapshottableEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1039, 22, -1, 'toStreamEvents', FALSE, FALSE, FALSE, '{"label":"toStreamEvents((streams:SnapshottableStreamEvent[]|any[]|()) events)((streams:StreamEvent|())[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nConverts a given array of snapshotable events to an array of `streams:StreamEvent` objects.  \n**Params**  \n- `(streams:SnapshottableStreamEvent[]|any[]|())` events: Snapshotable events to be converted to `streams:StreamEvents`.  \n  \n**Returns** `(streams:StreamEvent|())[]`   \n- Returns the converted `streams:StreamEvents` objects array.  \n  \n"}},"insertText":"toStreamEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1040, 22, -1, 'toSnapshottableEvent', FALSE, FALSE, FALSE, '{"label":"toSnapshottableEvent(streams:StreamEvent event)(streams:SnapshottableStreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nConvert a single `streams:StreamEvent` object to `streams:SnapshottableStreamEvent` object.  \n**Params**  \n- `streams:StreamEvent` event: The `streams:StreamEvent` object to be converted to snapshotable event.  \n  \n**Returns** `streams:SnapshottableStreamEvent`   \n- The converted `streams:SnapshottableStreamEvent` object.  \n  \n"}},"insertText":"toSnapshottableEvent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1041, 22, -1, 'toStreamEvent', FALSE, FALSE, FALSE, '{"label":"toStreamEvent(streams:SnapshottableStreamEvent event)(streams:StreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nConvert a single `streams:SnapshottableStreamEvent` object to `streams:StreamEvent` object.  \n**Params**  \n- `streams:SnapshottableStreamEvent` event: The `streams:SnapshottableStreamEvent` object to be converted to a stream event.  \n  \n**Returns** `streams:StreamEvent`   \n- The converted `streams:StreamEvent` object.  \n  \n"}},"insertText":"toStreamEvent(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1042, 22, -1, 'delay', FALSE, FALSE, FALSE, '{"label":"delay(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `delay` function creates a `DelayWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"delay(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1043, 22, -1, 'externalTimeBatch', FALSE, FALSE, FALSE, '{"label":"externalTimeBatch(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `externalTimeBatch` function creates a `ExternalTimeBatchWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"externalTimeBatch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1044, 22, -1, 'externalTime', FALSE, FALSE, FALSE, '{"label":"externalTime(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `externalTime` function creates a `ExternalTimeWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"externalTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1045, 22, -1, 'hopping', FALSE, FALSE, FALSE, '{"label":"hopping(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `hopping` function creates a `HoppingWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"hopping(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1046, 22, -1, 'lengthBatch', FALSE, FALSE, FALSE, '{"label":"lengthBatch(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `lengthBatch` function creates a `LengthBatchWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"lengthBatch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1047, 22, -1, 'length', FALSE, FALSE, FALSE, '{"label":"length(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `length` function creates a `LengthWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"length(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1048, 22, -1, 'sort', FALSE, FALSE, FALSE, '{"label":"sort(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `sort` function creates a `SortWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"sort(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1049, 22, -1, 'timeAccum', FALSE, FALSE, FALSE, '{"label":"timeAccum(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `timeAccum` function creates a `TimeAccumulatingWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"timeAccum(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1050, 22, -1, 'timeBatch', FALSE, FALSE, FALSE, '{"label":"timeBatch(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `timeBatch` function creates a `TimeBatchWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"timeBatch(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1051, 22, -1, 'timeLength', FALSE, FALSE, FALSE, '{"label":"timeLength(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `timeLength` function creates a `TimeLengthWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"timeLength(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1052, 22, -1, 'timeOrder', FALSE, FALSE, FALSE, '{"label":"timeOrder(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `timeOrder` function creates a `TimeOrderWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"timeOrder(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1053, 22, -1, 'uniqueLength', FALSE, FALSE, FALSE, '{"label":"uniqueLength(any[] windowParameters, (function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer)(streams:Window)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `uniqueLength` function creates a `UniqueLengthWindow` object and returns it.  \n**Params**  \n- `any[]` windowParameters: Arguments which should be passed with the window function in the streams query in the order\n                      they appear in the argument list.  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.(Defaultable)  \n- `(function (ballerina/streams:StreamEvent?[]) returns ()|())` nextProcessPointer: The function pointer to the `process` function of the next processor.  \n  \n**Returns** `streams:Window`   \n- Returns the created window.  \n  \n"}},"insertText":"uniqueLength(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1054, 22, 85, 'Aggregator.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of self, but it does not contain the current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1055, 22, 85, 'Aggregator.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the aggregated value and returns the final aggregated value.\n  \n**Params**  \n- `anydata` value: value being aggregated.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`. Based on the\n              type of the event `value` will be added to the aggregation or removed from the aggregation.\n  \n  \n**Returns** `anydata`   \n- Updated aggregated value after `value` being aggregated.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1056, 22, 86, 'AbstractOperatorProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1057, 22, 86, 'AbstractOperatorProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1058, 22, 87, 'AbstractPatternProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1059, 22, 87, 'AbstractPatternProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1060, 22, 87, 'AbstractPatternProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1061, 22, 87, 'AbstractPatternProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1062, 22, 87, 'AbstractPatternProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1063, 22, 87, 'AbstractPatternProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1064, 22, 88, 'AndOperatorProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1065, 22, 88, 'AndOperatorProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1066, 22, 88, 'AndOperatorProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1067, 22, 88, 'AndOperatorProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1068, 22, 88, 'AndOperatorProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1069, 22, 88, 'AndOperatorProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1070, 22, 88, 'AndOperatorProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1071, 22, 88, 'AndOperatorProcessor.setLHSProcessor', FALSE, FALSE, TRUE, '{"label":"setLHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the LHS `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: lhs processor"}},"insertText":"setLHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1072, 22, 88, 'AndOperatorProcessor.setRHSProcessor', FALSE, FALSE, TRUE, '{"label":"setRHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the RHS `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: rhs processor"}},"insertText":"setRHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1073, 22, 88, 'AndOperatorProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1074, 22, 88, 'AndOperatorProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1075, 22, 89, 'CompoundPatternProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1076, 22, 89, 'CompoundPatternProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1077, 22, 89, 'CompoundPatternProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1078, 22, 89, 'CompoundPatternProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1079, 22, 89, 'CompoundPatternProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1080, 22, 89, 'CompoundPatternProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1081, 22, 89, 'CompoundPatternProcessor.emit', FALSE, FALSE, TRUE, '{"label":"emit(streams:StreamEvent stateEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEmits given `StreamEvent` as a fulfilled event.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to emit"}},"insertText":"emit(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1082, 22, 89, 'CompoundPatternProcessor.flushAndGetFulfilledEvents', FALSE, FALSE, TRUE, '{"label":"flushAndGetFulfilledEvents()((streams:StreamEvent|())[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns fulfilled state events and flush returned states from the state machine.\n  \n  \n  \n**Returns** `(streams:StreamEvent|())[]`   \n- an array of `StreamEvent`s.  \n  \n"}},"insertText":"flushAndGetFulfilledEvents()","insertTextFormat":"Snippet"}'),
(1083, 22, 89, 'CompoundPatternProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1084, 22, 89, 'CompoundPatternProcessor.setProcessor', FALSE, FALSE, TRUE, '{"label":"setProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the descendant `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: descendant processor"}},"insertText":"setProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1085, 22, 89, 'CompoundPatternProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1086, 22, 89, 'CompoundPatternProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init((int|()) withinTimeMillis)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1087, 22, 90, 'FollowedByProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1088, 22, 90, 'FollowedByProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1089, 22, 90, 'FollowedByProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1090, 22, 90, 'FollowedByProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1091, 22, 90, 'FollowedByProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1092, 22, 90, 'FollowedByProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1093, 22, 90, 'FollowedByProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1094, 22, 90, 'FollowedByProcessor.setLHSProcessor', FALSE, FALSE, TRUE, '{"label":"setLHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the lhs `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: lhs processor"}},"insertText":"setLHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1095, 22, 90, 'FollowedByProcessor.setRHSProcessor', FALSE, FALSE, TRUE, '{"label":"setRHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the rhs `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: rhs processor"}},"insertText":"setRHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1096, 22, 90, 'FollowedByProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1097, 22, 90, 'FollowedByProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1098, 22, 91, 'NotOperatorProcessor.rescheduleNextEvent', FALSE, FALSE, TRUE, '{"label":"rescheduleNextEvent((int|()) delay)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReschedules the next NOT event.\n  \n**Params**  \n- `(int|())` delay: delay for the next event"}},"insertText":"rescheduleNextEvent(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1099, 22, 91, 'NotOperatorProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1100, 22, 91, 'NotOperatorProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1101, 22, 91, 'NotOperatorProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1102, 22, 91, 'NotOperatorProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1103, 22, 91, 'NotOperatorProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1104, 22, 91, 'NotOperatorProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1105, 22, 91, 'NotOperatorProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1106, 22, 91, 'NotOperatorProcessor.setProcessor', FALSE, FALSE, TRUE, '{"label":"setProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the descendant `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: descendant processor"}},"insertText":"setProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1107, 22, 91, 'NotOperatorProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1108, 22, 91, 'NotOperatorProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init((int|()) forTimeMillis)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1109, 22, 92, 'OperandProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1110, 22, 92, 'OperandProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1111, 22, 92, 'OperandProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1112, 22, 92, 'OperandProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1113, 22, 92, 'OperandProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1114, 22, 92, 'OperandProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1115, 22, 92, 'OperandProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init(string alias, (function (map\u003canydata\u003e) returns (boolean)|()) onConditionFunc, int minOccurs, int maxOccurs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1116, 22, 93, 'OrOperatorProcessor.process', FALSE, FALSE, TRUE, '{"label":"process(streams:StreamEvent event, (string|()) processorAlias)([boolean,boolean])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the `StreamEvent`.\n  \n**Params**  \n- `streams:StreamEvent` event: event to process  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs).\n  \n  \n**Returns** `[boolean,boolean]`   \n- a tuple indicating, whether the event is promoted and whether to continue to the next processor.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1117, 22, 93, 'OrOperatorProcessor.setStateMachine', FALSE, FALSE, TRUE, '{"label":"setStateMachine(streams:StateMachine stateMachine)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the `StateMachine` to the procesor and it\u0027s descendants.\n  \n**Params**  \n- `streams:StateMachine` stateMachine: `StateMachine` instance"}},"insertText":"setStateMachine(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1118, 22, 93, 'OrOperatorProcessor.validate', FALSE, FALSE, TRUE, '{"label":"validate()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nValidates the processor and its configs.  \n"}},"insertText":"validate();","insertTextFormat":"Snippet"}'),
(1119, 22, 93, 'OrOperatorProcessor.promote', FALSE, FALSE, TRUE, '{"label":"promote(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nPromotes the `StreamEvent` to the previous processor.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"promote(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1120, 22, 93, 'OrOperatorProcessor.evict', FALSE, FALSE, TRUE, '{"label":"evict(streams:StreamEvent stateEvent, (string|()) processorAlias)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEvicts the `StreamEvent` from current state branch.\n  \n**Params**  \n- `streams:StreamEvent` stateEvent: event to promote  \n- `(string|())` processorAlias: alias for the calling processor, for identification purposes (lhs, rhs)."}},"insertText":"evict(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1121, 22, 93, 'OrOperatorProcessor.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves a given `StreamEvent` from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1122, 22, 93, 'OrOperatorProcessor.setPreviousProcessor', FALSE, FALSE, TRUE, '{"label":"setPreviousProcessor(streams:AbstractOperatorProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the previous `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractOperatorProcessor` processor: previous processor"}},"insertText":"setPreviousProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1123, 22, 93, 'OrOperatorProcessor.setLHSProcessor', FALSE, FALSE, TRUE, '{"label":"setLHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the lhs `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: lhs processor"}},"insertText":"setLHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1124, 22, 93, 'OrOperatorProcessor.setRHSProcessor', FALSE, FALSE, TRUE, '{"label":"setRHSProcessor(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets a link to the rhs `AbstractOperatorProcessor`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: rhs processor"}},"insertText":"setRHSProcessor(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1125, 22, 93, 'OrOperatorProcessor.getAlias', FALSE, FALSE, TRUE, '{"label":"getAlias()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the alias of the current processor.\n  \n  \n  \n**Returns** `string`   \n- alias of the processor.  \n  \n"}},"insertText":"getAlias()","insertTextFormat":"Snippet"}'),
(1126, 22, 93, 'OrOperatorProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1127, 22, 94, 'StateMachine.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcesses the nicoming streamEvents array.\n  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: list of stream events"}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1128, 22, 94, 'StateMachine.inject', FALSE, FALSE, TRUE, '{"label":"inject(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nInjects a given `StreamEvent` to the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be injected"}},"insertText":"inject(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1129, 22, 94, 'StateMachine.remove', FALSE, FALSE, TRUE, '{"label":"remove(streams:StreamEvent streamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves all the matchihng states from the `StateMachine`.\n  \n**Params**  \n- `streams:StreamEvent` streamEvent: event to be removed"}},"insertText":"remove(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1130, 22, 94, 'StateMachine.register', FALSE, FALSE, TRUE, '{"label":"register(streams:AbstractPatternProcessor processor)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRegister a processor to the `StateMachine`.\n  \n**Params**  \n- `streams:AbstractPatternProcessor` processor: processor to register"}},"insertText":"register(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1131, 22, 94, 'StateMachine.__init', TRUE, FALSE, TRUE, '{"label":"__init(streams:CompoundPatternProcessor rootProcessor, function (ballerina/streams:StreamEvent?[]) returns () nextProcessorPointer)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1132, 22, 95, 'Filter.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcess the incoming stream events. This function takes an array of stream events, iterate each of the events\nin the array, then call the `conditionFunc` on each and see if `conditionFunc` is evaluates to true. if so,\nthose events will be passed to the `nextPrcessorPointer` which can be the `process` function of the next\nprocessor object ( e.g. `Select`, `Window`, `Aggregator`.. etc).  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The events being filtered."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1133, 22, 95, 'Filter.__init', TRUE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () nextProcessorPointer, function (map\u003canydata\u003e) returns (boolean) conditionFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1134, 22, 96, 'OrderBy.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSorts the given array of stream events according to the given parameters (fieldFuncs and sortTypes).\n  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be sorted."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1135, 22, 96, 'OrderBy.__init', FALSE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () nextProcessorPointer, (function (map\u003canydata\u003e) returns (anydata)|())[] fieldFuncs, string[] sortTypes)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1136, 22, 97, 'MergeSort.topDownMergeSort', FALSE, FALSE, TRUE, '{"label":"topDownMergeSort((streams:StreamEvent|())[] events)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSorts the given stream events using the merge sort algorithm.\n  \n**Params**  \n- `(streams:StreamEvent|())[]` events: The array of stream events to be sorted."}},"insertText":"topDownMergeSort(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1137, 22, 97, 'MergeSort.topDownSplitMerge', TRUE, FALSE, TRUE, '{"label":"topDownSplitMerge((streams:StreamEvent|())[] b, int iBegin, int iEnd, (streams:StreamEvent|())[] a)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"topDownSplitMerge(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1138, 22, 97, 'MergeSort.topDownMerge', TRUE, FALSE, TRUE, '{"label":"topDownMerge((streams:StreamEvent|())[] a, int iBegin, int iMiddle, int iEnd, (streams:StreamEvent|())[] b)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"topDownMerge(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1139, 22, 97, 'MergeSort.numberSort', TRUE, FALSE, TRUE, '{"label":"numberSort((int|float) x, (int|float) y)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"numberSort(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1140, 22, 97, 'MergeSort.stringSort', TRUE, FALSE, TRUE, '{"label":"stringSort(string x, string y)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"stringSort(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1141, 22, 97, 'MergeSort.sortFunc', TRUE, FALSE, TRUE, '{"label":"sortFunc(streams:StreamEvent x, streams:StreamEvent y, int fieldIndex)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"sortFunc(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1142, 22, 97, 'MergeSort.callNextSortFunc', TRUE, FALSE, TRUE, '{"label":"callNextSortFunc(streams:StreamEvent x, streams:StreamEvent y, int c, int fieldIndex)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"callNextSortFunc(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1143, 22, 97, 'MergeSort.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (map\u003canydata\u003e) returns (anydata)|())[] fieldFuncs, string[] sortTypes)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1144, 22, 98, 'OutputProcess.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSends the output to the streaming action. most of the time the output is published to a destination stream\nat the streaming action. Only the events with type `streams:CURRENT` are passed to the `outputFunc`.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be filtered out for CURRENT events."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1145, 22, 98, 'OutputProcess.__init', FALSE, FALSE, TRUE, '{"label":"__init(function (map\u003canydata\u003e[]) returns () outputFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1146, 22, 99, 'Select.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSelects only the selected fields in the select clause.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events passed to the select clause."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1147, 22, 99, 'Select.getGroupByKey', FALSE, FALSE, TRUE, '{"label":"getGroupByKey(((function (ballerina/streams:StreamEvent) returns (anydata)|())[]|()) groupbyFunctionArray, streams:StreamEvent e)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates a unique key for each group with the given values in the group by clause.  \n**Params**  \n- `((function (ballerina/streams:StreamEvent) returns (anydata)|())[]|())` groupbyFunctionArray: Function pointer array to the lambda function which returns each group by field.  \n- `streams:StreamEvent` e: Stream Event object being grouped.  \n  \n**Returns** `string`   \n- Returns a unique groupby key by which the event `e` is grouped.  \n  \n"}},"insertText":"getGroupByKey(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1148, 22, 99, 'Select.__init', TRUE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () nextProcessorPointer, streams:Aggregator[] aggregatorArr, ((function (ballerina/streams:StreamEvent) returns (anydata)|())[]|()) groupbyFuncArray, function (ballerina/streams:StreamEvent,ballerina/streams:Aggregator[]) returns (map\u003canydata\u003e) selectFunc, string scopeName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1149, 22, 100, 'StreamJoinProcessor.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nProcess the events from both `lhsStream` and the `rhsStream` and perform the joining.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: Stream events being joined."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1150, 22, 100, 'StreamJoinProcessor.setLHS', FALSE, FALSE, TRUE, '{"label":"setLHS(string streamName, streams:Window windowInstance)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets the left hand side stream name and the respective window instance.  \n**Params**  \n- `string` streamName: The name of the left hand side stream.  \n- `streams:Window` windowInstance: The window attached to the left hand side stream."}},"insertText":"setLHS(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1151, 22, 100, 'StreamJoinProcessor.setRHS', FALSE, FALSE, TRUE, '{"label":"setRHS(string streamName, streams:Window windowInstance)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets the right hand side stream name and the respective window instance.  \n**Params**  \n- `string` streamName: The name of the right hand side stream.  \n- `streams:Window` windowInstance: The window attached to the right hand side stream."}},"insertText":"setRHS(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1152, 22, 100, 'StreamJoinProcessor.setUnidirectionalStream', FALSE, FALSE, TRUE, '{"label":"setUnidirectionalStream(string streamName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSets the stream by which the joining is triggered.  \n**Params**  \n- `string` streamName: The name of the stream. In most cases, the joining is triggered when the events are received by\n               the left hand side stream even if the right hand side stream receives the events before the left\n               hand side stream receives events."}},"insertText":"setUnidirectionalStream(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1153, 22, 100, 'StreamJoinProcessor.joinEvents', TRUE, FALSE, TRUE, '{"label":"joinEvents((streams:StreamEvent|()) lhsEvent, (streams:StreamEvent|()) rhsEvent, boolean lhsTriggered)((streams:StreamEvent|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `(streams:StreamEvent|())`   \n  \n"}},"insertText":"joinEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1154, 22, 100, 'StreamJoinProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () nextProcessor, JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN joinType, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) onConditionFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1155, 22, 101, 'TableJoinProcessor.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nJoins the incoming events to the stream with the given table.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The stream events being joined with the table."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1156, 22, 101, 'TableJoinProcessor.setJoinProperties', FALSE, FALSE, TRUE, '{"label":"setJoinProperties(string tn, string sn, streams:Window wi)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSet the properties required for joining.  \n**Params**  \n- `string` tn: The name of the table being joined with the stream.  \n- `string` sn: The name of the stream being joined with the table.  \n- `streams:Window` wi: The window instance which is attached to the stream."}},"insertText":"setJoinProperties(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1157, 22, 101, 'TableJoinProcessor.joinEvents', TRUE, FALSE, TRUE, '{"label":"joinEvents((streams:StreamEvent|()) lhsEvent, (streams:StreamEvent|()) rhsEvent)((streams:StreamEvent|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `(streams:StreamEvent|())`   \n  \n"}},"insertText":"joinEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1158, 22, 101, 'TableJoinProcessor.__init', FALSE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () nextProcessor, JOIN|LEFTOUTERJOIN|RIGHTOUTERJOIN|FULLOUTERJOIN joinType, function (ballerina/streams:StreamEvent) returns (map\u003canydata\u003e[]) tableQuery)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1159, 22, 102, 'Node.__init', FALSE, FALSE, TRUE, '{"label":"__init((streams:Node|()) prev, (any|()) data, (streams:Node|()) next)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1160, 22, 103, 'LinkedList.isEmpty', FALSE, FALSE, TRUE, '{"label":"isEmpty()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nChecks if the linked list is empty.\n  \n  \n  \n**Returns** `boolean`   \n- Returns `true` if the linked list is empty, otherwise returns `false`.  \n  \n"}},"insertText":"isEmpty()","insertTextFormat":"Snippet"}'),
(1161, 22, 103, 'LinkedList.resetToFront', FALSE, FALSE, TRUE, '{"label":"resetToFront()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nMoves the cursoer to the front/head of the linked list.  \n"}},"insertText":"resetToFront();","insertTextFormat":"Snippet"}'),
(1162, 22, 103, 'LinkedList.resetToRear', FALSE, FALSE, TRUE, '{"label":"resetToRear()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nMoves the cursor to the end of the linked list if the cursor is not already at the last element of the linked\nlist.  \n"}},"insertText":"resetToRear();","insertTextFormat":"Snippet"}'),
(1163, 22, 103, 'LinkedList.hasNext', FALSE, FALSE, TRUE, '{"label":"hasNext()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns true if the linked list has more elements starting from the current cursor location.\n  \n  \n  \n**Returns** `boolean`   \n- Returns `true` if there are more elements onwards from the current cursor location, otherwise `false`.  \n  \n"}},"insertText":"hasNext()","insertTextFormat":"Snippet"}'),
(1164, 22, 103, 'LinkedList.hasPrevious', FALSE, FALSE, TRUE, '{"label":"hasPrevious()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns `true` if there are prior elements to the current element/cursor location, otherwise false.\n  \n  \n  \n**Returns** `boolean`   \n- Returns true, if there are elements prior to the current cursor location, otherwise `false`.  \n  \n"}},"insertText":"hasPrevious()","insertTextFormat":"Snippet"}'),
(1165, 22, 103, 'LinkedList.next', FALSE, FALSE, TRUE, '{"label":"next()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the next element of the linked list and moves the cursor to the next element.\n  \n  \n  \n**Returns** `(any|())`   \n- The next element from the current cursor location.  \n  \n"}},"insertText":"next()","insertTextFormat":"Snippet"}'),
(1166, 22, 103, 'LinkedList.previous', FALSE, FALSE, TRUE, '{"label":"previous()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the previous element of the linked list and moves the cursor to the previous element.\n  \n  \n  \n**Returns** `(any|())`   \n- The previous element from the current cursor location.  \n  \n"}},"insertText":"previous()","insertTextFormat":"Snippet"}'),
(1167, 22, 103, 'LinkedList.removeCurrent', FALSE, FALSE, TRUE, '{"label":"removeCurrent()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves the element at the current cursor location.  \n"}},"insertText":"removeCurrent();","insertTextFormat":"Snippet"}'),
(1168, 22, 103, 'LinkedList.getSize', FALSE, FALSE, TRUE, '{"label":"getSize()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the current number of elements in the linked list.\n  \n  \n  \n**Returns** `int`   \n- The number of elements in the linked list.  \n  \n"}},"insertText":"getSize()","insertTextFormat":"Snippet"}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1169, 22, 103, 'LinkedList.clear', FALSE, FALSE, TRUE, '{"label":"clear()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nEmpties the linked list.  \n"}},"insertText":"clear();","insertTextFormat":"Snippet"}'),
(1170, 22, 103, 'LinkedList.removeFirstOccurrence', FALSE, FALSE, TRUE, '{"label":"removeFirstOccurrence((any|()) elem)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves the first occurence of the element pass as `elem` and return `true` of the removal is successful.\n  \n  \n  \n**Returns** `boolean`   \n- Return `true` if removal is successful otherwise `false`.  \n  \n"}},"insertText":"removeFirstOccurrence(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1171, 22, 103, 'LinkedList.remove', FALSE, FALSE, TRUE, '{"label":"remove((any|()) elem)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves the first occurence of the element pass as `elem` and return `true` of the removal is successful.\n  \n  \n  \n**Returns** `boolean`   \n- Return `true` if removal is successful otherwise `false`.  \n  \n"}},"insertText":"remove(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1172, 22, 103, 'LinkedList.getFirst', FALSE, FALSE, TRUE, '{"label":"getFirst()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the first element of the linked list, without moving the cursor.\n  \n  \n  \n**Returns** `(any|())`   \n- First element of the linked list.  \n  \n"}},"insertText":"getFirst()","insertTextFormat":"Snippet"}'),
(1173, 22, 103, 'LinkedList.getLast', FALSE, FALSE, TRUE, '{"label":"getLast()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the last element of the linked list, without moving the cursor.\n  \n  \n  \n**Returns** `(any|())`   \n- Last element of the linked list.  \n  \n"}},"insertText":"getLast()","insertTextFormat":"Snippet"}'),
(1174, 22, 103, 'LinkedList.addFirst', FALSE, FALSE, TRUE, '{"label":"addFirst(any data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nAdds a new element to the front of the linked list without moving the cursor.\n  \n**Params**  \n- `any` data: Data to be added to the front of the linked list."}},"insertText":"addFirst(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1175, 22, 103, 'LinkedList.addLast', FALSE, FALSE, TRUE, '{"label":"addLast(any data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nAdds a new element to the end of the linked list without moving the cursor.\n  \n**Params**  \n- `any` data: Data to be added to the end of the linked list."}},"insertText":"addLast(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1176, 22, 103, 'LinkedList.removeFirst', FALSE, FALSE, TRUE, '{"label":"removeFirst()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves the first element in the linked list without moving the cursor.\n  \n  \n  \n**Returns** `(any|())`   \n- Returns the removed element.  \n  \n"}},"insertText":"removeFirst()","insertTextFormat":"Snippet"}'),
(1177, 22, 103, 'LinkedList.removeLast', FALSE, FALSE, TRUE, '{"label":"removeLast()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRemoves the last element in the linked list without moving the cursor.\n  \n  \n  \n**Returns** `(any|())`   \n- Returns the removed element.  \n  \n"}},"insertText":"removeLast()","insertTextFormat":"Snippet"}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1178, 22, 103, 'LinkedList.insertBeforeCurrent', FALSE, FALSE, TRUE, '{"label":"insertBeforeCurrent(any data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nInsert a new element before the current cursor location.\n  \n**Params**  \n- `any` data: Data to be inserted."}},"insertText":"insertBeforeCurrent(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1179, 22, 103, 'LinkedList.linkFirst', TRUE, FALSE, TRUE, '{"label":"linkFirst(any data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"linkFirst(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1180, 22, 103, 'LinkedList.linkLast', TRUE, FALSE, TRUE, '{"label":"linkLast(any data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"linkLast(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1181, 22, 103, 'LinkedList.linkBefore', TRUE, FALSE, TRUE, '{"label":"linkBefore(any data, streams:Node succ)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"linkBefore(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1182, 22, 103, 'LinkedList.unlinkFirst', TRUE, FALSE, TRUE, '{"label":"unlinkFirst(streams:Node node)((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `(any|())`   \n  \n"}},"insertText":"unlinkFirst(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1183, 22, 103, 'LinkedList.unlinkLast', TRUE, FALSE, TRUE, '{"label":"unlinkLast(streams:Node node)((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `(any|())`   \n  \n"}},"insertText":"unlinkLast(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1184, 22, 103, 'LinkedList.unlink', TRUE, FALSE, TRUE, '{"label":"unlink(streams:Node x)((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `(any|())`   \n  \n"}},"insertText":"unlink(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1185, 22, 103, 'LinkedList.dequeue', FALSE, FALSE, TRUE, '{"label":"dequeue()((any|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the first element which is added to the linked list.\n  \n  \n  \n**Returns** `(any|())`   \n- The dequeued element.  \n  \n"}},"insertText":"dequeue()","insertTextFormat":"Snippet"}'),
(1186, 22, 103, 'LinkedList.asArray', FALSE, FALSE, TRUE, '{"label":"asArray()(any[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates an array from the elements in the linked list and return it. The cursor will not be changed.\n  \n  \n  \n**Returns** `any[]`   \n- An array of elements in the linked list.  \n  \n"}},"insertText":"asArray()","insertTextFormat":"Snippet"}'),
(1187, 22, 103, 'LinkedList.addAll', FALSE, FALSE, TRUE, '{"label":"addAll(any[] data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nAdds elements of an array to the current cursor location and moves the cursor to the end of the list.\n  \n**Params**  \n- `any[]` data: The array to be added to the linked list."}},"insertText":"addAll(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1188, 22, 103, 'LinkedList.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1189, 22, 104, 'IntSort.sort', FALSE, FALSE, TRUE, '{"label":"sort(int[] arr)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSorts a given array of int values.\n  \n**Params**  \n- `int[]` arr: The array of int values to be sorted."}},"insertText":"sort(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1190, 22, 104, 'IntSort.sortInternal', TRUE, FALSE, TRUE, '{"label":"sortInternal(int[] arr, int l, int r)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"sortInternal(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1191, 22, 104, 'IntSort.merge', TRUE, FALSE, TRUE, '{"label":"merge(int[] arr, int l, int m, int r)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"merge(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1192, 22, 104, 'IntSort.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(1193, 22, 105, 'Scheduler.notifyAt', FALSE, FALSE, TRUE, '{"label":"notifyAt(int timestamp)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nSchedule to send a timer events at the given timestamp.  \n**Params**  \n- `int` timestamp: The timestamp at which the timer event will be generated and passed to the provided `processFunc`."}},"insertText":"notifyAt(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1194, 22, 105, 'Scheduler.schedule', TRUE, FALSE, TRUE, '{"label":"schedule(int timestamp)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"schedule(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1195, 22, 105, 'Scheduler.wrapperFunc', TRUE, FALSE, TRUE, '{"label":"wrapperFunc()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"wrapperFunc();","insertTextFormat":"Snippet"}'),
(1196, 22, 105, 'Scheduler.sendTimerEvents', FALSE, FALSE, TRUE, '{"label":"sendTimerEvents()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCreates the timer events.  \n  \n  \n**Returns** `(()|error)`   \n- Returns error if sending timer events failed.  \n  \n"}},"insertText":"sendTimerEvents()","insertTextFormat":"Snippet"}'),
(1197, 22, 105, 'Scheduler.__init', FALSE, FALSE, TRUE, '{"label":"__init(function (ballerina/streams:StreamEvent?[]) returns () processFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1198, 22, 106, 'Snapshotable.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to return the current state of a snapshotable object.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A `map\u003cany\u003e` that represents the current state of  \nthe snapshotable instance.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1199, 22, 106, 'Snapshotable.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nFunction to restore a previous state intoa a snapshotable object.  \n**Params**  \n- `map\u003cany\u003e` state: A `map\u003cany\u003e` state that can be used to restore\nsnapshotable instance to a previous state."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1200, 22, 107, 'StreamEvent.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:StreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the stream event instance.\n  \n  \n  \n**Returns** `streams:StreamEvent`   \n- A copy of the `StreamEvent` object with its state.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1201, 22, 107, 'StreamEvent.addData', FALSE, FALSE, TRUE, '{"label":"addData(map\u003canydata\u003e eventData)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nAdds key values pairs in a given map to the field `data`.\n  \n**Params**  \n- `map\u003canydata\u003e` eventData: map of anydata values to be added to field `data`."}},"insertText":"addData(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1202, 22, 107, 'StreamEvent.addAttribute', FALSE, FALSE, TRUE, '{"label":"addAttribute(string key, anydata val)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nAdds an attribute of an event to the map with its value.\n  \n**Params**  \n- `string` key: The key of the map entry.  \n- `anydata` val: Respective value of the `key`."}},"insertText":"addAttribute(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1203, 22, 107, 'StreamEvent.get', FALSE, FALSE, TRUE, '{"label":"get(string path)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the value of an attribute.\n  \n  \n  \n**Returns** `anydata`   \n- the attribute value.  \n  \n"}},"insertText":"get(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1204, 22, 107, 'StreamEvent.getStreamName', FALSE, FALSE, TRUE, '{"label":"getStreamName()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the name of the stream.\n  \n  \n  \n**Returns** `string`   \n- the stream name.  \n  \n"}},"insertText":"getStreamName()","insertTextFormat":"Snippet"}'),
(1205, 22, 107, 'StreamEvent.getEventId', FALSE, FALSE, TRUE, '{"label":"getEventId()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the id of the event.\n  \n  \n  \n**Returns** `string`   \n- the event id.  \n  \n"}},"insertText":"getEventId()","insertTextFormat":"Snippet"}'),
(1206, 22, 107, 'StreamEvent.cloneData', FALSE, FALSE, TRUE, '{"label":"cloneData()(map\u003canydata\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a clone of the event data.\n  \n  \n  \n**Returns** `map\u003canydata\u003e`   \n- clone of the event data.  \n  \n"}},"insertText":"cloneData()","insertTextFormat":"Snippet"}'),
(1207, 22, 107, 'StreamEvent.cloneDataMap', FALSE, FALSE, TRUE, '{"label":"cloneDataMap()(map\u003cmap\u003canydata\u003e[]\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a clone of the event data map.\n  \n  \n  \n**Returns** `map\u003cmap\u003canydata\u003e[]\u003e`   \n- clone of the event data map.  \n  \n"}},"insertText":"cloneDataMap()","insertTextFormat":"Snippet"}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1208, 22, 107, 'StreamEvent.toData', FALSE, FALSE, TRUE, '{"label":"toData(map\u003cmap\u003canydata\u003e[]\u003e dataMap)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCopy values of a given `dataMap` into the `self.data` field.\n  \n**Params**  \n- `map\u003cmap\u003canydata\u003e[]\u003e` dataMap: map containg event attribute values."}},"insertText":"toData(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1209, 22, 107, 'StreamEvent.toDataMap', FALSE, FALSE, TRUE, '{"label":"toDataMap(map\u003canydata\u003e data)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nCopy values of a given `data` into the `self.dataMap` field.\n  \n**Params**  \n- `map\u003canydata\u003e` data: map containg event attribute values."}},"insertText":"toDataMap(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1210, 22, 107, 'StreamEvent.__init', FALSE, FALSE, TRUE, '{"label":"__init(([string,map\u003cmap\u003canydata\u003e[]\u003e]|[string,map\u003canydata\u003e]|map\u003canydata\u003e) eventData, CURRENT|EXPIRED|ALL|RESET|TIMER eventType, int timestamp)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1211, 22, 108, 'Window.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1212, 22, 108, 'Window.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1213, 22, 109, 'Average.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the calculated average after `value` being aggregated into current average. If the `eventType` is\n`streams:CURRENT`,`value` is added to the current sum and count is increase by 1. If the `eventType` is\n`streams:EXPIRED`,  `value` is subtracted from the current sum and count is descreased by 1. If the `eventType`\nis `streams:RESET`, Current  summation and count is reset, regardless the `value`. Then by dividing the sum by\ncount, the average is calculated.\n  \n**Params**  \n- `anydata` value: The numeric value being aggregated in order to calculate the new average.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated average value after `value` being aggregated.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1214, 22, 109, 'Average.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `Average` aggregator without its current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- Returns `Average` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1215, 22, 109, 'Average.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1216, 22, 109, 'Average.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1217, 22, 109, 'Average.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1218, 22, 110, 'Count.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current count when a new event arrives and return the updated count. If the `eventType` is\n`streams:CURRENT`, count is increase by 1. If the `eventType` is `streams:EXPIRED`, count is descreased by 1.\nIf the `eventType`is `streams:RESET`, count is reset, regardless the `value`.\n  \n**Params**  \n- `anydata` value: In count aggregator the value is not used.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated count.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1219, 22, 110, 'Count.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `Count` aggregator without its current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- Returns `Count` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1220, 22, 110, 'Count.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1221, 22, 110, 'Count.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1222, 22, 110, 'Count.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1223, 22, 111, 'DistinctCount.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current distinct count when a new event arrives and return the updated count. If the `eventType` is\n`streams:CURRENT`, count is increased by 1. If the `eventType` is `streams:EXPIRED`, count is descreased by 1.\nIf the `eventType`is `streams:RESET`, count is reset, regardless of the `value`.\n  \n**Params**  \n- `anydata` value: Value being counted uniquely.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated distinct count.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1224, 22, 111, 'DistinctCount.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `DistinctCount` aggregator without its current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- Returns `DistinctCount` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1225, 22, 111, 'DistinctCount.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1226, 22, 111, 'DistinctCount.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1227, 22, 111, 'DistinctCount.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1228, 22, 112, 'Max.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current maximum value and return the updated maximum value.\n  \n**Params**  \n- `anydata` value: Value being checked whether it is greater than the current maximum value.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated max value.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1229, 22, 112, 'Max.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `Max` aggregator without its current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- Returns `Max` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1230, 22, 112, 'Max.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1231, 22, 112, 'Max.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1232, 22, 112, 'Max.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1233, 22, 113, 'MaxForever.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current maximum value and return the updated maximum value.\n  \n**Params**  \n- `anydata` value: Value being checked whether it is greater than the current maximum value.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated maximum value.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1234, 22, 113, 'MaxForever.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `MaxForever` aggregator.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which represents `MaxForever` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1235, 22, 113, 'MaxForever.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1236, 22, 113, 'MaxForever.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1237, 22, 113, 'MaxForever.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1238, 22, 114, 'Min.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current minimum value and return the updated minimum value.\n  \n**Params**  \n- `anydata` value: Value being checked whether it is lesser than the current minimum value.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated minimum value.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1239, 22, 114, 'Min.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `Min` aggregator.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which represents `Min` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1240, 22, 114, 'Min.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1241, 22, 114, 'Min.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1242, 22, 114, 'Min.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1243, 22, 115, 'MinForever.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current minimum value and return the updated minimum value.\n  \n**Params**  \n- `anydata` value: Value being checked whether it is lesser than the current minimum value.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated minimum value.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');             
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1244, 22, 115, 'MinForever.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `MinForever` aggregator.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which represents `MinForever` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1245, 22, 115, 'MinForever.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1246, 22, 115, 'MinForever.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1247, 22, 115, 'MinForever.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1248, 22, 116, 'StdDev.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current standard deviation as the new values come into the aggregation.\n  \n**Params**  \n- `anydata` value: Value being added or removed from aggregation in order to calculate the new standard deviation.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- Updated standard deviation.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1249, 22, 116, 'StdDev.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `StdDev` aggregator.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- A `Aggregator` object which represents `StdDev` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1250, 22, 116, 'StdDev.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1251, 22, 116, 'StdDev.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1252, 22, 116, 'StdDev.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1253, 22, 117, 'Sum.process', FALSE, FALSE, TRUE, '{"label":"process(anydata value, CURRENT|EXPIRED|ALL|RESET|TIMER eventType)(anydata)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nUpdates the current sum of numeric values based on the `eventType`. If the `eventType` is `streams:CURRENT`,\n`value` is added to the current sum. If the `eventType` is `streams:EXPIRED`, `value` is subtracted from the\ncurrent sum. If the `eventType` is `streams:RESET`, Current summation will be reset, regardless the `value`.\n  \n**Params**  \n- `anydata` value: The numeric value being aggregated to the current sum.  \n- `CURRENT|EXPIRED|ALL|RESET|TIMER` eventType: Type of the incoming event `streams:CURRENT`, `streams:EXPIRED` or `streams:RESET`.\n  \n  \n**Returns** `anydata`   \n- aggregated summation after the given `value`.  \n  \n"}},"insertText":"process(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1254, 22, 117, 'Sum.copy', FALSE, FALSE, TRUE, '{"label":"copy()(streams:Aggregator)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns a copy of the `Sum` aggregator without its current state.\n  \n  \n  \n**Returns** `streams:Aggregator`   \n- Returns `Sum` aggregator.  \n  \n"}},"insertText":"copy()","insertTextFormat":"Snippet"}'),
(1255, 22, 117, 'Sum.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.\n  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1256, 22, 117, 'Sum.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.\n  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1257, 22, 117, 'Sum.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init();","insertTextFormat":"Snippet"}'),
(1258, 22, 118, 'DelayWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1259, 22, 118, 'DelayWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1260, 22, 118, 'DelayWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1261, 22, 118, 'DelayWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1262, 22, 118, 'DelayWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1263, 22, 118, 'DelayWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1264, 22, 119, 'ExternalTimeBatchWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1265, 22, 119, 'ExternalTimeBatchWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1266, 22, 119, 'ExternalTimeBatchWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1267, 22, 119, 'ExternalTimeBatchWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1268, 22, 119, 'ExternalTimeBatchWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1269, 22, 119, 'ExternalTimeBatchWindow.cloneAppend', FALSE, FALSE, TRUE, '{"label":"cloneAppend(streams:StreamEvent currStreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"cloneAppend(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1270, 22, 119, 'ExternalTimeBatchWindow.flushToOutputChunk', FALSE, FALSE, TRUE, '{"label":"flushToOutputChunk(streams:LinkedList complexEventChunks, int currentTime, boolean preserveCurrentEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"flushToOutputChunk(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1271, 22, 119, 'ExternalTimeBatchWindow.appendToOutputChunk', FALSE, FALSE, TRUE, '{"label":"appendToOutputChunk(streams:LinkedList complexEventChunks, int currentTime, boolean preserveCurrentEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"appendToOutputChunk(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1272, 22, 119, 'ExternalTimeBatchWindow.findEndTime', FALSE, FALSE, TRUE, '{"label":"findEndTime(int currentTime, int startTime_, int timeToKeep_)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"findEndTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1273, 22, 119, 'ExternalTimeBatchWindow.initTiming', FALSE, FALSE, TRUE, '{"label":"initTiming(streams:StreamEvent firstStreamEvent)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initTiming(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1274, 22, 119, 'ExternalTimeBatchWindow.getTimestamp', FALSE, FALSE, TRUE, '{"label":"getTimestamp(any val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getTimestamp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1275, 22, 119, 'ExternalTimeBatchWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1276, 22, 120, 'ExternalTimeWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1277, 22, 120, 'ExternalTimeWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1278, 22, 120, 'ExternalTimeWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1279, 22, 120, 'ExternalTimeWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1280, 22, 120, 'ExternalTimeWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1281, 22, 120, 'ExternalTimeWindow.getTimestamp', FALSE, FALSE, TRUE, '{"label":"getTimestamp(any val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getTimestamp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1282, 22, 120, 'ExternalTimeWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1283, 22, 121, 'HoppingWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1284, 22, 121, 'HoppingWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1285, 22, 121, 'HoppingWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1286, 22, 121, 'HoppingWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1287, 22, 121, 'HoppingWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1288, 22, 121, 'HoppingWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1289, 22, 122, 'LengthBatchWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1290, 22, 122, 'LengthBatchWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1291, 22, 122, 'LengthBatchWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');    
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1292, 22, 122, 'LengthBatchWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1293, 22, 122, 'LengthBatchWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1294, 22, 122, 'LengthBatchWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1295, 22, 123, 'LengthWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1296, 22, 123, 'LengthWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1297, 22, 123, 'LengthWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1298, 22, 123, 'LengthWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1299, 22, 123, 'LengthWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1300, 22, 123, 'LengthWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1301, 22, 124, 'SortWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1302, 22, 124, 'SortWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.\n  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1303, 22, 124, 'SortWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1304, 22, 124, 'SortWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1305, 22, 124, 'SortWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1306, 22, 124, 'SortWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1307, 22, 125, 'TimeAccumulatingWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1308, 22, 125, 'TimeAccumulatingWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1309, 22, 125, 'TimeAccumulatingWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1310, 22, 125, 'TimeAccumulatingWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1311, 22, 125, 'TimeAccumulatingWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1312, 22, 125, 'TimeAccumulatingWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1313, 22, 126, 'TimeBatchWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1314, 22, 126, 'TimeBatchWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1315, 22, 126, 'TimeBatchWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1316, 22, 126, 'TimeBatchWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1317, 22, 126, 'TimeBatchWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1318, 22, 126, 'TimeBatchWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1319, 22, 127, 'TimeLengthWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1320, 22, 127, 'TimeLengthWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1321, 22, 127, 'TimeLengthWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1322, 22, 127, 'TimeLengthWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1323, 22, 127, 'TimeLengthWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1324, 22, 127, 'TimeLengthWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1325, 22, 128, 'TimeOrderWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1326, 22, 128, 'TimeOrderWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1327, 22, 128, 'TimeOrderWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'); 
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1328, 22, 128, 'TimeOrderWindow.getTimestamp', FALSE, FALSE, TRUE, '{"label":"getTimestamp(any val)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getTimestamp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1329, 22, 128, 'TimeOrderWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1330, 22, 128, 'TimeOrderWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1331, 22, 128, 'TimeOrderWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1332, 22, 129, 'TimeWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1333, 22, 129, 'TimeWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1334, 22, 129, 'TimeWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1335, 22, 129, 'TimeWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1336, 22, 129, 'TimeWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1337, 22, 129, 'TimeWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1338, 22, 130, 'UniqueLengthWindow.initParameters', FALSE, FALSE, TRUE, '{"label":"initParameters(any[] parameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"initParameters(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1339, 22, 130, 'UniqueLengthWindow.process', FALSE, FALSE, TRUE, '{"label":"process((streams:StreamEvent|())[] streamEvents)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nThe `process` function process the incoming events to the events and update the current state of the window.  \n**Params**  \n- `(streams:StreamEvent|())[]` streamEvents: The array of stream events to be processed."}},"insertText":"process(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1340, 22, 130, 'UniqueLengthWindow.getCandidateEvents', FALSE, FALSE, TRUE, '{"label":"getCandidateEvents(streams:StreamEvent originEvent, (function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|()) conditionFunc, boolean isLHSTrigger)([(streams:StreamEvent|()),(streams:StreamEvent|())][])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturns the events(State) which match with the where condition in the join clause for a given event.  \n**Params**  \n- `streams:StreamEvent` originEvent: The event against which the state or the events being held by the window is matched.  \n- `(function (map\u003canydata\u003e,map\u003canydata\u003e) returns (boolean)|())` conditionFunc: The function pointer to the lambda function which contain the condition logic in where clause.  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.(Defaultable)  \n- `boolean` isLHSTrigger: Specify if the join is triggered when the lhs stream received the events, if so it should be\n                 true. Most of the time it is true. In rare cases, where the join is triggered when the rhs\n                  stream receives events this should be false.  \n  \n**Returns** `[(streams:StreamEvent|()),(streams:StreamEvent|())][]`   \n- Returns an array of 2 element tuples of events. A tuple contains the matching events one from lhs  \n           stream and one from rhs stream.  \n  \n"}},"insertText":"getCandidateEvents(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1341, 22, 130, 'UniqueLengthWindow.saveState', FALSE, FALSE, TRUE, '{"label":"saveState()(map\u003cany\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nReturn current state to be saved as a map of `any` typed values.  \n  \n  \n**Returns** `map\u003cany\u003e`   \n- A map of `any` typed values.  \n  \n"}},"insertText":"saveState()","insertTextFormat":"Snippet"}'),
(1342, 22, 130, 'UniqueLengthWindow.restoreState', FALSE, FALSE, TRUE, '{"label":"restoreState(map\u003cany\u003e state)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \nRestores the saved state which is passed as a map of `any` typed values.  \n**Params**  \n- `map\u003cany\u003e` state: A map of typed `any` values. This map contains the values to be restored from the persisted data."}},"insertText":"restoreState(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1343, 22, 130, 'UniqueLengthWindow.__init', FALSE, FALSE, TRUE, '{"label":"__init((function (ballerina/streams:StreamEvent?[]) returns ()|()) nextProcessPointer, any[] windowParameters)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/streams_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1344, 23, -1, 'getEnv', FALSE, FALSE, FALSE, '{"label":"getEnv(string name)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nReturns the environment variable value associated with the provided name.\n  \n**Params**  \n- `string` name: Name of the environment variable  \n  \n**Returns** `string`   \n- Environment variable value if it exists, otherwise an empty string  \n  \n"}},"insertText":"getEnv(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1345, 23, -1, 'getUsername', FALSE, FALSE, FALSE, '{"label":"getUsername()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nReturns the current user\u0027s name.\n  \n  \n  \n**Returns** `string`   \n- Current user\u0027s name if it can be determined, an empty string otherwise  \n  \n"}},"insertText":"getUsername()","insertTextFormat":"Snippet"}'),
(1346, 23, -1, 'getUserHome', FALSE, FALSE, FALSE, '{"label":"getUserHome()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nReturns the current user\u0027s home directory path.\n  \n  \n  \n**Returns** `string`   \n- Current user\u0027s home directory if it can be determined, an empty string otherwise  \n  \n"}},"insertText":"getUserHome()","insertTextFormat":"Snippet"}'),
(1347, 23, -1, 'uuid', FALSE, FALSE, FALSE, '{"label":"uuid()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nReturns a random UUID string.\n  \n  \n  \n**Returns** `string`   \n- The random string  \n  \n"}},"insertText":"uuid()","insertTextFormat":"Snippet"}'),
(1348, 23, -1, 'exec', FALSE, FALSE, FALSE, '{"label":"exec(string command, map\u003cstring\u003e env, (string|()) dir, ...string)((system:Process|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nExecutes an operating system command as a subprocess of the current process.\n  \n**Params**  \n- `string` command: The name of the command to be executed  \n- `map\u003cstring\u003e` env: Environment variables to be set to the process(Defaultable)  \n- `map\u003cstring\u003e` env: Environment variables to be set to the process  \n- `(string|())` dir: The current working directory to be set to the process(Defaultable)  \n- `(string|())` dir: The current working directory to be set to the process  \n- args: Command arguments to be passed in  \n  \n**Returns** `(system:Process|error)`   \n- Returns a `Process` object in success, or an `Error` if a failure occurs  \n  \n"}},"insertText":"exec(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1349, 23, 131, 'Process.waitForExit', FALSE, FALSE, TRUE, '{"label":"waitForExit()((int|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nWaits for the process to finish its work and exit.\n  \n  \n  \n**Returns** `(int|error)`   \n- Returns the exit code for the process, or an `Error` if a failure occurs  \n  \n"}},"insertText":"waitForExit()","insertTextFormat":"Snippet"}'),
(1350, 23, 131, 'Process.exitCode', FALSE, FALSE, TRUE, '{"label":"exitCode()((int|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nReturns the exit code of the process when it finished execution.\nError if the process has not exited yet.\n  \n  \n  \n**Returns** `(int|error)`   \n- Returns the exit code of the process, or an `Error` if the process hasn\u0027t exited yet.  \n  \n"}},"insertText":"exitCode()","insertTextFormat":"Snippet"}'),
(1351, 23, 131, 'Process.destroy', FALSE, FALSE, TRUE, '{"label":"destroy()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nDestroys the process.  \n"}},"insertText":"destroy();","insertTextFormat":"Snippet"}'),
(1352, 23, 131, 'Process.stdin', FALSE, FALSE, TRUE, '{"label":"stdin()(io:WritableByteChannel)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nProvides a channel (to write into), which is made available as the \u0027standard input\u0027 for the process.\n  \n  \n  \n**Returns** `io:WritableByteChannel`   \n- The `io:WritableByteChannel` which represents the process\u0027s \u0027standard input\u0027  \n  \n"}},"insertText":"stdin()","insertTextFormat":"Snippet"}'),
(1353, 23, 131, 'Process.stdout', FALSE, FALSE, TRUE, '{"label":"stdout()(io:ReadableByteChannel)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nProvides a channel (to read from), which is made available as the \u0027standard output\u0027 of the process.\n  \n  \n  \n**Returns** `io:ReadableByteChannel`   \n- The `io:ReadableByteChannel` which represents the process\u0027s \u0027standard output\u0027  \n  \n"}},"insertText":"stdout()","insertTextFormat":"Snippet"}'),
(1354, 23, 131, 'Process.stderr', FALSE, FALSE, TRUE, '{"label":"stderr()(io:ReadableByteChannel)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nProvides a channel (to read from), which is made available as the \u0027standard error\u0027 of the process.\n  \n  \n  \n**Returns** `io:ReadableByteChannel`   \n- The `io:ReadableByteChannel` which represents the process\u0027s \u0027standard error\u0027  \n  \n"}},"insertText":"stderr()","insertTextFormat":"Snippet"}'),
(1355, 23, 131, 'Process.pipe', FALSE, FALSE, TRUE, '{"label":"pipe(system:Process process)(system:Process)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \nPipes the standard output of the current process to the standard input of the given process.\n  \n**Params**  \n- `system:Process` process: The process to pipe the data to  \n  \n**Returns** `system:Process`   \n- The process that is passed in, which is used to help chain pipe operations  \n  \n"}},"insertText":"pipe(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1356, 23, 131, 'Process.doPipe', TRUE, FALSE, TRUE, '{"label":"doPipe(io:ReadableByteChannel input, io:WritableByteChannel output)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/system_  \n  \n  \n"}},"insertText":"doPipe(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');          
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1357, 23, 131, 'Process.__init', FALSE, FALSE, TRUE, '{"label":"__init()","kind":"Function","detail":"Function","insertText":"__init();","insertTextFormat":"Snippet"}'),
(1358, 24, 132, 'Listener.__attach', FALSE, FALSE, TRUE, '{"label":"__attach(service s, (string|()) name)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1359, 24, 132, 'Listener.__start', FALSE, FALSE, TRUE, '{"label":"__start()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__start()","insertTextFormat":"Snippet"}'),
(1360, 24, 132, 'Listener.__gracefulStop', FALSE, FALSE, TRUE, '{"label":"__gracefulStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__gracefulStop()","insertTextFormat":"Snippet"}'),
(1361, 24, 132, 'Listener.__immediateStop', FALSE, FALSE, TRUE, '{"label":"__immediateStop()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"__immediateStop()","insertTextFormat":"Snippet"}'),
(1362, 24, 132, 'Listener.init', TRUE, FALSE, TRUE, '{"label":"init()((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n  \n"}},"insertText":"init()","insertTextFormat":"Snippet"}'),
(1363, 24, 132, 'Listener.register', TRUE, FALSE, TRUE, '{"label":"register(service s, map\u003cany\u003e config)((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1364, 24, 132, 'Listener.start', TRUE, FALSE, TRUE, '{"label":"start()((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(1365, 24, 132, 'Listener.stop', TRUE, FALSE, TRUE, '{"label":"stop()((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n  \n"}},"insertText":"stop()","insertTextFormat":"Snippet"}'),
(1366, 24, 132, 'Listener.detachService', TRUE, FALSE, TRUE, '{"label":"detachService(service attachedService)((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n  \n"}},"insertText":"detachService(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1367, 24, 132, 'Listener.isStarted', TRUE, FALSE, TRUE, '{"label":"isStarted()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isStarted()","insertTextFormat":"Snippet"}'),
(1368, 24, 132, 'Listener.pause', FALSE, FALSE, TRUE, '{"label":"pause()((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nPauses the task.\n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n- Returns `ListenerError` if an error is occurred while resuming, nil Otherwise.  \n  \n"}},"insertText":"pause()","insertTextFormat":"Snippet"}');               
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1369, 24, 132, 'Listener.resume', FALSE, FALSE, TRUE, '{"label":"resume()((()|task:ListenerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nResumes a paused task.\n  \n  \n  \n**Returns** `(()|task:ListenerError)`   \n- Returns `ListenerError` when an error occurred while pausing, nil Otherwise.  \n  \n"}},"insertText":"resume()","insertTextFormat":"Snippet"}'),
(1370, 24, 132, 'Listener.__init', FALSE, FALSE, TRUE, '{"label":"__init((task:TimerConfiguration|task:AppointmentConfiguration) configs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1371, 24, 133, 'Scheduler.attach', FALSE, FALSE, TRUE, '{"label":"attach(service serviceToAttach, any attachment)((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nAttaches the provided service to the task.\n  \n**Params**  \n- `service` serviceToAttach: Service which needs to be attached to the task.  \n- `any` attachment: An optional parameter which needs to passed inside the resources.(Defaultable)  \n- `any` attachment: An optional parameter which needs to passed inside the resources.  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` if the process failed due to any reason, nil otherwise.  \n  \n"}},"insertText":"attach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1372, 24, 133, 'Scheduler.detach', FALSE, FALSE, TRUE, '{"label":"detach(service attachedService)((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nDetach the provided service from the task.\n  \n**Params**  \n- `service` attachedService: service which needs to be detached from the task.  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` if the process failed due to any reason, nil otherwise.  \n  \n"}},"insertText":"detach(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1373, 24, 133, 'Scheduler.start', FALSE, FALSE, TRUE, '{"label":"start()((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nStarts running the task. Task will not run until this has been called.\n  \n  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` if the process failed due to any reason, nil otherwise.  \n  \n"}},"insertText":"start()","insertTextFormat":"Snippet"}'),
(1374, 24, 133, 'Scheduler.stop', FALSE, FALSE, TRUE, '{"label":"stop()((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nStops the task. This will stop, after finish running the existing jobs.\n  \n  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` if the process failed due to any reason, nil otherwise.  \n  \n"}},"insertText":"stop()","insertTextFormat":"Snippet"}'),
(1375, 24, 133, 'Scheduler.pause', FALSE, FALSE, TRUE, '{"label":"pause()((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nPauses the task.\n  \n  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` if an error is occurred while resuming, nil Otherwise.  \n  \n"}},"insertText":"pause()","insertTextFormat":"Snippet"}'),
(1376, 24, 133, 'Scheduler.resume', FALSE, FALSE, TRUE, '{"label":"resume()((()|task:SchedulerError))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nResumes a paused task.\n  \n  \n  \n**Returns** `(()|task:SchedulerError)`   \n- Returns `SchedulerError` when an error occurred while pausing, nil Otherwise.  \n  \n"}},"insertText":"resume()","insertTextFormat":"Snippet"}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1377, 24, 133, 'Scheduler.isStarted', FALSE, FALSE, TRUE, '{"label":"isStarted()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \nChecks whether the task is started or not.\n  \n  \n  \n**Returns** `boolean`   \n- Returns `true` if the Scheduler is already started, `false` if the Scheduler is  \n              not started yet or stopped calling the `stop()` function.  \n  \n"}},"insertText":"isStarted()","insertTextFormat":"Snippet"}'),
(1378, 24, 133, 'Scheduler.__init', FALSE, FALSE, TRUE, '{"label":"__init((task:TimerConfiguration|task:AppointmentConfiguration) configs)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/task_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1379, 25, -1, 'createBallerinaError', FALSE, FALSE, FALSE, '{"label":"createBallerinaError(string errorMessage, string category)(error)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nCreates an AssertError with custom message and category.\n  \n**Params**  \n- `string` errorMessage: Custom message for the ballerina error  \n- `string` category: error category\n  \n  \n**Returns** `error`   \n- an AssertError with custom message and category  \n  \n"}},"insertText":"createBallerinaError(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1380, 25, -1, 'assertTrue', FALSE, FALSE, FALSE, '{"label":"assertTrue(boolean condition, string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nAsserts whether the given condition is true. If it is not, a AssertError is thrown with the given errorMessage.\n  \n**Params**  \n- `boolean` condition: Boolean condition to evaluate  \n- `string` msg: Assertion error message(Defaultable)  \n- `string` msg: Assertion error message"}},"insertText":"assertTrue(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1381, 25, -1, 'assertFalse', FALSE, FALSE, FALSE, '{"label":"assertFalse(boolean condition, string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nAsserts whether the given condition is false. If it is not, a AssertError is thrown with the given errorMessage.\n  \n**Params**  \n- `boolean` condition: Boolean condition to evaluate  \n- `string` msg: Assertion error message(Defaultable)  \n- `string` msg: Assertion error message"}},"insertText":"assertFalse(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1382, 25, -1, 'assertEquals', FALSE, FALSE, FALSE, '{"label":"assertEquals((any|error) actual, (any|error) expected, string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nAsserts whether the given values are equal. If it is not, an AssertError is thrown with the given errorMessage.\n  \n**Params**  \n- `(any|error)` actual: Actual value  \n- `(any|error)` expected: Expected value  \n- `string` msg: Assertion error message(Defaultable)  \n- `string` msg: Assertion error message"}},"insertText":"assertEquals(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1383, 25, -1, 'assertNotEquals', FALSE, FALSE, FALSE, '{"label":"assertNotEquals((any|error) actual, (any|error) expected, string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nAsserts whether the given values are not equal. If it is equal, an AssertError is thrown with the given errorMessage.\n  \n**Params**  \n- `(any|error)` actual: Actual value  \n- `(any|error)` expected: Expected value  \n- `string` msg: Assertion error message(Defaultable)  \n- `string` msg: Assertion error message"}},"insertText":"assertNotEquals(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1384, 25, -1, 'assertFail', FALSE, FALSE, FALSE, '{"label":"assertFail(string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nAssert failure is triggered based on user discretion. AssertError is thrown with the given errorMessage.\n  \n**Params**  \n- `string` msg: Assertion error message(Defaultable)  \n- `string` msg: Assertion error message"}},"insertText":"assertFail(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1385, 25, -1, 'startServices', FALSE, FALSE, FALSE, '{"label":"startServices(string moduleName)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nStarts all the services defined in the module specified in the \u0027moduleName\u0027 argument.\n  \n**Params**  \n- `string` moduleName: Name of the module\n  \n  \n**Returns** `boolean`   \n- `true` if the services were started successfully, `false` otherwise  \n  \n"}},"insertText":"startServices(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1386, 25, -1, 'stopServices', FALSE, FALSE, FALSE, '{"label":"stopServices(string moduleName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nStops all the services defined in the module specified in the \u0027moduleName\u0027 argument.\n  \n**Params**  \n- `string` moduleName: Name of the module"}},"insertText":"stopServices(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1387, 25, -1, 'startServiceSkeleton', FALSE, FALSE, FALSE, '{"label":"startServiceSkeleton(string moduleName, string openApiFilePath)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nStart a service skeleton from a given OpenApi definition in the given ballerina module.\n  \n**Params**  \n- `string` moduleName: Name of the module  \n- `string` openApiFilePath: Path to the OpenApi definition\n  \n  \n**Returns** `boolean`   \n- `true` if the service skeleton was started successfully, `false` otherwise  \n  \n"}},"insertText":"startServiceSkeleton(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1388, 25, -1, 'stopServiceSkeleton', FALSE, FALSE, FALSE, '{"label":"stopServiceSkeleton(string moduleName)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/test_  \n  \nStop a service skeleton and cleanup created directories of a given ballerina module.\n  \n**Params**  \n- `string` moduleName: Name of the module"}},"insertText":"stopServiceSkeleton(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1389, 26, -1, 'toString', FALSE, FALSE, FALSE, '{"label":"toString(time:Time time)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns ISO 8601 string representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to be converted to string  \n  \n**Returns** `string`   \n- The ISO 8601 formatted string of the given time  \n  \n"}},"insertText":"toString(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1390, 26, -1, 'format', FALSE, FALSE, FALSE, '{"label":"format(time:Time time, (string|RFC_1123) timeFormat)((string|time:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns formatted string representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to be formatted  \n- `(string|RFC_1123)` timeFormat: The format which is used to format the time represented by this object  \n  \n**Returns** `(string|time:Error)`   \n- The formatted string of the given time or an `time:Error` if failed to format the time  \n  \n"}},"insertText":"format(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');         
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1391, 26, -1, 'getYear', FALSE, FALSE, FALSE, '{"label":"getYear(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the year representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to retrieve the year representation from  \n  \n**Returns** `int`   \n- The year representation  \n  \n"}},"insertText":"getYear(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1392, 26, -1, 'getMonth', FALSE, FALSE, FALSE, '{"label":"getMonth(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the month representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the month representation from  \n  \n**Returns** `int`   \n- The month-of-year, from 1 (January) to 12 (December)  \n  \n"}},"insertText":"getMonth(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1393, 26, -1, 'getDay', FALSE, FALSE, FALSE, '{"label":"getDay(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the date representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the date representation from  \n  \n**Returns** `int`   \n- The day-of-month, from 1 to 31  \n  \n"}},"insertText":"getDay(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1394, 26, -1, 'getWeekday', FALSE, FALSE, FALSE, '{"label":"getWeekday(time:Time time)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the weekday representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the weekday representation from  \n  \n**Returns** `string`   \n- The weekday representation from SUNDAY to SATURDAY  \n  \n"}},"insertText":"getWeekday(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1395, 26, -1, 'getHour', FALSE, FALSE, FALSE, '{"label":"getHour(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the hour representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the  hour representation from  \n  \n**Returns** `int`   \n- The hour-of-day, from 0 to 23  \n  \n"}},"insertText":"getHour(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1396, 26, -1, 'getMinute', FALSE, FALSE, FALSE, '{"label":"getMinute(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the minute representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the  minute representation from  \n  \n**Returns** `int`   \n- The minute-of-hour to represent, from 0 to 59  \n  \n"}},"insertText":"getMinute(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1397, 26, -1, 'getSecond', FALSE, FALSE, FALSE, '{"label":"getSecond(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the second representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the second representation from  \n  \n**Returns** `int`   \n- The second-of-minute, from 0 to 59  \n  \n"}},"insertText":"getSecond(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1398, 26, -1, 'getMilliSecond', FALSE, FALSE, FALSE, '{"label":"getMilliSecond(time:Time time)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the millisecond representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the millisecond representation from  \n  \n**Returns** `int`   \n- The milli-of-second, from 0 to 999  \n  \n"}},"insertText":"getMilliSecond(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1399, 26, -1, 'getDate', FALSE, FALSE, FALSE, '{"label":"getDate(time:Time time)([int,int,int])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the date representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record to get the date representation from  \n  \n**Returns** `[int,int,int]`   \n- The year representation.  \n           The month-of-year, from 1 (January) to 12 (December).  \n           The day-of-month, from 1 to 31.  \n  \n"}},"insertText":"getDate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1400, 26, -1, 'getTime', FALSE, FALSE, FALSE, '{"label":"getTime(time:Time time)([int,int,int,int])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the time representation of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record  \n  \n**Returns** `[int,int,int,int]`   \n- The hour-of-day, from 0 to 23.  \n           The minute-of-hour to represent, from 0 to 59.  \n           The second-of-minute, from 0 to 59.  \n           The milli-of-second, from 0 to 999.  \n  \n"}},"insertText":"getTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1401, 26, -1, 'addDuration', FALSE, FALSE, FALSE, '{"label":"addDuration(time:Time time, int years, int months, int days, int hours, int minutes, int seconds, int milliSeconds)(time:Time)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nAdd specified durations to the given time value.\n  \n**Params**  \n- `time:Time` time: The Time record to add the duration to  \n- `int` years: The year representation  \n- `int` months: The month-of-year to represent, from 1 (January) to 12 (December)  \n- `int` days: The day-of-month to represent, from 1 to 31  \n- `int` hours: The hour-of-day to represent, from 0 to 23  \n- `int` minutes: The minute-of-hour to represent, from 0 to 59  \n- `int` seconds: The second-of-minute to represent, from 0 to 59  \n- `int` milliSeconds: The milli-of-second to represent, from 0 to 999  \n  \n**Returns** `time:Time`   \n- Time object containing time and zone information after the addition  \n  \n"}},"insertText":"addDuration(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1402, 26, -1, 'subtractDuration', FALSE, FALSE, FALSE, '{"label":"subtractDuration(time:Time time, int years, int months, int days, int hours, int minutes, int seconds, int milliSeconds)(time:Time)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nSubtract specified durations from the given time value.\n  \n**Params**  \n- `time:Time` time: The Time record to subtract the duration from  \n- `int` years: The year representation  \n- `int` months: The month-of-year to represent, from 1 (January) to 12 (December)  \n- `int` days: The day-of-month to represent, from 1 to 31  \n- `int` hours: The hour-of-day to represent, from 0 to 23  \n- `int` minutes: The minute-of-hour to represent, from 0 to 59  \n- `int` seconds: The second-of-minute to represent, from 0 to 59  \n- `int` milliSeconds: The milli-of-second to represent, from 0 to 999  \n  \n**Returns** `time:Time`   \n- Time object containing time and zone information after the subtraction  \n  \n"}},"insertText":"subtractDuration(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1403, 26, -1, 'toTimeZone', FALSE, FALSE, FALSE, '{"label":"toTimeZone(time:Time time, string zoneId)((time:Time|time:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nChange the time-zone of the given time.\n  \n**Params**  \n- `time:Time` time: The Time record of which the time-zone to be changed  \n- `string` zoneId: The new time-zone id  \n  \n**Returns** `(time:Time|time:Error)`   \n- Time object containing time and zone information after the conversion  \n           or an `time:Error` if failed to format the time  \n  \n"}},"insertText":"toTimeZone(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1404, 26, -1, 'currentTime', FALSE, FALSE, FALSE, '{"label":"currentTime()(time:Time)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the current time value with the system default time-zone.\n  \n  \n  \n**Returns** `time:Time`   \n- Time object containing the time and zone information  \n  \n"}},"insertText":"currentTime()","insertTextFormat":"Snippet"}'),
(1405, 26, -1, 'nanoTime', FALSE, FALSE, FALSE, '{"label":"nanoTime()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the current system time in nano seconds.\n  \n  \n  \n**Returns** `int`   \n- Int value of the current system time in nano seconds  \n  \n"}},"insertText":"nanoTime()","insertTextFormat":"Snippet"}'),
(1406, 26, -1, 'createTime', FALSE, FALSE, FALSE, '{"label":"createTime(int year, int month, int date, int hour, int minute, int second, int milliSecond, string zoneId)((time:Time|time:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the Time object correspoding to the given time components and time-zone.\n  \n**Params**  \n- `int` year: The year representation  \n- `int` month: The month-of-year to represent, from 1 (January) to 12 (December)  \n- `int` date: The day-of-month to represent, from 1 to 31  \n- `int` hour: The hour-of-day to represent, from 0 to 23  \n- `int` minute: The minute-of-hour to represent, from 0 to 59  \n- `int` second: The second-of-minute to represent, from 0 to 59  \n- `int` milliSecond: The milli-of-second to represent, from 0 to 999  \n- `string` zoneId: The zone id of the required time-zone.If empty the system local time-zone will be used  \n  \n**Returns** `(time:Time|time:Error)`   \n- Time object containing time and zone information or an `time:Error` if failed to create the time  \n  \n"}},"insertText":"createTime(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1407, 26, -1, 'parse', FALSE, FALSE, FALSE, '{"label":"parse(string data, (string|RFC_1123) timeFormat)((time:Time|time:Error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/time_  \n  \nReturns the time for the given string representation based on the given format string.\n  \n**Params**  \n- `string` data: The time text to parse  \n- `(string|RFC_1123)` timeFormat: The format which is used to parse the given text  \n  \n**Returns** `(time:Time|time:Error)`   \n- Time object containing time and zone information or an `time:Error` if failed to parse the given string  \n  \n"}},"insertText":"parse(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1408, 27, -1, 'cleanupTransactions', TRUE, FALSE, FALSE, '{"label":"cleanupTransactions()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(()|error)`   \n  \n"}},"insertText":"cleanupTransactions()","insertTextFormat":"Snippet"}');  
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1409, 27, -1, 'isRegisteredParticipant', TRUE, FALSE, FALSE, '{"label":"isRegisteredParticipant(string participantId, map\u003ctransactions:Participant\u003e participants)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isRegisteredParticipant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1410, 27, -1, 'isValidCoordinationType', TRUE, FALSE, FALSE, '{"label":"isValidCoordinationType(string coordinationType)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"isValidCoordinationType(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1411, 27, -1, 'protoName', TRUE, FALSE, FALSE, '{"label":"protoName((transactions:LocalProtocol|transactions:RemoteProtocol) p)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"protoName(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1412, 27, -1, 'protocolCompatible', TRUE, FALSE, FALSE, '{"label":"protocolCompatible(string coordinationType, (transactions:LocalProtocol|transactions:RemoteProtocol|())[] participantProtocols)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `boolean`   \n  \n"}},"insertText":"protocolCompatible(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1413, 27, -1, 'respondToBadRequest', TRUE, FALSE, FALSE, '{"label":"respondToBadRequest(http:Caller ep, string msg)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"respondToBadRequest(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1414, 27, -1, 'getCoordinatorProtocolAt', TRUE, FALSE, FALSE, '{"label":"getCoordinatorProtocolAt(string protocolName, string transactionBlockId)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getCoordinatorProtocolAt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1415, 27, -1, 'getParticipantProtocolAt', TRUE, FALSE, FALSE, '{"label":"getParticipantProtocolAt(string protocolName, string transactionBlockId)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getParticipantProtocolAt(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1416, 27, -1, 'createTransactionContext', TRUE, FALSE, FALSE, '{"label":"createTransactionContext(string coordinationType, string transactionBlockId)((transactions:TransactionContext|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nThe initiator will create a new transaction context by calling this function. At this point, a transaction object\ncorresponding to the coordinationType will also be created and stored as an initiated transaction.\n  \n**Params**  \n- `string` coordinationType: The type of the coordination relevant to the transaction block for which this TransactionContext\n                     is being created for.  \n- `string` transactionBlockId: The ID of the transaction block.  \n  \n**Returns** `(transactions:TransactionContext|error)`   \n- TransactionContext if the coordination type is valid or an error in case of an invalid coordination type.  \n  \n"}},"insertText":"createTransactionContext(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1417, 27, -1, 'registerLocalParticipantWithInitiator', TRUE, FALSE, FALSE, '{"label":"registerLocalParticipantWithInitiator(string transactionId, string transactionBlockId, string registerAtURL)((transactions:TransactionContext|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nRegister a local participant, which corresponds to a nested transaction of the initiated transaction, with the\ninitiator. Such participants and the initiator don\u0027t have to communicate over the network, so we are special casing\nsuch participants.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n- `string` registerAtURL: The URL of the initiator  \n  \n**Returns** `(transactions:TransactionContext|error)`   \n- TransactionContext if the registration is successul or an error in case of a failure.  \n  \n"}},"insertText":"registerLocalParticipantWithInitiator(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1418, 27, -1, 'removeParticipatedTransaction', TRUE, FALSE, FALSE, '{"label":"removeParticipatedTransaction(string participatedTxnId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"removeParticipatedTransaction(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1419, 27, -1, 'removeInitiatedTransaction', TRUE, FALSE, FALSE, '{"label":"removeInitiatedTransaction(string transactionId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"removeInitiatedTransaction(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1420, 27, -1, 'getInitiatorClient', TRUE, FALSE, FALSE, '{"label":"getInitiatorClient(string registerAtURL)(transactions:InitiatorClientEP)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `transactions:InitiatorClientEP`   \n  \n"}},"insertText":"getInitiatorClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1421, 27, -1, 'getParticipant2pcClient', TRUE, FALSE, FALSE, '{"label":"getParticipant2pcClient(string participantURL)(transactions:Participant2pcClientEP)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `transactions:Participant2pcClientEP`   \n  \n"}},"insertText":"getParticipant2pcClient(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1422, 27, -1, 'registerParticipantWithRemoteInitiator', FALSE, FALSE, FALSE, '{"label":"registerParticipantWithRemoteInitiator(string transactionId, string transactionBlockId, string registerAtURL, transactions:RemoteProtocol[] participantProtocols)((transactions:TransactionContext|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nRegisters a participant with the initiator\u0027s coordinator. This function will be called by the participant.\n  \n**Params**  \n- `string` transactionId: Global transaction ID to which this participant is registering with.  \n- `string` transactionBlockId: The local ID of the transaction block on the participant.  \n- `string` registerAtURL: The URL of the coordinator.  \n- `transactions:RemoteProtocol[]` participantProtocols: The coordination protocals supported by the participant.  \n  \n**Returns** `(transactions:TransactionContext|error)`   \n- TransactionContext if the registration is successful or an error in case of a failure.  \n  \n"}},"insertText":"registerParticipantWithRemoteInitiator(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1423, 27, -1, 'getParticipatedTransactionId', TRUE, FALSE, FALSE, '{"label":"getParticipatedTransactionId(string transactionId, string transactionBlockId)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getParticipatedTransactionId(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1424, 27, -1, 'getParticipantId', TRUE, FALSE, FALSE, '{"label":"getParticipantId(string transactionBlockId)(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getParticipantId(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1425, 27, -1, 'getAvailablePort', TRUE, FALSE, FALSE, '{"label":"getAvailablePort()(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `int`   \n  \n"}},"insertText":"getAvailablePort()","insertTextFormat":"Snippet"}'),
(1426, 27, -1, 'getHostAddress', TRUE, FALSE, FALSE, '{"label":"getHostAddress()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `string`   \n  \n"}},"insertText":"getHostAddress()","insertTextFormat":"Snippet"}'),
(1427, 27, -1, 'toProtocolArray', TRUE, FALSE, FALSE, '{"label":"toProtocolArray(transactions:RemoteProtocol[] remoteProtocols)((transactions:LocalProtocol|transactions:RemoteProtocol|())[])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(transactions:LocalProtocol|transactions:RemoteProtocol|())[]`   \n  \n"}},"insertText":"toProtocolArray(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1428, 27, -1, 'getCoordinationTypeToProtocolsMap', TRUE, FALSE, FALSE, '{"label":"getCoordinationTypeToProtocolsMap()(map\u003cstring[]\u003e)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `map\u003cstring[]\u003e`   \n  \n"}},"insertText":"getCoordinationTypeToProtocolsMap()","insertTextFormat":"Snippet"}'),
(1429, 27, -1, 'beginTransactionInitiator', TRUE, FALSE, FALSE, '{"label":"beginTransactionInitiator(string transactionBlockId, int rMax, function () returns (int) trxFunc, function () returns () retryFunc, function () returns () committedFunc, function () returns () abortedFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nHandles the transaction initiator block.\nTransaction initiator block will be desugared to following method.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n- `int` rMax: Max retry count.  \n- `function () returns (int)` trxFunc: Transaction main block function.  \n- `function () returns ()` retryFunc: On retry block function.  \n- `function () returns ()` committedFunc: Committed function.  \n- `function () returns ()` abortedFunc: Abort function."}},"insertText":"beginTransactionInitiator(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1430, 27, -1, 'beginLocalParticipant', TRUE, FALSE, FALSE, '{"label":"beginLocalParticipant(string transactionBlockId, function () returns ((any|error)) trxFunc, function (string) returns () committedFunc, function (string) returns () abortedFunc)((any|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nHandles the trahsaction local participant function.\nTransaction local participant function will be desugared to following method.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block.  \n- `function () returns ((any|error))` trxFunc: Participant logic.  \n- `function (string) returns ()` committedFunc: Committed function.  \n- `function (string) returns ()` abortedFunc: Abort function.  \n  \n**Returns** `(any|error)`   \n- Return value of the participant.  \n  \n"}},"insertText":"beginLocalParticipant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1431, 27, -1, 'beginRemoteParticipant', TRUE, FALSE, FALSE, '{"label":"beginRemoteParticipant(string transactionBlockId, function () returns ((any|error)) trxFunc, function (string) returns () committedFunc, function (string) returns () abortedFunc)((any|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nHandles the trahsaction remote participant function.\nTransaction remote participant function will be desugared to following method.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block.  \n- `function () returns ((any|error))` trxFunc: Participant logic.  \n- `function (string) returns ()` committedFunc: Committed function.  \n- `function (string) returns ()` abortedFunc: Abort function.  \n  \n**Returns** `(any|error)`   \n- Return value of the participant.  \n  \n"}},"insertText":"beginRemoteParticipant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1432, 27, -1, 'handleAbortTransaction', TRUE, FALSE, FALSE, '{"label":"handleAbortTransaction(string transactionId, string transactionBlockId, function () returns () abortedFunc)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"handleAbortTransaction(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1433, 27, -1, 'beginTransaction', TRUE, FALSE, FALSE, '{"label":"beginTransaction((string|()) transactionId, string transactionBlockId, string registerAtUrl, string coordinationType)((transactions:TransactionContext|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nWhen a transaction block in Ballerina code begins, it will call this function to begin a transaction.\nIf this is a new transaction (transactionId \u003d\u003d () ), then this instance will become the initiator and will\ncreate a new transaction context.\nIf the participant and initiator are in the same process, this transaction block will register with the local\ninitiator via a local function call.\nIf the participant and initiator are in different processes, this transaction block will register with the remote\ninitiator via a network call.\n  \n**Params**  \n- `(string|())` transactionId: Globally unique transaction ID. If this is a new transaction which is initiated, then this\n                  will be null.\n                  If this is a participant in an existing transaction, then it will have a value.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n- `string` registerAtUrl: The URL of the initiator  \n- `string` coordinationType: Coordination type of this transaction  \n  \n**Returns** `(transactions:TransactionContext|error)`   \n- Newly created/existing TransactionContext for this transaction.  \n  \n"}},"insertText":"beginTransaction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1434, 27, -1, 'abortTransaction', TRUE, FALSE, FALSE, '{"label":"abortTransaction(string transactionId, string transactionBlockId)((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nWhen an abort statement is executed, this function gets called.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `(()|error)`   \n- nil or error when transaction abortion is successful or not respectively.  \n  \n"}},"insertText":"abortTransaction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1435, 27, -1, 'endTransaction', TRUE, FALSE, FALSE, '{"label":"endTransaction(string transactionId, string transactionBlockId)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nWhen a transaction block in Ballerina code ends, it will call this function to end a transaction.\nEnding a transaction by a participant has no effect because it is the initiator who can decide whether to\ncommit or abort a transaction.\nDepending on the state of the transaction, the initiator decides to commit or abort the transaction.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `(string|error)`   \n- A string or an error representing the transaction end succcess status or failure respectively.  \n  \n"}},"insertText":"endTransaction(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1436, 27, -1, 'isInitiator', TRUE, FALSE, FALSE, '{"label":"isInitiator(string transactionId, string transactionBlockId)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nChecks whether this instance is an initiator. Returns true if initiator.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `boolean`   \n- true or false representing whether this instance is an intiator or not.  \n  \n"}},"insertText":"isInitiator(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1437, 27, -1, 'transactionParticipantWrapper', TRUE, FALSE, FALSE, '{"label":"transactionParticipantWrapper(function () returns ((any|error)) trxFunc)(transactions:ParticipantFunctionResult)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nWrapper function used to seperate panic and return error after calling participant function.\n  \n**Params**  \n- `function () returns ((any|error))` trxFunc: Participant logic.  \n  \n**Returns** `transactions:ParticipantFunctionResult`   \n- Return value of the participant.  \n  \n"}},"insertText":"transactionParticipantWrapper(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1438, 27, -1, 'prepareResourceManagers', TRUE, FALSE, FALSE, '{"label":"prepareResourceManagers(string transactionId, string transactionBlockId)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nPrepare local resource managers.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `boolean`   \n- true or false representing whether the resource manager preparation is successful or not.  \n  \n"}},"insertText":"prepareResourceManagers(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1439, 27, -1, 'commitResourceManagers', TRUE, FALSE, FALSE, '{"label":"commitResourceManagers(string transactionId, string transactionBlockId)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nCommit local resource managers.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `boolean`   \n- true or false representing whether the commit is successful or not.  \n  \n"}},"insertText":"commitResourceManagers(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');   
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1440, 27, -1, 'abortResourceManagers', TRUE, FALSE, FALSE, '{"label":"abortResourceManagers(string transactionId, string transactionBlockId)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nAbort local resource managers.\n  \n**Params**  \n- `string` transactionId: Globally unique transaction ID.  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n  \n**Returns** `boolean`   \n- true or false representing whether the resource manager abortion is successful or not.  \n  \n"}},"insertText":"abortResourceManagers(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1441, 27, -1, 'getCurrentTransactionId', FALSE, FALSE, FALSE, '{"label":"getCurrentTransactionId()(string)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nGet the current transaction id. This function is useful for user code to save state against a transaction ID,\nso that when the `oncommit` or `onabort` functions registered for a transaction can retrieve that state using the\ntransaction  that is passed in to those functions.\n  \n  \n  \n**Returns** `string`   \n- A string representing the ID of the current transaction.  \n  \n"}},"insertText":"getCurrentTransactionId()","insertTextFormat":"Snippet"}'),
(1442, 27, -1, 'isNestedTransaction', TRUE, FALSE, FALSE, '{"label":"isNestedTransaction()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nChecks whether the transaction is nested.\n  \n  \n  \n**Returns** `boolean`   \n- true or false representing whether the transaction is nested.  \n  \n"}},"insertText":"isNestedTransaction()","insertTextFormat":"Snippet"}'),
(1443, 27, -1, 'setTransactionContext', TRUE, FALSE, FALSE, '{"label":"setTransactionContext(transactions:TransactionContext transactionContext)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nSet the transactionContext.\n  \n**Params**  \n- `transactions:TransactionContext` transactionContext: Transaction context."}},"insertText":"setTransactionContext(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1444, 27, -1, 'registerLocalParticipant', TRUE, FALSE, FALSE, '{"label":"registerLocalParticipant(string transactionBlockId, function (string) returns () committedFunc, function (string) returns () abortedFunc)((transactions:TransactionContext|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nRegister local participant. Functions with participant annotations will be desugered to below functions.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n- `function (string) returns ()` committedFunc: Function pointer for commit function for participant.  \n- `function (string) returns ()` abortedFunc: Function pointer for abort function for participant.  \n  \n**Returns** `(transactions:TransactionContext|())`   \n- Transaction context.  \n  \n"}},"insertText":"registerLocalParticipant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1445, 27, -1, 'registerRemoteParticipant', TRUE, FALSE, FALSE, '{"label":"registerRemoteParticipant(string transactionBlockId, function (string) returns () committedFunc, function (string) returns () abortedFunc)((transactions:TransactionContext|()))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nRegister remote participant. Functions with participant annotations will be desugered to below functions.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block. Each transaction block in a process has a unique ID.  \n- `function (string) returns ()` committedFunc: Function pointer for commit function for participant.  \n- `function (string) returns ()` abortedFunc: Function pointer for abort function for participant.  \n  \n**Returns** `(transactions:TransactionContext|())`   \n- Transaction context.  \n  \n"}},"insertText":"registerRemoteParticipant(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');      
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1446, 27, -1, 'notifyLocalParticipantOnFailure', TRUE, FALSE, FALSE, '{"label":"notifyLocalParticipantOnFailure()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nNotify the transaction resource manager on local participant failture.  \n"}},"insertText":"notifyLocalParticipantOnFailure();","insertTextFormat":"Snippet"}'),
(1447, 27, -1, 'notifyRemoteParticipantOnFailure', TRUE, FALSE, FALSE, '{"label":"notifyRemoteParticipantOnFailure()","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nNotify the transaction resource manager on remote participant failture.  \n"}},"insertText":"notifyRemoteParticipantOnFailure();","insertTextFormat":"Snippet"}'),
(1448, 27, -1, 'notifyResourceManagerOnAbort', TRUE, FALSE, FALSE, '{"label":"notifyResourceManagerOnAbort(string transactionBlockId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nNotify the transaction resource manager on abort.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block."}},"insertText":"notifyResourceManagerOnAbort(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1449, 27, -1, 'rollbackTransaction', TRUE, FALSE, FALSE, '{"label":"rollbackTransaction(string transactionBlockId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nRollback the transaction.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block."}},"insertText":"rollbackTransaction(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1450, 27, -1, 'cleanupTransactionContext', TRUE, FALSE, FALSE, '{"label":"cleanupTransactionContext(string transactionBlockId)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nCleanup the transaction context.\n  \n**Params**  \n- `string` transactionBlockId: ID of the transaction block."}},"insertText":"cleanupTransactionContext(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1451, 27, -1, 'getAndClearFailure', TRUE, FALSE, FALSE, '{"label":"getAndClearFailure()(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nGet and Cleanup the failure.\n  \n  \n  \n**Returns** `boolean`   \n- is failed.  \n  \n"}},"insertText":"getAndClearFailure()","insertTextFormat":"Snippet"}'),
(1452, 27, 134, 'RemoteParticipant.prepare', TRUE, FALSE, TRUE, '{"label":"prepare(string protocol)([(prepared|aborted|committed|read-only|()|error),transactions:Participant])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `[(prepared|aborted|committed|read-only|()|error),transactions:Participant]`   \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1453, 27, 134, 'RemoteParticipant.notify', TRUE, FALSE, TRUE, '{"label":"notify(string action, (string|()) protocolName)((committed|aborted|()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(committed|aborted|()|error)`   \n  \n"}},"insertText":"notify(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1454, 27, 134, 'RemoteParticipant.prepareMe', TRUE, FALSE, TRUE, '{"label":"prepareMe(string protocolUrl)((prepared|aborted|committed|read-only|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(prepared|aborted|committed|read-only|error)`   \n  \n"}},"insertText":"prepareMe(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');        
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1455, 27, 134, 'RemoteParticipant.notifyMe', TRUE, FALSE, TRUE, '{"label":"notifyMe(string protocolUrl, string action)((committed|aborted|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(committed|aborted|error)`   \n  \n"}},"insertText":"notifyMe(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1456, 27, 134, 'RemoteParticipant.__init', TRUE, FALSE, TRUE, '{"label":"__init(string participantId, string transactionId, transactions:RemoteProtocol[] participantProtocols)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1457, 27, 135, 'LocalParticipant.prepare', TRUE, FALSE, TRUE, '{"label":"prepare(string protocol)([(prepared|aborted|committed|read-only|()|error),transactions:Participant])","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `[(prepared|aborted|committed|read-only|()|error),transactions:Participant]`   \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1458, 27, 135, 'LocalParticipant.prepareMe', TRUE, FALSE, TRUE, '{"label":"prepareMe(string transactionId, string transactionBlockId)((prepared|aborted|committed|read-only|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(prepared|aborted|committed|read-only|error)`   \n  \n"}},"insertText":"prepareMe(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1459, 27, 135, 'LocalParticipant.notify', TRUE, FALSE, TRUE, '{"label":"notify(string action, (string|()) protocolName)((committed|aborted|()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(committed|aborted|()|error)`   \n  \n"}},"insertText":"notify(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1460, 27, 135, 'LocalParticipant.notifyMe', TRUE, FALSE, TRUE, '{"label":"notifyMe(string action, string participatedTxnBlockId)((committed|aborted|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(committed|aborted|error)`   \n  \n"}},"insertText":"notifyMe(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1461, 27, 135, 'LocalParticipant.__init', TRUE, FALSE, TRUE, '{"label":"__init(string participantId, transactions:TwoPhaseCommitTransaction participatedTxn, transactions:LocalProtocol[] participantProtocols)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1462, 27, 136, 'TwoPhaseCommitTransaction.twoPhaseCommit', TRUE, FALSE, TRUE, '{"label":"twoPhaseCommit()((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(string|error)`   \n  \n"}},"insertText":"twoPhaseCommit()","insertTextFormat":"Snippet"}');            
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1463, 27, 136, 'TwoPhaseCommitTransaction.markForAbortion', TRUE, FALSE, TRUE, '{"label":"markForAbortion()((()|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nWhen an abort statement is executed, this function gets called. The transaction in concern will be marked for\nabortion.\n  \n  \n  \n**Returns** `(()|error)`   \n- error or nil retured when marking transaction for abortion is unsuccessful or successful  \n           respectively  \n  \n"}},"insertText":"markForAbortion()","insertTextFormat":"Snippet"}'),
(1464, 27, 136, 'TwoPhaseCommitTransaction.prepareParticipants', TRUE, FALSE, TRUE, '{"label":"prepareParticipants(string protocol)((commit|abort))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(commit|abort)`   \n  \n"}},"insertText":"prepareParticipants(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1465, 27, 136, 'TwoPhaseCommitTransaction.notifyParticipants', TRUE, FALSE, TRUE, '{"label":"notifyParticipants(string action, (string|()) protocolName)((committed|aborted|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(committed|aborted|error)`   \n  \n"}},"insertText":"notifyParticipants(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1466, 27, 136, 'TwoPhaseCommitTransaction.abortInitiatorTransaction', TRUE, FALSE, TRUE, '{"label":"abortInitiatorTransaction()((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(string|error)`   \n  \n"}},"insertText":"abortInitiatorTransaction()","insertTextFormat":"Snippet"}'),
(1467, 27, 136, 'TwoPhaseCommitTransaction.abortLocalParticipantTransaction', TRUE, FALSE, TRUE, '{"label":"abortLocalParticipantTransaction()((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \nThe participant should notify the initiator that it aborted. This function is called by the participant.\nThe initiator is remote.\n  \n  \n  \n**Returns** `(string|error)`   \n- An empty string or an error is returned when transaction abortion is successful or unsccuessful  \n           respectively  \n  \n"}},"insertText":"abortLocalParticipantTransaction()","insertTextFormat":"Snippet"}'),
(1468, 27, 136, 'TwoPhaseCommitTransaction.removeParticipant', TRUE, FALSE, TRUE, '{"label":"removeParticipant(string participantId, string failedMessage)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"removeParticipant(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1469, 27, 136, 'TwoPhaseCommitTransaction.__init', TRUE, FALSE, TRUE, '{"label":"__init(string transactionId, string transactionBlockId, string coordinationType)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1470, 27, 137, 'InitiatorClientEP.register', TRUE, TRUE, TRUE, '{"label":"register(string transactionId, string transactionBlockId, transactions:RemoteProtocol[] participantProtocols)((transactions:RegistrationResponse|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(transactions:RegistrationResponse|error)`   \n  \n"}},"insertText":"register(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');     
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1471, 27, 137, 'InitiatorClientEP.__init', TRUE, FALSE, TRUE, '{"label":"__init(transactions:InitiatorClientConfig conf)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1472, 27, 138, 'Participant2pcClientEP.prepare', FALSE, TRUE, TRUE, '{"label":"prepare(string transactionId)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(string|error)`   \n  \n"}},"insertText":"prepare(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1473, 27, 138, 'Participant2pcClientEP.notify', FALSE, TRUE, TRUE, '{"label":"notify(string transactionId, string message)((string|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n  \n  \n**Returns** `(string|error)`   \n  \n"}},"insertText":"notify(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1474, 27, 138, 'Participant2pcClientEP.__init', FALSE, FALSE, TRUE, '{"label":"__init(transactions:Participant2pcClientConfig c)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/transactions_  \n  \n  \n"}},"insertText":"__init(${1});","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1475, 28, -1, 'clone', TRUE, FALSE, FALSE, '{"label":"clone(any value)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nClone a given value.\n  \n**Params**  \n- `any` value: Value to be cloned  \n  \n**Returns** `(anydata|error)`   \n- Clone of the given value  \n  \n"}},"insertText":"clone(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1476, 28, -1, 'stamp', TRUE, FALSE, FALSE, '{"label":"stamp(typedesc\u003c(any|error)\u003e stampType, any value)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nStamp the value to given type.\n  \n**Params**  \n- `typedesc\u003c(any|error)\u003e` stampType: Type to be stamped  \n- `any` value: Value to be stamped  \n  \n**Returns** `(anydata|error)`   \n- Stamped value  \n  \n"}},"insertText":"stamp(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1477, 28, -1, 'convert', TRUE, FALSE, FALSE, '{"label":"convert(typedesc\u003c(any|error)\u003e convertType, any value)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nConvert value to given type which can be stampable.\n  \n**Params**  \n- `typedesc\u003c(any|error)\u003e` convertType: Type to be converted  \n- `any` value: Value to be converted  \n  \n**Returns** `(anydata|error)`   \n- Converted value  \n  \n"}},"insertText":"convert(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1478, 28, -1, 'simpleValueConvert', TRUE, FALSE, FALSE, '{"label":"simpleValueConvert(typedesc\u003c(any|error)\u003e convertType, any value)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nConvert simple value to given type.\n  \n**Params**  \n- `typedesc\u003c(any|error)\u003e` convertType: Type to be converted  \n- `any` value: Value to be converted  \n  \n**Returns** `(anydata|error)`   \n- Converted value  \n  \n"}},"insertText":"simpleValueConvert(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');              
INSERT INTO "PUBLIC"."BLANGFUNCTION" VALUES
(1479, 28, -1, 'freeze', TRUE, FALSE, FALSE, '{"label":"freeze((any|error) value)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nFreeze a given value.\n  \n**Params**  \n- `(any|error)` value: Value to be frozen  \n  \n**Returns** `(anydata|error)`   \n- Frozen value  \n  \n"}},"insertText":"freeze(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1480, 28, -1, 'isFrozen', TRUE, FALSE, FALSE, '{"label":"isFrozen((any|error) value)(boolean)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nCheck freeze status of given value.\n  \n**Params**  \n- `(any|error)` value: Value to check freeze status  \n  \n**Returns** `boolean`   \n- True for a frozen value  \n  \n"}},"insertText":"isFrozen(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1481, 28, -1, 'iterate', TRUE, FALSE, FALSE, '{"label":"iterate(any data)(any)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nGet a new Iterator\n  \n**Params**  \n- `any` data: Data collection  \n  \n**Returns** `any`   \n- Iterator for the given data  \n  \n"}},"insertText":"iterate(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1482, 28, -1, 'length', TRUE, FALSE, FALSE, '{"label":"length(anydata value)(int)","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nGet length of given value.\n  \n**Params**  \n- `anydata` value: Value to get the length  \n  \n**Returns** `int`   \n- Length of the given value  \n  \n"}},"insertText":"length(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}'),
(1483, 28, -1, 'next', TRUE, FALSE, FALSE, '{"label":"next(any iterator)((anydata|error))","kind":"Function","detail":"Function","documentation":{"right":{"kind":"markdown","value":"**Package:** _ballerina/utils_  \n  \nGet the next value of an iterator.\n  \n**Params**  \n- `any` iterator: Iterator  \n  \n**Returns** `(anydata|error)`   \n- Next value  \n  \n"}},"insertText":"next(${1})","insertTextFormat":"Snippet","command":{"title":"editor.action.triggerParameterHints","command":"editor.action.triggerParameterHints"}}');       
CREATE MEMORY TABLE "PUBLIC"."BLANGOBJECT"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_5965FBCA_B16F_436C_9148_DEFA039A9FF4") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_5965FBCA_B16F_436C_9148_DEFA039A9FF4",
    "PACKAGEID" INT NOT NULL,
    "NAME" VARCHAR(256) NOT NULL,
    "FIELDS" VARCHAR(256),
    "TYPE" INT DEFAULT '3' NOT NULL,
    "PRIVATE" BIT DEFAULT 1 NOT NULL,
    "COMPLETIONITEM" VARCHAR DEFAULT NULL
);        
ALTER TABLE "PUBLIC"."BLANGOBJECT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6" PRIMARY KEY("ID");   
-- 138 +/- SELECT COUNT(*) FROM PUBLIC.BLANGOBJECT;            
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(1, 1, 'InboundAuthProvider', '', 3, FALSE, '{"label":"InboundAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents the inbound Auth provider. Any type of implementation such as LDAP, JDBC, file-based etc.\nshould be object-wise similar."},"insertText":"InboundAuthProvider"}'),
(2, 1, 'InboundBasicAuthProvider', '', 3, FALSE, '{"label":"InboundBasicAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents an inbound basic Auth provider, which is a configuration-file-based Auth store provider.\n"},"insertText":"InboundBasicAuthProvider"}'),
(3, 1, 'OutboundAuthProvider', '', 3, FALSE, '{"label":"OutboundAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents the outbound Auth provider. Any type of implementation such as JWT and OAuth2 should be object-wise similar\nto the `OutboundAuthProvider` object."},"insertText":"OutboundAuthProvider"}'),
(4, 1, 'OutboundBasicAuthProvider', '', 3, FALSE, '{"label":"OutboundBasicAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents the outbound Basic Auth authenticator.\n"},"insertText":"OutboundBasicAuthProvider"}'),
(5, 2, 'Cache', '', 3, FALSE, '{"label":"Cache","kind":"Class","detail":"Object","documentation":{"left":"Represents a cache."},"insertText":"Cache"}'),
(6, 6, 'FileInfo', '', 3, FALSE, '{"label":"FileInfo","kind":"Class","detail":"Object","documentation":{"left":"FileInfo record contains metadata information of a file.\nThis record is returned by getFileInfo function is os module."},"insertText":"FileInfo"}'),
(7, 8, 'Caller', '', 1, FALSE, '{"label":"Caller","kind":"Class","detail":"Object","documentation":{"left":"Provides the gRPC remote functions for interacting with caller.\n"},"insertText":"Caller"}'),
(8, 8, 'ConnectionManager', '', 3, TRUE, '{"label":"ConnectionManager","kind":"Class","detail":"Object","insertText":"ConnectionManager"}'),
(9, 8, 'Client', '', 1, FALSE, '{"label":"Client","kind":"Class","detail":"Object","documentation":{"left":"The gRPC client endpoint provides the capability for initiating contact with a remote gRPC service. The API it\nprovides includes functions to send request/error messages."},"insertText":"Client"}'),
(10, 8, 'AbstractClientEndpoint', '', 3, FALSE, '{"label":"AbstractClientEndpoint","kind":"Class","detail":"Object","documentation":{"left":"Represents gRPC client endpoint generated by the protobuf tool."},"insertText":"AbstractClientEndpoint"}'),
(11, 8, 'Headers', '', 3, FALSE, '{"label":"Headers","kind":"Class","detail":"Object","documentation":{"left":"Provides actions to read/write header values in gRPC request/response message."},"insertText":"Headers"}'),
(12, 8, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"Represents server listener where one or more services can be registered. so that ballerina program can offer\nservice through this listener."},"insertText":"Listener"}'),
(13, 8, 'StreamingClient', '', 1, FALSE, '{"label":"StreamingClient","kind":"Class","detail":"Object","documentation":{"left":"Provides the gRPC actions for interacting with gRPC server."},"insertText":"StreamingClient"}'),
(14, 9, 'AuthnFilter', '', 3, FALSE, '{"label":"AuthnFilter","kind":"Class","detail":"Object","documentation":{"left":"Representation of the Authentication filter.\n"},"insertText":"AuthnFilter"}'),
(15, 9, 'AuthzFilter', '', 3, FALSE, '{"label":"AuthzFilter","kind":"Class","detail":"Object","documentation":{"left":"Representation of the Authorization filter\n"},"insertText":"AuthzFilter"}'),
(16, 9, 'AuthzHandler', '', 3, FALSE, '{"label":"AuthzHandler","kind":"Class","detail":"Object","documentation":{"left":"Representation of Authorization Handler for HTTP.\n"},"insertText":"AuthzHandler"}'),
(17, 9, 'InboundAuthHandler', '', 3, FALSE, '{"label":"InboundAuthHandler","kind":"Class","detail":"Object","documentation":{"left":"The representation of an inbound authentication handler for HTTP traffic."},"insertText":"InboundAuthHandler"}');             
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(18, 9, 'OutboundAuthHandler', '', 3, FALSE, '{"label":"OutboundAuthHandler","kind":"Class","detail":"Object","documentation":{"left":"The representation of an outbound authentication handler for HTTP traffic."},"insertText":"OutboundAuthHandler"}'),
(19, 9, 'RequestCacheControl', '', 3, FALSE, '{"label":"RequestCacheControl","kind":"Class","detail":"Object","documentation":{"left":"Configures cache control directives for a `Request`.\n"},"insertText":"RequestCacheControl"}'),
(20, 9, 'ResponseCacheControl', '', 3, FALSE, '{"label":"ResponseCacheControl","kind":"Class","detail":"Object","documentation":{"left":"Configures cache control directives for a `Response`.\n"},"insertText":"ResponseCacheControl"}'),
(21, 9, 'HttpCache', '', 3, FALSE, '{"label":"HttpCache","kind":"Class","detail":"Object","documentation":{"left":"Implements a cache for storing HTTP responses. This cache complies with the caching policy set when configuring\nHTTP caching in the HTTP client endpoint.\n"},"insertText":"HttpCache"}'),
(22, 9, 'HttpCachingClient', '', 1, FALSE, '{"label":"HttpCachingClient","kind":"Class","detail":"Object","documentation":{"left":"An HTTP caching client implementation which takes an `HttpActions` instance and wraps it with an HTTP caching layer.\n"},"insertText":"HttpCachingClient"}'),
(23, 9, 'Client', '', 1, FALSE, '{"label":"Client","kind":"Class","detail":"Object","documentation":{"left":"The HTTP client provides the capability for initiating contact with a remote HTTP service. The API it\nprovides includes functions for the standard HTTP methods, forwarding a received request and sending requests\nusing custom HTTP verbs."},"insertText":"Client"}'),
(24, 9, 'HttpFuture', '', 3, FALSE, '{"label":"HttpFuture","kind":"Class","detail":"Object","documentation":{"left":"Represents a \u0027future\u0027 that returns as a result of an asynchronous HTTP request submission.\nThis can be used as a reference to fetch the results of the submission."},"insertText":"HttpFuture"}'),
(25, 9, 'PushPromise', '', 3, FALSE, '{"label":"PushPromise","kind":"Class","detail":"Object","documentation":{"left":"Represents an HTTP/2 `PUSH_PROMISE` frame.\n"},"insertText":"PushPromise"}'),
(26, 9, 'HttpClient', '', 1, FALSE, '{"label":"HttpClient","kind":"Class","detail":"Object","documentation":{"left":"Provides the HTTP actions for interacting with an HTTP server. Apart from the standard HTTP methods, `forward()`\nand `execute()` functions are provided. More complex and specific endpoint types can be created by wrapping this\ngeneric HTTP actions implementation.\n"},"insertText":"HttpClient"}'),
(27, 9, 'ConnectionManager', '', 3, TRUE, '{"label":"ConnectionManager","kind":"Class","detail":"Object","insertText":"ConnectionManager"}'),
(28, 9, 'Caller', '', 1, FALSE, '{"label":"Caller","kind":"Class","detail":"Object","documentation":{"left":"The caller actions for responding to client requests.\n"},"insertText":"Caller"}'),
(29, 9, 'RequestFilter', '', 3, FALSE, '{"label":"RequestFilter","kind":"Class","detail":"Object","documentation":{"left":"Abstract Representation of a HTTP Request Filter.\nThis filter will be applied before the request is dispatched to the relevant resource.\nAny RequestFilter implementation should be structurally similar to or implement the RequestFilter object."},"insertText":"RequestFilter"}'),
(30, 9, 'ResponseFilter', '', 3, FALSE, '{"label":"ResponseFilter","kind":"Class","detail":"Object","documentation":{"left":"Abstract Representation of a HTTP Response Filter.\nThis filter will be applied in the response path.\nAny ResponseFilter implementation should be structurally similar to or implement the ResponseFilter object."},"insertText":"ResponseFilter"}'),
(31, 9, 'FilterContext', '', 3, FALSE, '{"label":"FilterContext","kind":"Class","detail":"Object","documentation":{"left":"Representation of request filter Context.\n"},"insertText":"FilterContext"}'),
(32, 9, 'Request', '', 3, FALSE, '{"label":"Request","kind":"Class","detail":"Object","documentation":{"left":"Represents an HTTP request.\n"},"insertText":"Request"}');               
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(33, 9, 'Response', '', 3, FALSE, '{"label":"Response","kind":"Class","detail":"Object","documentation":{"left":"Represents an HTTP response.\n"},"insertText":"Response"}'),
(34, 9, 'HttpSecureClient', '', 1, FALSE, '{"label":"HttpSecureClient","kind":"Class","detail":"Object","documentation":{"left":"Provides secure HTTP remote functions for interacting with HTTP endpoints. This will make use of the authentication\nschemes configured in the HTTP client endpoint to secure the HTTP requests.\n"},"insertText":"HttpSecureClient"}'),
(35, 9, 'MockListener', '', 3, FALSE, '{"label":"MockListener","kind":"Class","detail":"Object","documentation":{"left":"Mock server endpoint which does not open a listening port."},"insertText":"MockListener"}'),
(36, 9, 'RedirectClient', '', 1, FALSE, '{"label":"RedirectClient","kind":"Class","detail":"Object","documentation":{"left":"Provides redirect functionality for HTTP client remote functions.\n"},"insertText":"RedirectClient"}'),
(37, 9, 'FailoverClient', '', 1, FALSE, '{"label":"FailoverClient","kind":"Class","detail":"Object","documentation":{"left":"An HTTP client endpoint which provides failover support over multiple HTTP clients.\n"},"insertText":"FailoverClient"}'),
(38, 9, 'CircuitBreakerClient', '', 1, FALSE, '{"label":"CircuitBreakerClient","kind":"Class","detail":"Object","documentation":{"left":"A Circuit Breaker implementation which can be used to gracefully handle network failures.\n"},"insertText":"CircuitBreakerClient"}'),
(39, 9, 'LoadBalancerRule', '', 3, FALSE, '{"label":"LoadBalancerRule","kind":"Class","detail":"Object","documentation":{"left":"\nLoadBalancerRule provides a required interfaces to implement different algorithms.\n"},"insertText":"LoadBalancerRule"}'),
(40, 9, 'RetryClient', '', 1, FALSE, '{"label":"RetryClient","kind":"Class","detail":"Object","documentation":{"left":"Provides the HTTP remote functions for interacting with an HTTP endpoint. This is created by wrapping the HTTP client\nto provide retrying over HTTP requests.\n"},"insertText":"RetryClient"}'),
(41, 9, 'LoadBalancerRounRobinRule', '', 3, FALSE, '{"label":"LoadBalancerRounRobinRule","kind":"Class","detail":"Object","documentation":{"left":"Implementation of round robin load balancing strategy.\n"},"insertText":"LoadBalancerRounRobinRule"}'),
(42, 9, 'LoadBalanceClient', '', 1, FALSE, '{"label":"LoadBalanceClient","kind":"Class","detail":"Object","documentation":{"left":"LoadBalanceClient endpoint provides load balancing functionality over multiple HTTP clients.\n"},"insertText":"LoadBalanceClient"}'),
(43, 9, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"This is used for creating HTTP server endpoints. An HTTP server endpoint is capable of responding to\nremote callers. The `Listener` is responsible for initializing the endpoint using the provided configurations."},"insertText":"Listener"}'),
(44, 9, 'AttributeFilter', '', 3, TRUE, '{"label":"AttributeFilter","kind":"Class","detail":"Object","insertText":"AttributeFilter"}'),
(45, 9, 'WebSocketListener', '', 3, FALSE, '{"label":"WebSocketListener","kind":"Class","detail":"Object","documentation":{"left":"Represents a WebSocket service endpoint."},"insertText":"WebSocketListener"}'),
(46, 9, 'WebSocketCaller', '', 1, FALSE, '{"label":"WebSocketCaller","kind":"Class","detail":"Object","documentation":{"left":"Represents a WebSocket caller."},"insertText":"WebSocketCaller"}'),
(47, 9, 'WebSocketClient', '', 1, FALSE, '{"label":"WebSocketClient","kind":"Class","detail":"Object","documentation":{"left":"Represents a WebSocket client endpoint."},"insertText":"WebSocketClient"}'),
(48, 9, 'WebSocketConnector', '', 3, TRUE, '{"label":"WebSocketConnector","kind":"Class","detail":"Object","documentation":{"left":"Represents a WebSocket connection in Ballerina. This includes all connection-oriented operations."},"insertText":"WebSocketConnector"}'),
(49, 9, 'BasicAuthHandler', '', 3, FALSE, '{"label":"BasicAuthHandler","kind":"Class","detail":"Object","documentation":{"left":"Defines the Basic Auth header handler for inbound and outbound HTTP traffic.\n"},"insertText":"BasicAuthHandler"}');
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(50, 9, 'BearerAuthHandler', '', 3, FALSE, '{"label":"BearerAuthHandler","kind":"Class","detail":"Object","documentation":{"left":"Representation of the Bearer Auth header handler for both inbound and outbound HTTP traffic.\n"},"insertText":"BearerAuthHandler"}'),
(51, 10, 'ReadableByteChannel', '', 3, FALSE, '{"label":"ReadableByteChannel","kind":"Class","detail":"Object","documentation":{"left":"ReadableByteChannel represents an input resource (i.e file, socket). which could be used to source bytes."},"insertText":"ReadableByteChannel"}'),
(52, 10, 'ReadableCharacterChannel', '', 3, FALSE, '{"label":"ReadableCharacterChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a channel which could be used to read characters through a given ReadableByteChannel."},"insertText":"ReadableCharacterChannel"}'),
(53, 10, 'ReadableCSVChannel', '', 3, FALSE, '{"label":"ReadableCSVChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a ReadableCSVChannel which could be used to read records from CSV file."},"insertText":"ReadableCSVChannel"}'),
(54, 10, 'ReadableDataChannel', '', 3, FALSE, '{"label":"ReadableDataChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a data channel for reading data."},"insertText":"ReadableDataChannel"}'),
(55, 10, 'ReadableTextRecordChannel', '', 3, FALSE, '{"label":"ReadableTextRecordChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a channel which will allow to read"},"insertText":"ReadableTextRecordChannel"}'),
(56, 10, 'StringReader', '', 3, FALSE, '{"label":"StringReader","kind":"Class","detail":"Object","documentation":{"left":"Represents a reader which will wrap string content as a channel."},"insertText":"StringReader"}'),
(57, 10, 'WritableByteChannel', '', 3, FALSE, '{"label":"WritableByteChannel","kind":"Class","detail":"Object","documentation":{"left":"WritableByteChannel represents an output resource (i.e file, socket). which could be used to sink bytes."},"insertText":"WritableByteChannel"}'),
(58, 10, 'WritableCharacterChannel', '', 3, FALSE, '{"label":"WritableCharacterChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a channel which could be used to write characters through a given WritableCharacterChannel."},"insertText":"WritableCharacterChannel"}'),
(59, 10, 'WritableCSVChannel', '', 3, FALSE, '{"label":"WritableCSVChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a WritableCSVChannel which could be used to write records from CSV file."},"insertText":"WritableCSVChannel"}'),
(60, 10, 'WritableDataChannel', '', 3, FALSE, '{"label":"WritableDataChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a WritableDataChannel for writing data."},"insertText":"WritableDataChannel"}'),
(61, 10, 'WritableTextRecordChannel', '', 3, FALSE, '{"label":"WritableTextRecordChannel","kind":"Class","detail":"Object","documentation":{"left":"Represents a channel which will allow to write records through a given WritableCharacterChannel."},"insertText":"WritableTextRecordChannel"}'),
(62, 11, 'InboundJwtAuthProvider', '', 3, FALSE, '{"label":"InboundJwtAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents inbound JWT auth provider.\n"},"insertText":"InboundJwtAuthProvider"}'),
(63, 11, 'OutboundJwtAuthProvider', '', 3, FALSE, '{"label":"OutboundJwtAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents outbound JWT authenticator.\n"},"insertText":"OutboundJwtAuthProvider"}'),
(64, 12, 'InboundLdapAuthProvider', '', 3, FALSE, '{"label":"InboundLdapAuthProvider","kind":"Class","detail":"Object","documentation":{"left":"Represents Ballerina configuration for LDAP based auth provider.\n"},"insertText":"InboundLdapAuthProvider"}'),
(65, 15, 'Message', '', 3, FALSE, '{"label":"Message","kind":"Class","detail":"Object","documentation":{"left":"Represents a message, which will be pushed from the NATS server to the consumer."},"insertText":"Message"}');    
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(66, 15, 'Producer', '', 1, FALSE, '{"label":"Producer","kind":"Class","detail":"Object","documentation":{"left":"NATS producer would act as a basic client allowing to publish messages to the NATS server.\nProducer needs the NATS connection to be initialized."},"insertText":"Producer"}'),
(67, 15, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"Represents a connection which will be used for subscription."},"insertText":"Listener"}'),
(68, 15, 'Connection', '', 3, FALSE, '{"label":"Connection","kind":"Class","detail":"Object","documentation":{"left":"Represents a NATS connection."},"insertText":"Connection"}'),
(69, 15, 'StreamingListener', '', 3, FALSE, '{"label":"StreamingListener","kind":"Class","detail":"Object","documentation":{"left":"Represents the NATS Streaming Server connection, to which a subscription service should be bound to in order to receive messages\nof the corresponding subscription."},"insertText":"StreamingListener"}'),
(70, 15, 'StreamingMessage', '', 1, FALSE, '{"label":"StreamingMessage","kind":"Class","detail":"Object","documentation":{"left":"Represents the message a NATS Streaming Server sends to a subscription service."},"insertText":"StreamingMessage"}'),
(71, 15, 'StreamingProducer', '', 1, FALSE, '{"label":"StreamingProducer","kind":"Class","detail":"Object","insertText":"StreamingProducer"}'),
(72, 16, 'Channel', '', 1, FALSE, '{"label":"Channel","kind":"Class","detail":"Object","documentation":{"left":"Public Ballerina API - Ballerina interface to an AMQP `Channel`.\nTo provide AMQ `Channel` related functionalities.\n"},"insertText":"Channel"}'),
(73, 16, 'Connection', '', 3, FALSE, '{"label":"Connection","kind":"Class","detail":"Object","documentation":{"left":"Public Ballerina API - Interface to an AMQ `Connection`."},"insertText":"Connection"}'),
(74, 16, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"Public Ballerina API - Ballerina RabbitMQ Message Listener.\nTo provide a listener to consume messages from RabbitMQ.\n"},"insertText":"Listener"}'),
(75, 16, 'Message', '', 1, FALSE, '{"label":"Message","kind":"Class","detail":"Object","documentation":{"left":"Public Ballerina API - Ballerina RabbitMQ Message."},"insertText":"Message"}'),
(76, 17, 'ContentDisposition', '', 3, FALSE, '{"label":"ContentDisposition","kind":"Class","detail":"Object","documentation":{"left":"Represents values in `Content-Disposition` header.\n"},"insertText":"ContentDisposition"}'),
(77, 17, 'MediaType', '', 3, FALSE, '{"label":"MediaType","kind":"Class","detail":"Object","documentation":{"left":"Describes the nature of the data in the body of a MIME entity.\n"},"insertText":"MediaType"}'),
(78, 17, 'Entity', '', 3, FALSE, '{"label":"Entity","kind":"Class","detail":"Object","documentation":{"left":"Represents the headers and body of a message. This can be used to represent both the entity of a top level message\nand an entity(body part) inside of a multipart entity.\n"},"insertText":"Entity"}'),
(79, 18, 'InboundOAuth2Provider', '', 3, FALSE, '{"label":"InboundOAuth2Provider","kind":"Class","detail":"Object","documentation":{"left":"Represents inbound OAuth2 provider, which calls the introspection server and validate the received credentials.\n"},"insertText":"InboundOAuth2Provider"}'),
(80, 18, 'OutboundOAuth2Provider', '', 3, FALSE, '{"label":"OutboundOAuth2Provider","kind":"Class","detail":"Object","documentation":{"left":"Represents outbound OAuth2 provider.\n"},"insertText":"OutboundOAuth2Provider"}'),
(81, 21, 'Client', '', 1, FALSE, '{"label":"Client","kind":"Class","detail":"Object","documentation":{"left":"Represents socket client and related remote functions.\n"},"insertText":"Client"}'),
(82, 21, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"Represents service endpoint where socket server service registered and start.\n"},"insertText":"Listener"}'),
(83, 21, 'Caller', '', 1, FALSE, '{"label":"Caller","kind":"Class","detail":"Object","documentation":{"left":"Represents caller object in socket service resources and client callback service resources.\nThis has all the remote functions expose by socket:Client."},"insertText":"Caller"}');    
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(84, 21, 'UdpClient', '', 1, FALSE, '{"label":"UdpClient","kind":"Class","detail":"Object","documentation":{"left":"Represents UDP socket client and related remote functions.\n"},"insertText":"UdpClient"}'),
(85, 22, 'Aggregator', '', 3, FALSE, '{"label":"Aggregator","kind":"Class","detail":"Object","documentation":{"left":"Abstract object, which should be implemented in order to create a new aggregator."},"insertText":"Aggregator"}'),
(86, 22, 'AbstractOperatorProcessor', '', 3, FALSE, '{"label":"AbstractOperatorProcessor","kind":"Class","detail":"Object","documentation":{"left":"Abstract processor encapsulating operator functions.\n"},"insertText":"AbstractOperatorProcessor"}'),
(87, 22, 'AbstractPatternProcessor', '', 3, FALSE, '{"label":"AbstractPatternProcessor","kind":"Class","detail":"Object","documentation":{"left":"Abstract processor encapsulating pattern processor functions.\n"},"insertText":"AbstractPatternProcessor"}'),
(88, 22, 'AndOperatorProcessor', '', 3, FALSE, '{"label":"AndOperatorProcessor","kind":"Class","detail":"Object","documentation":{"left":"Processor to perform AND stream operations.\n"},"insertText":"AndOperatorProcessor"}'),
(89, 22, 'CompoundPatternProcessor', '', 3, FALSE, '{"label":"CompoundPatternProcessor","kind":"Class","detail":"Object","documentation":{"left":"Processor to perform compound stream operations.\n"},"insertText":"CompoundPatternProcessor"}'),
(90, 22, 'FollowedByProcessor', '', 3, FALSE, '{"label":"FollowedByProcessor","kind":"Class","detail":"Object","documentation":{"left":"Processor to perform FollowedBy stream operations.\n"},"insertText":"FollowedByProcessor"}'),
(91, 22, 'NotOperatorProcessor', '', 3, FALSE, '{"label":"NotOperatorProcessor","kind":"Class","detail":"Object","insertText":"NotOperatorProcessor"}'),
(92, 22, 'OperandProcessor', '', 3, FALSE, '{"label":"OperandProcessor","kind":"Class","detail":"Object","documentation":{"left":"Processor to perform operand processor operations.\n"},"insertText":"OperandProcessor"}'),
(93, 22, 'OrOperatorProcessor', '', 3, FALSE, '{"label":"OrOperatorProcessor","kind":"Class","detail":"Object","documentation":{"left":"Processor to perform OR stream operations.\n"},"insertText":"OrOperatorProcessor"}'),
(94, 22, 'StateMachine', '', 3, FALSE, '{"label":"StateMachine","kind":"Class","detail":"Object","documentation":{"left":"StateMachine which performs stream pattern processing.\n"},"insertText":"StateMachine"}'),
(95, 22, 'Filter', '', 3, FALSE, '{"label":"Filter","kind":"Class","detail":"Object","documentation":{"left":"The ` Filter` object represents the `where` clause in a streaming query. This object takes two parameter for\ninitialization. `nextProcessorPointer` is the function pointer of the next processor to be invoked once the\nfiltering is complete. conditionFunc is a function pointer which return true if the given where clause evaluates to\ntrue."},"insertText":"Filter"}'),
(96, 22, 'OrderBy', '', 3, FALSE, '{"label":"OrderBy","kind":"Class","detail":"Object","documentation":{"left":"The `OrderBy` object represents the desugared code of `order by` clause of a streaming query. This object takes 3\nparameters to initialize itself. `nextProcessPointer` is the `process` method of the next processor. `fieldFuncs`\nis an array of function pointers which returns the field values to be sorted. `sortTypes` is an array of string\nspecifying whether the sort order (ascending or descending). Internally this processor uses a `MergeSort` object\nto sort.\n"},"insertText":"OrderBy"}'),
(97, 22, 'MergeSort', '', 3, FALSE, '{"label":"MergeSort","kind":"Class","detail":"Object","documentation":{"left":"This object implements the merge sort algorithm to sort the provided value arrays. `fieldFuncs` are function pointers\nwhich returns the field values of each stream event\u0027s `data` map\u0027s values. `sortTypes` are an array of (\nstreams:ASCENDING or streams:DESCENDING).\n"},"insertText":"MergeSort"}'),
(98, 22, 'OutputProcess', '', 3, FALSE, '{"label":"OutputProcess","kind":"Class","detail":"Object","documentation":{"left":"The `OutputProcess` object is responsible for sending the output (only the events of type `streams:CURRENT` to the\ndestination stream. It takes a function pointer `outputFunc` which actually has the logic to process the output."},"insertText":"OutputProcess"}'); 
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(99, 22, 'Select', '', 3, FALSE, '{"label":"Select","kind":"Class","detail":"Object","documentation":{"left":"The `Select` object represents the select clause. Anything that comes under select clause like aggregator function\ninvocations are also handled in this processor. Further, grouping of the events (provided by the groupby clause) is\nalso performed in this processor. `aggregatorArr` is an array of aggregators which are used in the select clause.\n`groupbyFuncArray` is an array of function pointers which returns the values being grouped. `selectFunc` is a\nfunction pointer to a lambda function which creates the `data` field of the output stream event. `scopeName` is\nused as a breadcrumb to identify the select clause if there are multiple `forever` blocks."},"insertText":"Select"}'),
(100, 22, 'StreamJoinProcessor', '', 3, FALSE, '{"label":"StreamJoinProcessor","kind":"Class","detail":"Object","documentation":{"left":"The `StreamJoinProcessor` object is responsible for  performing SQLish joins between two or more streams.\nThe `onConditionFunc` is the lambda function which represents the where clause in the join clause. The joining\nhappens only if the condition is statified. `nextProcessor` is the `process` function of the next processor, which\ncan be a `Select` processor, `Aggregator` processor, `Having` processor.. etc. The `lhsStream` is the left hand side\nstream of the join and its attached window is `\u0027lhsWindow`. The `rhsStream` is the right hand side stream of the join\nand its attached window is `\u0027rhsWindow`. The `unidirectionalStream` stream defines the stream by which the joining is\ntriggered when the events are received. Usually it is `lhsStream`, in rare cases it can be `rhsStream`. The\n`joinType` is the type of the join and it can be any value defined by `streams:JoinType`.\n"},"insertText":"StreamJoinProcessor"}'),
(101, 22, 'TableJoinProcessor', '', 3, FALSE, '{"label":"TableJoinProcessor","kind":"Class","detail":"Object","documentation":{"left":"The `TableJoinProcessor` object handles joining streams with in-memory tables in ballerina.\n`nextProcessor` is the `process` function of the next processor, which can be a `Select` processor, `Aggregator`\nprocessor, `Having` processor.. etc. The `streamName` is the stream of the join and its attached\nwindow is `\u0027windowInstance`. The `tableName` is the name of the table with which the stream is joined. The\n`joinType` is the type of the join and it can be any value defined by `streams:JoinType`.\n"},"insertText":"TableJoinProcessor"}'),
(102, 22, 'Node', '', 3, FALSE, '{"label":"Node","kind":"Class","detail":"Object","documentation":{"left":"The `Node` object represents a node in the linkedlist data structure.\n"},"insertText":"Node"}'),
(103, 22, 'LinkedList', '', 3, FALSE, '{"label":"LinkedList","kind":"Class","detail":"Object","documentation":{"left":"The `LinkedList` object which represents the linked list data structure.\n"},"insertText":"LinkedList"}'),
(104, 22, 'IntSort', '', 3, FALSE, '{"label":"IntSort","kind":"Class","detail":"Object","documentation":{"left":"This class implements a merge sort algorithm to sort timestamp values for state persistence."},"insertText":"IntSort"}'),
(105, 22, 'Scheduler', '', 3, FALSE, '{"label":"Scheduler","kind":"Class","detail":"Object","documentation":{"left":"The `Scheduler` object is responsible for generating streams:TIMER events at the given timestamp. Once the event is\ngenerated, the timer event is passed to the provided `processFunc` function pointer. The function pointer is the\n`process` function of the target processor, to which the timer event should be sent."},"insertText":"Scheduler"}'),
(106, 22, 'Snapshotable', '', 3, FALSE, '{"label":"Snapshotable","kind":"Class","detail":"Object","documentation":{"left":"Abstract Snapshotable to be referenced by all snapshotable objects."},"insertText":"Snapshotable"}'),
(107, 22, 'StreamEvent', '', 3, FALSE, '{"label":"StreamEvent","kind":"Class","detail":"Object","documentation":{"left":"The `StreamEvent` object is a wrapper around the actual data being received to the input stream. If a record is\nreceive to a input stream, that record is converted to a map of anydata values and set that map to a field called\n`data` in a new `StreamEvent` object. `StreamEvent` is only used internally to transmit event data from one\nprocessor to another processor. At the time the record is converted to a map, the timestamp is set. If the record\nis first received by the input stream, the eventType is set to streams:CURRENT. Other than stream events of type\nstreams:CURRENT, there are 3 types of StreamEvents. They are streams:EXPIRED, streams:RESET, streams:TIMER. An expired\nevent is used to remove the state of its respective current event. A reset event is used to completely wipe the\nstate and a timer event is used to trigger the `process` method of a particular processor in timely manner.\n"},"insertText":"StreamEvent"}');              
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(108, 22, 'Window', '', 3, FALSE, '{"label":"Window","kind":"Class","detail":"Object","documentation":{"left":"The `Window` abstract objects is the base object for implementing windows in Ballerina streams. The `process`\nfunction contains the logic of processing events when events are received. `getCandidateEvents` function is used\ninside the `Select` object to return the events in the window to perform joining.\nThe window names in the window objects cannot be used in the queries. Always a function which returns the specific\nwindow has to be used in streaing query.\nE.g. If `LengthWindow` has to be used in a streaming query, the function `streams:length` has to be used for\nstreaming  query without the module identifier `streams`. An example is shown below.\n\n      from inputStream window `length`(5)\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }"},"insertText":"Window"}'),
(109, 22, 'Average', '', 3, FALSE, '{"label":"Average","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to calculate average in streams.\n"},"insertText":"Average"}'),
(110, 22, 'Count', '', 3, FALSE, '{"label":"Count","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to count events in streams.\n"},"insertText":"Count"}'),
(111, 22, 'DistinctCount', '', 3, FALSE, '{"label":"DistinctCount","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to get the distinct counts of values in streams.\n"},"insertText":"DistinctCount"}'),
(112, 22, 'Max', '', 3, FALSE, '{"label":"Max","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to find the maximum value in a stream.\n"},"insertText":"Max"}'),
(113, 22, 'MaxForever', '', 3, FALSE, '{"label":"MaxForever","kind":"Class","detail":"Object","documentation":{"left":"The aggregator to keep the maximum value received so far. It is similar to `Max` aggregator, but it keeps the maximum\nvalue it received so far, forever.\n"},"insertText":"MaxForever"}'),
(114, 22, 'Min', '', 3, FALSE, '{"label":"Min","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to find the minimum value in a stream.\n"},"insertText":"Min"}'),
(115, 22, 'MinForever', '', 3, FALSE, '{"label":"MinForever","kind":"Class","detail":"Object","documentation":{"left":"The aggregator to keep the minimum value received so far. It is similar to `Min` aggregator, but it keeps the minimum\nvalue it received so far, forever.\n"},"insertText":"MinForever"}'),
(116, 22, 'StdDev', '', 3, FALSE, '{"label":"StdDev","kind":"Class","detail":"Object","documentation":{"left":"The aggregator object to calculate standard deviation.\n"},"insertText":"StdDev"}'),
(117, 22, 'Sum', '', 3, FALSE, '{"label":"Sum","kind":"Class","detail":"Object","documentation":{"left":"Aggregator to perform summation of values in a stream.\n"},"insertText":"Sum"}'),
(118, 22, 'DelayWindow', '', 3, FALSE, '{"label":"DelayWindow","kind":"Class","detail":"Object","documentation":{"left":"This window will delay the incoming events for a given amount of time.\nE.g.\n      from inputStream window `delay(4000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `delay` window should only have one parameter (\u003cint\u003e delayTime)\n"},"insertText":"DelayWindow"}'),
(119, 22, 'ExternalTimeBatchWindow', '', 3, FALSE, '{"label":"ExternalTimeBatchWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a batch (tumbling) time window based on external time, that holds events arrived during window time periods,\nand gets updated for every window time.\nE.g.\n      from inputStream window `externalTimeBatch(inputStream.timestamp, 1000, 500, 1200, true)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `externalTimeBatch` window should only have two to five parameters (timestamp field, \u003cint\u003e windowTime, \u003cint\u003e\nstartTime, \u003cint\u003e timeout, \u003cboolean\u003e replaceTimestampWithBatchEndTime)\n"},"insertText":"ExternalTimeBatchWindow"}');             
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(120, 22, 'ExternalTimeWindow', '', 3, FALSE, '{"label":"ExternalTimeWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a sliding time window based on external time, that holds events for that arrived during last window time\nperiod from the external timestamp, and gets updated on every monotonically increasing timestamp.\nE.g.\n      from inputStream window `externalTime(inputStream.timestamp, 4000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `externalTime` window should only have two parameters (timestamp field, \u003cint\u003e windowTime)\n"},"insertText":"ExternalTimeWindow"}'),
(121, 22, 'HoppingWindow', '', 3, FALSE, '{"label":"HoppingWindow","kind":"Class","detail":"Object","documentation":{"left":"The hopping window releases the events in batches defined by a time period every given time interval. The batch is\nalso determined by  the time period given in the window. When the time interval the events being released and the\ntime period it hold the events are equal, the hopping window acts as a `TimeBatch` window.\nE.g.\n      from inputStream window `hopping(5000, 4000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nHopping window should only have two parameters (\u003cint\u003e windowTime, \u003cint\u003e hoppingTime)\n"},"insertText":"HoppingWindow"}'),
(122, 22, 'LengthBatchWindow', '', 3, FALSE, '{"label":"LengthBatchWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a batch (tumbling) length window, that holds up to the given length of events, and gets updated on every\ngiven number of events arrival.\nE.g.\n      from inputStream window `lengthBatch(5)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `lengthBatch` window should only have one parameter (\u003cint\u003e windowBatchLength)\n"},"insertText":"LengthBatchWindow"}'),
(123, 22, 'LengthWindow', '', 3, FALSE, '{"label":"LengthWindow","kind":"Class","detail":"Object","documentation":{"left":"The `LengthWindow` is a sliding length window, that holds last windowLength events, and gets updated on every event\narrival and expiry.\nE.g.\n      from inputStream window `length(5)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `length` window should only have one parameter (\u003cint\u003e windowLength)\n"},"insertText":"LengthWindow"}'),
(124, 22, 'SortWindow', '', 3, FALSE, '{"label":"SortWindow","kind":"Class","detail":"Object","documentation":{"left":"The sort window hold a given number of events and emit the expired events in the ordered by the given fields.\nE.g.\n      from inputStream window `sort(10, inputStream.age, \"ascending\", inputStream.name, \"descending\")`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `sort` window should have three or more odd no of parameters (\u003cint\u003e windowLength, stream field, \u003cstring\u003e\norder1,  stream field, \u003cstring\u003e order2, ...)\n"},"insertText":"SortWindow"}');         
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(125, 22, 'TimeAccumulatingWindow', '', 3, FALSE, '{"label":"TimeAccumulatingWindow","kind":"Class","detail":"Object","documentation":{"left":"The  `TimeAccumulatingWindow` holds the events but if the events are not received for a specific time period, the\ncollected events are released, at the point the time exceeds the given time period from the time when the last\nevent is received.\nE.g.\n      from inputStream window `timeAccum(4000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nTime accumulating window should only have one parameter (\u003cint\u003e timePeriod)\n"},"insertText":"TimeAccumulatingWindow"}'),
(126, 22, 'TimeBatchWindow', '', 3, FALSE, '{"label":"TimeBatchWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a batch (tumbling) time window, that holds events arrived between window time periods, and gets updated for\nevery window time.\nE.g.\n      from inputStream window `timeBatch(5000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `timeBatch` window should only have one parameter (\u003cint\u003e windowBatchTime)\n"},"insertText":"TimeBatchWindow"}'),
(127, 22, 'TimeLengthWindow', '', 3, FALSE, '{"label":"TimeLengthWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a sliding time window that, at a given time holds the last windowLength events that arrived during last\nwindowTime period, and gets updated for every event arrival and expiry.\nE.g.\n      from inputStream window `timeLength(4000, 10)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `timeLength` window should only have two parameters (\u003cint\u003e windowTime, \u003cint\u003e windowLength)\n"},"insertText":"TimeLengthWindow"}'),
(128, 22, 'TimeOrderWindow', '', 3, FALSE, '{"label":"TimeOrderWindow","kind":"Class","detail":"Object","documentation":{"left":"The `TimeOrderWindow` sorts the events to be expired by the given timestamp field by comparing that timestamp value\nto engine system time.\nE.g.\n      from inputStream window `timeOrder(inputStream.timestamp, 4000, true)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\n`timeOrder` window should only have three parameters (timestamp field, \u003cint\u003e windowTime, \u003cboolean\u003e dropOlderEvents)\n"},"insertText":"TimeOrderWindow"}'),
(129, 22, 'TimeWindow', '', 3, FALSE, '{"label":"TimeWindow","kind":"Class","detail":"Object","documentation":{"left":"The `TimeWindow` is a sliding time window, that holds events for that arrived during last windowTime period, and\ngets updated on every event arrival and expiry.\nE.g.\n      from inputStream window `time(5000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `time` window should only have one parameter (\u003cint\u003e windowTime)\n"},"insertText":"TimeWindow"}'),
(130, 22, 'UniqueLengthWindow', '', 3, FALSE, '{"label":"UniqueLengthWindow","kind":"Class","detail":"Object","documentation":{"left":"This is a length window which only keeps the unique events.\nE.g.\n      from inputStream window `uniqueLength(inputStream.timestamp, 4000)`\n      select inputStream.name, inputStream.age, sum(inputStream.age) as sumAge, count() as count\n      group by inputStream.name \u003d\u003e (TeacherOutput [] teachers) {\n           foreach var t in teachers {\n               outputStream.publish(t);\n           }\n       }\nThe `uniqueLength` window should only have two parameters (stream field, \u003cint\u003e windowLength)\n"},"insertText":"UniqueLengthWindow"}');     
INSERT INTO "PUBLIC"."BLANGOBJECT" VALUES
(131, 23, 'Process', '', 3, FALSE, '{"label":"Process","kind":"Class","detail":"Object","documentation":{"left":"This object contains information on a process being created from Ballerina.\nThis is returned from the `exec` function in the `system` module."},"insertText":"Process"}'),
(132, 24, 'Listener', '', 3, FALSE, '{"label":"Listener","kind":"Class","detail":"Object","documentation":{"left":"Represents a ballerina task listener."},"insertText":"Listener"}'),
(133, 24, 'Scheduler', '', 3, FALSE, '{"label":"Scheduler","kind":"Class","detail":"Object","documentation":{"left":"Represents a ballerina task."},"insertText":"Scheduler"}'),
(134, 27, 'RemoteParticipant', '', 3, TRUE, '{"label":"RemoteParticipant","kind":"Class","detail":"Object","insertText":"RemoteParticipant"}'),
(135, 27, 'LocalParticipant', '', 3, TRUE, '{"label":"LocalParticipant","kind":"Class","detail":"Object","insertText":"LocalParticipant"}'),
(136, 27, 'TwoPhaseCommitTransaction', '', 3, TRUE, '{"label":"TwoPhaseCommitTransaction","kind":"Class","detail":"Object","insertText":"TwoPhaseCommitTransaction"}'),
(137, 27, 'InitiatorClientEP', '', 1, TRUE, '{"label":"InitiatorClientEP","kind":"Class","detail":"Object","insertText":"InitiatorClientEP"}'),
(138, 27, 'Participant2pcClientEP', '', 1, FALSE, '{"label":"Participant2pcClientEP","kind":"Class","detail":"Object","insertText":"Participant2pcClientEP"}');            
CREATE MEMORY TABLE "PUBLIC"."BLANGPACKAGE"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_234A4E4D_CC86_4B31_895E_BAAF598244AC") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_234A4E4D_CC86_4B31_895E_BAAF598244AC",
    "NAME" VARCHAR(256) NOT NULL,
    "ORGNAME" VARCHAR(256) NOT NULL,
    "VERSION" VARCHAR(256) NOT NULL
);            
ALTER TABLE "PUBLIC"."BLANGPACKAGE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_2D" PRIMARY KEY("ID"); 
-- 28 +/- SELECT COUNT(*) FROM PUBLIC.BLANGPACKAGE;            
INSERT INTO "PUBLIC"."BLANGPACKAGE" VALUES
(1, 'auth', 'ballerina', ''),
(2, 'cache', 'ballerina', ''),
(3, 'config', 'ballerina', ''),
(4, 'crypto', 'ballerina', ''),
(5, 'encoding', 'ballerina', ''),
(6, 'file', 'ballerina', ''),
(7, 'filepath', 'ballerina', ''),
(8, 'grpc', 'ballerina', ''),
(9, 'http', 'ballerina', ''),
(10, 'io', 'ballerina', ''),
(11, 'jwt', 'ballerina', ''),
(12, 'ldap', 'ballerina', ''),
(13, 'log', 'ballerina', ''),
(14, 'math', 'ballerina', ''),
(15, 'nats', 'ballerina', ''),
(16, 'rabbitmq', 'ballerina', ''),
(17, 'mime', 'ballerina', ''),
(18, 'oauth2', 'ballerina', ''),
(19, 'openapi', 'ballerina', ''),
(20, 'reflect', 'ballerina', ''),
(21, 'socket', 'ballerina', ''),
(22, 'streams', 'ballerina', ''),
(23, 'system', 'ballerina', ''),
(24, 'task', 'ballerina', ''),
(25, 'test', 'ballerina', ''),
(26, 'time', 'ballerina', ''),
(27, 'transactions', 'ballerina', ''),
(28, 'utils', 'ballerina', '');     
CREATE MEMORY TABLE "PUBLIC"."BLANGRECORD"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_49E4B062_1A06_40A3_8ED6_7972DF343511") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_49E4B062_1A06_40A3_8ED6_7972DF343511",
    "PACKAGEID" INT NOT NULL,
    "NAME" VARCHAR(256) NOT NULL,
    "FIELDS" VARCHAR NOT NULL,
    "PRIVATE" BIT DEFAULT 1 NOT NULL,
    "COMPLETIONITEM" VARCHAR DEFAULT NULL
);         
ALTER TABLE "PUBLIC"."BLANGRECORD" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_7" PRIMARY KEY("ID");   
-- 144 +/- SELECT COUNT(*) FROM PUBLIC.BLANGRECORD;            
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(1, 1, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(2, 1, 'BasicAuthConfig', '', FALSE, '{"label":"BasicAuthConfig","kind":"Class","detail":"Record","documentation":{"left":"The `BasicAuthConfig` record can be used to configure inbound Basic Authentication configurations.\n"},"insertText":"BasicAuthConfig"}'),
(3, 1, 'Credential', '', FALSE, '{"label":"Credential","kind":"Class","detail":"Record","documentation":{"left":"The `Credential` record can be used to configure Basic authentication, which is used by the HTTP endpoint.\n"},"insertText":"Credential"}'),
(4, 2, 'CacheEntry', '', TRUE, '{"label":"CacheEntry","kind":"Class","detail":"Record","documentation":{"left":"Represents a cache entry.\n"},"insertText":"CacheEntry"}'),
(5, 2, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(6, 4, 'KeyStore', '', FALSE, '{"label":"KeyStore","kind":"Class","detail":"Record","documentation":{"left":"Record for providing key store related configurations.\n"},"insertText":"KeyStore"}'),
(7, 4, 'TrustStore', '', FALSE, '{"label":"TrustStore","kind":"Class","detail":"Record","documentation":{"left":"Record for providing trust store related configurations.\n"},"insertText":"TrustStore"}'),
(8, 4, 'PrivateKey', '', FALSE, '{"label":"PrivateKey","kind":"Class","detail":"Record","documentation":{"left":"Private key used in cryptographic operations.\n"},"insertText":"PrivateKey"}'),
(9, 4, 'PublicKey', '', FALSE, '{"label":"PublicKey","kind":"Class","detail":"Record","documentation":{"left":"Public key used in cryptographic operations.\n"},"insertText":"PublicKey"}'),
(10, 4, 'Certificate', '', FALSE, '{"label":"Certificate","kind":"Class","detail":"Record","documentation":{"left":"X509 public key certificate information.\n"},"insertText":"Certificate"}'),
(11, 4, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(12, 5, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(13, 6, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Represents the details of an error.\n"},"insertText":"Detail"}'),
(14, 7, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Represents the details of an error.\n"},"insertText":"Detail"}'),
(15, 8, 'GrpcServiceConfig', '', FALSE, '{"label":"GrpcServiceConfig","kind":"Class","detail":"Record","documentation":{"left":"Service configuration. Sets only for client and bidirectional streaming service.\n"},"insertText":"GrpcServiceConfig"}'),
(16, 8, 'GrpcResourceConfig', '', FALSE, '{"label":"GrpcResourceConfig","kind":"Class","detail":"Record","documentation":{"left":"Service resource configuration. Sets only for server streaming service.\n"},"insertText":"GrpcResourceConfig"}'),
(17, 8, 'ServiceDescriptorData', '', FALSE, '{"label":"ServiceDescriptorData","kind":"Class","detail":"Record","documentation":{"left":"Service descriptor data. This is for internal use.\n"},"insertText":"ServiceDescriptorData"}'),
(18, 8, 'Remote', '', FALSE, '{"label":"Remote","kind":"Class","detail":"Record","documentation":{"left":"Presents a read-only view of the remote address.\n"},"insertText":"Remote"}'),
(19, 8, 'Local', '', FALSE, '{"label":"Local","kind":"Class","detail":"Record","documentation":{"left":"Presents a read-only view of the local address.\n"},"insertText":"Local"}'),
(20, 8, 'PoolConfiguration', '', FALSE, '{"label":"PoolConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Configurations for managing gRPC client connection pool.\n"},"insertText":"PoolConfiguration"}'),
(21, 8, 'ClientEndpointConfig', '', FALSE, '{"label":"ClientEndpointConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents client endpoint configuration.\n"},"insertText":"ClientEndpointConfig"}'),
(22, 8, 'SecureSocket', '', FALSE, '{"label":"SecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for facilitating secure communication with a remote HTTP endpoint.\n"},"insertText":"SecureSocket"}');      
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(23, 8, 'Protocols', '', FALSE, '{"label":"Protocols","kind":"Class","detail":"Record","documentation":{"left":"Protocols record represents SSL/TLS protocol related options to be used for HTTP client/service invocation.\n"},"insertText":"Protocols"}'),
(24, 8, 'ValidateCert', '', FALSE, '{"label":"ValidateCert","kind":"Class","detail":"Record","documentation":{"left":"ValidateCert record represents options related to check whether a certificate is revoked or not.\n"},"insertText":"ValidateCert"}'),
(25, 8, 'ListenerOcspStapling', '', FALSE, '{"label":"ListenerOcspStapling","kind":"Class","detail":"Record","documentation":{"left":"OcspStapling record represents options related to check whether a certificate is revoked or not.\n"},"insertText":"ListenerOcspStapling"}'),
(26, 8, 'Detail', '', FALSE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Holds the details of an gRPC error\n"},"insertText":"Detail"}'),
(27, 8, 'ListenerConfiguration', '', FALSE, '{"label":"ListenerConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Represents the gRPC server endpoint configuration.\n"},"insertText":"ListenerConfiguration"}'),
(28, 8, 'ListenerSecureSocket', '', FALSE, '{"label":"ListenerSecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Configures the SSL/TLS options to be used for HTTP service.\n"},"insertText":"ListenerSecureSocket"}'),
(29, 9, 'HttpServiceConfig', '', FALSE, '{"label":"HttpServiceConfig","kind":"Class","detail":"Record","documentation":{"left":"Contains the configurations for an HTTP service.\n"},"insertText":"HttpServiceConfig"}'),
(30, 9, 'CorsConfig', '', FALSE, '{"label":"CorsConfig","kind":"Class","detail":"Record","documentation":{"left":"Configurations for CORS support.\n"},"insertText":"CorsConfig"}'),
(31, 9, 'Versioning', '', FALSE, '{"label":"Versioning","kind":"Class","detail":"Record","documentation":{"left":"Configurations for service versioning.\n"},"insertText":"Versioning"}'),
(32, 9, 'WSServiceConfig', '', FALSE, '{"label":"WSServiceConfig","kind":"Class","detail":"Record","documentation":{"left":"Configurations for a WebSocket service.\n"},"insertText":"WSServiceConfig"}'),
(33, 9, 'HttpResourceConfig', '', FALSE, '{"label":"HttpResourceConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration for an HTTP resource.\n"},"insertText":"HttpResourceConfig"}'),
(34, 9, 'WebSocketUpgradeConfig', '', FALSE, '{"label":"WebSocketUpgradeConfig","kind":"Class","detail":"Record","documentation":{"left":"Resource configuration to upgrade from HTTP to WebSocket.\n"},"insertText":"WebSocketUpgradeConfig"}'),
(35, 9, 'ServiceResourceAuth', '', FALSE, '{"label":"ServiceResourceAuth","kind":"Class","detail":"Record","documentation":{"left":"Configures the authentication scheme for a service or a resource.\n"},"insertText":"ServiceResourceAuth"}'),
(36, 9, 'HttpParamOrderConfig', '', TRUE, '{"label":"HttpParamOrderConfig","kind":"Class","detail":"Record","documentation":{"left":"Path param order config keep the signature path param index against the variable names for runtime path param processing.\n"},"insertText":"HttpParamOrderConfig"}'),
(37, 9, 'CacheConfig', '', FALSE, '{"label":"CacheConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for controlling the caching behaviour of the endpoint.\n"},"insertText":"CacheConfig"}'),
(38, 9, 'TargetService', '', FALSE, '{"label":"TargetService","kind":"Class","detail":"Record","documentation":{"left":"Represents a single service and its related configurations.\n"},"insertText":"TargetService"}'),
(39, 9, 'ClientEndpointConfig', '', FALSE, '{"label":"ClientEndpointConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for controlling the behaviours when communicating with a remote HTTP endpoint.\n"},"insertText":"ClientEndpointConfig"}'),
(40, 9, 'ClientHttp1Settings', '', FALSE, '{"label":"ClientHttp1Settings","kind":"Class","detail":"Record","documentation":{"left":"Provides settings related to HTTP/1.x protocol.\n"},"insertText":"ClientHttp1Settings"}');              
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(41, 9, 'ClientHttp2Settings', '', FALSE, '{"label":"ClientHttp2Settings","kind":"Class","detail":"Record","documentation":{"left":"Provides settings related to HTTP/2 protocol.\n"},"insertText":"ClientHttp2Settings"}'),
(42, 9, 'RetryConfig', '', FALSE, '{"label":"RetryConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for controlling the retrying behavior in failure scenarios.\n"},"insertText":"RetryConfig"}'),
(43, 9, 'ClientSecureSocket', '', FALSE, '{"label":"ClientSecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for facilitating secure communication with a remote HTTP endpoint.\n"},"insertText":"ClientSecureSocket"}'),
(44, 9, 'FollowRedirects', '', FALSE, '{"label":"FollowRedirects","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for controlling the endpoint\u0027s behaviour in response to HTTP redirect related responses.\n"},"insertText":"FollowRedirects"}'),
(45, 9, 'ProxyConfig', '', FALSE, '{"label":"ProxyConfig","kind":"Class","detail":"Record","documentation":{"left":"Proxy server configurations to be used with the HTTP client endpoint.\n"},"insertText":"ProxyConfig"}'),
(46, 9, 'OutboundAuthConfig', '', FALSE, '{"label":"OutboundAuthConfig","kind":"Class","detail":"Record","documentation":{"left":"The `OutboundAuthConfig` record can be used to configure the authentication mechanism used by the HTTP endpoint.\n"},"insertText":"OutboundAuthConfig"}'),
(47, 9, 'HttpTimeoutError', '', FALSE, '{"label":"HttpTimeoutError","kind":"Class","detail":"Record","documentation":{"left":"Defines a timeout error occurred during service invocation.\n"},"insertText":"HttpTimeoutError"}'),
(48, 9, 'PoolConfiguration', '', FALSE, '{"label":"PoolConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Configurations for managing HTTP client connection pool.\n"},"insertText":"PoolConfiguration"}'),
(49, 9, 'Protocols', '', FALSE, '{"label":"Protocols","kind":"Class","detail":"Record","documentation":{"left":"A record for configuring SSL/TLS protocol and version to be used.\n"},"insertText":"Protocols"}'),
(50, 9, 'ValidateCert', '', FALSE, '{"label":"ValidateCert","kind":"Class","detail":"Record","documentation":{"left":"A record for providing configurations for certificate revocation status checks.\n"},"insertText":"ValidateCert"}'),
(51, 9, 'ListenerOcspStapling', '', FALSE, '{"label":"ListenerOcspStapling","kind":"Class","detail":"Record","documentation":{"left":"A record for providing configurations for certificate revocation status checks.\n"},"insertText":"ListenerOcspStapling"}'),
(52, 9, 'CompressionConfig', '', FALSE, '{"label":"CompressionConfig","kind":"Class","detail":"Record","documentation":{"left":"A record for providing configurations for content compression.\n"},"insertText":"CompressionConfig"}'),
(53, 9, 'HTTPError', '', TRUE, '{"label":"HTTPError","kind":"Class","detail":"Record","insertText":"HTTPError"}'),
(54, 9, 'Detail', '', FALSE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Holds the details of an HTTP error\n"},"insertText":"Detail"}'),
(55, 9, 'MutualSslHandshake', '', FALSE, '{"label":"MutualSslHandshake","kind":"Class","detail":"Record","documentation":{"left":"A record for providing mutual ssl handshake results.\n"},"insertText":"MutualSslHandshake"}'),
(56, 9, 'FailoverConfig', '', FALSE, '{"label":"FailoverConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for controlling the failover behaviour of the endpoint.\n"},"insertText":"FailoverConfig"}'),
(57, 9, 'FailoverInferredConfig', '', FALSE, '{"label":"FailoverInferredConfig","kind":"Class","detail":"Record","documentation":{"left":"Inferred failover configurations passed into the failover client.\n"},"insertText":"FailoverInferredConfig"}'),
(58, 9, 'FailoverClientEndpointConfiguration', '', FALSE, '{"label":"FailoverClientEndpointConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of HTTP related configurations and failover related configurations.\n"},"insertText":"FailoverClientEndpointConfiguration"}');     
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(59, 9, 'CircuitHealth', '', FALSE, '{"label":"CircuitHealth","kind":"Class","detail":"Record","documentation":{"left":"Maintains the health of the Circuit Breaker.\n"},"insertText":"CircuitHealth"}'),
(60, 9, 'CircuitBreakerConfig', '', FALSE, '{"label":"CircuitBreakerConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for controlling the behaviour of the Circuit Breaker.\n"},"insertText":"CircuitBreakerConfig"}'),
(61, 9, 'RollingWindow', '', FALSE, '{"label":"RollingWindow","kind":"Class","detail":"Record","documentation":{"left":"Represents a rolling window in the Circuit Breaker.\n"},"insertText":"RollingWindow"}'),
(62, 9, 'Bucket', '', FALSE, '{"label":"Bucket","kind":"Class","detail":"Record","documentation":{"left":"Represents a discrete sub-part of the time window (Bucket).\n"},"insertText":"Bucket"}'),
(63, 9, 'CircuitBreakerInferredConfig', '', FALSE, '{"label":"CircuitBreakerInferredConfig","kind":"Class","detail":"Record","documentation":{"left":"Derived set of configurations from the `CircuitBreakerConfig`.\n"},"insertText":"CircuitBreakerInferredConfig"}'),
(64, 9, 'RetryInferredConfig', '', FALSE, '{"label":"RetryInferredConfig","kind":"Class","detail":"Record","documentation":{"left":"Derived set of configurations from the `RetryConfig`.\n"},"insertText":"RetryInferredConfig"}'),
(65, 9, 'LoadBalanceActionErrorData', '', FALSE, '{"label":"LoadBalanceActionErrorData","kind":"Class","detail":"Record","documentation":{"left":"Represents an error occurred in an remote function of the Load Balance connector.\n"},"insertText":"LoadBalanceActionErrorData"}'),
(66, 9, 'LoadBalanceClientEndpointConfiguration', '', FALSE, '{"label":"LoadBalanceClientEndpointConfiguration","kind":"Class","detail":"Record","documentation":{"left":"The configurations related to the load balance client endpoint.\n"},"insertText":"LoadBalanceClientEndpointConfiguration"}'),
(67, 9, 'Remote', '', FALSE, '{"label":"Remote","kind":"Class","detail":"Record","documentation":{"left":"Presents a read-only view of the remote address.\n"},"insertText":"Remote"}'),
(68, 9, 'Local', '', FALSE, '{"label":"Local","kind":"Class","detail":"Record","documentation":{"left":"Presents a read-only view of the local address.\n"},"insertText":"Local"}'),
(69, 9, 'ListenerConfiguration', '', FALSE, '{"label":"ListenerConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for HTTP service endpoints.\n"},"insertText":"ListenerConfiguration"}'),
(70, 9, 'ListenerHttp1Settings', '', FALSE, '{"label":"ListenerHttp1Settings","kind":"Class","detail":"Record","documentation":{"left":"Provides settings related to HTTP/1.x protocol.\n"},"insertText":"ListenerHttp1Settings"}'),
(71, 9, 'ListenerAuth', '', FALSE, '{"label":"ListenerAuth","kind":"Class","detail":"Record","documentation":{"left":"Authentication configurations for the listener.\n"},"insertText":"ListenerAuth"}'),
(72, 9, 'ListenerSecureSocket', '', FALSE, '{"label":"ListenerSecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Configures the SSL/TLS options to be used for HTTP service.\n"},"insertText":"ListenerSecureSocket"}'),
(73, 9, 'AuthCacheConfig', '', FALSE, '{"label":"AuthCacheConfig","kind":"Class","detail":"Record","documentation":{"left":"Provides a set of configurations for controlling the authorization caching behaviour of the endpoint.\n"},"insertText":"AuthCacheConfig"}'),
(74, 9, 'WebSocketClientConfiguration', '', FALSE, '{"label":"WebSocketClientConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Configuration for the WebSocket client endpoint.\n"},"insertText":"WebSocketClientConfiguration"}'),
(75, 10, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(76, 11, 'JwtHeader', '', FALSE, '{"label":"JwtHeader","kind":"Class","detail":"Record","documentation":{"left":"Represents a JWT header."},"insertText":"JwtHeader"}'),
(77, 11, 'JwtPayload', '', FALSE, '{"label":"JwtPayload","kind":"Class","detail":"Record","documentation":{"left":"Represents a JWT payload."},"insertText":"JwtPayload"}');
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(78, 11, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(79, 11, 'JwtIssuerConfig', '', FALSE, '{"label":"JwtIssuerConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents authentication provider configurations that supports generating JWT for client interactions.\n"},"insertText":"JwtIssuerConfig"}'),
(80, 11, 'JwtKeyStoreConfig', '', FALSE, '{"label":"JwtKeyStoreConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents JWT key store configurations.\n"},"insertText":"JwtKeyStoreConfig"}'),
(81, 11, 'JwtValidatorConfig', '', FALSE, '{"label":"JwtValidatorConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents JWT validator configurations."},"insertText":"JwtValidatorConfig"}'),
(82, 11, 'JwtTrustStoreConfig', '', FALSE, '{"label":"JwtTrustStoreConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents JWT trust store configurations.\n"},"insertText":"JwtTrustStoreConfig"}'),
(83, 11, 'CachedJwt', '', FALSE, '{"label":"CachedJwt","kind":"Class","detail":"Record","documentation":{"left":"Represents parsed and cached JWT.\n"},"insertText":"CachedJwt"}'),
(84, 12, 'LdapConnectionConfig', '', FALSE, '{"label":"LdapConnectionConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents configurations that required for LDAP auth store.\n"},"insertText":"LdapConnectionConfig"}'),
(85, 12, 'SecureSocket', '', FALSE, '{"label":"SecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Configures the SSL/TLS options to be used for LDAP communication.\n"},"insertText":"SecureSocket"}'),
(86, 12, 'LdapConnection', '', FALSE, '{"label":"LdapConnection","kind":"Class","detail":"Record","insertText":"LdapConnection"}'),
(87, 12, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(88, 14, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(89, 15, 'SubscriptionConfigData', '', FALSE, '{"label":"SubscriptionConfigData","kind":"Class","detail":"Record","documentation":{"left":"NATS basic subscription parameters\n"},"insertText":"SubscriptionConfigData"}'),
(90, 15, 'ConnectionConfig', '', FALSE, '{"label":"ConnectionConfig","kind":"Class","detail":"Record","documentation":{"left":"NATS core connection configuration\n"},"insertText":"ConnectionConfig"}'),
(91, 15, 'SecureSocket', '', FALSE, '{"label":"SecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for facilitating secure communication with a remote HTTP endpoint.\n"},"insertText":"SecureSocket"}'),
(92, 15, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Represents the details of an error.\n"},"insertText":"Detail"}'),
(93, 15, 'StreamingSubscriptionConfigData', '', FALSE, '{"label":"StreamingSubscriptionConfigData","kind":"Class","detail":"Record","documentation":{"left":" NATS Streaming Subscription Parameters.\n"},"insertText":"StreamingSubscriptionConfigData"}'),
(94, 15, 'StreamingConfig', '', FALSE, '{"label":"StreamingConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration related to a streaming connection.\n"},"insertText":"StreamingConfig"}'),
(95, 16, 'RabbitMQServiceConfig', '', FALSE, '{"label":"RabbitMQServiceConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents the list of parameters required to create a subscription.\n"},"insertText":"RabbitMQServiceConfig"}'),
(96, 16, 'BasicProperties', '', FALSE, '{"label":"BasicProperties","kind":"Class","detail":"Record","documentation":{"left":"Holds other properties of the message - routing headers etc.\n"},"insertText":"BasicProperties"}'),
(97, 16, 'QueueConfiguration', '', FALSE, '{"label":"QueueConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Holds the parameters used to declare a queue.\n"},"insertText":"QueueConfiguration"}'),
(98, 16, 'ExchangeConfiguration', '', FALSE, '{"label":"ExchangeConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Holds the parameters used to declare an exchange.\n"},"insertText":"ExchangeConfiguration"}');         
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(99, 16, 'ConnectionConfiguration', '', FALSE, '{"label":"ConnectionConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Holds the parameters used to create a RabbitMQ `Connection`.\n"},"insertText":"ConnectionConfiguration"}'),
(100, 16, 'SecureSocket', '', FALSE, '{"label":"SecureSocket","kind":"Class","detail":"Record","documentation":{"left":"Provides configurations for facilitating secure connections.\n"},"insertText":"SecureSocket"}'),
(101, 16, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(102, 17, 'Detail', '', FALSE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(103, 18, 'IntrospectionServerConfig', '', FALSE, '{"label":"IntrospectionServerConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents introspection server onfigurations.\n"},"insertText":"IntrospectionServerConfig"}'),
(104, 18, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(105, 18, 'ClientCredentialsGrantConfig', '', FALSE, '{"label":"ClientCredentialsGrantConfig","kind":"Class","detail":"Record","documentation":{"left":"The `ClientCredentialsGrantConfig` record can be used to configue OAuth2 client credentials grant type.\n"},"insertText":"ClientCredentialsGrantConfig"}'),
(106, 18, 'PasswordGrantConfig', '', FALSE, '{"label":"PasswordGrantConfig","kind":"Class","detail":"Record","documentation":{"left":"The `PasswordGrantConfig` record can be used to configue OAuth2 password grant type\n"},"insertText":"PasswordGrantConfig"}'),
(107, 18, 'DirectTokenConfig', '', FALSE, '{"label":"DirectTokenConfig","kind":"Class","detail":"Record","documentation":{"left":"The `DirectTokenConfig` record configures the access token directly.\n"},"insertText":"DirectTokenConfig"}'),
(108, 18, 'RefreshConfig', '', FALSE, '{"label":"RefreshConfig","kind":"Class","detail":"Record","documentation":{"left":"The `RefreshConfig` record can be used to pass the configurations for refreshing the access token of password grant type.\n"},"insertText":"RefreshConfig"}'),
(109, 18, 'DirectTokenRefreshConfig', '', FALSE, '{"label":"DirectTokenRefreshConfig","kind":"Class","detail":"Record","documentation":{"left":"The `DirectTokenRefreshConfig` record passes the configurations for refreshing the access token for\nthe grant type of the direct token grant type.\n"},"insertText":"DirectTokenRefreshConfig"}'),
(110, 18, 'CachedToken', '', FALSE, '{"label":"CachedToken","kind":"Class","detail":"Record","documentation":{"left":"The `CachedToken` stores the values received from the authorization/token server to use them\nfor the latter requests without requesting tokens again.\n"},"insertText":"CachedToken"}'),
(111, 18, 'RequestConfig', '', TRUE, '{"label":"RequestConfig","kind":"Class","detail":"Record","documentation":{"left":"The `RequestConfig` record prepares the HTTP request, which is to be sent to the authorization endpoint.\n"},"insertText":"RequestConfig"}'),
(112, 19, 'ServiceInformation', '', FALSE, '{"label":"ServiceInformation","kind":"Class","detail":"Record","documentation":{"left":"Service validation codee"},"insertText":"ServiceInformation"}'),
(113, 19, 'ClientInformation', '', FALSE, '{"label":"ClientInformation","kind":"Class","detail":"Record","documentation":{"left":"Configuration elements for client code generation.\n"},"insertText":"ClientInformation"}'),
(114, 21, 'ClientConfig', '', FALSE, '{"label":"ClientConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration for socket client endpoint.\n"},"insertText":"ClientConfig"}'),
(115, 21, 'ListenerConfig', '', FALSE, '{"label":"ListenerConfig","kind":"Class","detail":"Record","documentation":{"left":"Represents the socket server configuration.\n"},"insertText":"ListenerConfig"}'),
(116, 21, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(117, 21, 'Address', '', FALSE, '{"label":"Address","kind":"Class","detail":"Record","documentation":{"left":"This represent the IP socket address.\n"},"insertText":"Address"}');          
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(118, 21, 'UdpClientConfig', '', FALSE, '{"label":"UdpClientConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration for UDP client.\n"},"insertText":"UdpClientConfig"}'),
(119, 22, 'SnapshottableStreamEvent', '', FALSE, '{"label":"SnapshottableStreamEvent","kind":"Class","detail":"Record","documentation":{"left":"This record represents a stream event which can be persisted.\n"},"insertText":"SnapshottableStreamEvent"}'),
(120, 23, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Represents the details of an error.\n"},"insertText":"Detail"}'),
(121, 24, 'TimerConfiguration', '', FALSE, '{"label":"TimerConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Configurations related to a Timer\n"},"insertText":"TimerConfiguration"}'),
(122, 24, 'AppointmentConfiguration', '', FALSE, '{"label":"AppointmentConfiguration","kind":"Class","detail":"Record","documentation":{"left":"Configurations related to an Appointment\n"},"insertText":"AppointmentConfiguration"}'),
(123, 24, 'AppointmentData', '', FALSE, '{"label":"AppointmentData","kind":"Class","detail":"Record","documentation":{"left":"Details for schedule an Appointment.\n"},"insertText":"AppointmentData"}'),
(124, 24, 'Detail', '', FALSE, '{"label":"Detail","kind":"Class","detail":"Record","documentation":{"left":"Record type to hold details of task errors.\n"},"insertText":"Detail"}'),
(125, 25, 'TestConfig', '', FALSE, '{"label":"TestConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration set for test functions.\n"},"insertText":"TestConfig"}'),
(126, 25, 'MockConfig', '', FALSE, '{"label":"MockConfig","kind":"Class","detail":"Record","documentation":{"left":"Configuration of the function to be mocked.\n"},"insertText":"MockConfig"}'),
(127, 25, 'AssertError', '', TRUE, '{"label":"AssertError","kind":"Class","detail":"Record","documentation":{"left":"The error struct for assertion errors.\n"},"insertText":"AssertError"}'),
(128, 26, 'Detail', '', TRUE, '{"label":"Detail","kind":"Class","detail":"Record","insertText":"Detail"}'),
(129, 26, 'TimeZone', '', FALSE, '{"label":"TimeZone","kind":"Class","detail":"Record","documentation":{"left":"Ballerina TimeZone represents the time-zone information associated with a particular time.\n"},"insertText":"TimeZone"}'),
(130, 26, 'Time', '', FALSE, '{"label":"Time","kind":"Class","detail":"Record","documentation":{"left":"Ballerina Time represents a particular time with its associated time-zone.\n"},"insertText":"Time"}'),
(131, 27, 'LocalProtocol', '', TRUE, '{"label":"LocalProtocol","kind":"Class","detail":"Record","documentation":{"left":"This represents the protocol associated with the coordination type.\n"},"insertText":"LocalProtocol"}'),
(132, 27, 'RemoteProtocol', '', FALSE, '{"label":"RemoteProtocol","kind":"Class","detail":"Record","documentation":{"left":"This represents the protocol associated with the coordination type."},"insertText":"RemoteProtocol"}'),
(133, 27, 'TransactionParticipantConfig', '', FALSE, '{"label":"TransactionParticipantConfig","kind":"Class","detail":"Record","documentation":{"left":"Contains the configurations for local transaction participant function.\n"},"insertText":"TransactionParticipantConfig"}'),
(134, 27, 'InitiatorClientConfig', '', TRUE, '{"label":"InitiatorClientConfig","kind":"Class","detail":"Record","insertText":"InitiatorClientConfig"}'),
(135, 27, 'Participant2pcClientConfig', '', FALSE, '{"label":"Participant2pcClientConfig","kind":"Class","detail":"Record","insertText":"Participant2pcClientConfig"}'),
(136, 27, 'TransactionContext', '', FALSE, '{"label":"TransactionContext","kind":"Class","detail":"Record","insertText":"TransactionContext"}'),
(137, 27, 'RegistrationRequest', '', TRUE, '{"label":"RegistrationRequest","kind":"Class","detail":"Record","insertText":"RegistrationRequest"}'),
(138, 27, 'RegistrationResponse', '', TRUE, '{"label":"RegistrationResponse","kind":"Class","detail":"Record","insertText":"RegistrationResponse"}');      
INSERT INTO "PUBLIC"."BLANGRECORD" VALUES
(139, 27, 'RequestError', '', FALSE, '{"label":"RequestError","kind":"Class","detail":"Record","insertText":"RequestError"}'),
(140, 27, 'PrepareRequest', '', FALSE, '{"label":"PrepareRequest","kind":"Class","detail":"Record","insertText":"PrepareRequest"}'),
(141, 27, 'PrepareResponse', '', FALSE, '{"label":"PrepareResponse","kind":"Class","detail":"Record","insertText":"PrepareResponse"}'),
(142, 27, 'NotifyRequest', '', FALSE, '{"label":"NotifyRequest","kind":"Class","detail":"Record","insertText":"NotifyRequest"}'),
(143, 27, 'NotifyResponse', '', FALSE, '{"label":"NotifyResponse","kind":"Class","detail":"Record","insertText":"NotifyResponse"}'),
(144, 27, 'ParticipantFunctionResult', '', FALSE, '{"label":"ParticipantFunctionResult","kind":"Class","detail":"Record","insertText":"ParticipantFunctionResult"}');             
CREATE MEMORY TABLE "PUBLIC"."BLANGTYPE"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_0ECCA014_C94F_4A29_8615_8ED49C561442") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_0ECCA014_C94F_4A29_8615_8ED49C561442",
    "PACKAGEID" INT NOT NULL,
    "NAME" VARCHAR(256) NOT NULL,
    "FIELDS" VARCHAR NOT NULL,
    "COMPLETIONITEM" VARCHAR DEFAULT NULL
); 
ALTER TABLE "PUBLIC"."BLANGTYPE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_8" PRIMARY KEY("ID");     
-- 56 +/- SELECT COUNT(*) FROM PUBLIC.BLANGTYPE;               
INSERT INTO "PUBLIC"."BLANGTYPE" VALUES
(1, 3, 'ValueType', '', '{"label":"ValueType","kind":"Enum","detail":"Union","insertText":"ValueType"}'),
(2, 4, 'KeyAlgorithm', '', '{"label":"KeyAlgorithm","kind":"Enum","detail":"Finite","documentation":{"left":"The key algorithms supported by crypto module."},"insertText":"KeyAlgorithm"}'),
(3, 4, 'AesPadding', '', '{"label":"AesPadding","kind":"Enum","detail":"Union","documentation":{"left":"Padding algorithms supported with AES encryption and decryption"},"insertText":"AesPadding"}'),
(4, 4, 'RsaPadding', '', '{"label":"RsaPadding","kind":"Enum","detail":"Union","documentation":{"left":"Padding algorithms supported with RSA encryption and decryption"},"insertText":"RsaPadding"}'),
(5, 6, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(6, 8, 'KeepAlive', '', '{"label":"KeepAlive","kind":"Enum","detail":"Union","documentation":{"left":"Defines the possible values for the keep-alive configuration in service and client endpoints."},"insertText":"KeepAlive"}'),
(7, 8, 'Compression', '', '{"label":"Compression","kind":"Enum","detail":"Union","documentation":{"left":"Options to compress using gzip or deflate.\n\n`AUTO`: When service behaves as a HTTP gateway inbound request/response accept-encoding option is set as the\n        outbound request/response accept-encoding/content-encoding option\n`ALWAYS`: Always set accept-encoding/content-encoding in outbound request/response\n`NEVER`: Never set accept-encoding/content-encoding header in outbound request/response"},"insertText":"Compression"}'),
(8, 8, 'ErrorType', '', '{"label":"ErrorType","kind":"Enum","detail":"Union","insertText":"ErrorType"}'),
(9, 8, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(10, 9, 'CredentialBearer', '', '{"label":"CredentialBearer","kind":"Enum","detail":"Union","documentation":{"left":"Specifies how to send the authentication credentials when exchanging tokens."},"insertText":"CredentialBearer"}'),
(11, 9, 'CachingPolicy', '', '{"label":"CachingPolicy","kind":"Enum","detail":"Union","documentation":{"left":"Used for configuring the caching behaviour. Setting the `policy` field in the `CacheConfig` record allows\nthe user to control the caching behaviour."},"insertText":"CachingPolicy"}'),
(12, 9, 'HttpVersion', '', '{"label":"HttpVersion","kind":"Enum","detail":"Union","documentation":{"left":"Defines the supported HTTP protocols.\n\n`HTTP_1_0`: HTTP/1.0 protocol\n`HTTP_1_1`: HTTP/1.1 protocol\n`HTTP_2_0`: HTTP/2.0 protocol"},"insertText":"HttpVersion"}'),
(13, 9, 'Chunking', '', '{"label":"Chunking","kind":"Enum","detail":"Union","documentation":{"left":"Defines the possible values for the chunking configuration in HTTP services and clients.\n\n`AUTO`: If the payload is less than 8KB, content-length header is set in the outbound request/response,\n        otherwise chunking header is set in the outbound request/response\n`ALWAYS`: Always set chunking header in the response\n`NEVER`: Never set the chunking header even if the payload is larger than 8KB in the outbound request/response"},"insertText":"Chunking"}'),
(14, 9, 'Compression', '', '{"label":"Compression","kind":"Enum","detail":"Union","documentation":{"left":"Options to compress using gzip or deflate.\n\n`AUTO`: When service behaves as a HTTP gateway inbound request/response accept-encoding option is set as the\n        outbound request/response accept-encoding/content-encoding option\n`ALWAYS`: Always set accept-encoding/content-encoding in outbound request/response\n`NEVER`: Never set accept-encoding/content-encoding header in outbound request/response"},"insertText":"Compression"}'),
(15, 9, 'HttpOperation', '', '{"label":"HttpOperation","kind":"Enum","detail":"Union","documentation":{"left":"Defines the HTTP operations related to circuit breaker, failover and load balancer.\n\n`FORWARD`: Forward the specified payload\n`GET`: Request a resource\n`POST`: Create a new resource\n`DELETE`: Deletes the specified resource\n`OPTIONS`: Request communication options available\n`PUT`: Replace the target resource\n`PATCH`: Apply partial modification to the resource\n`HEAD`: Identical to `GET` but no resource body should be returned\n`SUBMIT`: Submits a http request and returns an HttpFuture object\n`NONE`: No operation should be performed"},"insertText":"HttpOperation"}');             
INSERT INTO "PUBLIC"."BLANGTYPE" VALUES
(16, 9, 'RedirectCode', '', '{"label":"RedirectCode","kind":"Enum","detail":"Union","documentation":{"left":"Defines the HTTP redirect codes as a type."},"insertText":"RedirectCode"}'),
(17, 9, 'ResiliencyError', '', '{"label":"ResiliencyError","kind":"Enum","detail":"Union","documentation":{"left":"Ballerina Http Union Errors"},"insertText":"ResiliencyError"}'),
(18, 9, 'ClientAuthError', '', '{"label":"ClientAuthError","kind":"Enum","detail":"Union","insertText":"ClientAuthError"}'),
(19, 9, 'OutboundRequestError', '', '{"label":"OutboundRequestError","kind":"Enum","detail":"Union","insertText":"OutboundRequestError"}'),
(20, 9, 'InboundResponseError', '', '{"label":"InboundResponseError","kind":"Enum","detail":"Union","insertText":"InboundResponseError"}'),
(21, 9, 'InboundRequestError', '', '{"label":"InboundRequestError","kind":"Enum","detail":"Union","insertText":"InboundRequestError"}'),
(22, 9, 'OutboundResponseError', '', '{"label":"OutboundResponseError","kind":"Enum","detail":"Union","insertText":"OutboundResponseError"}'),
(23, 9, 'ClientError', '', '{"label":"ClientError","kind":"Enum","detail":"Union","insertText":"ClientError"}'),
(24, 9, 'ListenerError', '', '{"label":"ListenerError","kind":"Enum","detail":"Union","insertText":"ListenerError"}'),
(25, 9, 'MutualSslStatus', '', '{"label":"MutualSslStatus","kind":"Enum","detail":"Union","documentation":{"left":"Defines the possible values for the mutual ssl status.\n\n`passed`: Mutual SSL handshake is successful.\n`failed`: Mutual SSL handshake has failed."},"insertText":"MutualSslStatus"}'),
(26, 9, 'CircuitState', '', '{"label":"CircuitState","kind":"Enum","detail":"Union","documentation":{"left":"A finite type for modeling the states of the Circuit Breaker. The Circuit Breaker starts in the `CLOSED` state.\nIf any failure thresholds are exceeded during execution, the circuit trips and goes to the `OPEN` state. After\nthe specified timeout period expires, the circuit goes to the `HALF_OPEN` state. If the trial request sent while\nin the `HALF_OPEN` state succeeds, the circuit goes back to the `CLOSED` state."},"insertText":"CircuitState"}'),
(27, 9, 'KeepAlive', '', '{"label":"KeepAlive","kind":"Enum","detail":"Union","documentation":{"left":"Defines the possible values for the keep-alive configuration in service and client endpoints."},"insertText":"KeepAlive"}'),
(28, 9, 'WebSocketError', '', '{"label":"WebSocketError","kind":"Enum","detail":"Union","insertText":"WebSocketError"}'),
(29, 9, 'RequestMessage', '', '{"label":"RequestMessage","kind":"Enum","detail":"Union","documentation":{"left":"The types of messages that are accepted by HTTP `client` when sending out the outbound request."},"insertText":"RequestMessage"}'),
(30, 9, 'ResponseMessage', '', '{"label":"ResponseMessage","kind":"Enum","detail":"Union","documentation":{"left":"The types of messages that are accepted by HTTP `listener` when sending out the outbound response."},"insertText":"ResponseMessage"}'),
(31, 9, 'HttpResponse', '', '{"label":"HttpResponse","kind":"Enum","detail":"Union","insertText":"HttpResponse"}'),
(32, 10, 'Format', '', '{"label":"Format","kind":"Enum","detail":"Union","documentation":{"left":"Format which will be used to represent the CSV.\n\nDEFAULT - Would default to the format specified by CSVChannel. Precedence will be given to field\n          separator and record separator.\n\nCSV - Field separator would be \",\" and the record separator would be new line.\n\nTDF - Field separator will be tab and record separator will be new line."},"insertText":"Format"}'),
(33, 10, 'Separator', '', '{"label":"Separator","kind":"Enum","detail":"Union","documentation":{"left":"Field separators which are supported by DelimitedTextRecordChannel."},"insertText":"Separator"}'),
(34, 10, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(35, 10, 'Mode', '', '{"label":"Mode","kind":"Enum","detail":"Union","insertText":"Mode"}'),
(36, 10, 'ByteOrder', '', '{"label":"ByteOrder","kind":"Enum","detail":"Finite","documentation":{"left":"Represents network byte order.\n\nBIG_ENDIAN - specifies the bytes to be in the order of most significant byte first\n\nLITTLE_ENDIAN - specifies the byte order to be the least significant byte first"},"insertText":"ByteOrder"}');
INSERT INTO "PUBLIC"."BLANGTYPE" VALUES
(37, 11, 'JwtSigningAlgorithm', '', '{"label":"JwtSigningAlgorithm","kind":"Enum","detail":"Union","documentation":{"left":"The key algorithms supported by crypto module."},"insertText":"JwtSigningAlgorithm"}'),
(38, 15, 'Content', '', '{"label":"Content","kind":"Enum","detail":"Union","insertText":"Content"}'),
(39, 15, 'TimeDeltaStart', '', '{"label":"TimeDeltaStart","kind":"Keyword","detail":"Tuple","insertText":"TimeDeltaStart"}'),
(40, 15, 'SequenceNumber', '', '{"label":"SequenceNumber","kind":"Keyword","detail":"Tuple","insertText":"SequenceNumber"}'),
(41, 15, 'StartPosition', '', '{"label":"StartPosition","kind":"Enum","detail":"Union","documentation":{"left":"The position to start receiving messages.\nNEW_ONLY - Specifies that message delivery should start with the messages, which are published after the subscription\nis created.\nLAST_RECEIVED - Specifies that message delivery should start with the last (most recent) message stored for\nthis subject.\nTimeDeltaStart - Specifies that message delivery should start with a given historical time delta (from now).\nSequenceNumber - Specifies that message delivery should start at the given sequence number.\nFIRST - Specifies that message delivery should begin at the oldest available message for this subject."},"insertText":"StartPosition"}'),
(42, 16, 'MessageContent', '', '{"label":"MessageContent","kind":"Enum","detail":"Union","documentation":{"left":"Holds the types of message content that can be published."},"insertText":"MessageContent"}'),
(43, 16, 'ExchangeType', '', '{"label":"ExchangeType","kind":"Enum","detail":"Finite","documentation":{"left":"Types of exchanges supported by the Ballerina RabbitMQ Connector."},"insertText":"ExchangeType"}'),
(44, 16, 'AcknowledgementMode', '', '{"label":"AcknowledgementMode","kind":"Enum","detail":"Union","documentation":{"left":"Types of acknowledgement modes supported by the Ballerina RabbitMQ Connector."},"insertText":"AcknowledgementMode"}'),
(45, 17, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(46, 21, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(47, 22, 'EventType', '', '{"label":"EventType","kind":"Enum","detail":"Finite","documentation":{"left":"The type of stream events."},"insertText":"EventType"}'),
(48, 22, 'JoinType', '', '{"label":"JoinType","kind":"Enum","detail":"Finite","documentation":{"left":"The types of joins between streams and tables."},"insertText":"JoinType"}'),
(49, 23, 'Error', '', '{"label":"Error","kind":"Enum","detail":"Union","insertText":"Error"}'),
(50, 24, 'TaskError', '', '{"label":"TaskError","kind":"Enum","detail":"Union","documentation":{"left":"Union error type of ballerina/task module."},"insertText":"TaskError"}'),
(51, 26, 'TimeFormat', '', '{"label":"TimeFormat","kind":"Enum","detail":"Finite","documentation":{"left":"The time format defined by the RFC-1123."},"insertText":"TimeFormat"}'),
(52, 27, 'UProtocol', '', '{"label":"UProtocol","kind":"Enum","detail":"Union","insertText":"UProtocol"}'),
(53, 27, 'TransactionState', '', '{"label":"TransactionState","kind":"Enum","detail":"Union","insertText":"TransactionState"}'),
(54, 27, 'PrepareResult', '', '{"label":"PrepareResult","kind":"Enum","detail":"Union","insertText":"PrepareResult"}'),
(55, 27, 'NotifyResult', '', '{"label":"NotifyResult","kind":"Enum","detail":"Union","insertText":"NotifyResult"}'),
(56, 27, 'PrepareDecision', '', '{"label":"PrepareDecision","kind":"Enum","detail":"Union","insertText":"PrepareDecision"}');       
CREATE MEMORY TABLE "PUBLIC"."BLANGRESOURCE"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_FCE2482C_869C_4A8A_8ADF_14A0C357B389") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_FCE2482C_869C_4A8A_8ADF_14A0C357B389",
    "SERVICEID" INT NOT NULL,
    "NAME" VARCHAR(256) NOT NULL
);       
ALTER TABLE "PUBLIC"."BLANGRESOURCE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_3" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLANGRESOURCE;            
CREATE MEMORY TABLE "PUBLIC"."BLANGSERVICE"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_C8BB383D_C675_4B58_838D_1A3C23B678B3") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_C8BB383D_C675_4B58_838D_1A3C23B678B3",
    "PACKAGEID" INT NOT NULL,
    "NAME" VARCHAR(256) NOT NULL
);        
ALTER TABLE "PUBLIC"."BLANGSERVICE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_D" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLANGSERVICE;             
CREATE MEMORY TABLE "PUBLIC"."BLANGANNOTATION"(
    "ID" INT DEFAULT (NEXT VALUE FOR "PUBLIC"."SYSTEM_SEQUENCE_CC1FF0F3_FE0A_4D63_B941_016BBBD65B37") NOT NULL NULL_TO_DEFAULT SEQUENCE "PUBLIC"."SYSTEM_SEQUENCE_CC1FF0F3_FE0A_4D63_B941_016BBBD65B37",
    "PACKAGEID" INT NOT NULL,
    "ATTACHMENTPOINT" VARCHAR(64) DEFAULT NULL,
    "FIELDS" BLOB,
    "FIELDSCOMPLETIONITEMS" BLOB,
    "COMPLETIONITEM" VARCHAR NOT NULL
);           
ALTER TABLE "PUBLIC"."BLANGANNOTATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_2" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLANGANNOTATION;          
